import mongoose from "mongoose";
import Users from "../model/users.model.js";
import agentTracking from "../model/agentTracking.model.js";
import agentData from "../model/Agent.data.js";
import AgentPaymentdetails from "../model/AgentPaymentDetails.js";
import order from "../model/order.model.js";
import agentpaymentotp from "../model/AgentPaymentSettlementotp.js";
import dotenv from 'dotenv';
import axios from "axios";
import pkg from 'body-parser';
const { json } = pkg;
import SibApiV3Sdk from 'sib-api-v3-sdk';
import Paymentdetails from "../model/AgentPaymentDetails.js";






// import mongoose from "mongoose";

dotenv.config();
const apiKey = process.env.APIKEY;
// const apiKey = 'rzp_live_c8RouP3eKq6D1C';
const apiSecret = process.env.APISECRET;
// const apiSecret = '63WBO3yFwX6gHymOiypMjXm7';

const ObjectId = mongoose.Types.ObjectId;
//api for get all the data
export const getAgent_data = async (req, res) => {
    try {
        const agent_data = await Users.find({ usertype: "agent" });
        for (const agent of agent_data) {
            // console.log("The agent is", agent);
            const selected_agent = agent._id;
            console.log("The selected agent is", selected_agent);
            var today_Date = new Date().toISOString().slice(0, 10); // "2025-02-10"
            var [year, month, day] = today_Date.split("-");
            var formattedDate = `${day}-${month}-${year}`; // "10-02-25"
            console.log("the formated date is",formattedDate);
             console.log("the date is",today_Date);
            const today = new Date();
            const startOfDay = new Date(today.setUTCHours(0, 0, 0, 0));  // 2025-02-10T00:00:00.000Z
            const endOfDay = new Date(today.setUTCHours(23, 59, 59, 999));


            // Await works here because it's inside an async function
            const todayOrders = await order.find({
                agent_id: selected_agent,
                schedule_date:formattedDate,
                status: { $in: ["processed", "Pickup Completed", "reversed"] }
            });
            
            const createdAt = new Date().toDateString();
            console.log("the order data is", todayOrders);
            if(todayOrders.length>0){
                const agentId=todayOrders[0].agent_id;
                console.log("the agent Id is",agentId);
                
                //fetch the agents data from the user table
                const agent_data = await Users.findOne({ _id: agentId });
                console.log("the agent data is",agent_data);
                var today_Date = new Date().toISOString().slice(0, 10); 
                var [year, month, day] = today_Date.split("-");
                var db_date = `${day}-${month}-${year}`;
                const Daily_wages=agent_data.Daily_wages;
                const agent_name=agent_data.name;
                console.log("the dailywages is",Daily_wages);
                //condition to check if the duplicate data will not entered
                const check_duplicate_entry=await agentData.find({
                    agent_Id:agentId,
                    Date:db_date,
                    Daily_wages: { $gt: 0 }

                })
                console.log()
                if(check_duplicate_entry.length>0){
                    return res.status(400).json({message:"No duplicate data entry"});
                }
                else{
                
                const agentdata=({
                    agent_Id:agentId,
                    Date:db_date,
                    Daily_wages:Daily_wages,
                    name:agent_name
                })
                const response=await agentData.create(agentdata);
                console.log(response);
                if(response){
                    return res.status(200).json({message:"Data inserted successfully"});
                }
                else{
                    return res.status(400).json({message:"Failed to insert data"});
                }
            }
            }
        }
    } catch (error) {
        console.log(error);
        return res.status(500).json({ message: "Internal server error" });
    }
}

export const calculatewages=async(req,res)=>{
    try{
       const {agentId}=req.params;
       console.log("the agent id is",agentId);
       const agent_data = await Users.find({ _id: agentId ,usertype:"agent"});
       if(!agent_data){
        return res.status(404).json({message:"Agent not found"});
       }
       //calculate the settled amount
       const total_settled_amount=await agentData.find({agent_Id:agentId,settlement_status:true,Daily_wages:{$gt:0}})
       const totalsettled_amount = total_settled_amount.reduce((total, record) => total + record.Daily_wages, 0);
       console.log("the settled amount is",totalsettled_amount);
       const totalunsettled_amount=await agentData.find({agent_Id:agentId,settlement_status:false,Daily_wages:{$gt:0}});
        console.log("the not settled amount is",totalunsettled_amount);
       const totalunsettled_wages = totalunsettled_amount.reduce((total, record) => total + record.Daily_wages, 0);
       console.log("the unsettled amount is",totalunsettled_wages);
       
      
       //fetch the agent details and check the advance there
       const agent_details = await Users.findOne({ _id: agentId });
       const advance=agent_details.Advance;
       console.log("the advance is",advance);
       const pending_amount=totalunsettled_wages-advance;
       console.log("the pending amount is",pending_amount);
    //    if(!totalsettled_amount||!totalunsettled_wages||!pending_amount){
    //     res.status(200).json({
    //         message: "No data found",
    //         totalsettled_amount:0,
    //         // totalunsettled_wages:0,
    //         pending_amount:0,
    //         advance:0
    //     })
    //    }
    //    else{
        res.status(200).json({
            message: "Data found",
            totalsettled_amount:totalsettled_amount,
            // totalunsettled_wages:totalunsettled_wages,
            pending_amount:totalunsettled_wages,
            advance:advance
        })
    //    }


    }catch(error){
        console.log(error);
        return res.status(500).json({ message: "Internal server error" });
    }
}
export const getDailyPaymentHistory=async(req,res)=>{
    try{
         const{agentId}=req.params;
         const agent_data=await agentData.find({agent_Id:agentId,Daily_wages:{$gt:0},settlement_status:false});
         if(!agent_data){
            return res.status(200).json({message:'History not found'});
         }
         console.log("the agent date is",agent_data);
         const filteredData = agent_data.map(record => ({
            _id: record._id,
            Date: record.Date,
            Daily_wages: record.Daily_wages
          }));
         if(filteredData){
            res.status(200).json({
                message: "Data found",
                data: filteredData
            })
         }
         else{
            res.status(200).json({
                message: "No data found", 
            })
         }

    }catch(error){
        console.log(error);
        return res.status(500).json({ message: "Internal server error" });
    }
}

//api for fetch the amount which is not settled to show in the admin side
export const getAllPaymentData=async(req,res)=>{
    try{ const limit = parseInt(req.query.limit) || 10; 
         const page = parseInt(req.query.offset) || 1; 
         console.log("the limit and the offset is",limit,page);
         const {agentId}=req.params;
         const skip = (page - 1) * limit;
         console.log("the agent id is",agentId);
         const unsettled_data=await agentData.find({agent_Id:new mongoose.Types.ObjectId(agentId)}) .sort({ createdAt: -1 }) 
         .skip(skip)
         .limit(limit);
         
         const totalData=unsettled_data.length;
         
         if(!unsettled_data){
            return res.status(200).json({message:'No unsettled data found',data:[]});
         }
         else{
            return res.status(200).json({message:'Unsettled data found',data:unsettled_data,total_data:totalData})
         }
    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error"});
    }
}
export const addAdvance=async(req,res)=>{
    try{
       const {agentId}=req.params;
       const {advance}=req.body;
       console.log("the advance data is",advance);
       const {mode_of_advance}=req.body;
       const {date}=req.body;
       console.log("the mode of advance given is",mode_of_advance);
       const user = await Users.findOne({ _id: new mongoose.Types.ObjectId(agentId) });
       if (user) {
        const previousAdvance = parseInt(user.Advance) || 0;
        const newAdvance = previousAdvance + (parseInt(advance) || 0);
  
      
        // Update the Advance field with the new value
        const update_advance_inuser = await Users.updateOne(
          { _id: new mongoose.Types.ObjectId(agentId) },
          { $set: { Advance: newAdvance } }
        );
      
        console.log("The updated advance in the user table is", update_advance_inuser);
      } else {
        console.log("User not found");
      }
       
    //    console.log("the advance data in the usertable is",update_advance_inuser);

       //add a advance doclument in the agentdata field
                var today_Date = new Date().toISOString().slice(0, 10); 
                var [year, month, day] = today_Date.split("-");
                var db_date = `${day}-${month}-${year}`;
                const newAdvance = previousAdvance + (parseInt(advance) || 0);
       const advance_inagentdata=({
        advance:newAdvance,
        Date:date,
        agent_Id:agentId,
        advance_mode:mode_of_advance,

       })
       const add_advance_totable=await agentData.create(advance_inagentdata);
       console.log("the advance data is ",add_advance_totable);
       if(add_advance_totable){
        return res.status(200).json({message:"Advance added successfully",data:add_advance_totable});
       }
       else{
        return res.status(400).json({message:"Failed to add advance"});
       }
    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error"})
    }
}
//api for get the advance history
export const getAdvanceHistory=async(req,res)=>{
    try{
        const{agentId}=req.params;
        const advancehistory=await agentData.find({agent_Id:agentId,advance: { $gt: 0 } }).sort({createdAt:-1})
        console.log("the advance history is",advancehistory);
        if(!advancehistory){
            return res.status(200).json({message:"No advance history found",data:[]})
        }
        else{
            return res.status(200).json({message:"Advance history found",data:advancehistory})
        }
    }catch(error){
        console.log(error);
        return res.status(500).json({message:'Internal server error'});
    }
}
//api to fetch the last settled amount
export const getLastSettlement = async (req, res) => {
    try {
      const { agentId } = req.params;
  
      // Find all settlements for the given agent with settlement_status true
      const settlements = await agentData
        .find({ agent_Id: agentId, settlement_status: true,Daily_wages:{$gt:0}})
        .sort({ settlement_date: -1 })
        .exec();
  
      if (settlements.length === 0) {
        return res.status(200).json({ message: "No settlement found for this agent" });
      }
  
      // Get the latest settlement date
      const latestDate = settlements[0].settlement_date;
  
      // Filter settlements to include only those with the latest date and calculate the total amount
      const latestSettlements = settlements.filter(
        (settlement) => settlement.settlement_date === latestDate
      );
      console.log("the latest settlement data is",latestSettlements);
  
      const totalAmount = latestSettlements.reduce((sum, settlement) => sum + settlement.Daily_wages, 0);
  
      return res.status(200).json({
        message: "Last settlement found",
        lastSettlement: [
            {
              totalAmount: totalAmount,
              date: latestDate,
            },
          ],
      });
    } catch (error) {
      console.log(error);
      return res.status(500).json({ message: "Internal server error" });
    }
  };
  //generate the ci and fa for the customer
  export const generateCIandFA = async(req,res)=>{
    try{
          const{agentId}=req.params;
          const {account_type,paymentdetails}=req.body;
        //   console.log("the mode of payment is",mode_of_payment);
          console.log("the payment details are",paymentdetails);
          console.log("the bank details account number is",paymentdetails.account_number);
          console.log("the ifsc code is",paymentdetails.IFSC_code);
          console.log("the account holder name is",paymentdetails.name);
        let requestData={};
        let payment = {};
          const auth = {
            username: apiKey,
            password: apiSecret,
        };
        const user_data=await Users.findById({_id:agentId});
        if(!user_data){
            return res.status(404).json({message:"User not found"});
        }
        console.log("the user data is",user_data);
        const name=user_data.name;
        const email=user_data.email;
        const mobile=user_data.mobile;
        if(!user_data.ci){
            if (!name || name.trim().length < 3) {
                return res.status(400).json({
                    isSuccess: false,
                    message: "Customer name must be at least 3 characters long and should not have trailing spaces.",
                });
            }
            const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
            if (!email || !emailRegex.test(email)) {
                return res.status(400).json({
                    isSuccess: false,
                    message: "Invalid email address found for the customer.",
                });
            }
            const mobileRegex = /^[0-9]{10}$/;
            if (!mobile || !mobileRegex.test(mobile)) {
                return res.status(400).json({
                    isSuccess: false,
                    message: "Invalid mobile number found for the customer. It must be 10 digits.",
                });
            }
            //generate the ci here
            const requestDataForCi = {
                name: name.trim(),
                email: email.trim(),
                contact: mobile,
            }; 
            try{
                 const ciResponse = await axios.post(`https://api.razorpay.com/v1/contacts`, requestDataForCi, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    auth: auth,
                });
                console.log('CI Generation Response is:', ciResponse.data);
                //set the ci after generation
                const update_user_data=await Users.findOneAndUpdate({_id:agentId},{ $set: { ci: ciResponse.data.id } })
                console.log("the update field after generating the ci is",update_user_data);

            } catch(error){
                console.log(error);
                return res.status(500).json({message:"Internal server Error in generating CI"});
            }
        }
        
            // return res.status(200).json({message:"ci found for the user",data:user_data.ci})
            const ci_in_user=user_data.ci;
            if(paymentdetails && account_type=='bank_account'){
                  requestData = {
                    contact_id: ci_in_user,
                    account_type: account_type,
                    bank_account: paymentdetails,
                };
                console.log("the requested data for the bank account detailks is",requestData);
            }
            else if (paymentdetails && account_type === "vpa") {
                console.log("the upi id is",paymentdetails.vpa);
                const existingPayment = await AgentPaymentdetails.findOne({ agent_Id:agentId, vpa:paymentdetails.vpa });
    
                if (existingPayment) {
                    return res.json({
                        isSuccess: true,
                        msg: "UPI already exists.",
                    });
                }
    
                requestData = {
                    contact_id: ci_in_user,
                    account_type: account_type,
                    vpa: paymentdetails.vpa,
                };
                console.log("the requested data is",requestData);

            }
            if (Object.keys(requestData).length !== 0) {
                const response = await axios.post(`https://api.razorpay.com/v1/fund_accounts`, requestData, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    auth: auth,
                });
    
                if (response) {
                    if (paymentdetails && account_type=='bank_account') {
                        payment = await AgentPaymentdetails.create({
                            agent_Id: new mongoose.Types.ObjectId(agentId),
                            ci: ci_in_user,
                            fa: response.data.id,
                            account_type: account_type,
                            bank_account: paymentdetails,
                            mode: "IMPS",
                            default: 1,
                        });
                    } else if (paymentdetails && account_type === "vpa") {
                        const countPayment = await AgentPaymentdetails.countDocuments({ agent_Id: agentId, mode: "UPI" });
                        console.log("countPayment", countPayment);
                        if (countPayment == 0) {
                            payment = await AgentPaymentdetails.create({
                                agent_Id: new mongoose.Types.ObjectId(agentId),
                                ci: ci_in_user,
                                fa: response.data.id,
                                account_type: account_type,
                                vpa: paymentdetails.vpa,
                                mode: "UPI",
                                default: 1,
                            });
                        } else {
                           
                                payment = await AgentPaymentdetails.create({
                                    agent_Id: new mongoose.Types.ObjectId(agentId),
                                    ci: ci_in_user,
                                    fa: response.data.id,
                                    account_type: account_type,
                                    vpa: paymentdetails.vpa,
                                    mode: "UPI",
                                    default: 0,
                            });
                        }
                        
                    }
    
                    if (payment) {
                        return res.json({
                            isSuccess: true,
                            message: `Payment ${account_type} details added.`,
                            fa: payment.fa,
                        });
                    } else {
                        return res.json({
                            isSuccess: false,
                            message: "Failed to add payment details.",
                        });
                    }
                }
            } else {
                return res.json({
                    isSuccess: false,
                    message: "No valid data provided.",
                });
            }


        
    }catch(error){
        console.log(error);
        return res.status(500).json({message:'Internal server error'});
    }
  }
  //api to fetch the account details and the payment details of the agent by Id
  export const getAccountDetailsOfAgent = async (req, res) => {
    try {
        const { agentId } = req.params;

        // Fetch all payment details for the agent with 'default: 1'
        const agent_account_details = await AgentPaymentdetails.find({ agent_Id: agentId, default: 1 });

        if (!agent_account_details.length) {
            return res.status(400).json({ message: "Account details not found for the agent" });
        }

        // Separate Bank and UPI details
        const bankDetails = agent_account_details.find(item => item.account_type === "bank_account") || null;
        const upiDetails = agent_account_details.find(item => item.account_type === "vpa") || null;

        return res.status(200).json({
            isSuccess: true,
            data: {
                bank: bankDetails ? bankDetails.bank_account : null,
                upi: upiDetails ? upiDetails.vpa : null
            }
        });

    } catch (error) {
        console.log(error);
        return res.status(500).json({ message: 'Internal server error' });
    }
};
//api for otp generation store in the database and send to the admin also
 export const sendotpToAdmin=async(req,res)=>{
    try{
          const {agentId}=req.params;
          const otp = Math.floor(1000 + Math.random() * 9000);
            console.log("the otp is",otp);
             await sendEmailToAdmin(otp);
            const otp_data={
                otp:otp,
                email:'neelima@ajatus.co.in'
            }
            const otp_details = await agentpaymentotp.findOneAndUpdate(
                { email: "neelima@ajatus.co.in" },        // Filter to match the document by email
                { $set: { otp: otp } }    // Update the otp field
                      // Options: return the updated document and do not insert a new document
              );
              if (!otp_details) {
                const create_otp=await agentpaymentotp.create(otp_data);
                if(create_otp){
                    return res.status(200).json({message:"otp sent to admin",isSuccess:true});
                }
              }
              
            console.log("the otp details is",otp_details);
            if(otp_details){
                return res.status(200).json({message:'OTP sent to the admin successfully',isSuccess:true})
            }
            else{
                return res.status(400).json({message:'Failed to send OTP to the admin',isSuccess:false})
            }


    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error"});
    }
 }

 //function for send the otp
 async function sendEmailToAdmin(otp) {
     var defaultClient = SibApiV3Sdk.ApiClient.instance;
     // Configure API key authorization: api-key
     var apiKey = defaultClient.authentications['api-key'];
     console.log("the api key is", apiKey)
     apiKey.apiKey = process.env.MAILAPIKEY;
     // console.log("the api key after this is", apiKey)
     // Uncomment below two lines to configure authorization using: partner-key
     // var partnerKey = defaultClient.authentications['partner-key'];
     // partnerKey.apiKey = 'YOUR API KEY';
     var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();
     var adminMail = new SibApiV3Sdk.SendSmtpEmail();
     const getIndianTime = () => {
         return new Date().toLocaleTimeString('en-IN', { 
             timeZone: 'Asia/Kolkata', 
             hour: '2-digit', 
             minute: '2-digit', 
             second: '2-digit', 
             hour12: false 
         });
     };
 
     try {
 
         adminMail = {
             to: [
                 
                    { email: 'gyanaranjan@ajatus.co.in'},
                    // { email: 'neelima@ajatus.co.in'},
                    // { email: 'omprakash.sadangi@ajatus.co.in'},
                     
                 
             ],
             from: {
                 email: 'support@ceibagreen.com'
             },
             templateId:40 ,
             params: {
                 otp:otp
             },
             subject: `Your payment verification otp is ${otp}`,
             headers: {
                 'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
             },
         }
         const data = await apiInstance.sendTransacEmail(adminMail);
         console.log("mail send  for verify by admin successfully", data.messageId);
         
     } catch (error) {
         console.log(error);
     }
 }
 //api for otp verification the otp which will be the admin enter
 export const verifyAdminOtp=async(req,res)=>{
    const {otp}=req.body;
    const verify_otp=await agentpaymentotp.find({otp:otp});
    if(verify_otp.length>0){
        return res.status(200).json({message:"otp verification successful"});
    }
    else{
        return res.status(400).json({message:"invalid otp"});
    }
 }
 //api for whole payment settlement for admin
 export const settleAllPayment=async(req,res)=>{
    try{
        const{agentId}=req.params;
        const {mode}=req.body;
        const {date}=req.body;
        console.log("the date coming from the frontend is",date);
        const date_toString=date.toString();
        console.log(typeof date_toString);
        
        console.log("the mode is",mode);
        const totalunsettled_amount=await agentData.find({agent_Id:agentId,settlement_status:false,Daily_wages:{$gt:0}});
        console.log("the not settled amount is",totalunsettled_amount);
       const totalunsettled_wages = totalunsettled_amount.reduce((total, record) => total + record.Daily_wages, 0);
       console.log("the unsettled amount is",totalunsettled_wages);

       const advance_ofAgent=await Users.findById({_id:agentId});
       console.log("the advance data os the agent is",advance_ofAgent);
       const advance=advance_ofAgent.Advance;
       console.log("the advance of agent is",advance);

       const total = Math.round(parseFloat(totalunsettled_wages) - parseFloat(advance));
       console.log("the total is",total);

       //now fetch the account details and the upi according to the mode which is coming
       const account_details=await Paymentdetails.find({agent_Id:agentId,mode:mode,default:1});
       console.log("the account details is",account_details);
       if(!account_details){
        return res.status(400).json({message:"account details not found"});
       }
       const payment_fa=account_details[0].fa;
       console.log("the payment fa is",payment_fa);

       const auth = {
        username: apiKey,
        password: apiSecret,
    };
      
    const requestData = {
        account_number: process.env.ACC_NO,
        // account_number: "4564566996247139",
        fund_account_id: payment_fa,
        // amount: req.body.est_price * 100,
        // amount: Math.round(req.body.est_price) * 100,
        // amount: parseInt((OrderID.est_price).toFixed(2) * 100),
        // amount: parseInt(parseFloat(OrderID.est_price).toFixed(2) * 100),
        amount:total,
        currency: "INR",
        mode: mode,
        purpose: "payout",
        notes: { notes: `payment from RecyclePay` },
        // purpose: ``,
    }
    try{
    const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
        headers: {
            'Content-Type': 'application/json',
            // 'X-Payout-Idempotency': idempotencyKey,
        },
        auth: auth,
    })
    console.log("the response is",response);
    if(response.status==200){
        console.log("the payment is successful");
        const update_agent_data = await agentData.updateMany(
            { agent_Id: agentId },
            [
              {
                $set: {
                  settlement_status: true,
                  settlement_date: {
                    $cond: {
                      if: { $gt: ["$settlement_date", null] }, // Check if settlement_date exists
                      then: "$settlement_date", // Keep existing value
                      else: date_toString // Set new value if null
                    }
                  },
                  paymentdetails: [
                    {
                      payment_date: response.data.created_at,
                      p_outId: response.data.id,
                      amount: response.data.amount
                    }
                  ]
                }
              }
            ]
          );
          
          
          console.log("the update agent data is",update_agent_data);
          const update_user_table=await Users.findOneAndUpdate({_id:agentId},{$set:{Advance:0}})
          console.log("the updated advance is",update_user_table);
          return res.status(200).json({message:"Payment successful"});
    }
    else{
        console.log("the payment is failed");
        return res.status(400).json({message:"Payment failed"});
    }
}catch(error){
    console.log("the error is",error);
}
    


    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error for agent settlement"});
    }
 }


 //api for single payment settlement for the agent
 export const  singlePaymentSettlement=async(req,res)=>{
    try{
        const{agentId}=req.params;
        const {mode}=req.body;
        const {paymentIds}=req.body;
        const {date}=req.body;
        const date_toString=date.toString();
        console.log("the payment ids is",paymentIds);

        const get_payment_data = await agentData.find({
            agent_Id: agentId,
            settlement_status: false,
             _id: { $in: paymentIds } 
          });
          
          const totalDailyWages = get_payment_data.reduce((accumulator, currentItem) => {
            return accumulator + parseInt(currentItem.Daily_wages, 10);
          }, 0);
          
          console.log("Total Daily Wages:", totalDailyWages);
          

          //get the account type of the agent according to the mode
          const get_account_type= await Paymentdetails.find({agent_Id:agentId,mode:mode,default:1})
          if(!get_account_type){
            return res.status(400).json({message:"Account Details not found"})
          }
          console.log("the payment details is",get_account_type);

          const fa=get_account_type[0].fa;
          console.log("the fa id is",fa);

          const auth = {
            username: apiKey,
            password: apiSecret,
        };
        const requestData = {
            account_number: process.env.ACC_NO,
            // account_number: "4564566996247139",
            fund_account_id: fa,
            amount:totalDailyWages,
            currency: "INR",
            mode: mode,
            purpose: "payout",
            notes: { notes: `payment from RecyclePay` },
            // purpose: ``,
        }
        try{
            const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
                headers: {
                    'Content-Type': 'application/json',
                    // 'X-Payout-Idempotency': idempotencyKey,
                },
                auth: auth,
            })
            if(response.status==200){
                console.log("payment is done");


                const update_agent_data = await agentData.updateMany(
                    { _id: { $in: paymentIds } },
                    [
                      {
                        $set: {
                          settlement_status: true,
                          settlement_date: {
                            $cond: {
                              if: { $gt: ["$settlement_date", null] }, 
                              then: "$settlement_date",
                              else: date_toString 
                            }
                          },
                          paymentdetails: [
                            {
                              payment_date: response.data.created_at,
                              p_outId: response.data.id,
                              amount: response.data.amount
                            }
                          ]
                        }
                      }
                    ]
                  );

                  console.log("the update agent data is for single settlement",update_agent_data);
                  return res.status(200).json({message:"Payment successful and data updated"})
                  

            }
            else{
               return res.status(500).json({message:"payment failed"})
            }
        }catch(error){
            console.log(error);
            return res.status(500).json({message:"Internal server error in razorpay"})
        }

         

    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error "});
    }
 }

  
  
  
