import mongoose from "mongoose";
import Carts from "../model/cart.model.js";

// Add to Cart in Customer-side
export const addCart = async (req, res) => {
    try {
        const { customer_id, item } = req.body;

        const getCart = await Carts.findOne({ customer_id: req.body.customer_id })
        console.log(getCart);
        if (getCart) {
            const cart = await Carts.findOneAndUpdate({ customer_id: req.body.customer_id }, { $set: { item: item } })
            if (cart) {
                return res.send({
                    isSuccess: true,
                    message: "Update add-to-cart products.",
                });
            } else {
                return res.send({
                    isSuccess: false,
                    message: "Failed to add-to-cart products.",
                });
            }
        } else {
            const cart = await Carts.create({
                customer_id: customer_id,
                item: item,
            });

            if (cart) {
                return res.send({
                    isSuccess: true,
                    message: "Create add-to-cart products.",
                });
            } else {
                return res.send({
                    isSuccess: false,
                    message: "Failed to add-to-cart products.",
                });
            }
        }

    } catch {
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }

}




// Get to Cart in Customer-side
export const getCart = async (req, res) => {
console.log(req.params.custid);
    // try {
        // const cart = await Carts.findOne({ customer_id: req.params.custid })
        const pipeline = [
            {
                $match: {
                    customer_id: new mongoose.Types.ObjectId(req.params.custid)
                }
            },
            {
                $unwind: "$item" // Unwind the "item" array
            },
            {
                $lookup: {
                    from: "items",
                    localField: "item.itemid",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $group: {
                    _id: "$_id",
                    customer_id: { $first: "$customer_id" },
                    item: {
                        $push: {
                            itemid: "$item.itemid",
                            weight: "$item.weight",
                            item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
                            price: { $arrayElemAt: ["$itemDetails.price", 0] },
                        }
                    },
                }
            },
            // {
            //     $sort: {
            //         "updatedAt": 1
            //     }
            // },
        ];



        const result = await Carts.aggregate(pipeline);
        console.log(result);
        if (result) {
            return res.send({
                isSuccess: true,
                data: result,
            });
        } else {
            return res.send({
                isSuccess: false,
                message: "Failed to get add-to-cart products.",
            });
        }
    // } catch {
    //     return res.send({
    //         isSuccess: false,
    //         message: "Something went wrong.",
    //     });
    // }

}








