import mongoose from "mongoose";
import CustomNotify from "../model/customNotify.model.js";
import Customers from "../model/customer.model.js";
import NotificationStatus from "../model/notificationStatus.model.js";
import Orders from "../model/order.model.js";
import Address from "../model/address.model.js";
import Location from "../model/location.model.js";
import NotifyCondition from "../model/notifyCondition.model.js";
import Items from "../model/items.model.js"
import Cart from "../model/cart.model.js";
import moment from "moment";
import multer from 'multer';
import axios from "axios";
import { google } from "googleapis";

import fetch from 'node-fetch';

const ObjectId = mongoose.Types.ObjectId;

const recyclemintKey = {
    "type": "service_account",
    "project_id": "recyclemint-a0a42",
    "private_key_id": "6554439ea4a8bc9f5461e4748ded2c21d2f6525e",
    "private_key": "-----BEGIN PRIVATE KEY-----\nMIIEvAIBADANBgkqhkiG9w0BAQEFAASCBKYwggSiAgEAAoIBAQCqAT1naKrMJ2bG\nu4CJXM1MnhAE+TgMN5hnIN4GqekwxZGAwldjlCA0rqdsun8NRekcy5F+jQm6F7OJ\nJqCytIPie39/vUUb9QFpGZBLvFGoF+RBne77WEdMUtIqQvBi6mrMLhe853WOlaGE\n8S0eMEmsDliCBNjg5E0AMA4q0F3knnq3euIPuYrk8yuODWNMlZ1bsCe+jFYN6Kng\nfk6Uo5cmJnt7HJXcmv0/a5TFjt9ndD4iuM9e2lIfiVmNag+j286p6CaKwJmDlmo0\nSka1sgG0BkYQd6cTWNrfJx09YuJ/XRTIJRB+bIwoYrQdp5gz9+2zYm0GgRwZu3Cd\nV0Lp4/EhAgMBAAECggEACpJsKp+YK3zxx78GRcSHIdIcheqnoR7d89/X3ss3LKjE\nnSC4xYEDJbOMxtasKvujfP5tzFRh+/gYWpmT2bkfEHkEm0F+aDgqv8nurr8FxvHB\naJE1ON0rBeSKnEUwZL5WKN9e64jrRxQoCLfkyeFP24rC10cM46Ne5HmYj/IIPLzC\nLUMBkIANTtni/JpIMJ7tFRf0U+6b8cW0GGIV1v6Mwr6hS4I9HdyGvPBH1/1gHSBY\n8/d+1Qm93QsoqAaBsqZElfR5Og5RpuTos6Aj7bHjdU2LzM0nRAJSMe2LhrnaZ3Nw\nTABbhjb65aFtmml0b7bDyRz3U5j2ONh0CxKPWXjv7wKBgQDlgimfahXyU4CfSvO9\ns+Ph3wCxwgHIfolqhysbfrJWCRVoed/BTBCbsIBm3C0HJX+zlXmdYro8n1wXganB\nc+sQIgYdblITrvSNiZ4iitejubUJ6nHhv3RhF2EmgXKk6nT2I9wkYO+iimxj1Ie8\naAxvzVSg3/ff4bYavkJnRrDzZwKBgQC9oMgFl09fuiub92RYn6DCfVe20WxQy2nO\n//3aKr2q7/EBSE9aSkYQb4qtwNppE3mbxkkZ5Ljq5QYcsPFZc+BVvg5/Kzi9mKwQ\nNCbQekMJozGJ5BID8YUMP3N1wlpjgKCnHBf096xkqdhWIy5Qvw/MbJ4uGwXey2dd\nQB+KktFqNwKBgAYuVDqj28Vz9EHV/ex8/MUngVhINk4VAlRpIYMTDXB9vCLdLWaC\nSuw2e67JfTj1DJRkkSro7sUVMaC8cDryiUEc+XcvcmxvSMzLCQQ7IwWYycRjmP+Q\nbWzz+TzVPaYtXksGujYMmkeRXMvvfFxZnQQhzoaqoX1ZEdN0jktDvx4/AoGATx8T\n9olA3C9g3M3nt7a7LAuCmsxdBoUpW+6iK/Kjevxssd1LBuBwxZDU61TJjQhMOHwO\nqlgt9AyldTk7KtjXpM8NW3BcV3epa4VnIJuy9wV5uRBJmA2hNxAOi/cRIe1cmv10\n3YiuDL51ftNlEtn1rJUxlwk9dM2oDlegEYDbEhcCgYB8qJAx+V4dsNtovf0RTzO6\nTEeh/eTtmxIxG4ekhbPNZ9OoyYbROsgxInQaBS3zQ4bXQPACaGRDX9aG1lvSINb1\nctJ1DhH57TM6oCu+U9rwkoVMHvmItNplpDH4gsHC6TnvKLqy0zLJVGXqcqtMf2Un\n10cxxRg0mjP0G/GMXY669A==\n-----END PRIVATE KEY-----\n",
    "client_email": "firebase-adminsdk-6w9gv@recyclemint-a0a42.iam.gserviceaccount.com",
    "client_id": "115816445007619551651",
    "auth_uri": "https://accounts.google.com/o/oauth2/auth",
    "token_uri": "https://oauth2.googleapis.com/token",
    "auth_provider_x509_cert_url": "https://www.googleapis.com/oauth2/v1/certs",
    "client_x509_cert_url": "https://www.googleapis.com/robot/v1/metadata/x509/firebase-adminsdk-6w9gv%40recyclemint-a0a42.iam.gserviceaccount.com",
    "universe_domain": "googleapis.com"
}


const Storage = multer.diskStorage({
    destination: 'uploads',
    filename: (req, res, cb) => {
        cb(null, Date.now() + "_" + (res.originalname).trim());
    }
});
const upload = multer({
    storage: Storage,
}).single('image');

// Add new custom notification
export const addNotification = async (req, res) => {
    upload(req, res, async (err) => {
        if (err) {
            console.error(err); // Log error for debugging purposes
            return res.status(500).json({ uploaded: false, error: 'File upload failed' });
        }

        try {
            const newNotification = new CustomNotify({
                title: req.body.title,
                content: req.body.content,
                date: req.body.date,
                time: req.body.time,
                conditionId: [
                    { _id: req.body.condition[0] },
                    { condition_name: req.body.condition[1] }
                ],
                cityid: req.body.cityid,
                itemId: req.body.itemId,
                status: req.body.status                 // status: sent / Not send
            });

            if (req.file) {
                newNotification.image = {
                    contentType: 'image',
                    data: req.file.filename
                };
                newNotification.imageURL = 'uploads/' + req.file.filename;
            }

            await newNotification.save();
            res.status(200).json({ uploaded: true });
        } catch (error) {
            console.error(error);
            res.status(500).json({ uploaded: false, error: 'Failed to save notification' });
        }
    });
};


// Get all Custom Notfications
export const getAllNotifications = async (req, res) => {
    // const allCustomNotify = await CustomNotify.find({ isDelete: false })
    // allCustomNotify.forEach((notification, index) => {
    //     console.log(`Date of Notification ${index + 1}:`, notification.date);
    //     const convertDate = new Date(notification.date);
    //     console.log(`Converted Date:`, convertDate);
    //   });

    //   const sortedNotifications = allCustomNotify.sort(
    //     (a, b) => new Date(b.date) - new Date(a.date)
    //   );
    const notificationData=await CustomNotify.aggregate([{
        $addFields: {
            // Create a new ISODate from the split date components
            formatDate: {
                $dateFromString: {
                    dateString: {
                        $concat: [
                            {
                                $arrayElemAt: [
                                    {
                                        $split: ["$date", "-"]
                                    },
                                    2
                                ]
                            }, // Year
                            "-",
                            {
                                $arrayElemAt: [
                                    {
                                        $split: ["$date", "-"]
                                    },
                                    1
                                ]
                            }, // Month
                            "-",
                            {
                                $arrayElemAt: [
                                    {
                                        $split: ["$date", "-"]
                                    },
                                    0
                                ]
                            } // Day
                        ]
                    }
                }
            }
        }
    },
    {
        $sort: {
            formatDate: -1 // Sort by the newly created formatDate field in ascending order
        }
    },
])
  
      console.log("Sorted Notifications:", notificationData);
    res.send({
        error: false,
        notificationData
    })
}


// Get particular notification by ID
export const getNotificationById = async (req, res) => {
    const notification = await CustomNotify.find({ _id: new ObjectId(req.params.id), isDelete: false });
    if (notification && notification.length != 0) {
        res.send({
            error: false,
            notification
        })
    } else {
        res.send({
            error: false,
            message: "notification not found !!"
        })
    }
}


// Edit custom notification
export const editNotification = async (req, res) => {
    upload(req, res, async (err) => {
        if (err) {
            console.log(err);
            return res.send({
                error: true,
                message: "File upload failed"
            });
        }

        const updateData = {
            $set: {
                "title": req.body.title, "content": req.body.content, "date": req.body.date, "condition": {
                    "_id": req.body.condition[0],
                    "condition_name": req.body.condition[1]
                }, "time": req.body.time, "cityid": req.body.cityid, "itemId": req.body.itemId, "status": req.body.status, "isActive": true, "isDelete": false
            }
        };

        if (req.file) {
            updateData.$set.image = {
                contentType: 'image',
                data: req.file.filename
            };
            updateData.$set.imageURL = 'uploads/' + req.file.filename;
        }

        try {
            const updateNotification = await CustomNotify.updateOne({ _id: new ObjectId(req.body._id) }, updateData);

            if (updateNotification) {
                console.log(updateNotification)
                res.status(200).json({ message: "update success" });
            } else {
                res.status(200).json({ message: "update failed" });
            }
        } catch (error) {
            console.error(error);
            return res.send({
                error: true,
                message: "Internal server error"
            });
        }

    });
};


// Activate the notification
export const activateNotification = async (req, res) => {
    try {
        const notification = await CustomNotify.findByIdAndUpdate({ _id: new ObjectId(req.params.id) }, { isActive: true }, { new: true });
        res.send({
            error: false,
            "Notification": notification
        });
    } catch (error) {
        console.error(error);
        res.send({ error: 'Internal Server Error' });
    }
};

// Deactivate the notification
export const deactivateNotification = async (req, res) => {
    try {
        const notification = await CustomNotify.findByIdAndUpdate({ _id: new ObjectId(req.params.id) }, { isActive: false }, { new: true });
        res.send({
            error: false,
            "Notification": notification
        });
    } catch (error) {
        console.error(error);
        res.send({ error: 'Internal Server Error' });
    }
};


// Function to send specific notifications to all customer devices  (General)
async function notificationToAllCustomers(notificationId) {
    try {
        const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
        const jwtClient = new google.auth.JWT(
            recyclemintKey.client_email,
            null,
            recyclemintKey.private_key,
            SCOPES,
            null
        );

        const token = await new Promise((resolve, reject) => {
            jwtClient.authorize((err, token) => {
                if (err) {
                    console.error('Authorization failed:', err);
                    reject(err);
                } else {
                    resolve(token);
                }
            });
        });

        const notifications = await CustomNotify.find({ _id: notificationId });

        console.log("notifications", notifications);

        if (!notifications || notifications.length === 0) {
            console.error('No notifications found.');
            return;
        }

        const accessToken = token.access_token;
        const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

        // const tokens = [
        //     "d8hVOYFZQ66oIZ_OWPKBGP:APA91bHGCVI03ayXxJWyET4-_q5gH1-l8uW_rrslQSKX80QyJyUNIfH-Rcps8xwQ4enyqhgXOXg__e_1y_NFr8PZyVBqsRMuBRO6mlYGffziFVKIFtNAQzR98AccBgKCRssGqkZmHCUK",
        //     "crK46igjR4CzcTC6vDr9ES:APA91bFMVFCN8g3Q_FS8Y2zKl5wUVq_5jUnPifw1HsjMEkaNNTZY6wFcIVu_k_1NbwpJYE6o-f1CzQhOkU8LJSTQsWxpZurSPz9ls7LAtJc0erkmy6UzlEbtTmhpwaweMq0Wr_FapMlz",
        //     "e8kzs1_VR5u15Bkz3e2p5t:APA91bHbum_QdmieAlUCsRNB3yx1DIATfiKFxA1vV0cswQkPFDRSujEVdbeokypzQohnA7At_SkWZbF49EH7DJi2WPB1WjLoflwUHf5d20gfmlR8B89L0Wz6_m3G6lUs5uB9UzMhAo34"
        // ];

        const devices = await Customers.find({ token: { $exists: true, $ne: null } }, 'token');
        if (!devices || devices.length === 0) {
            console.error('No any tokens available in customer table  ............');
            return;
        }
        // console.log("devices", devices);

        // const registrationTokens = tokens;

        const registrationTokens = devices.map(device => device.token).filter(token => token !== undefined);
        const customerID = devices.map(device => ({ _id: device._id }));
        console.log("customerID  :  ", customerID);

        for (let i = 0; i < registrationTokens.length; i++) {
            // const notificationData = {
            //     title: "Hii!!",
            //     body: "Good Afternoon Everyone!!",
            //     image: "https://i.pinimg.com/736x/26/84/3f/26843f7ab80385301c592c5078447874.jpg"
            // };
            
            const customer = await Customers.findById(customerID[i]._id);

            // console.log("customer data is :  ", customer);
            console.log("customer id is : ", customer.id);

            const customerName = customer.name;
            console.log("customer Name is: ", customerName);

            const notificationData = {
                title: notifications[0]?.title,
                body: notifications[0]?.content,
                image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
            };
            console.log("notificationData.image  ----------", notificationData.image);

            const message = {
                message: {
                    token: registrationTokens[i],
                    data: {
                        title: notificationData.title,
                        body: notificationData.body,
                        image: notificationData.image,
                        condition: notifications[0].conditionId[1].condition_name
                    },
                    notification: notificationData,
                },
            };

            console.log(`Sending notification to ${customer.name}`, notifications[0].conditionId[1].condition_name);
            console.log(`message with index: ${i}`, message);

            try {
                const response = await axios.post(api, message, {
                    headers: {
                        'Authorization': `Bearer ${accessToken}`,
                        'Content-Type': 'application/json',
                    },
                });

                console.log(`Notification sent to: ${customerName} and token number is: ${registrationTokens[i]} successfully:`, response.data);
            } catch (error) {
                if (error.response) {
                    console.log(`Notification Not sent to : ${customerName}`);
                    console.log('Error Response:', error.response.data);
                    console.error('Error sending notification:', error.response.data);
                } else {
                    console.log("Catch error not getting , issue in setup.................");
                    console.log('Error during request setup:', error.message);
                    console.error('Error sending notification:', error.message);
                }

                // If an error occurs while sending notification, save the status to the database
                await saveNotificationStatus(
                    customer.id,
                    customer.name,
                    registrationTokens[i],
                    notificationId,
                    notifications[0].title,
                    error.message
                );

            }
        }

    } catch (error) {
        console.error('Error sending notifications:', error);
    }
}

// API to call function "notificationToAllCustomers"    (General)
export const notifyMultipleCustomers = async (req, res) => {
    try {
        const notificationId = req.body._id;
        if (notificationId) {
            notificationToAllCustomers(notificationId);
            // console.log("notificationId", notificationId);

            // // If the notifications are successfully sent, update the status to 'sent'
            await CustomNotify.updateOne(
                { _id: notificationId },
                { $set: { status: 'Sent' } }
            );

            res.status(200).json({
                error: false,
                message: 'notification sent successfully'
            });
        } else {
            res.status(500).json({
                error: true,
                message: 'notification ID required'
            });
        }
    } catch (err) {
        console.error(err);
        res.status(500).send({ error: 'Internal server error' });
    }
};

// Function for "Signed up but No Order since 10 days"   (Conditional)
async function signupButNoOrder(notificationId) {
    try {
        const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
        const jwtClient = new google.auth.JWT(
            recyclemintKey.client_email,
            null,
            recyclemintKey.private_key,
            SCOPES,
            null
        );

        const token = await new Promise((resolve, reject) => {
            jwtClient.authorize((err, token) => {
                if (err) {
                    console.error('Authorization failed:', err);
                    reject(err);
                } else {
                    resolve(token);
                }
            });
        });

        const notifications = await CustomNotify.find({ _id: notificationId });

        console.log("notifications", notifications);

        if (!notifications || notifications.length === 0) {
            console.error('No notifications found.');
            return;
        }

        const accessToken = token.access_token;
        const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

        const devices = await Customers.find({ token: { $exists: true, $ne: null } }, 'token');
        if (!devices || devices.length === 0) {
            console.error('No any tokens available in customer table  ............');
            return;
        }
        // console.log("devices", devices);

        // const registrationTokens = tokens;

        const registrationTokens = devices.map(device => device.token).filter(token => token !== undefined);
        const customerID = devices.map(device => ({ _id: device._id }));
        console.log("customerID  :  ", customerID);

        const today = moment().subtract(10, 'days'); // 10 days ago
        console.log("today", today.format('DD-MM-YYYY'));

        for (let i = 0; i < registrationTokens.length; i++) {
            // const notificationData = {
            //     title: "Hii!!",
            //     body: "Good Afternoon Everyone!!",
            //     image: "https://i.pinimg.com/736x/26/84/3f/26843f7ab80385301c592c5078447874.jpg"
            // };

            const notificationData = {
                title: notifications[0]?.title,
                body: notifications[0]?.content,
                image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
            };

            console.log("notifications", notificationData);

            // const customers = await Customers.find({ token: registrationTokens }).lean().exec();
            // console.log("customers", customers);

            const customer = await Customers.findById(customerID[i]._id);

            console.log("customer id is : ", customer.id);

            const customerName = customer.name;
            console.log("customer Name is: ", customerName);

            const lastOrder = await Orders.findOne({ customer_id: customer._id }).sort({ createdAt: -1 }).lean().exec();

            console.log("last order", lastOrder);

            let lastOrderDate;
            if (lastOrder && lastOrder.schedule_date) {
                lastOrderDate = moment(lastOrder.schedule_date, 'DD-MM-YYYY');
            }

            const signUpDate = moment(customer.createdAt).startOf('day');

            console.log("last order date", lastOrderDate ? lastOrderDate.format('DD-MM-YYYY') : 'N/A');
            console.log("signup date", signUpDate.format('DD-MM-YYYY'));

            if (!lastOrder && signUpDate.isSameOrAfter(today.startOf('day'))) {
                const message = {
                    message: {
                        token: customer.token,
                        data: {
                            title: notificationData.title,
                            body: notificationData.body,
                            image: notificationData.image,
                            condition: notifications[0].conditionId[1].condition_name
                        },
                        notification: notificationData,
                    },
                };

                console.log(`Sending notification to ${customer.name}`);
                console.log(`message with index :  ${[i]} `, message);

                try {
                    const response = await axios.post(api, message, {
                        headers: {
                            'Authorization': `Bearer ${accessToken}`,
                            'Content-Type': 'application/json',
                        },
                    });

                    console.log(`Notification sent to ${customer.name} and token number is: ${customer.token} successfully:`, response.data);
                } catch (error) {
                    console.log(`Notification not sent to ${customer.name}`);
                    console.error('Error sending notification:', error.response ? error.response.data : error.message);

                    await saveNotificationStatus(
                        customer._id,
                        customer.name,
                        customer.token,
                        notificationId,
                        notifications[0].title,
                        error.message
                    );
                }
            } else if (lastOrder && moment(lastOrder.createdAt).startOf('day').isSameOrAfter(today.startOf('day'))) {
                console.log(`Skipping ${customer.name} as they have recent orders.`);
            } else {
                console.log(`No orders found for ${customer.name}`);
            }
        }
    } catch (error) {
        console.error('Error sending notifications:', error);
    }
};


// API to call function "signupButNoOrder"    (Conditional)
export const notifySignupButNoOrderCust = async (req, res) => {
    try {
        const notificationId = req.body._id;
        if (!notificationId) {
            return res.status(400).json({
                error: true,
                message: 'Notification ID required'
            });
        }

        // Check if the notification exists
        const notification = await CustomNotify.findById(notificationId);
        if (!notification) {
            return res.status(404).json({
                error: true,
                message: 'Notification not found'
            });
        }

        // Get the current date
        const currentDate = new Date();

        // Calculate the next date
        const nextDate = new Date(currentDate);
        nextDate.setDate(nextDate.getDate() + 1);

        // Format the next date to DD-MM-YYYY
        const formattedDate = `${nextDate.getDate().toString().padStart(2, '0')}-${(nextDate.getMonth() + 1).toString().padStart(2, '0')}-${nextDate.getFullYear()}`;
        console.log("formattedDate", formattedDate);
        // Update the notification date to the next date
        await CustomNotify.updateOne(
            { _id: notificationId },
            { $set: { date: formattedDate } }
        );

        // Call the function to send notifications
        await signupButNoOrder(notificationId);

        return res.status(200).json({
            error: false,
            message: 'Notification sent successfully'
        });
    } catch (err) {
        console.error(err);
        return res.status(500).json({
            error: true,
            message: 'Internal server error'
        });
    }
};


//  Function for "Last order 20 Days Ago"   (Conditional)
async function lastOrder20DaysAgo(notificationId) {
    try {
        const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
        const jwtClient = new google.auth.JWT(
            recyclemintKey.client_email,
            null,
            recyclemintKey.private_key,
            SCOPES,
            null
        );

        const token = await new Promise((resolve, reject) => {
            jwtClient.authorize((err, token) => {
                if (err) {
                    console.error('Authorization failed:', err);
                    reject(err);
                } else {
                    resolve(token);
                }
            });
        });

        const notifications = await CustomNotify.find({ _id: notificationId });

        console.log("notifications", notifications);

        if (!notifications || notifications.length === 0) {
            console.error('No notifications found.');
            return;
        }

        const accessToken = token.access_token;
        const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

        // const tokens = [
        //     "fyPI-HXRSkKko9tf2CeVXJ:APA91bHRintuUmixm12sEmAXPadPMHnMBiuLiRwTVT2WCg5ms5DWNS2zMO5FM4blauvW4ywvITQ2Dsj3W_UtLOv18B6zI1OO15pA_hKWgAJqOyYPEMGPS0n-nQbfGmWeqa350dPZjTwy",
        //     "ecZdmoseQe24MY8GIKCxPt:APA91bGNekkpR3c1gL_rLRs1sDL4ACuVxcScMmjXPjrnZ0mNIKPLmDJLfmOjXeOU7herwUjhp2gXsxnptrG3H0iUspc8eBnAfgw_RuI1-hGKGuoX_TRrvhuhi2OG0BHU-5RV846iPSPJ",
        //     "d2XG2DqTT42Hqko_15dhCn:APA91bGKQSgX1ndL-ye0WhaTOICZNU513CJvTo-00RyDQN1qfbzQCfyLilqhJc2BEQ7zMFQwjBwxtxi5PUVUokD_Rl1Qw8x0DrW5Joc24L0zgPQnFBSURHiZxTKrIR5M-g4fWPbd6jQt",
        //     "fshZVfc2To2J6nHuwSdSHw:APA91bEDC0bcWhrxZnTBr3yVJ4JCBkRPheiW8lgmW9xc_rxo9spkkN48HG2PFYIKpNa6nE1aWtCs4aIQbtQBfT1j4MlZOjhiJbTLrGkpPOsKhOk5lXOYpZwT1O7cqDdkPknIJfMPOF_I"
        // ];

        // const registrationTokens = Array.from(new Set(tokens)); // Remove duplicates

        const devices = await Customers.find({ token: { $exists: true, $ne: null } }, 'token');
        if (!devices || devices.length === 0) {
            console.error('No any tokens available in customer table  ............');
            return;
        }
        // console.log("devices", devices);

        // const registrationTokens = tokens;

        const registrationTokens = devices.map(device => device.token).filter(token => token !== undefined);
        const customerID = devices.map(device => ({ _id: device._id }));
        console.log("customerID  :  ", customerID);

        const today = moment().startOf('day');
        const lastOrderDateThreshold = moment().subtract(20, 'days').startOf('day');

        console.log("today", today.format('DD-MM-YYYY'));
        console.log("lastOrderDateThreshold", lastOrderDateThreshold.format('DD-MM-YYYY'));

        for (let i = 0; i < registrationTokens.length; i++) {
            // const notificationData = {
            //     title: "Hii!!",
            //     body: "Good Afternoon Everyone!!",
            //     image: "https://i.pinimg.com/736x/26/84/3f/26843f7ab80385301c592c5078447874.jpg"
            // };

            const notificationData = {
                title: notifications[0]?.title,
                body: notifications[0]?.content,
                image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
            };

            console.log("notifications", notificationData);

            // const customers = await Customers.find({ token: registrationTokens }).lean().exec();
            // console.log("customers", customers);

            const customer = await Customers.findById(customerID[i]._id);

            console.log("customer id is : ", customer.id);

            const customerName = customer.name;
            console.log("customer Name is: ", customerName);

            const lastOrder = await Orders.findOne({ customer_id: customer._id }).sort({ createdAt: -1 }).lean().exec();

            console.log("last order", lastOrder);

            let lastOrderDate;
            if (lastOrder && lastOrder.schedule_date) {
                lastOrderDate = moment(lastOrder.schedule_date, 'DD-MM-YYYY').startOf('day');
            }

            console.log("last order date", lastOrderDate ? lastOrderDate.format('DD-MM-YYYY') : 'N/A');

            if (lastOrderDate && lastOrderDate.isSame(lastOrderDateThreshold)) {
                const message = {
                    message: {
                        token: customer.token,
                        data: {
                            title: notificationData.title,
                            body: notificationData.body,
                            image: notificationData.image,
                            condition: notifications[0].conditionId[1].condition_name
                        },
                        notification: notificationData,
                    },
                };
                console.log(`Sending notification to ${customer.name}`);
                console.log(`message with index :  ${[i]} `, message);

                try {
                    const response = await axios.post(api, message, {
                        headers: {
                            'Authorization': `Bearer ${accessToken}`,
                            'Content-Type': 'application/json',
                        },
                    });

                    console.log(`Notification sent to ${customer.name} and token number is: ${customer.token} successfully:`, response.data);
                } catch (error) {
                    console.log(`Notification not sent to ${customer.name}`);
                    console.error('Error sending notification:', error.response ? error.response.data : error.message);

                    await saveNotificationStatus(
                        customer._id,
                        customer.name,
                        customer.token,
                        notificationId,
                        notifications[0].title,
                        error.message
                    );
                }
            } else if (lastOrder && moment(lastOrder.createdAt).startOf('day').isSameOrAfter(today.startOf('day'))) {
                console.log(`Skipping ${customer.name} as they have recent orders.`);
            } else {
                console.log(`No orders found for ${customer.name}`);
            }

        }
    } catch (error) {
        console.error('Error sending notifications:', error);
    }
};

// API to call the function  "notifyOrder20DaysAgoCust"    (Conditional)
export const notifyOrder20DaysAgoCust = async (req, res) => {
    try {
        const notificationId = req.body._id;
        if (!notificationId) {
            return res.status(400).json({
                error: true,
                message: 'Notification ID required'
            });
        }

        // Check if the notification date needs to be updated
        const notification = await CustomNotify.findById(notificationId);
        if (!notification) {
            return res.status(404).json({
                error: true,
                message: 'Notification not found'
            });
        }

        // Get the current date
        const currentDate = new Date();

        // Calculate the next date
        const nextDate = new Date(currentDate);
        nextDate.setDate(nextDate.getDate() + 1);

        // Format the next date to DD-MM-YYYY
        const formattedDate = `${nextDate.getDate().toString().padStart(2, '0')}-${(nextDate.getMonth() + 1).toString().padStart(2, '0')}-${nextDate.getFullYear()}`;
        console.log("formattedDate", formattedDate);
        // Update the notification date to the next date
        await CustomNotify.updateOne(
            { _id: notificationId },
            { $set: { date: formattedDate } }
        );

        // Call the function to send notifications
        await lastOrder20DaysAgo(notificationId);

        // Update the status to 'Sent' after sending notifications
        await CustomNotify.updateOne(
            { _id: notificationId },
            { $set: { status: 'Sent' } }
        );

        return res.status(200).json({
            error: false,
            message: 'Notifications sent successfully'
        });
    } catch (err) {
        console.error(err);
        return res.status(500).json({
            error: true,
            message: 'Internal server error'
        });
    }
};


//  Function for "New Item Added Notification"   (Conditional)
async function sendItemNotification(notificationId) {
    try {
        console.log(`Processing notification with ID: ${notificationId}`);

        const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
        const jwtClient = new google.auth.JWT(
            recyclemintKey.client_email,
            null,
            recyclemintKey.private_key,
            SCOPES,
            null
        );

        const token = await new Promise((resolve, reject) => {
            jwtClient.authorize((err, token) => {
                if (err) {
                    console.error('Authorization failed:', err);
                    reject(err);
                } else {
                    resolve(token);
                }
            });
        });

        const notifications = await CustomNotify.find({ _id: notificationId });

        console.log("notifications", notifications);

        if (!notifications || notifications.length === 0) {
            console.error('No notifications found.');
            return;
        }

        const accessToken = token.access_token;
        const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

        const notificationData = {
            title: notifications[0]?.title,
            body: notifications[0]?.content,
            image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
        };

        console.log("Notification data:", notificationData);

        const notification = notifications[0];
        const cityId = notification.cityid;
        const itemId = notification.itemId;

        if (!cityId) {
            console.error('City ID not found in the notification condition.');
            return;
        }

        console.log("City ID:", cityId);

        if (!itemId) {
            console.error('Item ID not found in the notification condition.');
            return;
        }
        console.log("Item ID:", itemId);
        
        // const tokens = [
        //     "fyPI-HXRSkKko9tf2CeVXJ:APA91bHRintuUmixm12sEmAXPadPMHnMBiuLiRwTVT2WCg5ms5DWNS2zMO5FM4blauvW4ywvITQ2Dsj3W_UtLOv18B6zI1OO15pA_hKWgAJqOyYPEMGPS0n-nQbfGmWeqa350dPZjTwy",
        //     "ecZdmoseQe24MY8GIKCxPt:APA91bGNekkpR3c1gL_rLRs1sDL4ACuVxcScMmjXPjrnZ0mNIKPLmDJLfmOjXeOU7herwUjhp2gXsxnptrG3H0iUspc8eBnAfgw_RuI1-hGKGuoX_TRrvhuhi2OG0BHU-5RV846iPSPJ",
        //     "d2XG2DqTT42Hqko_15dhCn:APA91bGKQSgX1ndL-ye0WhaTOICZNU513CJvTo-00RyDQN1qfbzQCfyLilqhJc2BEQ7zMFQwjBwxtxi5PUVUokD_Rl1Qw8x0DrW5Joc24L0zgPQnFBSURHiZxTKrIR5M-g4fWPbd6jQt",
        //     "fshZVfc2To2J6nHuwSdSHw:APA91bEDC0bcWhrxZnTBr3yVJ4JCBkRPheiW8lgmW9xc_rxo9spkkN48HG2PFYIKpNa6nE1aWtCs4aIQbtQBfT1j4MlZOjhiJbTLrGkpPOsKhOk5lXOYpZwT1O7cqDdkPknIJfMPOF_I"
        // ];

        // const registrationTokens = Array.from(new Set(tokens)); // Remove duplicates

        const devices = await Customers.find({ token: { $exists: true, $ne: null } }, 'token');
        if (!devices || devices.length === 0) {
            console.error('No any tokens available in customer table  ............');
            return;
        }
        // console.log("devices", devices);

        // const registrationTokens = tokens;

        const registrationTokens = devices.map(device => device.token).filter(token => token !== undefined);
        const customerID = devices.map(device => ({ _id: device._id }));
        console.log("customerID  :  ", customerID);


        for (const token of registrationTokens) {
            const customer = await Customers.findOne({ token }).lean().exec();
            console.log("customer", customer);
            if (customer) {
                const address = await Address.findOne({ customer_Id: customer._id, isDelete: false }).lean().exec();
                console.log("address", address);
                if (address) {
                    const location = await Location.findOne({ PIN: address.PIN, cityid: cityId }).lean().exec();
                    console.log("location", location);
                    if (location) {
                        const message = {
                            message: {
                                token: customer.token,
                                data: {
                                    title: notificationData.title,
                                    body: notificationData.body,
                                    image: notificationData.image,
                                    condition: notifications[0].conditionId[1].condition_name,
                                    Item: itemId
                                },
                                notification: notificationData,
                            },
                        };
                        console.log(`Sending notification to ${customer.name}`);
                        try {
                            const response = await axios.post(api, message, {
                                headers: {
                                    'Authorization': `Bearer ${accessToken}`,
                                    'Content-Type': 'application/json',
                                },
                            });

                            console.log(`Notification sent to ${customer.name} with token number: ${customer.token} successfully:`, response.data);
                        } catch (error) {
                            console.log(`Error sending notification to ${customer.name}:`, error.response ? error.response.data : error.message);

                            await saveNotificationStatus(
                                customer._id,
                                customer.name,
                                customer.token,
                                notificationId,
                                notifications[0].title,
                                error.message
                            );
                        }
                    }
                } else {
                    console.log(`No location found for customer ${customer.name} with PIN ${address.PIN} and city ID ${cityId}. Skipping notification.`);
                }
            } else {
                console.log(`Customer with token ${token} not found in database.`);
            }
        }
    } catch (error) {
        console.error('Error sending notifications:', error);
    }
}


// async function sendItemNotification(notificationId) {
//     try {
//         console.log(`Processing notification with ID: ${notificationId}`);

//         const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
//         const jwtClient = new google.auth.JWT(
//             recyclemintKey.client_email,
//             null,
//             recyclemintKey.private_key,
//             SCOPES,
//             null
//         );

//         const token = await new Promise((resolve, reject) => {
//             jwtClient.authorize((err, token) => {
//                 if (err) {
//                     console.error('Authorization failed:', err);
//                     reject(err);
//                 } else {
//                     resolve(token);
//                 }
//             });
//         });

//         const accessToken = token.access_token;
//         const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

//         const notifications = await CustomNotify.find({ _id: notificationId });
//         if (!notifications || notifications.length === 0) {
//             console.error('No notifications found for ID:', notificationId);
//             return;
//         }

//         const notificationData = {
//             title: notifications[0]?.title,
//             body: notifications[0]?.content,
//             image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
//         };

//         console.log("Notification data:", notificationData);

//         const cityId = notification.condition[2]; // Assuming notification is accessible here
//         console.log("City ID:", cityId);

//         const addressCustomerIds = await Address.find({ cityid: cityId }).distinct('customer_id').lean().exec();
//         console.log("Found unique customer IDs from Address:", addressCustomerIds.length);

//         const customers = await Customers.find({ _id: { $in: addressCustomerIds } }).lean().exec();
//         console.log("Found customers:", customers.length);

//         for (const customer of customers) {
//             const message = {
//                 message: {
//                     token: customer.token,
//                     data: notificationData,
//                     notification: notificationData,
//                 },
//             };

//             console.log(`Sending notification to ${customer.name}`);

//             try {
//                 const response = await axios.post(api, message, {
//                     headers: {
//                         'Authorization': `Bearer ${accessToken}`,
//                         'Content-Type': 'application/json',
//                     },
//                 });

//                 console.log(`Notification sent to ${customer.name} with token number: ${customer.token} successfully:`, response.data);
//             } catch (error) {
//                 console.log(`Error sending notification to ${customer.name}:`, error.response ? error.response.data : error.message);

//                 await saveNotificationStatus(
//                     customer._id,
//                     customer.name,
//                     customer.token,
//                     notificationId,
//                     notifications[0].title,
//                     error.message
//                 );
//             }
//         }

//         // If the notifications are successfully sent, update the status to 'sent'
//         await CustomNotify.updateOne(
//             { _id: notificationId },
//             { $set: { status: 'Sent' } }
//         );

//     } catch (error) {
//         console.error('Error sending notifications:', error);
//     }
// }


// API to call the function  "sendNewItemNotification"    (Conditional)
export const notifyNewItemAdded = async (req, res) => {
    try {
        const notificationId = req.body._id;
        if (notificationId) {
            await sendItemNotification(notificationId);

            // If the notifications are successfully sent, update the status to 'Sent'
            await CustomNotify.updateOne(
                { _id: notificationId },
                { $set: { status: 'Sent' } }
            );

            res.status(200).json({
                error: false,
                message: 'Notifications sent successfully'
            });
        } else {
            res.status(500).json({
                error: true,
                message: 'Notification ID required'
            });
        }
    } catch (err) {
        console.error(err);
        res.status(500).send({ error: 'Internal server error' });
    }
};

//  Function for "send Cart Notification"   (Conditional)
async function sendCartNotification(notificationId) {
    try {
        const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
        const jwtClient = new google.auth.JWT(
            recyclemintKey.client_email,
            null,
            recyclemintKey.private_key,
            SCOPES,
            null
        );

        const token = await new Promise((resolve, reject) => {
            jwtClient.authorize((err, token) => {
                if (err) {
                    console.error('Authorization failed:', err);
                    reject(err);
                } else {
                    resolve(token);
                }
            });
        });

        const accessToken = token.access_token;
        const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';


        const notifications = await CustomNotify.find({ _id: notificationId });
        if (!notifications || notifications.length === 0) {
            console.error('No notifications found.');
            return;
        }

        const notificationData = {
            title: notifications[0]?.title,
            body: notifications[0]?.content,
            image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
        };

        console.log("notifications", notificationData);


        // Find carts created more than 24 hours ago
        const twentyFourHoursAgo = moment().subtract(24, 'hours');
        const carts = await Cart.find({ createdAt: { $lt: twentyFourHoursAgo } }).lean().exec();

        console.log("Carts to notify:", carts);

        for (const cart of carts) {
            const customer = await Customers.findOne({ _id: cart.customer_id }).lean().exec();

            if (!customer) {
                console.log(`Customer not found for cart ID ${cart._id}`);
                continue;
            }

            console.log("conditionId", notifications[0].conditionId);
            console.log("conditionId[0]._id", notifications[0].conditionId[0]._id);
            console.log("condition_name", notifications[0].conditionId[1].condition_name);

            const message = {
                message: {
                    token: customer.token,
                    data: {
                        title: notificationData.title,
                        body: notificationData.body,
                        image: notificationData.image,
                        condition: notifications[0].conditionId[1].condition_name
                    },
                    notification: notificationData,
                },
            };
            console.log("message", message);
            console.log(`Sending notification to ${customer.name}`);

            try {
                const response = await axios.post(api, message, {
                    headers: {
                        'Authorization': `Bearer ${accessToken}`,
                        'Content-Type': 'application/json',
                    },
                });

                console.log(`Notification sent to ${customer.name} and token number is: ${customer.token} successfully:`, response.data);
            } catch (error) {
                console.log(`Notification not sent to ${customer.name}`);
                console.error('Error sending notification:', error.response ? error.response.data : error.message);

                await saveNotificationStatus(
                    customer._id,
                    customer.name,
                    customer.token,
                    notificationId,
                    notifications[0].title,
                    error.message
                );
            }
        }
    } catch (error) {
        console.error('Error sending notifications:', error);
    }
}

// API to call the function  "notify Cart Items"    (Conditional)
export const notifyCartItems = async (req, res) => {
    try {
        const notificationId = req.body._id;
        if (!notificationId) {
            return res.status(400).json({
                error: true,
                message: 'Notification ID required'
            });
        }

        // Check if the notification date needs to be updated
        const notification = await CustomNotify.findById(notificationId);
        if (!notification) {
            return res.status(404).json({
                error: true,
                message: 'Notification not found'
            });
        }

        // Get the current date
        const currentDate = new Date();

        // Calculate the next date
        const nextDate = new Date(currentDate);
        nextDate.setDate(nextDate.getDate() + 1);

        // Format the next date to DD-MM-YYYY
        const formattedDate = `${nextDate.getDate().toString().padStart(2, '0')}-${(nextDate.getMonth() + 1).toString().padStart(2, '0')}-${nextDate.getFullYear()}`;
        console.log("formattedDate", formattedDate);
        // Update the notification date to the next date
        await CustomNotify.updateOne(
            { _id: notificationId },
            { $set: { date: formattedDate } }
        );

        // Call the function to send notifications
        await sendCartNotification(notificationId);

        // Update the status to 'Sent' after sending notifications
        await CustomNotify.updateOne(
            { _id: notificationId },
            { $set: { status: 'Sent' } }
        );

        return res.status(200).json({
            error: false,
            message: 'Notifications sent successfully'
        });
    } catch (err) {
        console.error(err);
        return res.status(500).json({
            error: true,
            message: 'Internal server error'
        });
    }
};


//  Function for "City Event"   (Conditional)
async function cityEventNotify(notificationId) {
    try {
        console.log(`Processing notification with ID: ${notificationId}`);

        const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
        const jwtClient = new google.auth.JWT(
            recyclemintKey.client_email,
            null,
            recyclemintKey.private_key,
            SCOPES,
            null
        );

        const token = await new Promise((resolve, reject) => {
            jwtClient.authorize((err, token) => {
                if (err) {
                    console.error('Authorization failed:', err);
                    reject(err);
                } else {
                    resolve(token);
                }
            });
        });

        const accessToken = token.access_token;
        const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

        const notifications = await CustomNotify.find({ _id: notificationId });
        if (!notifications || notifications.length === 0) {
            console.error('No notifications found for ID:', notificationId);
            return;
        }

        const notificationData = {
            title: notifications[0]?.title,
            body: notifications[0]?.content,
            image: notifications[0]?.imageURL ? `https://devapisbot.ceibagreen.com/${notifications[0].imageURL}` : ''
        };

        console.log("Notification data:", notificationData);

        const notification = notifications[0]; // Assuming the first notification is the correct one
        const cityId = notification.cityid; // Safely access the second element

        if (!cityId) {
            console.error('City ID not found in the notification condition.');
            return;
        }
        console.log("City ID:", cityId);

        // const tokens = [
        //     "fyPI-HXRSkKko9tf2CeVXJ:APA91bHRintuUmixm12sEmAXPadPMHnMBiuLiRwTVT2WCg5ms5DWNS2zMO5FM4blauvW4ywvITQ2Dsj3W_UtLOv18B6zI1OO15pA_hKWgAJqOyYPEMGPS0n-nQbfGmWeqa350dPZjTwy",
        //     "ecZdmoseQe24MY8GIKCxPt:APA91bGNekkpR3c1gL_rLRs1sDL4ACuVxcScMmjXPjrnZ0mNIKPLmDJLfmOjXeOU7herwUjhp2gXsxnptrG3H0iUspc8eBnAfgw_RuI1-hGKGuoX_TRrvhuhi2OG0BHU-5RV846iPSPJ",
        //     "d2XG2DqTT42Hqko_15dhCn:APA91bGKQSgX1ndL-ye0WhaTOICZNU513CJvTo-00RyDQN1qfbzQCfyLilqhJc2BEQ7zMFQwjBwxtxi5PUVUokD_Rl1Qw8x0DrW5Joc24L0zgPQnFBSURHiZxTKrIR5M-g4fWPbd6jQt",
        //     "fshZVfc2To2J6nHuwSdSHw:APA91bEDC0bcWhrxZnTBr3yVJ4JCBkRPheiW8lgmW9xc_rxo9spkkN48HG2PFYIKpNa6nE1aWtCs4aIQbtQBfT1j4MlZOjhiJbTLrGkpPOsKhOk5lXOYpZwT1O7cqDdkPknIJfMPOF_I"
        // ];

        const devices = await Customers.find({ token: { $exists: true, $ne: null } }, 'token');
        if (!devices || devices.length === 0) {
            console.error('No any tokens available in customer table  ............');
            return;
        }
        // console.log("devices", devices);

        // const registrationTokens = tokens;

        const registrationTokens = devices.map(device => device.token).filter(token => token !== undefined);
        const customerID = devices.map(device => ({ _id: device._id }));
        console.log("customerID  :  ", customerID);

        for (const token of registrationTokens) {
            const customer = await Customers.findOne({ token }).lean().exec();
            console.log("customer", customer);
            if (customer) {
                const address = await Address.findOne({ customer_Id: customer._id, isDelete: false }).lean().exec();
                console.log("address", address);
                if (address) {
                    const location = await Location.findOne({ PIN: address.PIN, cityid: cityId }).lean().exec();
                    console.log("location", location);
                    if (location) {
                        const message = {
                            message: {
                                token: customer.token,
                                data: {
                                    title: notificationData.title,
                                    body: notificationData.body,
                                    image: notificationData.image,
                                    condition: notifications[0].conditionId[1].condition_name
                                },
                                notification: notificationData,
                            },
                        };
                        console.log(`Sending notification to ${customer.name}`);
                        try {
                            const response = await axios.post(api, message, {
                                headers: {
                                    'Authorization': `Bearer ${accessToken}`,
                                    'Content-Type': 'application/json',
                                },
                            });

                            console.log(`Notification sent to ${customer.name} with token number: ${customer.token} successfully:`, response.data);
                        } catch (error) {
                            console.log(`Error sending notification to ${customer.name}:`, error.response ? error.response.data : error.message);

                            await saveNotificationStatus(
                                customer._id,
                                customer.name,
                                customer.token,
                                notificationId,
                                notifications[0].title,
                                error.message
                            );
                        }
                    }
                } else {
                    console.log(`No location found for customer ${customer.name} with PIN ${address.PIN} and city ID ${cityId}. Skipping notification.`);
                }
            } else {
                console.log(`Customer with token ${token} not found in database.`);
            }
        }
    } catch (error) {
        console.error('Error sending notifications:', error);
    }
}



// Function to save customers' tokens who didn't receive notifications due to errors
export async function saveNotificationStatus(customerId, customerName, token, notificationId, notificationTitle, error) {
    try {
        const notificationStatus = new NotificationStatus({
            customerId,
            customerName,
            token,
            notificationId,
            notificationTitle,
            error
        });
        await notificationStatus.save();
        console.log("added to database .............");
    } catch (err) {
        console.error('Error during saving notification unsend customer in database :', err);
    }
}



// // API to call all the functions with conditions    (Conditional)
// export const notifyBasedOnCondition = async (req, res) => {
//     try {
//         const notificationId = req.body._id;
//         if (!notificationId) return res.status(400).json({ error: true, message: 'Notification ID required' });

//         const notification = await CustomNotify.findById(notificationId);
//         if (!notification) return res.status(404).json({ error: true, message: 'Notification not found' });
//         console.log("notification for all functions", notification);

//         const conditionId = notification.conditionId[0]._id;
//         if (!conditionId) return res.status(400).json({ error: true, message: 'Condition ID required' });
//         console.log("condition id for all functions", conditionId);

//         const condition = await NotifyCondition.findById(conditionId);
//         if (!condition) return res.status(404).json({ error: true, message: 'Condition not found' });
//         console.log("condition name: ", condition.condition_name);

//         let executedFunction;
//         if (condition.condition_name === 'No order' && condition.isActive) executedFunction = signupButNoOrder;
//         else if (condition.condition_name === 'Order reminder' && condition.isActive) executedFunction = lastOrder20DaysAgo;
//         else if (condition.condition_name === 'Items updated' && condition.isActive) executedFunction = sendItemNotification;
//         else if (condition.condition_name === 'City event' && condition.isActive) executedFunction = cityEventNotify;
//         else if (condition.condition_name === 'Cart full' && condition.isActive) executedFunction = sendCartNotification;
//         else if (condition.condition_name === 'General' && condition.isActive) executedFunction = notificationToAllCustomers;
//         else if (condition.condition_name === 'General event' && condition.isActive) executedFunction = notificationToAllCustomers;

//         console.log("executed function: ", executedFunction);

//         if (executedFunction) {
//             await executedFunction(notificationId);
//             await CustomNotify.updateOne({ _id: notificationId }, { $set: { status: 'Sent' } });
//             return res.status(200).json({ error: false, message: 'Notifications sent successfully', data: notification });
//         } else {
//             return res.status(400).json({ error: true, message: 'No valid condition found or condition inactive' });
//         }
//     } catch (err) {
//         console.error(err);
//         res.status(500).json({ error: true, message: 'Internal server error' });
//     }
// };



// API to call all the functions with conditions (Conditional)
export const notifyBasedOnCondition = async (req, res) => {
    try {
        const notificationId = req.body._id;
        if (!notificationId) return res.status(400).json({ error: true, message: 'Notification ID required' });

        const notification = await CustomNotify.findById(notificationId);
        if (!notification) return res.status(404).json({ error: true, message: 'Notification not found' });
        console.log("notification for all functions", notification);

        const conditionId = notification.conditionId[0]._id;
        if (!conditionId) return res.status(400).json({ error: true, message: 'Condition ID required' });
        console.log("condition id for all functions", conditionId);

        const condition = await NotifyCondition.findById(conditionId);
        if (!condition) return res.status(404).json({ error: true, message: 'Condition not found' });
        console.log("condition name: ", condition.condition_name);

        let executedFunction;
        if (condition.condition_name === 'No order' && condition.isActive) executedFunction = signupButNoOrder;
        else if (condition.condition_name === 'Order reminder' && condition.isActive) executedFunction = lastOrder20DaysAgo;
        else if (condition.condition_name === 'Items updated' && condition.isActive) executedFunction = sendItemNotification;
        else if (condition.condition_name === 'City event' && condition.isActive) executedFunction = cityEventNotify;
        else if (condition.condition_name === 'Cart full' && condition.isActive) executedFunction = sendCartNotification;
        else if (condition.condition_name === 'General' && condition.isActive) executedFunction = notificationToAllCustomers;
        else if (condition.condition_name === 'General event' && condition.isActive) executedFunction = notificationToAllCustomers;

        let statusToUpdate = 'Sent';
        let dateToUpdate = notification.date; // Keep the original date if not updated

        if (executedFunction) {
            // For conditions 'No order', 'Order reminder', and 'Cart full', update status and date
            if (['No order', 'Order reminder', 'Cart full'].includes(condition.condition_name)) {
                statusToUpdate = 'Not send';
                dateToUpdate = moment().add(1, 'day').format('DD-MM-YYYY');
            }

            await executedFunction(notificationId);
            await CustomNotify.updateOne({ _id: notificationId }, { $set: { date: dateToUpdate, status: statusToUpdate } });
            return res.status(200).json({ error: false, message: 'Notifications sent successfully', data: notification });
        } else {
            return res.status(400).json({ error: true, message: 'No valid condition found or condition inactive' });
        }
    } catch (err) {
        console.error(err);
        res.status(500).json({ error: true, message: 'Internal server error' });
    }
};