import mongoose from "mongoose";
import Customers from "../model/customer.model.js";
import Address from "../model/address.model.js";
import Verifyotp from "../model/verifyotp.model.js";
import Location from "../model/location.model.js";
import Orders from "../model/order.model.js";
import axios from "axios";
import dotenv from 'dotenv';
import Coin from "../model/coin.model.js";
import { generate as generateReferralCode } from 'referral-codes';
import bcrypt from 'bcrypt';
const saltRounds = 10;
import SibApiV3Sdk from 'sib-api-v3-sdk';
import fs from 'fs';
import path from "path";


async function getAddressData() {
    try {
        // Adjust the path as needed
        const filePath = path.resolve('./pinCityState.json');
        const data = await fs.promises.readFile(filePath, 'utf-8');
        return JSON.parse(data);
    } catch (err) {
        console.error("Error reading JSON file:", err);
        return [];
    }
}

const addressDatacus = await getAddressData();

dotenv.config();
const apiKey = process.env.APIKEY;
// const apiKey = 'rzp_live_c8RouP3eKq6D1C';
const apiSecret = process.env.APISECRET;
// const apiSecret = '63WBO3yFwX6gHymOiypMjXm7';

import multer from "multer";
import Coinhist from "../model/coinhist.model.js";
const ObjectId = mongoose.Types.ObjectId;


const Storage = multer.diskStorage({
    destination: 'uploads',
    filename: (req, res, cb) => {
        cb(null, Date.now() + "_" + (res.originalname).trim());
    }
});
const upload = multer({
    storage: Storage,
}).single('image');



// External Login
// export const login = async (req, res) => {
//     Customers.findOne({
//         mobile: req.body.mobile
//     }).then((data) => {
//         console.log("user", data)
//         if (data) {
//             // generate OTP
//             const otp = Math.floor(1000 + Math.random() * 9000);
//             console.log(otp);
//             //update OTP
//             Customers.updateOne({ _id: data._id }, { $set: { OTP: otp } }).then(userData => {
//                 if (userData) {
//                     res.send({
//                         error: false,
//                         customerDetails: data,
//                         message: "LoggedIn successfully"
//                     })
//                 } else {
//                     res.send({
//                         error: true,
//                         message: "Some error occured"
//                     })
//                 }
//             })
//             // response send

//         } else {
//             //create customer with OTP
//             const otp = Math.floor(1000 + Math.random() * 9000);
//             console.log(otp);
//             let customerDetails = new Customers({
//                 mobile: req.body.mobile,
//                 OTP: otp
//             })
//             customerDetails.save()
//                 .then((data1) => {

//                     console.log(data1)

//                     //response send
//                     let response = {
//                         message: "Saved successfully",
//                         customerDetails: data1,
//                         // isComplete: false
//                     }

//                     console.log(response);

//                     res.send(response)


//                 }).catch(err => [
//                     res.status(500).send({
//                         error: true,
//                         message: err
//                     })
//                 ])
//         }

//     })
// };

export const login = async (req, res) => {
    await Customers.findOne({
        mobile: req.body.mobile,
        isDelete: false
    }).then(async (data) => {
        console.log(data);
        if (data) {
            let generatedCode = []
            if (data.name != "") {
                var x = (data.name).split(' ')[0]
                if (x.length >= 4) {
                    x = x.substring(0, 4)
                    x = x.toUpperCase();
                } else {
                    x = x.toUpperCase();
                }

                generatedCode = generateReferralCode({
                    prefix: x,
                    length: 6,
                    charset: '0123456789',
                });
            } else {
                generatedCode = [];
            }
            if (data.refCode) {
            } else if (!data.refCode || data.refCode == '') {
                await Customers.findOneAndUpdate({
                    mobile: req.body.mobile,
                    isDelete: false
                }, { $set: { refCode: generatedCode[0] } })
            }
        } else { }




        console.log("user", data);
        if (data) {
            // generate OTP
            const otp = Math.floor(1000 + Math.random() * 9000);
            console.log(otp);
            const headers = {
                'Authorization': 'Basic Q2VpYmE6Wjd5S3V4Qno=',
            };
            const auth = {
                username: 'Ceiba',
                password: 'Z7yKuxBz',
            }
            try {
                const response = await axios.post(
                    `https://app.crunchysms.com:3001/rest/send_sms?senderId=CEIBA&msg=Use OTP ${otp} to log into your Recycle Pay account. Donot share the OTP or your number with anyone. CEIBA GREEN&destAddr=91${req.body.mobile}&command=submit&flash=0&dataCoding=0&PE_ID=1701169770111580785&TEMP_ID=1707169787605858070`,
                    null, // POST requests usually have a request body, set to null if not needed
                    {
                        headers: headers,
                        auth: auth,
                    }
                );

                console.log(response);

                if (response) {
                    // await Customers.findOneAndUpdate({
                    //     mobile: req.body.mobile,
                    // }, { $set: { OTP: otp } });

                    console.log("enter response");

                    await Verifyotp.findOne({ mobile: req.body.mobile }).then(async (x) => {
                        console.log(x, x == null);
                        if (x) {
                            await Verifyotp.findOneAndUpdate({ mobile: req.body.mobile }, { $set: { OTP: otp } }).then((otp) => {
                                return res.send({
                                    isSuccess: true,
                                    customerDetails: data,
                                    // refCode: generatedCode[0],
                                    message: "OTP sent successfully"

                                });
                            })
                        }
                        else if (x == null) {
                            const verify = await Verifyotp.create({
                                mobile: req.body.mobile,
                                OTP: otp
                            });
                            if (verify) {
                                return res.send({
                                    isSuccess: true,
                                    customerDetails: data,
                                    // refCode: generatedCode[0],
                                    message: "OTP sent successfully"
                                });
                            }
                        }
                    })


                    // return res.send({
                    //     isSuccess: true,
                    //     customerDetails: data,
                    //     message: "OTP sent successfully"

                    // });
                } else {
                    return res.send({
                        isSuccess: true,
                        customerDetails: data,
                        message: "OTP sent successfully"

                    });
                }

                console.log(response.data);
            } catch (error) {
                console.error(error);
            }


            // const response = await axios.get(`https://app.crunchysms.com:3001/rest/send_sms?senderId=CEIBA&msg=Use OTP ${otp} to log into your Recycle Pay account.
            // Donot share the OTP or your number with anyone. CEIBA GREEN&destAddr=${req.body.mobile}&command=submit&flash=0&dataCoding=0&PE_ID=1701169770111580785&TEMP_ID=1707169787605858070`, {
            //     headers: headers,
            //     })



        } else {
            // generate OTP
            const otp = Math.floor(1000 + Math.random() * 9000);
            console.log(otp);
            const headers = {
                'Authorization': 'Basic Q2VpYmE6Wjd5S3V4Qno=',
            };
            const auth = {
                username: 'Ceiba',
                password: 'Z7yKuxBz',
            }
            try {
                const response = await axios.post(
                    `https://app.crunchysms.com:3001/rest/send_sms?senderId=CEIBA&msg=Use OTP ${otp} to log into your Recycle Pay account. Donot share the OTP or your number with anyone. CEIBA GREEN&destAddr=91${req.body.mobile}&command=submit&flash=0&dataCoding=0&PE_ID=1701169770111580785&TEMP_ID=1707169787605858070`,
                    null,
                    {
                        headers: headers,
                        auth: auth,
                    }
                );
                console.log(response.data);

                if (response) {
                    const getOTP = await Verifyotp.findOne({ mobile: req.body.mobile });
                    console.log('getOTP', getOTP);
                    if (getOTP) {
                        await Verifyotp.findOneAndUpdate({ mobile: req.body.mobile }, { $set: { OTP: otp } }).then((otp) => {
                            return res.send({
                                isSuccess: true,
                                message: "OTP sent successfully",
                                customerDetails: {},
                                // note: "Given number was trying before, but didn't save in customer table."
                            });
                        })
                    } else {
                        // await Verifyotp.findOneAndUpdate({ mobile: req.body.mobile }, { $set: { OTP: otp } }).then((otp) => {
                        //     return res.send({
                        //         isSuccess: true,
                        //         message: "OTP sent successfully",
                        //         // note: "Given number was trying before, but didn't save in customer table."
                        //     });
                        // })
                        const verify = await Verifyotp.create({
                            mobile: req.body.mobile,
                            OTP: otp
                        });
                        if (verify) {
                            return res.send({
                                isSuccess: true,
                                message: "OTP sent successfully",
                                customerDetails: {},
                            });
                        }
                        // await Customers.findOneAndUpdate({
                        //     mobile: req.body.mobile,
                        // }, { $set: { OTP: otp } });


                    }

                }

            } catch (error) {
                console.error(error);
            }



        }
    });
};








// verify OTP
export const verifyOTP = async (req, res) => {
    try {
        // Input validation (sanitize and validate mobile and OTP)
        const mobile = req.body.mobile;
        const OTP = req.body.OTP;

        if (!mobile || !OTP) {
            return res.send({
                error: true,
                message: "Mobile and OTP are required fields."
            });
        }

        // Query the database for customer data
        const customerData = await Customers.findOne({ mobile: mobile, isDelete: false });
        const getOTP = await Verifyotp.findOne({ mobile });
        // console.log(getOTP.OTP, OTP, customerData);
        if (getOTP) {
            if (getOTP.OTP == OTP) {
                if (customerData && customerData.email) {
                    await Customers.findOneAndUpdate({ mobile: mobile, isDelete: false }, { $set: { lastLogin: Date.now() } });
                    return res.send({
                        isSuccess: true,
                        message: "Customer already exists",
                        customerDetails: customerData
                    });
                } else if (!customerData) {
                    return res.send({
                        isSuccess: true,
                        message: "Customer doesn't exists",
                        customerDetails: {}
                    });
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Customer doesn't exists",
                        customerDetails: customerData
                    });
                }


            } else {
                return res.send({
                    isSuccess: false,
                    message: "Wrong OTP enter.",
                    customerDetails: {}
                });
            }

        } else if (customerData) {
            // if (customerData.OTP == OTP) {
            return res.send({
                isSuccess: true,
                message: "Customer already exists",
                customerDetails: customerData
            });
            // } else {
            //     return res.send({
            //         isSuccess: false,
            //         message: "Wrong OTP enter.",
            //         // customerDetails: customerData
            //     });
            // }

        }
    } catch (error) {
        console.error(error);
        return res.send({
            error: true,
            message: "Internal server error"
        });
    }
};



// wp auth token save in db
export const wpauth = async (req, res) => {
    await Verifyotp.find({ mobile: req.body.mobile }).then(async (x) => {
        if (x.length != 0) {
            await Verifyotp.findOneAndUpdate({ mobile: req.body.mobile }, { $set: { token: req.body.token } }).then((otp) => {
                return res.send({
                    isSuccess: true,
                    message: "Token update successfully",
                });
            })
        } else {
            const verify = await Verifyotp.create({
                mobile: req.body.mobile,
                token: req.body.token
            });
            return res.send({
                isSuccess: true,
                message: "Token genrate successfully",
            });
        }
    })

}




// wp auth token verify
export const wpauthVerify = async (req, res) => {
    console.log(req.body);
    const cust = await Customers.findOne({
        mobile: req.body.mobile, isDelete: false
    })
    await Verifyotp.find({ mobile: req.body.mobile }).then(async (x) => {
        console.log(x);
        if (x) {
            console.log(x[0].token == req.body.token, cust);
            if (x[0].token == req.body.token && cust) {
                await Customers.findOneAndUpdate({ mobile: req.body.mobile, isDelete: false }, { $set: { lastLogin: Date.now() } });
                return res.send({
                    isSuccess: true,
                    message: "Customer already exists",
                    customerDetails: cust,
                });
            } else {
                return res.send({
                    isSuccess: true,
                    message: "Customer doesn't exists",
                    customerDetails: [],
                });
            }
        } else {
            const verify = await Verifyotp.create({
                mobile: req.body.mobile,
                token: req.body.token
            });
            if (verify) {
                return res.send({
                    isSuccess: true,
                    message: "Customer doesn't exists",
                    customerDetails: [],
                });
            }

        }
    })

}




// Get Customers by mobile
export const getCustomersByPhone = async (req, res) => {
    const customers = await Customers.find({ mobile: (req.params.phone), isDelete: false });
    res.send(customers)
}



// Get phone number exist or not
export const getByMobile = async (req, res) => {
    const customers = await Customers.find({ mobile: (req.params.mobile) });
    if (customers) {
        return res.send(customers)
    } else {
        return res.send({})
    }
}




// create customer by passing mobile, refcode in body
export const createCustUsingRef = async (req, res) => {
    let customerRef = new Customers({
        mobile: req.body.mobile,
        useRefCode: req.body.useRefCode
    })
    customerRef.save()
        .then((save) => {
            if (save) {
                return res.json({
                    isSuccess: true,
                    data: save,
                })
            }
        })

}




// Refferal code
function refCode() {
    var x = ('Omm Prakas').split(' ')[0]
    if (x.length >= 4) {
        x = x.substring(0, 4)
        x = x.toUpperCase();
    } else {
        x = x.toUpperCase();
    }
    const generatedCode = generateReferralCode({
        prefix: x,
        // postfix: '',
        length: 6,
        charset: '0123456789',
    });

    console.log('Generated referral code:', generatedCode);
}

refCode()


// Complete Profile
export const createProfile = async (req, res) => {
    try {

        var x = (req.body.name).split(' ')[0]
        if (x.length >= 4) {
            x = x.substring(0, 4)
            x = x.toUpperCase();
        } else {
            x = x.toUpperCase();
        }

        let generatedCode = generateReferralCode({
            prefix: x,
            length: 6,
            charset: '0123456789',
        });

        console.log('Generated referral code:', generatedCode);

        console.log(req.body, req.body.useRefCode);

        var customerData;
        const existingDelMobile = await Customers.findOne({ mobile: req.body.mobile, isDelete: true });

        if (existingDelMobile && req.body.useRefCode) {
            return res.send({
                isSuccess: false,
                msg: "Already exist as deleted user."
            })
        } else if (req.body.useRefCode !== undefined) {
            customerData = new Customers({
                name: req.body.name,
                email: req.body.email,
                mobile: req.body.mobile,
                type: "customer",
                refCode: generatedCode[0],
                useRefCode: req.body.useRefCode,
                organisation: req.body.organisation,
            });
        } else {
            customerData = new Customers({
                name: req.body.name,
                email: req.body.email,
                mobile: req.body.mobile,
                type: "customer",
                refCode: generatedCode[0],
                // useRefCode: req.body.useRefCode,
                organisation: req.body.organisation,
            });
        }


        // Check if the customer with the same mobile already exists
        if (req.body.mobile) {
            const existingMobile = await Customers.findOne({ mobile: req.body.mobile, isDelete: false });
            console.log(existingMobile);
            if (existingMobile) {
                return res.send({ "uploaded": false, "message": "This mobile number already exists." });
            }
        }


        // Check if the email already exists in the database
        if (req.body.email) {
            const existingEmail = await Customers.findOne({ email: req.body.email, isDelete: false });
            if (existingEmail) {
                return res.send({ "uploaded": false, message: 'Oops! This email address is already in use with another account.' });
            }
        }

        if (customerData) {
            const savedCustomer = await customerData.save();
            if (savedCustomer) {
                console.log(`req.body.useRefCode != "" && req.body.useRefCode != undefined`, req.body.useRefCode != "" && req.body.useRefCode != undefined, req.body.useRefCode == undefined);
                const useRefCode = await Customers.findOne({ refCode: req.body.useRefCode, isDelete: false }).then(async (x) => {
                    if (x && req.body.useRefCode !== undefined) {
                        console.log('asdtfyguhiojk', x);
                        await Customers.findOneAndUpdate({ refCode: x.useRefCode, isDelete: false }, { $push: { refCodeUser: savedCustomer._id } },
                            { new: true })
                        // let _id = x._id
                        await Coin.findOne({ customer_id: new ObjectId(x._id) }).then(async (y) => {
                            console.log("coin", y.earn);

                            // if (y) {
                            //     let updatecoin = await Coin.findOneAndUpdate({ customer_id: new ObjectId(x._id) }, {$set: { earn: y.earn + 50, coins: y.coins + 50, left: y.left + 50 }}, { new: true })
                            //     console.log("updatecoin", updatecoin);
                            //     const coinhist = await Coinhist.create({
                            //         customer_id: new ObjectId(x._id),
                            //         earn: y.earn + 50,
                            //         coins: y.coins + 50,
                            //         left: y.left + 50,
                            //         credit: 50,
                            //         spend: y.spend,
                            //         withdraw: y.withdraw,
                            //         purpose: "Referal credit from Recycle-Pay.",
                            //         debit: y.debit
                            //     });
                            //     console.log('coinhist', coinhist);
                            // }
                        })
                    } else if (req.body.useRefCode != "" && req.body.useRefCode != undefined) {
                        return res.json({
                            isSuccess: false,
                            msg: "Enter active customer's RefCode."
                        })
                    } else if (req.body.useRefCode == undefined) {
                        // pass
                    }

                })
                console.log(savedCustomer);
                console.log("useRefCode", useRefCode);
                const coin = await Coin.create({
                    customer_id: savedCustomer._id,
                    coins: 0,
                    left: 0,
                    spend: 0,
                });

                const addressData = new Address({
                    location: req.body.location,
                    landmark: req.body.landmark,
                    city: req.body.city,
                    state: req.body.state,
                    PIN: req.body.PIN,
                    latitude: req.body.latitude,
                    longitude: req.body.longitude,
                    isComplete: true,
                    customer_Id: savedCustomer._id,            // Reference to the Customer document
                    isDefault: true
                });

                console.log("addressData", addressData);
                console.log("addressData.PIN", req.body.PIN);
                const addressPIN = req.body.PIN;
                console.log("Data : addressPIN", addressPIN);

                const locationExists = await Location.findOne({
                    PIN: addressPIN,
                    isActive: true
                });

                console.log("Data : locationExists", locationExists);

                if (locationExists) {
                    addressData.isActive = true;
                    console.log("locationExists");
                } else {
                    addressData.isActive = false;
                    console.log("location not Exists");
                }

                // Create a new Address document
                const savedAddress = await addressData.save();

                console.log("savedAddress", savedAddress);
                if (savedAddress) {
                    console.log("enter savedAddress", savedAddress);

                    return res.send({
                        message: 'Profile completed successfully',
                        customerDetails: savedCustomer,
                        // ci: response.data.id,
                        addressDetails: savedAddress,
                    });
                } else {
                    return res.status(500).send({
                        error: true,
                        message: 'An error occurred while saving the address',
                    });
                }

            }

            // const requestData = {
            //     name: req.body.name,
            //     email: req.body.email,
            //     contact: req.body.mobile,
            // };
            // console.log(requestData);
            // if (requestData) {
            //     await axios.post(`https://api.razorpay.com/v1/contacts`, requestData, {
            //         headers: {
            //             'Content-Type': 'application/json',
            //         },
            //         auth: auth,
            //     })
            //         .then(async (response) => {
            //             console.log('API Response:', response.data);
            //             await Customers.findOneAndUpdate({ mobile: response.data.contact, email: response.data.email, isDelete: false }, {
            //                 $set: {
            //                     ci: response.data.id
            //                 }
            //             }).then(async (update) => {
            //                 console.log("update", update);
            //                 const addressData = new Address({
            //                     location: req.body.location,
            //                     landmark: req.body.landmark,
            //                     city: req.body.city,
            //                     state: req.body.state,
            //                     PIN: req.body.PIN,
            //                     latitude: req.body.latitude,
            //                     longitude: req.body.longitude,
            //                     isComplete: true,
            //                     customer_Id: savedCustomer._id,            // Reference to the Customer document
            //                     isDefault: true
            //                 });

            //                 console.log("addressData", addressData);
            //                 console.log("addressData.PIN", req.body.PIN);
            //                 const addressPIN = req.body.PIN;
            //                 console.log("Data : addressPIN", addressPIN);

            //                 const locationExists = await Location.findOne({
            //                     PIN : addressPIN,
            //                     isActive: true
            //                 });

            //                 console.log("Data : locationExists", locationExists);

            //                 if (locationExists) {
            //                     addressData.isActive = true;
            //                     console.log("locationExists");
            //                 } else {
            //                     addressData.isActive = false;
            //                     console.log("location not Exists");
            //                 }

            //                 // Create a new Address document
            //                 const savedAddress = await addressData.save();

            //                 console.log("savedAddress", savedAddress);
            //                 if (savedCustomer._id && savedAddress && response.data) {
            //                     res.send({
            //                         message: 'Profile completed successfully',
            //                         customerDetails: update,
            //                         ci: response.data.id,
            //                         addressDetails: savedAddress,
            //                     });
            //                 } else {
            //                     res.status(500).send({
            //                         error: true,
            //                         message: 'An error occurred while saving the address',
            //                     });
            //                 }
            //             })

            //             // res.send({
            //             //     data: response.data
            //             // })

            //         })
            //         .catch((error) => {
            //             res.send({
            //                 data: error
            //             })
            //         });
            // }            

        } else {
            res.status(500).send({
                error: true,
                message: 'An error occurred while saving the customer',
            });
        }



    } catch (error) {
        res.send({
            error: true,
            message: 'An error occurred while completing the profile',
            error: error
        });
    }
};



// Razorpay ci generate for customer
export const ciGen = async (req, res) => {
    const auth = {
        username: apiKey,
        password: apiSecret,
    }

    const requestData = {
        name: req.body.name,
        email: req.body.email,
        contact: req.body.mobile,
    };
    console.log(requestData);
    if (requestData) {
        await axios.post(`https://api.razorpay.com/v1/contacts`, requestData, {
            headers: {
                'Content-Type': 'application/json',
            },
            auth: auth,
        })
            .then(async (response) => {
                console.log('API Response:', response.data);
                await Customers.findOneAndUpdate({ mobile: response.data.contact, email: response.data.email, isDelete: false }, {
                    $set: {
                        ci: response.data.id
                    }
                },
                    { new: true }).then(async (update) => {
                        console.log("update", update);
                        return res.send({
                            isSuccess: true,
                            message: 'CI update successfully',
                            data: update,
                        });
                    })

                // res.send({
                //     data: response.data
                // })

            })
            .catch((error) => {
                res.send({
                    data: error
                })
            });
    }
}



// Edit Profile after reference
export const updateProfileRef = async (req, res) => {
    var x = (req.body.name).split(' ')[0]
    if (x.length >= 4) {
        x = x.substring(0, 4)
        x = x.toUpperCase();
    } else {
        x = x.toUpperCase();
    }

    let generatedCode = generateReferralCode({
        prefix: x,
        length: 6,
        charset: '0123456789',
    });
    upload(req, res, async (err) => {
        if (err) {
            console.log(err);
            return res.send({
                error: true,
                message: "File upload failed"
            });
        }

        // Input validation
        const name = req.body.name;
        const email = req.body.email;
        const landmark = req.body.landmark;
        const PIN = req.body.PIN;
        const state = req.body.state;
        const city = req.body.city;
        const location = req.body.location;
        const longitude = req.body.longitude;
        const latitude = req.body.latitude;

        if (!/^[A-Za-z\s]+$/.test(name)) {
            return res.status(400).send({
                error: true,
                message: "Invalid characters in the name. Only alphabets and spaces allowed."
            });
        }

        if (!isValidEmail(email)) {
            return res.send({
                error: true,
                message: "Invalid email format."
            });
        }

        let updateData;

        const auth = {
            username: apiKey,
            password: apiSecret,
        }

        const requestData = {
            name: req.body.name,
            email: req.body.email,
            contact: req.body.mobile,
        };
        console.log(requestData);
        if (requestData) {
            await axios.post(`https://api.razorpay.com/v1/contacts`, requestData, {
                headers: {
                    'Content-Type': 'application/json',
                },
                auth: auth,
            }).then((response) => {
                updateData = {
                    $set: {
                        name,
                        email,
                        // landmark,
                        // PIN,
                        // state,
                        // city,
                        // location,
                        // longitude,
                        // latitude,
                        refCode: generatedCode[0],
                        ci: response.data.id,
                    },
                };
            })

        }

        const updateAddress = {
            // $set: {
            // name,
            // email,
            landmark,
            PIN,
            state,
            city,
            location,
            longitude,
            latitude,
            // refCode: generatedCode[0],
            // },
        };


        console.log(updateData);

        // if (req.file) {
        //     updateData.$set.image = {
        //         contentType: 'image',
        //         data: req.file.filename
        //     };
        //     updateData.$set.imageURL = 'uploads/' + req.file.filename;
        // }

        try {

            const resp = await Customers.updateOne({ _id: req.params.id, isDelete: false }, updateData);

            console.log("resp", resp);

            if (resp) {
                const updateCust = await Customers.findOne({ _id: req.params.id, isDelete: false });
                console.log("updateCust", updateCust._id);
                if (updateCust) {

                    const updateAdd = await Address.create({
                        landmark: landmark,
                        PIN: PIN,
                        state: state,
                        city: city,
                        location: location,
                        longitude: longitude,
                        latitude: latitude,
                        customer_Id: updateCust._id,
                        isDefault: true
                    });

                    console.log("updateAdd", updateAdd);
                    if (updateAdd) {
                        res.status(200).json({ message: "Profile completed successfully", customerDetails: updateCust, ci: updateData['$set'].ci, addressDetails: updateAdd });
                    }
                }
            } else {
                res.status(500).json({ message: "update failed" });
            }
        } catch (error) {
            console.error(error);
            return res.send({
                error: true,
                message: "Internal server error"
            });
        }
    });
};





// Edit Profile
export const updateProfile = async (req, res) => {
    upload(req, res, async (err) => {
        if (err) {
            console.log(err);
            return res.send({
                error: true,
                message: "File upload failed"
            });
        }

        // Input validation
        const { name, email, SellerId, BuyerId } = req.body;
        if (!/^[A-Za-z]+(\s[A-Za-z]+)*$/.test(name)) {
            return res.status(400).send({
                error: true,
                message: "Invalid characters in the name. Only alphabets and spaces allowed."
            });
        }


        if (!isValidEmail(email)) {
            return res.send({
                error: true,
                message: "Invalid email format."
            });
        }

        // Update the customer profile based on whether a file is uploaded or not
        const updateData = { $set: {} };
        if (name) updateData.$set.name = name;
        if (email) updateData.$set.email = email;
        if (BuyerId) updateData.$set.BuyerId = new mongoose.Types.ObjectId(BuyerId);
        if (SellerId) updateData.$set.SellerId = new mongoose.Types.ObjectId(SellerId);

        if (req.file) {
            updateData.$set.image = {
                contentType: 'image',
                data: req.file.filename
            };
            updateData.$set.imageURL = 'uploads/' + req.file.filename;
        }

        try {
            const resp = await Customers.updateOne({ mobile: req.body.mobile, isDelete: false }, updateData);

            if (resp) {
                res.status(200).json({ message: "update success" });
            } else {
                res.status(500).json({ message: "update failed" });
            }
        } catch (error) {
            console.error(error);
            return res.send({
                error: true,
                message: "Internal server error"
            });
        }
    });
};


// update FCM token by customer ID
export const updateTokenById = async (req, res) => {
    const updateToken = await Customers.updateOne({ _id: new ObjectId(req.body.id) }, { $set: { "token": req.body.token } });

    if (updateToken) {
        console.log(updateToken)
        res.send(
            {
                error: false,
                message: "update success"
            });
    } else {
        res.send(
            {
                error: true,
                message: "update failed"
            });
    }
};


// Get all Customers' Details
export const getAllCustomers = async (req, res) => {
    try {
        const { last7dayscond, last15dayscond, last30dayscond, notorderyet, accountst, citystatename, name, mobile, email } = req.query;
        let matchStage = {};
        let orderConditions = [];
        let limit = 10;
        let page = req.query.offset ? parseInt(req.query.offset) : 1;
        let offset = (page - 1) * limit;

        // Set account status condition
        if (accountst !== undefined) {
            if (accountst === 'true') {
                matchStage.isDelete = true;
            } else {
                matchStage.isDelete = { $in: [true, false] };
            }
        }

        // Date condition function
        const getDateCondition = (days) => ({
            $or: [
                { $eq: ["$lastOrderDate", null] }, // No orders at all
                { $lt: ["$lastOrderDate", { $dateSubtract: { startDate: "$$NOW", unit: "day", amount: days } }] }
            ]
        });

        // Add date conditions based on query parameters
        if (last7dayscond === 'true') {
            orderConditions.push({ $expr: getDateCondition(7) });
        }
        if (last15dayscond === 'true') {
            orderConditions.push({ $expr: getDateCondition(15) });
        }
        if (last30dayscond === 'true') {
            orderConditions.push({ $expr: getDateCondition(30) });
        }
        if (notorderyet === 'true') {
            orderConditions.push({ $expr: { $eq: ["$lastOrderDate", null] } });
        }

        let customerIds = [];

        // City name filtering logic
        if (citystatename) {
            const regex = new RegExp(citystatename, 'i'); // Case-insensitive regex
            const matchedPins = addressDatacus
                .filter(item => regex.test(item.city) || regex.test(item.state))
                .map(item => item.pin);

            console.log("matched pins are ", matchedPins);

            // Check if any addresses match the pins and are default
            const addressMatches = await Address.find({ PIN: { $in: matchedPins }, isDefault: true }).select('customer_Id');
            console.log("all matched addresses are", addressMatches);
            customerIds = addressMatches.map(address => address.customer_Id);

            console.log("customer ids are", customerIds);

            // Ensure customerIds are in ObjectId format if necessary
            if (customerIds.length > 0) {
                matchStage._id = { $in: customerIds.map(id => (typeof id === 'string' ? new mongoose.Types.ObjectId(id) : id)) };
            } else {
                // If no customer IDs found, return empty result set
                return res.json({
                    isSuccess: true,
                    customers: [],
                    total: 0,
                    currentPage: page,
                    totalPages: 0,
                });
            }
        }

        if (name) {
            matchStage.name = { $regex: name, $options: 'i' };
        }
        if (mobile) {
            matchStage.mobile = { $regex: mobile, $options: 'i' };
        }
        if (email) {
            matchStage.email = { $regex: email, $options: 'i' };
        }
        // Build the aggregation pipeline
        const pipeline = [
            {
                $lookup: {
                    from: "orders",
                    localField: "_id",
                    foreignField: "customer_id",
                    as: "orders"
                }
            },
            {
                $addFields: {
                    lastOrderDate: {
                        $ifNull: [{ $max: "$orders.createdAt" }, null]
                    }
                }
            },
            {
                $match: {
                    $and: [matchStage, ...orderConditions] // Match stage with all conditions
                }
            },
            {
                $sort: {
                    lastOrderDate: -1
                }
            },
            {
                $facet: {
                    paginatedResults: [
                        { $skip: offset },
                        { $limit: limit },
                        {
                            $project: {
                                name: 1,
                                email: 1,
                                mobile: 1,
                                isDelete: 1,
                                imageURL: 1,
                                lastOrderDate: 1
                            }
                        }
                    ],
                    totalCount: [
                        { $count: "totalCount" }
                    ]
                }
            }
        ];

        // Perform the aggregation
        const result = await Customers.aggregate(pipeline);
        const customers = result[0].paginatedResults;
        const total = result[0].totalCount.length > 0 ? result[0].totalCount[0].totalCount : 0;

        res.json({
            isSuccess: true,
            customers,
            total,
            currentPage: page,
            totalPages: Math.ceil(total / limit),
        });
    } catch (err) {
        console.error(err);
        res.status(500).send({ error: 'An error occurred while fetching customers' });
    }
}


// Delete customer by ID
export const deletecustomerById = async (req, res) => {
    const customers = await Customers.updateOne({ _id: new ObjectId(req.params.id) }, { $set: { "isActive": false, "isDelete": true } });
    if (customers) {
        res.send("deleted successfully")
    } else {
        res.send("deletion failed")
    }
}


// Check email duplicacy
export const emailDuplicacy = async (req, res) => {
    const existingEmail = await Customers.findOne({ email: req.params.email, isDelete: false });
    if (existingEmail) {
        return res.send({ message: 'Oops! This email address is already in use with another account.' });
    } else {
        return res.send({ message: 'Unique email address' });
    }
}


// Function
function isValidEmail(email) {
    // Use a regular expression for basic email validation
    const emailRegex = /^[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,}$/;
    return emailRegex.test(email);
}



// Cstomer delete
export const deleteCust = async (req, res) => {
    await Customers.findOneAndUpdate({ _id: req.params.cust }, { $set: { isDelete: true } }).then((x) => {
        if (x) {
            return res.send({
                isSuccess: true,
                customerDetails: [],
                message: "Delete successfully."
            });
        } else {
            return res.send({
                isSuccess: false,
                customerDetails: [],
                message: "Enter invalid customer id."
            });
        }
    })
}




// Update Bussines Customer Category
export const updateDetailsById = async (req, res) => {
    let generatedCode
    await Customers.findOne({ _id: new ObjectId(req.body.id) }).then(async (cust) => {
        var x = (cust.name).split(' ')[0]
        var y = (cust.mobile).substring(0, 3)
        if (x.length >= 4) {
            x = x.substring(0, 3)
            x = x.toUpperCase();
        } else {
            x = x.toUpperCase();
        }


        const prefix = `${x}${y}`

        generatedCode = generateReferralCode({
            prefix: prefix,
            length: 4,
            charset: '0123456789',
        });
    })

    console.log("generatedCode", generatedCode);

    function shuffleString(str) {
        return str
            .split('')
            .sort(() => Math.random() - 0.5)
            .join('');
    }

    const shuffledString = shuffleString(generatedCode[0]);

    console.log("shuffledString", shuffledString);

    bcrypt.hash(shuffledString, saltRounds, async (err, hash) => {
        if (err) {
            console.error('Error hashing password:', err);
        } else {
            const updateDetails = await Customers.findOneAndUpdate(
                { _id: new ObjectId(req.body.id) },
                {
                    $set: {
                        gst: req.body.gst,
                        business_name: req.body.business_name,
                        // payment_settlement: req.body.payment_settlement, 
                        // pickupday: req.body.pickupday, 
                        username: generatedCode[0],
                        password: hash,
                        business_reg: true,
                    }
                },
                { new: true }
            );

            if (updateDetails) {
                console.log(updateDetails)
                var defaultClient = SibApiV3Sdk.ApiClient.instance;
                var apiKey = defaultClient.authentications['api-key'];
                apiKey.apiKey = process.env.MAILAPIKEY;

                var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();

                var sendSmtpEmailAdmin = new SibApiV3Sdk.SendSmtpEmail();

                // const dynamicAdmSubject = `New order [${order.order_id}] has been placed!`;
                sendSmtpEmailAdmin = {
                    to: [
                        // { email: 'aditi.nandy@ajatus.co.in' }, 
                        { email: updateDetails.email },
                    ],
                    from: {
                        email: 'support@ceibagreen.com',
                        // name: 'Your Name'
                    },
                    templateId: 23,
                    params: { "parameter": "recycle-pay", "name": updateDetails.name, "username": updateDetails.username, "password": shuffledString },
                    // subject: dynamicAdmSubject,
                    headers: {
                        'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                    }
                };

                try {
                    apiInstance.sendTransacEmail(sendSmtpEmailAdmin).then(function (data) {
                        console.log('Admin API called successfully. Returned data: ' + data);
                    }, function (error) {
                        console.error(error);
                    });
                } catch (error) {
                    console.error("Error:", error);
                }

                return res.send(
                    {
                        error: false,
                        message: "update success"
                    });
            } else {
                return res.send(
                    {
                        error: true,
                        message: "update failed"
                    });
            }
        }
    });
};




// Login business customer dashboard
export const loginBusinessCustomerDash = async (req, res) => {
    await Customers.findOne({ username: req.body.username }).then(async (cust) => {
        console.log("cust", cust);
        if (cust) {
            bcrypt.compare(req.body.password, cust.password, (err, result) => {
                if (err) {
                    return res.send({
                        isSuccess: false,
                        message: "Enter invalid password."
                    });
                } else if (result) {
                    return res.send({
                        isSuccess: true,
                        message: "Loggedin.",
                        data: cust,
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong."
                    });
                }
            });
        } else {
            return res.send({
                isSuccess: false,
                message: "Please Enter correct username."
            });
        }

    })
}





// Get Business customer details
export const getDetailsById = async (req, res) => {

    const getDetails = await Customers.findOne(
        { _id: new ObjectId(req.params.id) },
        'business_name gst name mobile payment_settlement pickupday'
    );
    // const getDetails = await Customers.findOne({ _id: new ObjectId(req.params.id) });

    if (getDetails) {
        console.log(getDetails)
        return res.send(
            {
                error: false,
                data: getDetails
            });
    } else {
        return res.send(
            {
                error: true,
                data: []
            });
    }
};









// Check wheather customer exist or not
export const checkCust = async (req, res) => {
    await Customers.find({ mobile: req.params.mobile, isDelete: { $in: [false, true] }, isActive: { $in: [false, true] } }).then((cust) => {
        // console.log(cust);
        if (cust.length > 0) {
            return res.json({
                isSuccess: true,
                msg: "Customer exist in db."
            })
        } else {
            return res.json({
                isSuccess: true,
                msg: "Customer not exist in db."
            })
        }
    })
}
export const storeDeviceInfo = async (req, res) => {
    if (!req.params.id) {
        return res.status(200).send({ isSuccess: false, message: "Please provide customer id." });
    }
    if (!req.body) {
        return res.status(200).send({ isSuccess: false, message: "Please provide device info." });
    }
    try {

        const updateDetails = await Customers.findOneAndUpdate({
            _id: new ObjectId(req.params.id)
        }, {
            $set: {
                deviceInfo: req.body
            }
        }, {
            new: true,
            upsert: true
        })
        if (updateDetails) {
            return res.status(200).send({ isSuccess: true, message: "device info updated successfully.", data: updateDetails });
        } else {
            return res.status(200).send({ isSuccess: false, message: "device info not updated successfully." });
        }
    }
    catch (err) {
        console.log(err)
        const message = err.message || "Something went wrong.";
        return res.status(500).send({ isSuccess: false, message });
    }
}
export const LogoutCustomer = async (req, res) => {
    if (!req.params.id) {
        return res.status(200).send({ isSuccess: false, message: "Please provide customer id." });
    }
    try {
        const updateDetails = await Customers.findOneAndUpdate({
            _id: new ObjectId(req.params.id)
        }, {
            $set: {
                lastLogout: new Date()
            }
        }, {
            new: true,
        })
        if (updateDetails) {
            return res.status(200).send({ isSuccess: true, message: "Logout successfully.", data: updateDetails });
        } else {
            return res.status(200).send({ isSuccess: false, message: "Logout not successfully." });
        }
    }
    catch (err) {
        console.log(err)
        const message = err.message || "Something went wrong.";
        return res.status(500).send({ isSuccess: false, message });
    }

}

export const emailFinder = async (req, res) => {
    const { email } = req.body
    if (!email) {
        return res.status(400).json({ isSuccess: false, message: "Email is required" })
    }
    try {

        const customer = await Customers.findOne({ email: email, isDelete: false })
        if (customer) {
            return res.status(200).json({
                isSuccess: true,
                customer,
                message: "Customer found"
            })
        }
        else {
            return res.status(200).json({
                isSuccess: false,
                message: "Customer not found"
            })
        }
    }
    catch (err) {
        console.log("Getting error is", err)
        res.status(500).json({
            isSuccess: false,
            message: "Something went wrong"
        })
    }
}
export const getCustomersByEmail = async (req, res) => {
    const customers = await Customers.find({ email: (req.params.email), isDelete: false });
    res.send(customers)
}









export const setAllCustmrcitystate = async (req, res) => {
    try {
        const addresses = await Address.find({}, 'PIN');
        const uniquePincodes = new Set(addresses.map(address => address.PIN));

        const pinCityStateArray = [];
        const postalApiPromises = [...uniquePincodes].map(async (pincode) => {
            try {
                const apiResponse = await axios.get(`https://api.postalpincode.in/pincode/${pincode}`);
                const data = apiResponse.data[0];

                if (data.Status === 'Success' && data.PostOffice && data.PostOffice.length > 0) {
                    const postOffices = data.PostOffice;

                    let city = null;
                    let state = null;

                    // Try to find a city/town from the available PostOffice entries
                    for (const postOffice of postOffices) {
                        // Check if the name or division name matches a city-like entity
                        if (postOffice.Name && postOffice.Name.toLowerCase().includes("bhubaneswar")) {
                            city = postOffice.Name;
                        } else if (postOffice.Division && postOffice.Division.toLowerCase().includes("bhubaneswar")) {
                            city = postOffice.Division;
                        }

                        // State is usually consistent across entries, so we can extract it directly
                        if (!state) {
                            state = postOffice.State;
                        }
                    }

                    // If no specific city is found, use District as a fallback
                    if (!city) {
                        city = postOffices[0].District;
                    }

                    return {
                        pin: pincode,
                        city: city,
                        state: state
                    };
                }
            } catch (error) {
                console.error(`Error fetching data for pincode ${pincode}: `, error.message);
            }
            return null;
        });

        const results = await Promise.all(postalApiPromises);

        const validResults = results.filter(result => result !== null);
        pinCityStateArray.push(...validResults);
        const jsonData = JSON.stringify(pinCityStateArray, null, 2);
        fs.writeFileSync('pinCityState.json', jsonData, 'utf-8');
        res.status(200).json({ message: "City and state mapping saved successfully", data: pinCityStateArray });
    } catch (error) {
        console.error(error);
        res.status(500).json({ error: "An error occurred while processing the request" });
    }
};


export const NewverifyOTP = async (req, res) => {
    try {
        // Input validation (sanitize and validate mobile and OTP)
        const mobile = req.body.mobile;
        const OTP = req.body.OTP;

        if (!mobile || !OTP) {
            return res.send({
                error: true,
                message: "Mobile and OTP are required fields."
            });
        }

        // Query the database for customer data
        const customerData = await Customers.findOne({ mobile: mobile, isDelete: false });
        const getOTP = await Verifyotp.findOne({ mobile });
        if (customerData) {
            // if (customerData.OTP == OTP) {
            return res.send({
                isSuccess: true,
                message: "Customer already exists",
                customerDetails: customerData
            });
        }
        else {
            return res.send({
                isSuccess: true,
                message: "Customer doesn't exists",
                customerDetails: {}
            });
        }

        // } else {
        //     return res.send({
        //         isSuccess: false,
        //         message: "Wrong OTP enter.",
        //         // customerDetails: customerData
        //     });
        // }

    }
    catch (error) {
        console.error(error);
        return res.send({
            error: true,
            message: "Internal server error"
        });
    }
};
const timeout = new Promise((resolve) =>
    setTimeout(() => resolve('timeout'), 500)
);

export const Newlogin = async (req, res) => {
    await Customers.findOne({
        mobile: req.body.mobile,
        isDelete: false
    }).then(async (data) => {
        console.log(data);
        if (data) {
            let generatedCode = []
            if (data.name != "") {
                var x = (data.name).split(' ')[0]
                if (x.length >= 4) {
                    x = x.substring(0, 4)
                    x = x.toUpperCase();
                } else {
                    x = x.toUpperCase();
                }

                generatedCode = generateReferralCode({
                    prefix: x,
                    length: 6,
                    charset: '0123456789',
                });
            } else {
                generatedCode = [];
            }
            if (data.refCode) {
            } else if (!data.refCode || data.refCode == '') {
                await Customers.findOneAndUpdate({
                    mobile: req.body.mobile,
                    isDelete: false
                }, { $set: { refCode: generatedCode[0] } })
            }
        } else { }




        console.log("user", data);
        if (data) {
            // generate OTP
            const otp = Math.floor(1000 + Math.random() * 9000);
            console.log(otp);
            const existingOtp = await Verifyotp.findOne({ mobile: req.body.mobile });
        if (existingOtp) {
            await Verifyotp.findOneAndUpdate(
                { mobile: req.body.mobile },
                { $set: { OTP: otp } }
            );
        } else {
            await Verifyotp.create({ mobile: req.body.mobile, OTP: otp });
        }

            

            const headers = {
                'Authorization': 'Basic Q2VpYmE6Wjd5S3V4Qno=',
            };
            const auth = {
                username: 'Ceiba',
                password: 'Z7yKuxBz',
            }
            try {
                const responsePromise = axios.post(
                    `https://app.crunchysms.com:3001/rest/send_sms?senderId=CEIBA&msg=Use OTP ${otp} to log into your Recycle Pay account. Donot share the OTP or your number with anyone. CEIBA GREEN&destAddr=91${req.body.mobile}&command=submit&flash=0&dataCoding=0&PE_ID=1701169770111580785&TEMP_ID=1707169787605858070`,
                    null, // No request body
                    {
                        headers: headers,
                        auth: auth,
                    }
                );

                // Use Promise.race to handle the timeout and the response
                const result = await Promise.race([responsePromise, timeout]);
                console.log("To,e poyu resu;t is", result)
                if (result === 'timeout') {
                    console.log('CrunchySMS did not respond in time.');
                    // If no response, still return success message
                    return res.send({
                        isSuccess: true,
                        customerDetails: data,
                        message: "OTP sent successfully"

                    });
                }
                else if (result) {
                    return res.send({
                        isSuccess: true,
                        customerDetails: data,
                        message: "OTP sent successfully"

                    });
                } else {
                    return res.send({
                        isSuccess: true,
                        customerDetails: data,
                        message: "OTP sent successfully"

                    });
                }
            } catch (error) {
                console.error(error);
            }


            // const response = await axios.get(`https://app.crunchysms.com:3001/rest/send_sms?senderId=CEIBA&msg=Use OTP ${otp} to log into your Recycle Pay account.
            // Donot share the OTP or your number with anyone. CEIBA GREEN&destAddr=${req.body.mobile}&command=submit&flash=0&dataCoding=0&PE_ID=1701169770111580785&TEMP_ID=1707169787605858070`, {
            //     headers: headers,
            //     })



        } else {
            console.log("No data Found Api firefd ")
            // generate OTP
            const otp = Math.floor(1000 + Math.random() * 9000);
            console.log(otp);
            const existingOtp = await Verifyotp.findOne({ mobile: req.body.mobile });
        if (existingOtp) {
            await Verifyotp.findOneAndUpdate(
                { mobile: req.body.mobile },
                { $set: { OTP: otp } }
            );
        } else {
            await Verifyotp.create({ mobile: req.body.mobile, OTP: otp });
        }
            const headers = {
                'Authorization': 'Basic Q2VpYmE6Wjd5S3V4Qno=',
            };
            const auth = {
                username: 'Ceiba',
                password: 'Z7yKuxBz',
            }
            try {
                const responsePromise = axios.post(
                    `https://app.crunchysms.com:3001/rest/send_sms?senderId=CEIBA&msg=Use OTP ${otp} to log into your Recycle Pay account. Donot share the OTP or your number with anyone. CEIBA GREEN&destAddr=91${req.body.mobile}&command=submit&flash=0&dataCoding=0&PE_ID=1701169770111580785&TEMP_ID=1707169787605858070`,
                    null,
                    {
                        headers: headers,
                        auth: auth,
                    }
                );

                // Define the timeout promise
                const timeoutPromise = new Promise((resolve) => {
                    setTimeout(() => resolve('timeout'), 5000); // 5-second timeout
                });
                const result = await Promise.race([responsePromise, timeoutPromise]);
                console.log("outside timeout fired ", result)
                if (result === 'timeout') {
                    console.log('CrunchySMS did not respond in time.');
                    // If no response, still return success message
                    return res.send({
                        isSuccess: true,
                        message: "OTP sent successfully",
                        customerDetails: {},
                    });
                }

                else if (result) {
                    return res.send({
                        isSuccess: true,
                        message: "OTP sent successfully",
                        customerDetails: {},
                    }); 

                }

            } catch (error) {
                console.error(error);
            }



        }
    });
};
export const getAllCustomer = async (req, res) => {
    try {
        const limit = parseInt(req.query.limit) || 10; 
        const page = parseInt(req.query.offset) || 1; 
        const { name, email, mobile } = req.query;

        const skip = (page - 1) * limit;

        console.log("Backend Received -> Page:", page, "Limit:", limit, "Skip:", skip);

        // Build dynamic filter object
        let filter = {};
        if (name) filter.name = { $regex: name, $options: "i" }; // Case-insensitive search
        if (email) filter.email = { $regex: email, $options: "i" };
        if (mobile) filter.mobile = { $regex: mobile, $options: "i" };

        // Fetch customers with filtering, sorting, limit, and skip
        const cust_data = await Customers.find(filter)
            .sort({ createdAt: -1 }) 
            .skip(skip)
            .limit(limit);

        const totalCustomers = await Customers.countDocuments(filter);

        res.status(200).json({
            totalCustomers,
            limit,
            page,
            data: cust_data,
        });
    } catch (error) {
        res.status(500).json({ message: "Error fetching customers", error: error.message });
    }
};

