import mongoose from "mongoose";
import Orders from "../model/order.model.js";
import Items from "../model/items.model.js";
import Orderitems from "../model/orderitem.model.js";
import Customers from "../model/customer.model.js";
const ObjectId = mongoose.Types.ObjectId;



export const overalqty = async (req, res) => {
    const today = new Date().toISOString().split('T')[0];
    const parts = today.split('-');
    const reversedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
    console.log(reversedDate, new Date());
    // const pipeline1 = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: parseInt(2024),
    //                                     month: { $subtract: [{ $month: new Date() }, 0] }, // Adjusted to subtract 0 months (current month)
    //                                     day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },  
    //     {
    //         $unwind: "$item"
    //     },      
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" }
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: "$_id.month",
    //                 year: "$_id.year",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];

    const currentYear = new Date().getFullYear();

    const pipeline1 = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $gte: [
                                "$schedule_date_iso",
                                {
                                    $dateFromParts: {
                                        year: currentYear,
                                        month: { $subtract: [{ $month: new Date() }, 0] },
                                        day: 1
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    },
                    {
                        customer_id: new mongoose.Types.ObjectId(req.params.custid)
                    }
                ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: {
                    month: { $month: "$schedule_date_iso" },
                    year: { $year: "$schedule_date_iso" },
                    orderedItems: "$orderedItems"
                },
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalEmission: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.weight" },
                            { $toDouble: "$categoryItems.emission" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                categoryItems: {
                    $addToSet: "$categoryItems.emission"
                }
            }
        },
        {
            $group: {
                _id: {
                    month: "$_id.month",
                    year: "$_id.year"
                },
                items: {
                    $push: {
                        item_name: "$_id.orderedItems.item_name",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        totalEmission: "$totalEmission",
                        unit: "$_id.orderedItems.unit",
                        categoryItems: "$categoryItems"
                    }
                },
                totalAmount: { $sum: "$totalAmount" },
                totalWeight: { $sum: "$totalWeight" }
            }
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        {
            $project: {
                _id: 0,
                monthAndYear: "$_id",
                items: 1,
                // categoryDetails: {
                //     item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                //     emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                // },
                // totalAmount: 1,
                // totalWeight: 1,
                // footprint: {
                //     $map: {
                //         input: "$items.totalEmission",
                //         as: "e",
                //         in: { $multiply: ["$$e", "$totalWeight"] }
                //     }
                // }
            }
        },
        // {
        //     $sort: { totalAmount: -1 }
        // }

        {
            $sort: {
                "monthAndYear.year": 1,
                "monthAndYear.month": 1
            }
        }
    ];


    // const pipeline2 = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: new Date().getFullYear(), // Match with the current year
    //                                     // month: 1, // Start of the year (January)
    //                                     // day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {                        
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 // month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" }
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 // month: "$_id.month",
    //                 year: "$_id.year",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             // month: { $month: "$schedule_date_iso" },
    //     //             year: { $year: "$schedule_date_iso" }
    //     //         },
    //     //         totalEstPrice: { $sum: "$est_price" },
    //     //         totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //     //     }
    //     // },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];


    const pipeline2 = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $gte: [
                                "$schedule_date_iso",
                                {
                                    $dateFromParts: {
                                        year: currentYear,
                                        // month: { $subtract: [{ $month: new Date() }, 0] },
                                        // day: 1
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    },
                    {
                        customer_id: new mongoose.Types.ObjectId(req.params.custid)
                    }
                ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: {
                    // month: { $month: "$schedule_date_iso" },
                    year: { $year: "$schedule_date_iso" },
                    orderedItems: "$orderedItems"
                },
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalEmission: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.weight" },
                            { $toDouble: "$categoryItems.emission" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                categoryItems: {
                    $addToSet: "$categoryItems.emission"
                }
            }
        },
        {
            $group: {
                _id: {
                    // month: "$_id.month",
                    year: "$_id.year"
                },
                items: {
                    $push: {
                        item_name: "$_id.orderedItems.item_name",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        totalEmission: "$totalEmission",
                        unit: "$_id.orderedItems.unit",
                        categoryItems: "$categoryItems"
                    }
                },
                totalAmount: { $sum: "$totalAmount" },
                totalWeight: { $sum: "$totalWeight" }
            }
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        {
            $project: {
                _id: 0,
                monthAndYear: "$_id",
                items: 1,
                // categoryDetails: {
                //     item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                //     emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                // },
                // totalAmount: 1,
                // totalWeight: 1,
                // footprint: {
                //     $map: {
                //         input: "$items.totalEmission",
                //         as: "e",
                //         in: { $multiply: ["$$e", "$totalWeight"] }
                //     }
                // }
            }
        },
        // {
        //     $sort: { totalAmount: -1 }
        // }

        {
            $sort: {
                "monthAndYear.year": 1,
                // "monthAndYear.month": 1
            }
        }
    ];

    const result1 = await Orders.aggregate(pipeline1);
    const result2 = await Orders.aggregate(pipeline2);

    if (result1 && result2) {
        res.json({
            isSuccess: true,
            message: "Items sort by estimate purchase.",
            result1: result1,
            result2: result2,
        });
    } else {
        res.json({
            isSuccess: false,
            result1: [],
            result2: [],
            message: "Something went wrong.",
        });
    }
}



export const allOveralqty = async (req, res) => {
    const today = new Date().toISOString().split('T')[0];
    const parts = today.split('-');
    const reversedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
    console.log(reversedDate, new Date());
    // const pipeline1 = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: parseInt(2024),
    //                                     month: { $subtract: [{ $month: new Date() }, 0] }, // Adjusted to subtract 0 months (current month)
    //                                     day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },  
    //     {
    //         $unwind: "$item"
    //     },      
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" }
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: "$_id.month",
    //                 year: "$_id.year",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];

    const currentYear = new Date().getFullYear();

    const pipeline1 = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $gte: [
                                "$schedule_date_iso",
                                {
                                    $dateFromParts: {
                                        year: {
                                            $cond: [
                                                { $gte: [{ $month: new Date() }, 11] }, // If current month is November or later
                                                currentYear, // Use currentYear
                                                { $subtract: [currentYear, 1] } // Otherwise, use previous year
                                            ]
                                        },
                                        month: {
                                            $cond: [
                                                { $gte: [{ $month: new Date() }, 11] }, // If current month is November or later
                                                { $subtract: [{ $month: new Date() }, 10] }, // Use current month minus 10
                                                { $add: [{ $month: new Date() }, 2] } // Otherwise, add 2 to current month
                                            ]
                                        },
                                        day: 1
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    }
                ]
            }
            
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: {
                    month: { $month: "$schedule_date_iso" },
                    year: { $year: "$schedule_date_iso" },
                    orderedItems: "$orderedItems"
                },
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalEmission: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.weight" },
                            { $toDouble: "$categoryItems.emission" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                categoryItems: {
                    $addToSet: "$categoryItems.emission"
                }
            }
        },
        {
            $group: {
                _id: {
                    month: "$_id.month",
                    year: "$_id.year"
                },
                items: {
                    $push: {
                        item_name: "$_id.orderedItems.item_name",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        totalEmission: "$totalEmission",
                        unit: "$_id.orderedItems.unit",
                        categoryItems: "$categoryItems"
                    }
                },
                totalAmount: { $sum: "$totalAmount" },
                totalWeight: { $sum: "$totalWeight" }
            }
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        {
            $project: {
                _id: 0,
                monthAndYear: "$_id",
                items: 1,
                // categoryDetails: {
                //     item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                //     emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                // },
                // totalAmount: 1,
                // totalWeight: 1,
                // footprint: {
                //     $map: {
                //         input: "$items.totalEmission",
                //         as: "e",
                //         in: { $multiply: ["$$e", "$totalWeight"] }
                //     }
                // }
            }
        },
        // {
        //     $sort: { totalAmount: -1 }
        // }

        {
            $sort: {
                "monthAndYear.year": 1,
                "monthAndYear.month": 1
            }
        }
    ];


    // const pipeline2 = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: new Date().getFullYear(), // Match with the current year
    //                                     // month: 1, // Start of the year (January)
    //                                     // day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {                        
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 // month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" }
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 // month: "$_id.month",
    //                 year: "$_id.year",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             // month: { $month: "$schedule_date_iso" },
    //     //             year: { $year: "$schedule_date_iso" }
    //     //         },
    //     //         totalEstPrice: { $sum: "$est_price" },
    //     //         totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //     //     }
    //     // },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];


    const pipeline2 = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            // $match: {
            //     $and: [
            //         {
            //             $expr: {
            //                 $gte: [
            //                     "$schedule_date_iso",
            //                     {
            //                         $dateFromParts: {
            //                             year: currentYear,
            //                             // month: { $subtract: [{ $month: new Date() }, 0] },
            //                             // day: 1
            //                         }
            //                     }
            //                 ]
            //             }
            //         },
            //         {
            //             $or: [
            //                 { status: "processed" },
            //                 { status: "cash" },
            //                 { status: "Payment successful" }
            //             ]
            //         },
            //         // {
            //         //     customer_id: new mongoose.Types.ObjectId(req.params.custid)
            //         // }
            //     ]
            // }
            $match: {
                $and: [
                    {
                        $expr: {
                            $gte: [
                                "$schedule_date_iso",
                                {
                                    $dateFromParts: {
                                        year: {
                                            $cond: [
                                                { $gte: [{ $month: new Date() }, 11] }, // If current month is November or later
                                                currentYear, // Use currentYear
                                                { $subtract: [currentYear, 1] } // Otherwise, use previous year
                                            ]
                                        },
                                        month: {
                                            $cond: [
                                                { $gte: [{ $month: new Date() }, 11] }, // If current month is November or later
                                                { $subtract: [{ $month: new Date() }, 10] }, // Use current month minus 10
                                                { $add: [{ $month: new Date() }, 2] } // Otherwise, add 2 to current month
                                            ]
                                        },
                                        day: 1
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    }
                ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: {
                    // month: { $month: "$schedule_date_iso" },
                    // year: { $year: "$schedule_date_iso" },
                    orderedItems: "$orderedItems"
                },
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalEmission: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.weight" },
                            { $toDouble: "$categoryItems.emission" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                categoryItems: {
                    $addToSet: "$categoryItems.emission"
                }
            }
        },
        {
            $group: {
                _id: {
                    // month: "$_id.month",
                    // year: "$_id.year"
                },
                items: {
                    $push: {
                        item_name: "$_id.orderedItems.item_name",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        totalEmission: "$totalEmission",
                        unit: "$_id.orderedItems.unit",
                        categoryItems: "$categoryItems"
                    }
                },
                totalAmount: { $sum: "$totalAmount" },
                totalWeight: { $sum: "$totalWeight" }
            }
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        {
            $project: {
                _id: 0,
                monthAndYear: "$_id",
                items: 1,
                // categoryDetails: {
                //     item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                //     emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                // },
                // totalAmount: 1,
                // totalWeight: 1,
                // footprint: {
                //     $map: {
                //         input: "$items.totalEmission",
                //         as: "e",
                //         in: { $multiply: ["$$e", "$totalWeight"] }
                //     }
                // }
            }
        },
        // {
        //     $sort: { totalAmount: -1 }
        // }

        {
            $sort: {
                "monthAndYear.year": 1,
                // "monthAndYear.month": 1
            }
        }
    ];

    const result1 = await Orders.aggregate(pipeline1);
    const result2 = await Orders.aggregate(pipeline2);

    if (result1 && result2) {
        res.json({
            isSuccess: true,
            message: "All Items sort by estimate purchase.",
            result1: result1,
            result2: result2,
        });
    } else {
        res.json({
            isSuccess: false,
            result1: [],
            result2: [],
            message: "Something went wrong.",
        });
    }
}



export const monthAvg12Month = async (req, res) => {
    // console.log(req.params.year);
    // const pipeline = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: new Date().getFullYear(), // Match with the current year
    //                                     month: 1, // Start of the year (January)
    //                                     day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },  
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" },
    //                 // itemid: { $itemid: "$orderedItems._id"}
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             month: "$_id.month",
    //     //             year: "$_id.year",
    //     //             // categoryItemId: "$categoryItems._id"
    //     //         },
    //     //         totalEstPrice: { $first: "$totalEstPrice" },
    //     //         totalWeight: { $first: "$totalWeight" },
    //     //         // emissionsum: { $sum: { $toDouble: "$categoryItems.emission" } },
    //     //         categoryItem: { $first: "$categoryItems" },
    //     //     }
    //     // },
    //     {
    //         $group: {
    //             _id: {
    //                 month: "$_id.month",
    //                 year: "$_id.year",
    //                 // itemid: "$_id.itemid",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];


    const currentYear = new Date().getFullYear();

    const pipeline = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $gte: [
                                "$schedule_date_iso",
                                {
                                    $dateFromParts: {
                                        year: currentYear,
                                        month: 1,
                                        day: 1
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    },
                    {
                        customer_id: new mongoose.Types.ObjectId(req.params.custid)
                    }
                ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: {
                    month: { $month: "$schedule_date_iso" },
                    year: { $year: "$schedule_date_iso" },
                    orderedItems: "$orderedItems"
                },
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalEmission: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.weight" },
                            { $toDouble: "$categoryItems.emission" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                categoryItems: {
                    $addToSet: "$categoryItems.emission"
                }
            }
        },
        {
            $group: {
                _id: {
                    month: "$_id.month",
                    year: "$_id.year"
                },
                items: {
                    $push: {
                        item_name: "$_id.orderedItems.item_name",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        totalEmission: "$totalEmission",
                        unit: "$_id.orderedItems.unit",
                        categoryItems: "$categoryItems"
                    }
                },
                totalAmount: { $sum: "$totalAmount" },
                totalWeight: { $sum: "$totalWeight" }
            }
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        {
            $project: {
                _id: 0,
                monthAndYear: "$_id",
                items: 1,
                // categoryDetails: {
                //     item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                //     emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                // },
                // totalAmount: 1,
                // totalWeight: 1,
                // footprint: {
                //     $map: {
                //         input: "$items.totalEmission",
                //         as: "e",
                //         in: { $multiply: ["$$e", "$totalWeight"] }
                //     }
                // }
            }
        },
        // {
        //     $sort: { totalAmount: -1 }
        // }

        {
            $sort: {
                "monthAndYear.year": 1,
                "monthAndYear.month": 1
            }
        }
    ];


    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "12 month Estimate amount.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
            result: [],
        });
    }
}


export const allMonthAvg12Month = async (req, res) => {
    // console.log(req.params.year);
    // const pipeline = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: new Date().getFullYear(), // Match with the current year
    //                                     month: 1, // Start of the year (January)
    //                                     day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },  
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" },
    //                 // itemid: { $itemid: "$orderedItems._id"}
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             month: "$_id.month",
    //     //             year: "$_id.year",
    //     //             // categoryItemId: "$categoryItems._id"
    //     //         },
    //     //         totalEstPrice: { $first: "$totalEstPrice" },
    //     //         totalWeight: { $first: "$totalWeight" },
    //     //         // emissionsum: { $sum: { $toDouble: "$categoryItems.emission" } },
    //     //         categoryItem: { $first: "$categoryItems" },
    //     //     }
    //     // },
    //     {
    //         $group: {
    //             _id: {
    //                 month: "$_id.month",
    //                 year: "$_id.year",
    //                 // itemid: "$_id.itemid",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];


    const currentYear = new Date().getFullYear();

    const pipeline = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $or: [
                                {
                                    // Filter for November 2023 to December 2023
                                    $and: [
                                        { $eq: [{ $year: "$schedule_date_iso" }, currentYear - 1] },
                                        { $gte: [{ $month: "$schedule_date_iso" }, 11] } // November
                                    ]
                                },
                                {
                                    // Filter for January 2024 to October 2024
                                    $and: [
                                        { $eq: [{ $year: "$schedule_date_iso" }, currentYear] },
                                        { $lte: [{ $month: "$schedule_date_iso" }, 10] } // October
                                    ]
                                }
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    }
                ]
            }
            
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: {
                    month: { $month: "$schedule_date_iso" },
                    year: { $year: "$schedule_date_iso" },
                    orderedItems: "$orderedItems"
                },
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalEmission: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.weight" },
                            { $toDouble: "$categoryItems.emission" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                categoryItems: {
                    $addToSet: "$categoryItems.emission"
                }
            }
        },
        {
            $group: {
                _id: {
                    month: "$_id.month",
                    year: "$_id.year"
                },
                items: {
                    $push: {
                        item_name: "$_id.orderedItems.item_name",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        totalEmission: "$totalEmission",
                        unit: "$_id.orderedItems.unit",
                        categoryItems: "$categoryItems"
                    }
                },
                totalAmount: { $sum: "$totalAmount" },
                totalWeight: { $sum: "$totalWeight" }
            }
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        {
            $project: {
                _id: 0,
                monthAndYear: "$_id",
                items: 1,
                // categoryDetails: {
                //     item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                //     emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                // },
                // totalAmount: 1,
                // totalWeight: 1,
                // footprint: {
                //     $map: {
                //         input: "$items.totalEmission",
                //         as: "e",
                //         in: { $multiply: ["$$e", "$totalWeight"] }
                //     }
                // }
            }
        },
        // {
        //     $sort: { totalAmount: -1 }
        // }

        {
            $sort: {
                "monthAndYear.year": 1,
                "monthAndYear.month": 1
            }
        }
    ];


    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "12 month Estimate amount.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
            result: [],
        });
    }
}



export const itemwise = async (req, res) => {
    const pipeline = [
        {
            $match: {
                $and: [{
                    $or: [
                        { status: "processed" },
                        { status: "cash" }
                    ]
                },
                {
                    customer_id: new mongoose.Types.ObjectId(req.params.custid)
                }
            ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $group: {
                _id: "$orderedItems.item_name",
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                orderedItems: { $first: "$orderedItems" } // Select the first orderedItems document
            }
        },
        // {
        //     $group: {
        //         _id: "$orderedItems.category", // Group by the category field within orderedItems
        //         items: {
        //             $push: {
        //                 item_name: "$_id",
        //                 totalWeight: "$totalWeight",
        //                 totalAmount: "$totalAmount",
        //                 unit: "$orderedItems.unit"
        //             }
        //         },
        //         totalAmount: { $sum: "$totalAmount" }, // Calculate the sum of totalAmount for each category
        //         totalWeight: { $sum: "$totalWeight" }  // Calculate the sum of totalWeight for each category
        //     }
        // },
        // {
        //     $lookup: {
        //         from: "itemcategories", // Assuming the collection name is itemcategories
        //         localField: "_id",
        //         foreignField: "_id",
        //         as: "categoryDetails"
        //     }
        // },
        // {
        //     $project: {
        //         _id: 0,
        //         category: "$_id",
        //         items: 1,
        //         categoryDetails: { $arrayElemAt: ["$categoryDetails.item_name", 0] }, // Include the joined category details
        //         totalAmount: 1, // Include the sum of totalAmount for each category
        //         totalWeight: 1  // Include the sum of totalWeight for each category
        //     }
        // },
        {
            $sort: { totalAmount: -1 } // Sort by totalAmount in descending order
        }
    ];



    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Estimate weight and price for each item.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
            result: [],
        });
    }
}



export const categoryAvgItem = async (req, res) => {
    console.log(req.params.custid);
    const pipeline = [
        {
            $match: {
                $and: [
                    {
                        $or: [
                    { status: "processed" },
                    { status: "cash" }
                ]
            },
                {
                    customer_id: new mongoose.Types.ObjectId(req.params.custid)
                }
            ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: "$orderedItems.item_name",
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                orderedItems: { $first: "$orderedItems" } // Select the first orderedItems document
            }
        },
        {
            $group: {
                _id: "$orderedItems.category", // Group by the category field within orderedItems
                items: {
                    $push: {
                        item_name: "$_id",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        unit: "$orderedItems.unit",
                        categoryItems: "$categoryItems.emission"
                    }
                },
                totalAmount: { $sum: "$totalAmount" }, // Calculate the sum of totalAmount for each category
                totalWeight: { $sum: "$totalWeight" }  // Calculate the sum of totalWeight for each category
            }
        },
        {
            $lookup: {
                from: "itemcategories", // Assuming the collection name is itemcategories
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        // {
        //     $project: {
        //         _id: 0,
        //         category: "$_id",
        //         items: 1,
        //         categoryDetails: { item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
        //         emission: { $arrayElemAt: ["$categoryDetails.emission", 0] } }, // Include the joined category details
        //         totalAmount: 1, // Include the sum of totalAmount for each category
        //         totalWeight: 1,  // Include the sum of totalWeight for each category
        //         footprint: { $multiply: ["$categoryDetails.emission", "$totalWeight"] },
        //     }
        // },
        {
            $project: {
                _id: 0,
                category: "$_id",
                items: 1,
                categoryDetails: {
                    item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                    emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                },
                totalAmount: 1,
                totalWeight: 1,
                footprint: {
                    $map: {
                        input: "$categoryDetails.emission",
                        as: "e",
                        in: { $multiply: ["$$e", "$totalWeight"] }
                    }
                }
            }
        },        
        {
            $sort: { totalAmount: -1 } // Sort by totalAmount in descending order
        }
    ];



    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Total estimate weight and price for each item-catagory.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
}



export const allCategoryAvgItem = async (req, res) => {
    // console.log(req.params.custid);
    const currentYear = new Date().getFullYear();
    const currentMonth = new Date().getMonth() + 1;
    const pipeline = [
        {
            $match: {
                $and: [
                    {
                        $or: [
                    { status: "processed" },
                    { status: "cash" }
                ]
            },
                // {
                //     customer_id: new mongoose.Types.ObjectId(req.params.custid)
                // }
            ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: "$orderedItems.item_name",
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                orderedItems: { $first: "$orderedItems" } // Select the first orderedItems document
            }
        },
        {
            $group: {
                _id: "$orderedItems.category", // Group by the category field within orderedItems
                items: {
                    $push: {
                        item_name: "$_id",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        unit: "$orderedItems.unit",
                        categoryItems: "$categoryItems.emission"
                    }
                },
                totalAmount: { $sum: "$totalAmount" }, // Calculate the sum of totalAmount for each category
                totalWeight: { $sum: "$totalWeight" }  // Calculate the sum of totalWeight for each category
            }
        },
        {
            $lookup: {
                from: "itemcategories", // Assuming the collection name is itemcategories
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        // {
        //     $project: {
        //         _id: 0,
        //         category: "$_id",
        //         items: 1,
        //         categoryDetails: { item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
        //         emission: { $arrayElemAt: ["$categoryDetails.emission", 0] } }, // Include the joined category details
        //         totalAmount: 1, // Include the sum of totalAmount for each category
        //         totalWeight: 1,  // Include the sum of totalWeight for each category
        //         footprint: { $multiply: ["$categoryDetails.emission", "$totalWeight"] },
        //     }
        // },
        {
            $project: {
                _id: 0,
                category: "$_id",
                items: 1,
                categoryDetails: {
                    item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                    emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                },
                totalAmount: 1,
                totalWeight: 1,
                footprint: {
                    $map: {
                        input: "$categoryDetails.emission",
                        as: "e",
                        in: { $multiply: ["$$e", "$totalWeight"] }
                    }
                }
            }
        },        
        {
            $sort: { totalAmount: -1 } // Sort by totalAmount in descending order
        }
    ];



    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Total estimate weight and price for each item-catagory.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
}



export const monthAvgCurrentMonth = async (req, res) => {
    // console.log(req.params.year);
    // const pipeline = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: new Date().getFullYear(), // Match with the current year
    //                                     month: 1, // Start of the year (January)
    //                                     day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $expr: {
    //                         $eq: [
    //                             { $month: "$schedule_date_iso" },
    //                             new Date().getMonth() + 1 // Adding 1 to match with MongoDB's 1-based month indexing
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },        
    //     {
    //         $unwind: "$item"
    //     },  
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" }
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             month: "$_id.month",
    //     //             year: "$_id.year",
    //     //             // categoryItemId: "$categoryItems._id"
    //     //         },
    //     //         totalEstPrice: { $first: "$totalEstPrice" },
    //     //         totalWeight: { $first: "$totalWeight" },
    //     //         // emissionsum: { $sum: { $toDouble: "$categoryItems.emission" } },
    //     //         categoryItem: { $first: "$categoryItems" },
    //     //     }
    //     // },
    //     {
    //         $group: {
    //             _id: {
    //                 month: "$_id.month",
    //                 year: "$_id.year",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];


    const pipeline = [
        // {
        //     $match: {
        //         $and: [
        //             {
        //                 $or: [
        //             { status: "processed" },
        //             { status: "cash" }
        //         ]
        //     },
        //         {
        //             customer_id: new mongoose.Types.ObjectId(req.params.custid)
        //         }
        //     ]
        //     }
        // },
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $gte: [
                                "$schedule_date_iso",
                                {
                                    $dateFromParts: {
                                        year: new Date().getFullYear(),
                                        month: 1,
                                        day: 1
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $expr: {
                            $eq: [
                                { $month: "$schedule_date_iso" },
                                new Date().getMonth() + 1 
                            ]
                        }
                    },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    },
                    {
                        customer_id: new mongoose.Types.ObjectId(req.params.custid)
                    }
                ]
            }
        },        
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: "$orderedItems.item_name",
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                orderedItems: { $first: "$orderedItems" } // Select the first orderedItems document
            }
        },
        {
            $group: {
                _id: "$orderedItems.category", // Group by the category field within orderedItems
                items: {
                    $push: {
                        item_name: "$_id",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        unit: "$orderedItems.unit",
                        categoryItems: "$categoryItems.emission"
                    }
                },
                totalAmount: { $sum: "$totalAmount" }, // Calculate the sum of totalAmount for each category
                totalWeight: { $sum: "$totalWeight" }  // Calculate the sum of totalWeight for each category
            }
        },
        {
            $lookup: {
                from: "itemcategories", // Assuming the collection name is itemcategories
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        // {
        //     $project: {
        //         _id: 0,
        //         category: "$_id",
        //         items: 1,
        //         categoryDetails: { item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
        //         emission: { $arrayElemAt: ["$categoryDetails.emission", 0] } }, // Include the joined category details
        //         totalAmount: 1, // Include the sum of totalAmount for each category
        //         totalWeight: 1,  // Include the sum of totalWeight for each category
        //         footprint: { $multiply: ["$categoryDetails.emission", "$totalWeight"] },
        //     }
        // },
        {
            $project: {
                _id: 0,
                category: "$_id",
                items: 1,
                categoryDetails: {
                    item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                    emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                },
                totalAmount: 1,
                totalWeight: 1,
                footprint: {
                    $map: {
                        input: "$categoryDetails.emission",
                        as: "e",
                        in: { $multiply: ["$$e", "$totalWeight"] }
                    }
                }
            }
        },        
        {
            $sort: { totalAmount: -1 } // Sort by totalAmount in descending order
        }
    ];



    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Current month Category wise Estimate amount.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
            result: [],
        });
    }
}




export const allMonthAvgCurrentMonth = async (req, res) => {
    // console.log(req.params.year);
    // const pipeline = [
    //     {
    //         $addFields: {
    //             schedule_date_iso: {
    //                 $dateFromString: {
    //                     dateString: "$schedule_date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $match: {
    //             $and: [
    //                 {
    //                     $expr: {
    //                         $gte: [
    //                             "$schedule_date_iso",
    //                             {
    //                                 $dateFromParts: {
    //                                     year: new Date().getFullYear(), // Match with the current year
    //                                     month: 1, // Start of the year (January)
    //                                     day: 1
    //                                 }
    //                             }
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $expr: {
    //                         $eq: [
    //                             { $month: "$schedule_date_iso" },
    //                             new Date().getMonth() + 1 // Adding 1 to match with MongoDB's 1-based month indexing
    //                         ]
    //                     }
    //                 },
    //                 {
    //                     $or: [
    //                         { status: "processed" },
    //                         { status: "cash" },
    //                         { status: "Payment successful" }
    //                     ]
    //                 },
    //                 {
    //                     customer_id: new mongoose.Types.ObjectId(req.params.custid)
    //                 }
    //             ]
    //         }
    //     },        
    //     {
    //         $unwind: "$item"
    //     },  
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "orderedItems"
    //         }
    //     },
    //     {
    //         $unwind: "$orderedItems"
    //     },
    //     {
    //         $lookup: {
    //             from: "itemcategories",
    //             localField: "orderedItems.category",
    //             foreignField: "_id",
    //             as: "categoryItems"
    //         }
    //     },
    //     {
    //         $unwind: "$categoryItems"
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 month: { $month: "$schedule_date_iso" },
    //                 year: { $year: "$schedule_date_iso" }
    //             },
    //             totalEstPrice: { $sum: "$est_price" },
    //             totalWeight: { $sum: { $toDouble: "$item.weight" } },
    //             categoryItems: {
    //                 $addToSet: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                 }
    //             },
    //         }
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             month: "$_id.month",
    //     //             year: "$_id.year",
    //     //             // categoryItemId: "$categoryItems._id"
    //     //         },
    //     //         totalEstPrice: { $first: "$totalEstPrice" },
    //     //         totalWeight: { $first: "$totalWeight" },
    //     //         // emissionsum: { $sum: { $toDouble: "$categoryItems.emission" } },
    //     //         categoryItem: { $first: "$categoryItems" },
    //     //     }
    //     // },
    //     {
    //         $group: {
    //             _id: {
    //                 month: "$_id.month",
    //                 year: "$_id.year",
    //             },
    //             totalEstPrice: { $first: "$totalEstPrice" },
    //             totalWeight: { $first: "$totalWeight" },
    //             categoryItems: {
    //                 $push: {
    //                     _id: "$categoryItems._id",
    //                     emission: "$categoryItems.emission",
    //                     emissionsum: {
    //                         $reduce: {
    //                             input: "$categoryItems.emission",
    //                             initialValue: 0,
    //                             in: { $sum: ["$$value", "$$this"] }
    //                         }
    //                     }
    //                 }
    //             },
    //         }
    //     },
    //     {
    //         $addFields: {
    //             totalEstPrice: { $round: ["$totalEstPrice", 2] }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "_id.year": 1,
    //             "_id.month": 1
    //         }
    //     }
    // ];

    const currentYear = new Date().getFullYear();

    const pipeline = [
        // {
        //     $match: {
        //         $and: [
        //             {
        //                 $or: [
        //             { status: "processed" },
        //             { status: "cash" }
        //         ]
        //     },
        //         {
        //             customer_id: new mongoose.Types.ObjectId(req.params.custid)
        //         }
        //     ]
        //     }
        // },
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    {
                        $expr: {
                            $or: [
                                {
                                    $and: [
                                        {
                                            $eq: [
                                                { $year: "$schedule_date_iso" },
                                                currentYear - 1 // Previous year
                                            ]
                                        },
                                        {
                                            $gte: [
                                                { $month: "$schedule_date_iso" },
                                                11 // November
                                            ]
                                        }
                                    ]
                                },
                                {
                                    $and: [
                                        {
                                            $eq: [
                                                { $year: "$schedule_date_iso" },
                                                currentYear // Current year
                                            ]
                                        },
                                        {
                                            $lte: [
                                                { $month: "$schedule_date_iso" },
                                                10 // October
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    },
                    // {
                    //     $expr: {
                    //         $eq: [
                    //             { $month: "$schedule_date_iso" },
                    //             new Date().getMonth() + 1 
                    //         ]
                    //     }
                    // },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    },
                    // {
                    //     customer_id: new mongoose.Types.ObjectId(req.params.custid)
                    // }
                ]
            }
        },        
        {
            $unwind: "$item"
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "orderedItems"
            }
        },
        {
            $unwind: "$orderedItems"
        },
        {
            $lookup: {
                from: "itemcategories",
                localField: "orderedItems.category",
                foreignField: "_id",
                as: "categoryItems"
            }
        },
        {
            $unwind: "$categoryItems"
        },
        {
            $group: {
                _id: "$orderedItems.item_name",
                totalAmount: {
                    $sum: {
                        $multiply: [
                            { $toDouble: "$item.price" },
                            { $toDouble: "$item.weight" }
                        ]
                    }
                },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
                orderedItems: { $first: "$orderedItems" } // Select the first orderedItems document
            }
        },
        {
            $group: {
                _id: "$orderedItems.category", // Group by the category field within orderedItems
                items: {
                    $push: {
                        item_name: "$_id",
                        totalWeight: "$totalWeight",
                        totalAmount: "$totalAmount",
                        unit: "$orderedItems.unit",
                        categoryItems: "$categoryItems.emission"
                    }
                },
                totalAmount: { $sum: "$totalAmount" }, // Calculate the sum of totalAmount for each category
                totalWeight: { $sum: "$totalWeight" }  // Calculate the sum of totalWeight for each category
            }
        },
        {
            $lookup: {
                from: "itemcategories", // Assuming the collection name is itemcategories
                localField: "_id",
                foreignField: "_id",
                as: "categoryDetails"
            }
        },
        // {
        //     $project: {
        //         _id: 0,
        //         category: "$_id",
        //         items: 1,
        //         categoryDetails: { item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
        //         emission: { $arrayElemAt: ["$categoryDetails.emission", 0] } }, // Include the joined category details
        //         totalAmount: 1, // Include the sum of totalAmount for each category
        //         totalWeight: 1,  // Include the sum of totalWeight for each category
        //         footprint: { $multiply: ["$categoryDetails.emission", "$totalWeight"] },
        //     }
        // },
        {
            $project: {
                _id: 0,
                category: "$_id",
                items: 1,
                categoryDetails: {
                    item_name: { $arrayElemAt: ["$categoryDetails.item_name", 0] },
                    emission: { $arrayElemAt: ["$categoryDetails.emission", 0] }
                },
                totalAmount: 1,
                totalWeight: 1,
                footprint: {
                    $map: {
                        input: "$categoryDetails.emission",
                        as: "e",
                        in: { $multiply: ["$$e", "$totalWeight"] }
                    }
                }
            }
        },        
        {
            $sort: { totalAmount: -1 } // Sort by totalAmount in descending order
        }
    ];



    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Current month Category wise Estimate amount.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
            result: [],
        });
    }
}










export const overalwst = async (req, res) => {
    const pipeline = [
        {
            $addFields: {
                schedule_date_iso: {
                    $dateFromString: {
                        dateString: "$schedule_date",
                        format: "%d-%m-%Y"
                    }
                }
            }
        },
        {
            $match: {
                $and: [
                    // {
                    //     $expr: {
                    //         $gte: [
                    //             "$schedule_date_iso",
                    //             {
                    //                 $dateFromParts: {
                    //                     year: new Date().getFullYear(), // Match with the current year
                    //                     // month: 1, // Start of the year (January)
                    //                     // day: 1
                    //                 }
                    //             }
                    //         ]
                    //     }
                    // },
                    {
                        $or: [
                            { status: "processed" },
                            { status: "cash" },
                            { status: "Payment successful" }
                        ]
                    },
                    // {                        
                    //     customer_id: new mongoose.Types.ObjectId(req.params.custid)
                    // }
                ]
            }
        },
        {
            $unwind: "$item"
        },
        {
            $group: {
                _id: {
                    // month: { $month: "$schedule_date_iso" },
                    // year: { $year: "$schedule_date_iso" }
                },
                totalEstPrice: { $sum: "$est_price" },
                totalWeight: { $sum: { $toDouble: "$item.weight" } },
            }
        },
        {
            $addFields: {
                totalEstPrice: { $round: ["$totalEstPrice", 2] }
            }
        },
        {
            $sort: {
                "_id.year": 1,
                "_id.month": 1
            }
        }
    ];



    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Total Avg waste collected.",
            result: result,
        });
    } else {
        res.json({
            isSuccess: false,
            result: [],
            message: "Something went wrong.",
        });
    }
}




