import mongoose from "mongoose";
import Customers from "../model/customer.model.js";
import Users from "../model/users.model.js";
import Location from "../model/location.model.js";
import Address from "../model/address.model.js";
import { saveNotificationStatus } from "../controller/customNotify.controller.js"
import Orders from "../model/order.model.js";
// import recyclemintKey from "../recyclemint-a0a42-6554439ea4a8.json" assert { type: 'json' };
import { google } from "googleapis";
import axios from "axios";

const ObjectId = mongoose.Types.ObjectId;

const recyclemintKey = {
  "type": "service_account",
  "project_id": "recyclemint-a0a42",
  "private_key_id": "6554439ea4a8bc9f5461e4748ded2c21d2f6525e",
  "private_key": "-----BEGIN PRIVATE KEY-----\nMIIEvAIBADANBgkqhkiG9w0BAQEFAASCBKYwggSiAgEAAoIBAQCqAT1naKrMJ2bG\nu4CJXM1MnhAE+TgMN5hnIN4GqekwxZGAwldjlCA0rqdsun8NRekcy5F+jQm6F7OJ\nJqCytIPie39/vUUb9QFpGZBLvFGoF+RBne77WEdMUtIqQvBi6mrMLhe853WOlaGE\n8S0eMEmsDliCBNjg5E0AMA4q0F3knnq3euIPuYrk8yuODWNMlZ1bsCe+jFYN6Kng\nfk6Uo5cmJnt7HJXcmv0/a5TFjt9ndD4iuM9e2lIfiVmNag+j286p6CaKwJmDlmo0\nSka1sgG0BkYQd6cTWNrfJx09YuJ/XRTIJRB+bIwoYrQdp5gz9+2zYm0GgRwZu3Cd\nV0Lp4/EhAgMBAAECggEACpJsKp+YK3zxx78GRcSHIdIcheqnoR7d89/X3ss3LKjE\nnSC4xYEDJbOMxtasKvujfP5tzFRh+/gYWpmT2bkfEHkEm0F+aDgqv8nurr8FxvHB\naJE1ON0rBeSKnEUwZL5WKN9e64jrRxQoCLfkyeFP24rC10cM46Ne5HmYj/IIPLzC\nLUMBkIANTtni/JpIMJ7tFRf0U+6b8cW0GGIV1v6Mwr6hS4I9HdyGvPBH1/1gHSBY\n8/d+1Qm93QsoqAaBsqZElfR5Og5RpuTos6Aj7bHjdU2LzM0nRAJSMe2LhrnaZ3Nw\nTABbhjb65aFtmml0b7bDyRz3U5j2ONh0CxKPWXjv7wKBgQDlgimfahXyU4CfSvO9\ns+Ph3wCxwgHIfolqhysbfrJWCRVoed/BTBCbsIBm3C0HJX+zlXmdYro8n1wXganB\nc+sQIgYdblITrvSNiZ4iitejubUJ6nHhv3RhF2EmgXKk6nT2I9wkYO+iimxj1Ie8\naAxvzVSg3/ff4bYavkJnRrDzZwKBgQC9oMgFl09fuiub92RYn6DCfVe20WxQy2nO\n//3aKr2q7/EBSE9aSkYQb4qtwNppE3mbxkkZ5Ljq5QYcsPFZc+BVvg5/Kzi9mKwQ\nNCbQekMJozGJ5BID8YUMP3N1wlpjgKCnHBf096xkqdhWIy5Qvw/MbJ4uGwXey2dd\nQB+KktFqNwKBgAYuVDqj28Vz9EHV/ex8/MUngVhINk4VAlRpIYMTDXB9vCLdLWaC\nSuw2e67JfTj1DJRkkSro7sUVMaC8cDryiUEc+XcvcmxvSMzLCQQ7IwWYycRjmP+Q\nbWzz+TzVPaYtXksGujYMmkeRXMvvfFxZnQQhzoaqoX1ZEdN0jktDvx4/AoGATx8T\n9olA3C9g3M3nt7a7LAuCmsxdBoUpW+6iK/Kjevxssd1LBuBwxZDU61TJjQhMOHwO\nqlgt9AyldTk7KtjXpM8NW3BcV3epa4VnIJuy9wV5uRBJmA2hNxAOi/cRIe1cmv10\n3YiuDL51ftNlEtn1rJUxlwk9dM2oDlegEYDbEhcCgYB8qJAx+V4dsNtovf0RTzO6\nTEeh/eTtmxIxG4ekhbPNZ9OoyYbROsgxInQaBS3zQ4bXQPACaGRDX9aG1lvSINb1\nctJ1DhH57TM6oCu+U9rwkoVMHvmItNplpDH4gsHC6TnvKLqy0zLJVGXqcqtMf2Un\n10cxxRg0mjP0G/GMXY669A==\n-----END PRIVATE KEY-----\n",
  "client_email": "firebase-adminsdk-6w9gv@recyclemint-a0a42.iam.gserviceaccount.com",
  "client_id": "115816445007619551651",
  "auth_uri": "https://accounts.google.com/o/oauth2/auth",
  "token_uri": "https://oauth2.googleapis.com/token",
  "auth_provider_x509_cert_url": "https://www.googleapis.com/oauth2/v1/certs",
  "client_x509_cert_url": "https://www.googleapis.com/robot/v1/metadata/x509/firebase-adminsdk-6w9gv%40recyclemint-a0a42.iam.gserviceaccount.com",
  "universe_domain": "googleapis.com"
}

// saving fcm token of customer/users into the database
export const saveToken = async (req, res) => {
  const fcmToken = req.body.token;

  try {
    if (!fcmToken) {
      return res.status(400).json({ error: 'FCM token is required' });
    }

    if (req.query.utype == "agent") {
      var agent = await Users.updateOne({ _id: new ObjectId(req.body.id) }, { $set: { token: req.body.token } });
      if (agent) {
        res.status(200).json({
          error: false,
          token: fcmToken,
          message: 'FCM token saved successfully'
        });
      } else {
        res.status(500).json({
          error: true,
          message: 'failed to save'
        });
      }
    } else {
      if (req.query.utype == "customer") {
        // console.log("customer");
        var customer = await Customers.updateOne({ _id: new ObjectId(req.body.id) }, { $set: { token: req.body.token } });
        // console.log(new ObjectId(req.body.id))
        if (customer) {
          res.status(200).json({
            error: false,
            token: fcmToken,
            message: 'FCM token saved successfully'
          });
        } else {
          res.status(500).json({
            error: true,
            message: 'failed to save'
          });
        }
      }
    }
  } catch (err) {
    console.error(err);
    res.status(500).send({ error: 'Internal server error' });
  }
};

// Get Access Token
export const getAccessToken = (req, res) => {
  // res.send(recyclemintKey)

  // const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"]
  // const jwtClient = new google.auth.JWT(
  //   recyclemintKey.client_email,
  //   null,
  //   recyclemintKey.private_key,
  //   SCOPES,
  //   null
  // );
  // jwtClient.authorize(function (err, tokens) {
  //   if (err) {
  //     return;
  //   }
  //   res.status(200).json(tokens)
  // });
}


// Function to push notification
export function pushNotification(fcmToken, title, msg, condition_name,id) {
  const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"]
  const jwtClient = new google.auth.JWT(
    recyclemintKey.client_email,
    null,
    recyclemintKey.private_key,
    SCOPES,
    null
  );
  console.log("stage-1");
  jwtClient.authorize(function (err, token) {
    console.log("stage-2");

    if (err) {
      console.log("stage-3");
      return;
    } else {
      const accessToken = token.access_token;

      console.log("stage-4");

      const api = `https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send`;
      console.log("api       ", api);

      const message = {
        message: {
          token: fcmToken,
          notification: {
            title: title,
            body: msg,
          },
          data: {
            condition: condition_name,
            ...(id && { id })
          }
        }
      };

      console.log("stage-5");
      axios.post(api, message, {
        headers: {
          'Authorization': `Bearer ${accessToken}`,
          'Content-Type': 'application/json',
        },
      })
        .then(response => {
          console.log('Successfully sent message:', response.data);
          // res.status(200).json({ message: 'Notification sent successfully' });
        })
        .catch(error => {
          console.error('Error sending message:', error);
          // res.status(500).json({ message: 'Error sending notification' });
        });

      console.log("stage-6");
    }
  });
}


// Function to push notification for Events
export async function pushNotificationForEvents(plogging_data) {
  try {
    const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
    const jwtClient = new google.auth.JWT(
      recyclemintKey.client_email,
      null,
      recyclemintKey.private_key,
      SCOPES,
      null
    );

    await new Promise((resolve, reject) => {
      jwtClient.authorize((err, token) => {
        if (err) {
          console.error('Authorization failed:', err);
          reject(err);
        } else {
          resolve(token);
        }
      });
    });

    const accessToken = jwtClient.credentials.access_token;
    const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

    const eventCityId = plogging_data.cityid;
    console.log("New ploging event City ID: ", eventCityId);

    const locations = await Location.find({ cityid: eventCityId });
    const distinctPins = [...new Set(locations.map(location => location.PIN))];
    console.log("Distinct PINs in the city: ", distinctPins);

    let customerIds = [];

    for (const pin of distinctPins) {
      const address = await Address.find({ PIN: pin });
      customerIds.push(...address.map(addr => addr.customer_Id));
    }

    console.log("Customer IDs in the city: ", customerIds);

    const customers = await Customers.find({ _id: { $in: customerIds }, token: { $ne: null } }); // Filter out null or undefined tokens
    const customersToken = customers.map(customer => customer.token);
    console.log("Customer tokens:", customersToken);

    const title = "New Plogging Event Added";
    const msg = `🎉 New event "${plogging_data.title}" added in your city! Check it out.`;
    const condition_name = "City event";
    const Event_id = plogging_data._id;
    const Cityid = eventCityId;

    const processedTokens = new Set();

    for (const fcmToken of customersToken) {
      if (processedTokens.has(fcmToken)) {
        console.log(`Skipping processing for token ${fcmToken} as it has already been processed`);
        continue;
      }

      processedTokens.add(fcmToken);

      const customer = customers.find(cust => cust.token === fcmToken);
      const customerName = customer ? customer.name : "Unknown";

      const message = {
        message: {
          token: fcmToken,
          notification: {
            title,
            body: msg
          },
          data: {
            title,
            body: msg,
            condition: condition_name,
            Event: Event_id,
            City: Cityid
          }
        }
      };

      try {
        const response = await axios.post(api, message, {
          headers: {
            'Authorization': `Bearer ${accessToken}`,
            'Content-Type': 'application/json',
          },
        });

        console.log(`Notification sent to ${customerName} and token number is: ${fcmToken} successfully:`, response.data);
      } catch (error) {
        console.log(`Notification not sent to ${customerName}`);
        console.error('Error sending notification:', error.response ? error.response.data : error.message);

        // Assuming `notificationId` and `notifications` are defined elsewhere
        await saveNotificationStatus(
          customer._id,
          customer.name,
          customer.token,
          null,
          title,
          error.message
        );
      }
    }
  } catch (error) {
    console.error('Error sending notifications:', error);
  }
}


// Function for "Add Item auto notify to customer"   (Conditional)
export async function pushNotificationForItems(newItems) {
  try {
    const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
    const jwtClient = new google.auth.JWT(
      recyclemintKey.client_email,
      null,
      recyclemintKey.private_key,
      SCOPES,
      null
    );

    await new Promise((resolve, reject) => {
      jwtClient.authorize((err, token) => {
        if (err) {
          console.error('Authorization failed:', err);
          reject(err);
        } else {
          resolve(token);
        }
      });
    });

    const accessToken = jwtClient.credentials.access_token;
    const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

    const itemCityId = newItems.cityid;
    console.log("New Items City ID: ", itemCityId);

    const locations = await Location.find({ cityid: itemCityId });
    const distinctPins = [...new Set(locations.map(location => location.PIN))];
    console.log("Distinct PINs in the city: ", distinctPins);

    let customerIds = [];

    for (const pin of distinctPins) {
      const address = await Address.find({ PIN: pin });
      customerIds.push(...address.map(addr => addr.customer_Id));
    }

    console.log("Customer IDs in the city: ", customerIds);

    const customers = await Customers.find({ _id: { $in: customerIds }, token: { $ne: null } }); // Filter out null or undefined tokens
    const customersToken = customers.map(customer => customer.token);
    console.log("Customer tokens:", customersToken);

    const title = "New Item Added";
    const msg = `🎉 New item "${newItems.item_name}" added in your city! Check it out.`;
    const condition_name = "Items added";
    const Items_id = newItems._id;
    const Cityid = itemCityId;

    const processedTokens = new Set();

    for (const fcmToken of customersToken) {
      if (processedTokens.has(fcmToken)) {
        console.log(`Skipping processing for token ${fcmToken} as it has already been processed`);
        continue;
      }

      processedTokens.add(fcmToken);

      const customer = customers.find(cust => cust.token === fcmToken);
      const customerName = customer ? customer.name : "Unknown";

      const message = {
        message: {
          token: fcmToken,
          notification: {
            title,
            body: msg
          },
          data: {
            title,
            body: msg,
            condition: condition_name,
            Item: Items_id,
            City: Cityid
          }
        }
      };

      try {
        const response = await axios.post(api, message, {
          headers: {
            'Authorization': `Bearer ${accessToken}`,
            'Content-Type': 'application/json',
          },
        });

        console.log(`Notification sent to ${customerName} and token number is: ${fcmToken} successfully:`, response.data);
      } catch (error) {
        console.log(`Notification not sent to ${customerName}`);
        console.error('Error sending notification:', error.response ? error.response.data : error.message);

        // Assuming `notificationId` and `notifications` are defined elsewhere
        await saveNotificationStatus(
          customer._id,
          customer.name,
          customer.token,
          null,
          title,
          error.message
        );
      }
    }
  } catch (error) {
    console.error('Error sending notifications:', error);
  }
}



function formatDate(date) {
  const day = String(date.getDate()).padStart(2, '0');
  const month = String(date.getMonth() + 1).padStart(2, '0'); // Months are 0-based, so add 1
  const year = date.getFullYear();
  
  return `${day}-${month}-${year}`;
}



export async function pushNotificationForOrders(order) {
  const currentDate = new Date();
  const formattedDate = formatDate(currentDate);
  console.log(formattedDate);
  try {
    const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];
    const jwtClient = new google.auth.JWT(
      recyclemintKey.client_email,
      null,
      recyclemintKey.private_key,
      SCOPES,
      null
    );

    await new Promise((resolve, reject) => {
      jwtClient.authorize((err, token) => {
        if (err) {
          console.error('Authorization failed:', err);
          reject(err);
        } else {
          resolve(token);
        }
      });
    });

    const accessToken = jwtClient.credentials.access_token;
    const api = 'https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send';

    // const itemCityId = newItems.cityid;
    // console.log("New Items City ID: ", itemCityId);

    // const locations = await Location.find({ cityid: itemCityId });
    // const distinctPins = [...new Set(locations.map(location => location.PIN))];
    // console.log("Distinct PINs in the city: ", distinctPins);

    let customerIds = [];

    // for (const pin of distinctPins) {
    //   const address = await Address.find({ PIN: pin });
    //   customerIds.push(...address.map(addr => addr.customer_Id));
    // }

    console.log("Customer IDs in the city: ", customerIds);
    console.log("order_param", order);
    order.map(async (ord) => {
      console.log("order", ord);
        const customers = await Customers.find({ _id: { $in: new ObjectId(ord.customer_id) }, token: { $ne: null }, isDelete: false, isActive: true }); // Filter out null or undefined tokens
        console.log("customers", customers);
      const customersToken = customers.map(customer => customer.token);
      // console.log("Customer tokens:", customersToken);

      const title = "Agent arrive tomorrow";
      // const msg = `🎉 Keep "${ord.order_id}" items ready.`;
      const msg = `🎉 Keep Your next "${ord.order_id}" order for the selected items will be generated on the schedule date please confirm.`;
      const condition_name = "Order Pickup bussiness customer";
      const Items_id = ord._id;
      // const Cityid = itemCityId;

      const processedTokens = new Set();

      for (const fcmToken of customersToken) {
        if (processedTokens.has(fcmToken)) {
          console.log(`Skipping processing for token ${fcmToken} as it has already been processed`);
          continue;
        }

        processedTokens.add(fcmToken);

        const customer = customers.find(cust => cust.token === fcmToken);
        const customerName = customer ? customer.name : "Unknown";

        // Get an order_id for the customer from Orders collection (assuming each customer has an associated order)
        // const order = await Orders.findOne({ customer_Id: customer._id, schedule_date: formattedDate });
        // const orderId = order ? order._id : null;
        // data: {
        //     title: notificationData.title,
        //     body: notificationData.body,
        //     image: notificationData.image,
        //     condition: notifications[0].conditionId[1].condition_name
        // },
        const message = {
          message: {
            token: fcmToken,
            notification: {
              title,
              body: msg,
            },
            data: {
              title,
              body: msg,
              condition: "recursive order",
              _id: ord._id,
              schedule_date: ord.schedule_date,
              // click_action: "OPEN_ACTIVITY_1"
            },
            android: {
              ttl: "86400s",
              notification: {
                title: title,
                body: msg,
                // click_action: "OPEN_ACTIVITY_1"
              },
              // Custom data payload for actions (to be handled in your app)
              // data: {
              //   actions: JSON.stringify([
              //     {
              //       action: "REPLY_ACTION",
              //       title: "REPLY_ACTION"
              //     },
              //     {
              //       action: "MARK_AS_READ_ACTION",
              //       title: "MARK_AS_READ_ACTION"
              //     }
              //   ])
              // }
            },
            apns: {
              payload: {
                aps: {
                  alert: {
                    title: title,
                    body: msg
                  },
                  category: "NEW_ITEM_CATEGORY" // Notification category for iOS
                }
              },
              fcm_options: {
                image: "url_to_image" // Optional, include if needed
              }
            }
          }
        };


        // const message = {
        //   message: {
        //     token: fcmToken,
        //     notification: {
        //       title,
        //       body: msg
        //     },
        //     data: {
        //       title,
        //       body: msg,
        //       condition: condition_name,
        //       Item: Items_id,
        //       schedule_date: ord.schedule_date,
        //       // City: Cityid
        //     }
        //   }
        // };
        
        
        
        try {
          const response = await axios.post(api, message, {
            headers: {
              'Authorization': `Bearer ${accessToken}`,
              'Content-Type': 'application/json',
            },
          });

          console.log(`Notification sent to ${customerName} and token number is: ${fcmToken} successfully:`, response.data);
        } catch (error) {
          console.log(`Notification not sent to ${customerName}`);
          console.error('Error sending notification:', error.response ? error.response.data : error.message);

          // await saveNotificationStatus(
          //   customer._id,
          //   customer.name,
          //   customer.token,
          //   null,
          //   title,
          //   error.message
          // );
        }
      }
    })
    
  } catch (error) {
    console.error('Error sending notifications:', error);
  }
}

export async function apnsToFcm(req, res) {
  try {
    const apnsToken = req.body.apnsToken;
    if (!apnsToken) {
      return res.status(400).json({ message: 'APNs token is required' });
    }
    const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"]
    const jwtClient = new google.auth.JWT(
      recyclemintKey.client_email,
      null,
      recyclemintKey.private_key,
      SCOPES,
      null
    );
    const token = await new Promise((resolve, reject) => {
      jwtClient.authorize((err, token) => {
        if (err) {
          console.log("Authorization Error", err);
          reject(err);
        } else {
          resolve(token);
        }
      });
    });
    const accessToken = token.access_token;
    const lowerCaseapn=apnsToken.toLowerCase()
    console.log("Lower Case data", lowerCaseapn)
    const payload = {
      application: "com.recyclepay.customerapp",  // Your Firebase App ID (Bundle ID)
      sandbox: true,          // Set to true if using in the sandbox environment for iOS
      apns_tokens: [lowerCaseapn], // Array of APNs tokens
    };
    const response = await axios.post(
      'https://iid.googleapis.com/iid/v1:batchImport',
      payload,
      {
        headers: {
          'Authorization': `Bearer ${accessToken}`, // Use the obtained Bearer token
          'Content-Type': 'application/json',
          'access_token_auth':true
        },
      }
    );
    const { results } = response.data;
    if (results && results.length > 0) {
      const result = results[0];
      // Format the result for the single APNs token
      const formattedResult = {
        apns_token: result.apns_token,
        status: result.status,
        registration_token: result.registration_token || null, // In case the token failed to convert
      };
      if (result.status === 'OK') {
        return res.status(200).json({
          message: 'Token processed successfully',
          result: formattedResult
        });
      } else {
        return res.status(500).json({
          message: `Failed to convert APNs token: ${result.status}`,
          result: formattedResult
        });
      }
    } else {
      return res.status(500).json({ message: 'No results returned from the API' });
    }
  }
  catch (error) {
    res.status(500).json({ error: error.message });
    console.log(error);
  }
}

export async function testPushNotification(req, res) {
  try {
    const fcmToken = req.body.fcmToken;
    const SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"];

    // Initialize the JWT client
    const jwtClient = new google.auth.JWT(
      recyclemintKey.client_email,
      null,
      recyclemintKey.private_key,
      SCOPES,
      null
    );
    // Authorize the client and get the access token
    const token = await new Promise((resolve, reject) => {
      jwtClient.authorize((err, token) => {
        if (err) {
          console.log("Authorization Error", err);
          reject(err);
        } else {
          resolve(token);
        }
      });
    });
    const accessToken = token.access_token;
    const api = `https://fcm.googleapis.com/v1/projects/recyclemint-a0a42/messages:send`;
    // Message payload for FCM
    const message = {
      message: {
        token: fcmToken,
        notification: {
          title: "Test Message Title",
          body: "Test Message Body",
        },
        data: {
          condition: "Test Condition",
        },
      },
    };
    // Send the message via Axios
    const response = await axios.post(api, message, {
      headers: {
        'Authorization': `Bearer ${accessToken}`,
        'Content-Type': 'application/json',
      },
    });

    console.log('Successfully sent message:', response.data);
    res.status(200).json({ message: 'Notification sent successfully' });

  } catch (error) {
    console.error('Error sending notification:', error);
    res.status(500).json({ message: 'Error occurred', error });
  }
}

