import { schedule } from "node-cron";
import mongoose from "mongoose";
import Routeslot from "../model/routeslot.model.js";
import Users from "../model/users.model.js";
import Location from "../model/location.model.js";
import cityPercent from "../model/city_percent.model.js";
import Items from "../model/items.model.js";
import Slot from "../model/slot.model.js";
import Order from "../model/order.model.js";
const ObjectId = mongoose.Types.ObjectId;

// Create slot
// export const createSlot = async (req, res) => {
//     const month = req.body.month;
//     const year = req.body.year;
//     const date = req.body.date;
//     const time = req.body.time[0].zip;
//     const timeSlots = req.body.time[0].time;
//     const city = req.body.city;
//     const cityid = req.body.cityid;
//     console.log(req.body);
//     try {
//         let slot = await Routeslot.findOne({ date });
//         console.log("slot", slot);
//         if (slot) {
//             console.log("enter");
//             const existingDateIndex = slot.time.findIndex(slotDate => slotDate.zip === time);

//             // const existingDateIndex = slot.time.findIndex((slotDate) => {
//             //     console.log(slotDate.zip, slotDate.zip == time);
//             //     slotDate.zip == time
//             // });
//             console.log("existingDateIndex", existingDateIndex);
//             if (existingDateIndex !== -1) {
//                 // Date exists, update the time slots for the existing time
//                 slot.time[existingDateIndex].time = timeSlots;
//             } else {
//                 // Date doesn't exist, create a new time entry
//                 slot.time.push({ zip: time, time: timeSlots });
//                 console.log(slot);
//             }

//             // Save the updated slot document
//             slot.city = city; // Update city if needed
//             await slot.save();

//             res.send({
//                 isSuccess: true,
//                 msg: "Slot Update by Admin.",
//             });
//         } else {
//             console.log("went to else section");
//             if(!slot){
//                 console.log("create new slot");
//                 // Create a new slot document
//                 slot = await Routeslot.create({
//                     month,
//                     year,
//                     date,
//                     time: [{ zip: time, time: timeSlots }],
//                     city,
//                     cityid,
//                 });
    
//                 if (slot) {
//                     res.send({
//                         isSuccess: true,
//                         msg: "New Slot added by Admin.",
//                     });
//                 }
//             }

//         }
//     } catch (error) {
//         res.status(500).send({
//             isSuccess: false,
//             msg: "Something went wrong.",
//             error: error.message,
//         });
//     }
// };



export const createSlot = async (req, res) => {
    const month = req.body.month;
    const year = req.body.year;
    const date = req.body.date;
    const city = req.body.city;
    const cityid = req.body.cityid;
    const agent_id = req.body.agent_id;
    const routes = req.body.routes;
    console.log(req.body);
    try {
        let slot = await Routeslot.findOne({ date, cityid, agent_id });
        console.log("slot", slot);
        if (slot) {
            console.log("enter");
            req.body.time.forEach(async (timeObj) => {
                const time = timeObj.zip;
                const timeSlots = timeObj.time;
                const location = timeObj.location;

                const existingDateIndex = slot.time.findIndex(slotDate => slotDate.zip === time);
                console.log("existingDateIndex", existingDateIndex);
                if (existingDateIndex !== -1) {
                    // Date exists, update the time slots for the existing time
                    slot.time[existingDateIndex].time = timeSlots;
                    slot.time[existingDateIndex].location = location;
                } else {
                    // Date doesn't exist, create a new time entry
                    slot.time.push({ zip: time, time: timeSlots, location: location });
                    console.log(slot);
                }
            });

            // Save the updated slot document
            slot.city = city; // Update city if needed
            await slot.save();

            res.send({
                isSuccess: true,
                msg: "Slot Update by Admin.",
            });
        } else {
            console.log("went to else section");
            if (!slot) {
                console.log("create new slot");
                // Create a new slot document
                const newTimeSlots = req.body.time.map(timeObj => ({
                    zip: timeObj.zip,
                    time: timeObj.time,
                    location: timeObj.location,
                }));
                slot = await Routeslot.create({
                    month,
                    year,
                    date,
                    time: newTimeSlots,
                    city,
                    cityid,
                    agent_id,
                    routes,
                });

                if (slot) {
                    res.send({
                        isSuccess: true,
                        msg: "New Slot added by Admin.",
                    });
                }
            }
        }
    } catch (error) {
        res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
            error: error.message,
        });
    }
};




// Get slot
export const allSlotbyCity = async (req, res) => {
    const { cityid, agentid, date } = req.query;

    // Validate required parameters
    if (!cityid || !date) {
        return res.status(400).send({
            isSuccess: false,
            msg: "City ID and Date are required."
        });
    }

    // Create the pipeline for MongoDB aggregation
    const pipeline = [
        {
            $match: {
                cityid: new mongoose.Types.ObjectId(cityid),
                date: date // Directly match the date as a string
            }
        },
        {
            $unwind: "$time"
        },
        {
            $unwind: "$time.zip"
        },
        {
            $group: {
                _id: {
                    _id: "$_id",
                    date: "$date",
                    cityid: "$cityid",
                    createdAt: "$createdAt",
                    updatedAt: "$updatedAt",
                    zip: "$time.zip",
                    agent_id: "$agent_id",
                    routes: "$routes",
                },
                time: { $push: { time: "$time.time", location: "$time.location", _id: "$time._id" } },
            }
        },
        {
            $group: {
                _id: {
                    _id: "$_id._id",
                    date: "$_id.date",
                    cityid: "$_id.cityid",
                    createdAt: "$_id.createdAt",
                    updatedAt: "$_id.updatedAt",
                    routes: "$_id.routes",
                },
                slots: {
                    $addToSet: {
                        k: "$_id.zip",
                        v: "$time"
                    }
                },
                agent_id: { $first: "$_id.agent_id" },

            }
        },
        {
            // Join with the agents collection to get the agent's name
            $lookup: {
                from: "users", // The name of the collection that stores agent information
                localField: "agent_id",
                foreignField: "_id",
                as: "agentInfo"
            }
        },
        {
            $replaceRoot: {
                newRoot: {
                    $mergeObjects: [
                        "$_id",
                        { slots: { $arrayToObject: "$slots" } },
                        { agent_id: "$agent_id" }, // Include agent_ids in the root
                        { agent_name: "$agentInfo.name" }
                    ]
                }
            }
        },
        {
            $project: {
                _id: 1,
                cityid: 1,
                routes: 1,
                date: 1,
                slots: 1,
                createdAt: 1,
                updatedAt: 1,
                agent_id: 1,
                "agent_name":{ $arrayElemAt: ["$agent_name", 0] },
                "agenetInfo": {
            agent_id: "$agent_id", // Ensure agent_id is included
            agent_name: { $arrayElemAt: ["$agent_name", 0] } // Get the first element of the agent name array
        }
            }
        }
    ];

    if (agentid && agentid.trim()) {
        // Only add agent_id match if agentid is provided and not just empty spaces
        pipeline[0].$match.agent_id = new mongoose.Types.ObjectId(agentid);
    }

    try {
        let result = await Routeslot.aggregate(pipeline);

        const sortedResult = result.sort((a, b) => {
            if (a.year !== b.year) {
                return a.year - b.year;
            }

            if (a.month !== b.month) {
                return b.month - a.month;
            }

            return 0;
        });

        return res.send({
            isSuccess: true,
            msg: "Get All slot.",
            data: sortedResult
        });
    } catch (error) {
        return res.status(500).send({
            isSuccess: false,
            msg: "Error retrieving slots.",
            error: error.message
        });
    }
};





// Get agents by passing city_id
export const getAgents = async (req, res) => {
    console.log(new mongoose.Types.ObjectId(req.params.cityid));
    const agent = await Users.find({ cityid: new mongoose.Types.ObjectId(req.params.cityid), isDelete: false, usertype: "agent" })
    if (agent) {
        return res.json({
            isSuccess: true,
            data: agent
        })
    } else {
        return res.json({
            isSuccess: false,
            data: []
        })
    }
}





// Get order by passing agentId
export const getAgentsAssignOrd = async (req, res) => {
    function formatDate(date) {
        const day = String(date.getDate()).padStart(2, '0');
        const month = String(date.getMonth() + 1).padStart(2, '0'); // Months are zero-based
        const year = date.getFullYear();
      
        return `${day}-${month}-${year}`;
    }

    const currentDate = new Date();
    const formattedDate = formatDate(currentDate);

    try {
        const agentOrders = await Order.aggregate([
            {
                $match: {
                    agent_id: new mongoose.Types.ObjectId(req.params.agent_id),
                    schedule_date: formattedDate
                }
            },
            {
                $lookup: {
                    from: 'addresses', // Name of the addresses collection
                    localField: 'address_id', // Field from the orders collection
                    foreignField: '_id', // Field from the addresses collection
                    as: 'addressDetails'
                }
            },
            {
                $unwind: '$addressDetails' // Unwind the resulting array from the $lookup stage
            },
            {
                $lookup: {
                    from: 'customers', // Name of the addresses collection
                    localField: 'customer_id', // Field from the orders collection
                    foreignField: '_id', // Field from the addresses collection
                    as: 'customerDetails'
                }
            },
            {
                $unwind: '$customerDetails' // Unwind the resulting array from the $lookup stage
            },
            {
                $project: {
                    _id: 1,
                    agent_id: 1,
                    order_id: 1,
                    schedule_date: 1,
                    time: 1,
                    // Include other fields you want from the orders collection
                    pincode: "$addressDetails.PIN",
                    longitude: "$addressDetails.longitude",
                    latitude: "$addressDetails.latitude",
                    customermobile: "$customerDetails.mobile",
                    customerName: "$customerDetails.name",
                }
            }
        ]);

        if (agentOrders.length > 0) {
            return res.json({
                isSuccess: true,
                data: agentOrders
            });
        } else {
            return res.json({
                isSuccess: false,
                data: []
            });
        }
    } catch (error) {
        console.error(error);
        return res.status(500).json({
            isSuccess: false,
            message: 'An error occurred while fetching data.'
        });
    }
}







