import { schedule } from "node-cron";
import mongoose from "mongoose";
import Slots from "../model/slot.model.js";
import Orders from "../model/order.model.js";
import Location from "../model/location.model.js";
import cityPercent from "../model/city_percent.model.js";
import Items from "../model/items.model.js";
import Slot from "../model/slot.model.js";
import Routeslot from "../model/routeslot.model.js";
const ObjectId = mongoose.Types.ObjectId;
import Users from "../model/users.model.js";



// Slot create by Admin
// export const createSlot = async (req, res) => {
//     // Slots.findOne({ month: req.body.month, year: req.body.year }).then(async (getslot) => {

//     //     if (getslot) {
//     //         // await Slots.findOneAndUpdate({ month: req.body.month, year: req.body.year }, { $addToSet: { "date": req.body.date } }).then((updateSlot) => {
//     //         await Slots.findOneAndUpdate({ month: req.body.month, year: req.body.year, "date.date": req.body.date }, { $addToSet: { "date": req.body.date } }).then((updateSlot) => {
//     //             if (updateSlot) {
//     //                 res.send({
//     //                     isSuccess: true,
//     //                     msg: "Slot Update by Admin."
//     //                 })
//     //             } else {
//     //                 res.send({
//     //                     isSuccess: false,
//     //                     msg: "Somethoing went wrong."
//     //                 })
//     //             }
//     //         })
//     //     } else {
//     //         const slot = await Slots.create({
//     //             month: req.body.month,
//     //             year: req.body.year,
//     //             date: req.body.date
//     //         });

//     //         if (slot) {
//     //             res.send({
//     //                 isSuccess: true,
//     //                 msg: "Slot added by Admin."
//     //             })
//     //         }
//     //     }
//     // })

//     const month = req.body.month;
//     const year = req.body.year;
//     const date = req.body.date[0].date;
//     const timeSlots = req.body.date[0].time;
//     const city = req.body.city;
//     const cityid = req.body.cityid;

//     Slots.findOne({ month, year })
//         .then(async (getslot) => {
//             if (getslot) {
//                 // Check if the date already exists
//                 const existingDateIndex = getslot.date.findIndex((slotDate) => slotDate.date === date);

//                 if (existingDateIndex !== -1) {
//                     // Date exists, add time slots to the existing date
//                     getslot.date[existingDateIndex].time.push(...timeSlots);
//                 } else {
//                     // Date doesn't exist, create a new date entry
//                     getslot.date.push({ date, time: timeSlots });
//                 }

//                 // Save the updated slot document
//                 Slots.findOneAndUpdate({ month: month, year: year }, { $set: { city: city,
//                     cityid: cityid } }).then( async (x) => {
//                         if (x) {
//                             await getslot.save();

//                             res.send({
//                                 isSuccess: true,
//                                 msg: "Slot Update by Admin.",
//                             });
//                         }
//                     })
//             } else {
//                 // Create a new slot document
//                 const slot = await Slots.create({
//                     month,
//                     year,
//                     date: [{ date, time: timeSlots }],
//                     city,
//                     cityid,
//                 });

//                 if (slot) {
//                     res.send({
//                         isSuccess: true,
//                         msg: "Slot added by Admin.",
//                     });
//                 }
//             }
//         })
//         .catch((error) => {
//             res.status(500).send({
//                 isSuccess: false,
//                 msg: "Something went wrong.",
//                 error: error.message,
//             });
//         });

// }


export const createSlot = async (req, res) => {
    const month = req.body.month;
    const year = req.body.year;
    const date = req.body.date[0].date;
    const timeSlots = req.body.date[0].time;
    const city = req.body.city;
    const cityid = req.body.cityid;

    try {
        let slot = await Slots.findOne({ cityid, month, year });

        if (slot) {
            // Check if the date already exists for this cityid, month, and year
            const existingDateIndex = slot.date.findIndex(slotDate => slotDate.date === date);

            if (existingDateIndex !== -1) {
                // Date exists, update the time slots for the existing date
                slot.date[existingDateIndex].time = timeSlots;
            } else {
                // Date doesn't exist, create a new date entry
                slot.date.push({ date, time: timeSlots });
            }

            // Save the updated slot document
            slot.city = city; // Update city if needed
            await slot.save();

            res.send({
                isSuccess: true,
                msg: "Slot Update by Admin.",
            });
        } else {
            console.log("went to else section");
            if (!slot) {
                console.log("create new slot");
                // Create a new slot document
                slot = await Slots.create({
                    month,
                    year,
                    date: [{ date, time: timeSlots }],
                    city,
                    cityid,
                });

                if (slot) {
                    res.send({
                        isSuccess: true,
                        msg: "New Slot added by Admin.",
                    });
                }
            }

        }
    } catch (error) {
        res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
            error: error.message,
        });
    }
};



// get All Slot-Date
// export const allSlotbyCity = async (req, res) => {
//     // const pipeline = [
//     //     {
//     //       $project: {
//     //         month: 1,
//     //         year: 1,
//     //         date: {
//     //           $map: {
//     //             input: "$date",
//     //             as: "date",
//     //             in: {
//     //               $dateFromString: {
//     //                 dateString: "$$date",
//     //                 format: "%d-%m-%Y"
//     //               }
//     //             }
//     //           }
//     //         },
//     //         createdAt: 1,
//     //         updatedAt: 1,
//     //       },
//     //     },
//     //     {
//     //       $unwind: "$date"
//     //     },
//     //     {
//     //       $sort: { "date": 1 }
//     //     },
//     //     {
//     //       $group: {
//     //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
//     //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
//     //       }
//     //     },
//     //     {
//     //       $project: {
//     //         _id: "$_id._id",
//     //         month: "$_id.month",
//     //         year: "$_id.year",
//     //         date: 1,
//     //         createdAt: "$_id.createdAt",
//     //         updatedAt: "$_id.updatedAt"
//     //       }
//     //     }
//     //   ];
//     console.log(req.params.cityid);

//     const pipeline = [
//         {
//             $match: {
//                 cityid: new mongoose.Types.ObjectId(req.params.cityid)
//             }
//         },
//         {
//             $unwind: "$date"
//         },
//         {
//             $sort: { "date": 1 }
//         },
//         {
//             $group: {
//                 _id: {
//                     _id: "$_id",
//                     month: "$month",
//                     year: "$year",
//                     city: "$city",
//                     cityid: "$cityid",
//                     createdAt: "$createdAt",
//                     updatedAt: "$updatedAt"
//                 },
//                 date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
//             }
//         },
//         {
//             $project: {
//                 _id: "$_id._id",
//                 month: "$_id.month",
//                 year: "$_id.year",
//                 city: "$_id.city",
//                 cityid: "$_id.cityid",
//                 date: 1,
//                 createdAt: "$_id.createdAt",
//                 updatedAt: "$_id.updatedAt"
//             }
//         },
//         // {
//         //     $sort: {
//         //         "year": 1,
//         //         "month": -1
//         //     }
//         // },
//     ];

//     let result = await Slots.aggregate(pipeline);

//     const sortedResult = result.sort((a, b) => {
//         if (a.year !== b.year) {
//             return a.year - b.year;
//         }

//         if (a.month !== b.month) {
//             return b.month - a.month;
//         }

//         return 0;
//     });



//     // const result = await Slots.find()

//     if (sortedResult) {
//         return res.send({
//             isSuccess: true,
//             msg: "Get All slot.",
//             data: sortedResult
//         })
//     }
// }



// get All Slot-Date
// export const allSlotbyCity = async (req, res) => {
//     // const pipeline = [
//     //     {
//     //       $project: {
//     //         month: 1,
//     //         year: 1,
//     //         date: {
//     //           $map: {
//     //             input: "$date",
//     //             as: "date",
//     //             in: {
//     //               $dateFromString: {
//     //                 dateString: "$$date",
//     //                 format: "%d-%m-%Y"
//     //               }
//     //             }
//     //           }
//     //         },
//     //         createdAt: 1,
//     //         updatedAt: 1,
//     //       },
//     //     },
//     //     {
//     //       $unwind: "$date"
//     //     },
//     //     {
//     //       $sort: { "date": 1 }
//     //     },
//     //     {
//     //       $group: {
//     //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
//     //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
//     //       }
//     //     },
//     //     {
//     //       $project: {
//     //         _id: "$_id._id",
//     //         month: "$_id.month",
//     //         year: "$_id.year",
//     //         date: 1,
//     //         createdAt: "$_id.createdAt",
//     //         updatedAt: "$_id.updatedAt"
//     //       }
//     //     }
//     //   ];
//     console.log(req.params.cityid);

//     const pipeline = [
//         {
//             $match: {
//                 cityid: new mongoose.Types.ObjectId(req.params.cityid)
//             }
//         },
//         {
//             $unwind: "$date"
//         },
//         {
//             $sort: { "date": 1 }
//         },
//         {
//             $group: {
//                 _id: {
//                     _id: "$_id",
//                     month: "$month",
//                     year: "$year",
//                     city: "$city",
//                     cityid: "$cityid",
//                     createdAt: "$createdAt",
//                     updatedAt: "$updatedAt"
//                 },
//                 date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
//             }
//         },
//         {
//             $project: {
//                 _id: "$_id._id",
//                 month: "$_id.month",
//                 year: "$_id.year",
//                 city: "$_id.city",
//                 cityid: "$_id.cityid",
//                 date: 1,
//                 createdAt: "$_id.createdAt",
//                 updatedAt: "$_id.updatedAt"
//             }
//         },
//         // {
//         //     $sort: {
//         //         "year": 1,
//         //         "month": -1
//         //     }
//         // },
//     ];

//     let result = await Slots.aggregate(pipeline);

//     const sortedResult = result.sort((a, b) => {
//         if (a.year !== b.year) {
//             return a.year - b.year;
//         }

//         if (a.month !== b.month) {
//             return b.month - a.month;
//         }

//         return 0;
//     });



//     // const result = await Slots.find()

//     if (sortedResult) {
//         return res.send({
//             isSuccess: true,
//             msg: "Get All slot.",
//             data: sortedResult
//         })
//     }
// }



// get All Slot-Date
export const allSlotbyCity = async (req, res) => {
    // const pipeline = [
    //     {
    //       $project: {
    //         month: 1,
    //         year: 1,
    //         date: {
    //           $map: {
    //             input: "$date",
    //             as: "date",
    //             in: {
    //               $dateFromString: {
    //                 dateString: "$$date",
    //                 format: "%d-%m-%Y"
    //               }
    //             }
    //           }
    //         },
    //         createdAt: 1,
    //         updatedAt: 1,
    //       },
    //     },
    //     {
    //       $unwind: "$date"
    //     },
    //     {
    //       $sort: { "date": 1 }
    //     },
    //     {
    //       $group: {
    //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
    //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
    //       }
    //     },
    //     {
    //       $project: {
    //         _id: "$_id._id",
    //         month: "$_id.month",
    //         year: "$_id.year",
    //         date: 1,
    //         createdAt: "$_id.createdAt",
    //         updatedAt: "$_id.updatedAt"
    //       }
    //     }
    //   ];
    console.log(req.params.cityid);

    const pipeline = [
        {
            $match: {
                cityid: new mongoose.Types.ObjectId(req.params.cityid)
            }
        },
        {
            $unwind: "$date"
        },
        {
            $sort: { "date": 1 }
        },
        {
            $group: {
                _id: {
                    _id: "$_id",
                    month: "$month",
                    year: "$year",
                    city: "$city",
                    cityid: "$cityid",
                    createdAt: "$createdAt",
                    updatedAt: "$updatedAt"
                },
                date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
            }
        },
        {
            $project: {
                _id: "$_id._id",
                month: "$_id.month",
                year: "$_id.year",
                city: "$_id.city",
                cityid: "$_id.cityid",
                date: 1,
                createdAt: "$_id.createdAt",
                updatedAt: "$_id.updatedAt"
            }
        },
        // {
        //     $sort: {
        //         "year": 1,
        //         "month": -1
        //     }
        // },
    ];

    let result = await Slots.aggregate(pipeline);

    const sortedResult = result.sort((a, b) => {
        if (a.year !== b.year) {
            return a.year - b.year;
        }

        if (a.month !== b.month) {
            return b.month - a.month;
        }

        return 0;
    });



    // const result = await Slots.find()

    if (sortedResult) {
        return res.send({
            isSuccess: true,
            msg: "Get All slot.",
            data: sortedResult
        })
    }
}


// get All Slot-Date
// export const allSlotbyPIN = async (req, res) => {
//     // const pipeline = [
//     //     {
//     //       $project: {
//     //         month: 1,
//     //         year: 1,
//     //         date: {
//     //           $map: {
//     //             input: "$date",
//     //             as: "date",
//     //             in: {
//     //               $dateFromString: {
//     //                 dateString: "$$date",
//     //                 format: "%d-%m-%Y"
//     //               }
//     //             }
//     //           }
//     //         },
//     //         createdAt: 1,
//     //         updatedAt: 1,
//     //       },
//     //     },
//     //     {
//     //       $unwind: "$date"
//     //     },
//     //     {
//     //       $sort: { "date": 1 }
//     //     },
//     //     {
//     //       $group: {
//     //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
//     //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
//     //       }
//     //     },
//     //     {
//     //       $project: {
//     //         _id: "$_id._id",
//     //         month: "$_id.month",
//     //         year: "$_id.year",
//     //         date: 1,
//     //         createdAt: "$_id.createdAt",
//     //         updatedAt: "$_id.updatedAt"
//     //       }
//     //     }
//     //   ];
//     console.log(req.params.PIN);

//     await Location.findOne({ PIN: req.params.PIN }).then( async (x) => {
//         console.log(x);
//         // const pipeline = [
//         //     {
//         //         $match: {
//         //             cityid: new mongoose.Types.ObjectId(x.cityid)
//         //         }
//         //     },
//         //     {
//         //         $unwind: "$date"
//         //     },
//         //     {
//         //         $sort: { "date": 1 }
//         //     },
//         //     {
//         //         $group: {
//         //             _id: {
//         //                 _id: "$_id",
//         //                 month: "$month",
//         //                 year: "$year",
//         //                 city: x.city,
//         //                 PIN: x.PIN,
//         //                 cityid: "$cityid",
//         //                 createdAt: "$createdAt",
//         //                 updatedAt: "$updatedAt"
//         //             },
//         //             date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
//         //         }
//         //     },
//         //     {
//         //         $project: {
//         //             _id: "$_id._id",
//         //             month: "$_id.month",
//         //             year: "$_id.year",
//         //             city: "$_id.city",
//         //             cityid: "$_id.cityid",
//         //             PIN: "$_id.PIN",
//         //             cityid: "$_id.cityid",
//         //             date: 1,
//         //             createdAt: "$_id.createdAt",
//         //             updatedAt: "$_id.updatedAt"
//         //         }
//         //     },
//         //     // {
//         //     //     $sort: {
//         //     //         "year": 1,
//         //     //         "month": -1
//         //     //     }
//         //     // },
//         // ];

//         const today = new Date();
//         const daysToFetch = 7;

//         const pipeline = [
//             {
//                 $unwind: "$date"
//             },
//             {
//                 $addFields: {
//                     date: {
//                         $dateFromString: {
//                             dateString: "$date.date",
//                             format: "%d-%m-%Y"
//                         }
//                     },
//                     times: "$date.time"
//                 }
//             },
//             {
//                 $match: {
//                     cityid: new mongoose.Types.ObjectId(x.cityid),
//                     date: { $gte: today, $lt: new Date(today.getTime() + daysToFetch * 24 * 60 * 60 * 1000) }
//                 }
//             },
//             {
//                 $sort: {
//                     "date": 1
//                 }
//             },
//             {
//                 $limit: daysToFetch
//             },
//             {
//                 $project: {
//                     _id: 1,
//                     month: 1,
//                     year: 1,
//                     date: {
//                         $dateToString: {
//                             date: "$date",
//                             format: "%Y-%m-%d"
//                         }
//                     },
//                     createdAt: 1,
//                     updatedAt: 1,
//                     times: 1,
//                     cityid: 1,
//                     city: 1,
//                 }
//             }
//         ];

//         let result = await Slots.aggregate(pipeline);

//         const sortedResult = result.sort((a, b) => {
//             if (a.year !== b.year) {
//                 return a.year - b.year;
//             }

//             if (a.month !== b.month) {
//                 return b.month - a.month;
//             }

//             return 0;
//         });



//         // const result = await Slots.find()

//         if (sortedResult) {
//             return res.send({
//                 isSuccess: true,
//                 // msg: "Get All slot.",
//                 msg: sortedResult
//             })
//         } else {
//             return res.send({
//                 isSuccess: false,
//                 // msg: "Get All slot.",
//                 msg: []
//             })
//         }
//     })


// }




function formatDateToDDMMYYYY(date) {
    let day = String(date.getDate()).padStart(2, '0'); // Get day and add leading 0 if necessary
    let month = String(date.getMonth() + 1).padStart(2, '0'); // Get month (0-indexed, so +1) and add leading 0
    let year = date.getFullYear(); // Get year

    return `${day}-${month}-${year}`; // Return in dd-mm-yyyy format
}


function getIndianDate() {
    return new Date(new Date().toLocaleString("en-US", { timeZone: "Asia/Kolkata" }));
}

// get All Slot-Date
export const allSlotbyPIN = async (req, res) => {
    // const pipeline = [
    //     {
    //       $project: {
    //         month: 1,
    //         year: 1,
    //         date: {
    //           $map: {
    //             input: "$date",
    //             as: "date",
    //             in: {
    //               $dateFromString: {
    //                 dateString: "$$date",
    //                 format: "%d-%m-%Y"
    //               }
    //             }
    //           }
    //         },
    //         createdAt: 1,
    //         updatedAt: 1,
    //       },
    //     },
    //     {
    //       $unwind: "$date"
    //     },
    //     {
    //       $sort: { "date": 1 }
    //     },
    //     {
    //       $group: {
    //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
    //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
    //       }
    //     },
    //     {
    //       $project: {
    //         _id: "$_id._id",
    //         month: "$_id.month",
    //         year: "$_id.year",
    //         date: 1,
    //         createdAt: "$_id.createdAt",
    //         updatedAt: "$_id.updatedAt"
    //       }
    //     }
    //   ];
    console.log(req.params.PIN);

    const getadmin = await Users.findOne({
        usertype: "admin",
        isActive: true,
        isDelete: false,
        samedayslotStatus: { $exists: true }
    });
    if (!getadmin) {
        return res.status(404).send({
            isSuccess: false,
            msg: []
        });
    }
    console.log("admin aisidj", getadmin)
    // Check samedayslotStatus
    const showTodaySlot = getadmin.samedayslotStatus;

    await Location.findOne({ PIN: req.params.PIN }).then(async (x) => {
        console.log(x);
        // const pipeline = [
        //     {
        //         $match: {
        //             cityid: new mongoose.Types.ObjectId(x.cityid)
        //         }
        //     },
        //     {
        //         $unwind: "$date"
        //     },
        //     {
        //         $sort: { "date": 1 }
        //     },
        //     {
        //         $group: {
        //             _id: {
        //                 _id: "$_id",
        //                 month: "$month",
        //                 year: "$year",
        //                 city: x.city,
        //                 PIN: x.PIN,
        //                 cityid: "$cityid",
        //                 createdAt: "$createdAt",
        //                 updatedAt: "$updatedAt"
        //             },
        //             date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
        //         }
        //     },
        //     {
        //         $project: {
        //             _id: "$_id._id",
        //             month: "$_id.month",
        //             year: "$_id.year",
        //             city: "$_id.city",
        //             cityid: "$_id.cityid",
        //             PIN: "$_id.PIN",
        //             cityid: "$_id.cityid",
        //             date: 1,
        //             createdAt: "$_id.createdAt",
        //             updatedAt: "$_id.updatedAt"
        //         }
        //     },
        //     // {
        //     //     $sort: {
        //     //         "year": 1,
        //     //         "month": -1
        //     //     }
        //     // },
        // ];

        const today = getIndianDate();
        const formattedDate = formatDateToDDMMYYYY(today);
        console.log("Today: ",formattedDate);
        
        const daysToFetch = 7;

        let dateRange;
        if (showTodaySlot) {
            dateRange = {
                $gte: new Date(today.setHours(0, 0, 0, 0)),
                $lte: new Date(today.getTime() + daysToFetch * 24 * 60 * 60 * 1000)
            };
        } else {
            dateRange = { $gte: today, $lt: new Date(today.getTime() + daysToFetch * 24 * 60 * 60 * 1000) };
        }
        const pipeline = [
            {
                $unwind: "$date"
            },
            {
                $addFields: {
                    date: {
                        $dateFromString: {
                            dateString: "$date.date",
                            format: "%d-%m-%Y"
                        }
                    },
                    times: "$date.time"
                }
            },
            {
                $match: {
                    cityid: new mongoose.Types.ObjectId(x.cityid),
                    date: dateRange
                }
            },
            {
                $sort: {
                    "date": 1
                }
            },
            {
                $limit: daysToFetch
            },
            {
                $project: {
                    _id: 1,
                    month: 1,
                    year: 1,
                    date: {
                        $dateToString: {
                            date: "$date",
                            format: "%Y-%m-%d"
                        }
                    },
                    createdAt: 1,
                    updatedAt: 1,
                    times: 1,
                    cityid: 1,
                    city: 1,
                }
            }
        ];

        let result = await Slots.aggregate(pipeline);

        const sortedResult = result.sort((a, b) => {
            if (a.year !== b.year) {
                return a.year - b.year;
            }

            if (a.month !== b.month) {
                return b.month - a.month;
            }

            return 0;
        });



        // const result = await Slots.find()

        if (sortedResult) {
            return res.send({
                isSuccess: true,
                // msg: "Get All slot.",
                msg: sortedResult
            })
        } else {
            return res.send({
                isSuccess: false,
                // msg: "Get All slot.",
                msg: []
            })
        }
    })


}






// get All Slot-Date
export const allRouteSlotbyPIN = async (req, res) => {
    // const pipeline = [
    //     {
    //       $project: {
    //         month: 1,
    //         year: 1,
    //         date: {
    //           $map: {
    //             input: "$date",
    //             as: "date",
    //             in: {
    //               $dateFromString: {
    //                 dateString: "$$date",
    //                 format: "%d-%m-%Y"
    //               }
    //             }
    //           }
    //         },
    //         createdAt: 1,
    //         updatedAt: 1,
    //       },
    //     },
    //     {
    //       $unwind: "$date"
    //     },
    //     {
    //       $sort: { "date": 1 }
    //     },
    //     {
    //       $group: {
    //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
    //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
    //       }
    //     },
    //     {
    //       $project: {
    //         _id: "$_id._id",
    //         month: "$_id.month",
    //         year: "$_id.year",
    //         date: 1,
    //         createdAt: "$_id.createdAt",
    //         updatedAt: "$_id.updatedAt"
    //       }
    //     }
    //   ];
    console.log(req.params.PIN);

    await Location.findOne({ PIN: req.params.PIN }).then(async (x) => {
        console.log(x);
        // const pipeline = [
        //     {
        //         $match: {
        //             cityid: new mongoose.Types.ObjectId(x.cityid)
        //         }
        //     },
        //     {
        //         $unwind: "$date"
        //     },
        //     {
        //         $sort: { "date": 1 }
        //     },
        //     {
        //         $group: {
        //             _id: {
        //                 _id: "$_id",
        //                 month: "$month",
        //                 year: "$year",
        //                 city: x.city,
        //                 PIN: x.PIN,
        //                 cityid: "$cityid",
        //                 createdAt: "$createdAt",
        //                 updatedAt: "$updatedAt"
        //             },
        //             date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
        //         }
        //     },
        //     {
        //         $project: {
        //             _id: "$_id._id",
        //             month: "$_id.month",
        //             year: "$_id.year",
        //             city: "$_id.city",
        //             cityid: "$_id.cityid",
        //             PIN: "$_id.PIN",
        //             cityid: "$_id.cityid",
        //             date: 1,
        //             createdAt: "$_id.createdAt",
        //             updatedAt: "$_id.updatedAt"
        //         }
        //     },
        //     // {
        //     //     $sort: {
        //     //         "year": 1,
        //     //         "month": -1
        //     //     }
        //     // },
        // ];

        const today = new Date();
        const daysToFetch = 7;

        const pipeline = [
            {
                $unwind: "$time"
            },
            {
                $addFields: {
                    timeString: "$time.zip",
                    // times: "$time.time",
                    times: {
                        $map: {
                            input: "$time.time",  // Iterate over the time array
                            as: "t",  // Alias for each time entry
                            in: {
                                $let: {
                                    vars: {
                                        splitTimes: { $split: ["$$t", " to "] }  // Split 'start' and 'end' times
                                    },
                                    in: {
                                        $concat: [
                                            // Format 'start' time to 24-hour format
                                            {
                                                $dateToString: {
                                                    date: {
                                                        $dateFromString: {
                                                            dateString: {
                                                                $concat: ["1970-01-01 ", { $arrayElemAt: ["$$splitTimes", 0] }]
                                                            },
                                                            format: "%Y-%m-%d %H:%M"
                                                        }
                                                    },
                                                    format: "%H:%M"  // Use 24-hour format
                                                }
                                            },
                                            " ",
                                            {
                                                $cond: [
                                                    {
                                                        $lt: [
                                                            { $toInt: { $substr: [{ $arrayElemAt: ["$$splitTimes", 0] }, 0, 2] } },
                                                            12
                                                        ]
                                                    },
                                                    "AM",
                                                    "PM"
                                                ]
                                            },
                                            " - ",
                                            // Format 'end' time to 24-hour format
                                            {
                                                $dateToString: {
                                                    date: {
                                                        $dateFromString: {
                                                            dateString: {
                                                                $concat: ["1970-01-01 ", { $arrayElemAt: ["$$splitTimes", 1] }]
                                                            },
                                                            format: "%Y-%m-%d %H:%M"
                                                        }
                                                    },
                                                    format: "%H:%M"  // Use 24-hour format
                                                }
                                            },
                                            " ",
                                            {
                                                $cond: [
                                                    {
                                                        $lt: [
                                                            { $toInt: { $substr: [{ $arrayElemAt: ["$$splitTimes", 1] }, 0, 2] } },
                                                            12
                                                        ]
                                                    },
                                                    "AM",
                                                    "PM"
                                                ]
                                            }
                                        ]
                                    }
                                }
                            }
                        }
                    },
                    date: {
                        $dateFromString: {
                            dateString: "$date",
                            format: "%d-%m-%Y"
                        }
                    },
                    month: {
                        $dateToString: {
                            date: {
                                $dateFromString: {
                                    dateString: "$date",
                                    format: "%d-%m-%Y"
                                }
                            },
                            format: "%b"
                        }
                    },
                    year: {
                        $dateToString: {
                            date: {
                                $dateFromString: {
                                    dateString: "$date",
                                    format: "%d-%m-%Y"
                                }
                            },
                            format: "%Y"
                        }
                    }
                }
            },
            {
                $match: {
                    "time.zip": x.PIN,  // Match x.PIN with $time.zip
                    cityid: new mongoose.Types.ObjectId(x.cityid),
                    date: { $gte: today, $lt: new Date(today.getTime() + daysToFetch * 24 * 60 * 60 * 1000) }
                }
            },
            {
                $sort: {
                    date: 1
                }
            },
            {
                $limit: daysToFetch
            },
            {
                $project: {
                    _id: 1,
                    month: 1,
                    year: 1,
                    city: 1,
                    cityid: 1,
                    createdAt: 1,
                    updatedAt: 1,
                    times: 1,
                    date: {
                        $dateToString: {
                            date: "$date",
                            format: "%Y-%m-%d"
                        }
                    }
                }
            }
        ];

        let result = await Routeslot.aggregate(pipeline);

        console.log("result", result);

        const sortedResult = result.sort((a, b) => {
            if (a.year !== b.year) {
                return a.year - b.year;
            }

            if (a.month !== b.month) {
                return b.month - a.month;
            }

            return 0;
        });



        // const result = await Slots.find()

        if (sortedResult) {
            return res.send({
                isSuccess: true,
                // msg: "Get All slot.",
                msg: sortedResult
            })
        } else {
            return res.send({
                isSuccess: false,
                // msg: "Get All slot.",
                msg: []
            })
        }
    })


}







// get All Slot-Date
export const allSlot = async (req, res) => {
    // const pipeline = [
    //     {
    //       $project: {
    //         month: 1,
    //         year: 1,
    //         date: {
    //           $map: {
    //             input: "$date",
    //             as: "date",
    //             in: {
    //               $dateFromString: {
    //                 dateString: "$$date",
    //                 format: "%d-%m-%Y"
    //               }
    //             }
    //           }
    //         },
    //         createdAt: 1,
    //         updatedAt: 1,
    //       },
    //     },
    //     {
    //       $unwind: "$date"
    //     },
    //     {
    //       $sort: { "date": 1 }
    //     },
    //     {
    //       $group: {
    //         _id: { _id: "$_id", month: "$month", year: "$year", createdAt: "$createdAt", updatedAt: "$updatedAt" },
    //         date: { $push: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } }
    //       }
    //     },
    //     {
    //       $project: {
    //         _id: "$_id._id",
    //         month: "$_id.month",
    //         year: "$_id.year",
    //         date: 1,
    //         createdAt: "$_id.createdAt",
    //         updatedAt: "$_id.updatedAt"
    //       }
    //     }
    //   ];

    const pipeline = [
        {
            $unwind: "$date"
        },
        {
            $sort: { "date": 1 }
        },
        {
            $group: {
                _id: {
                    _id: "$_id",
                    month: "$month",
                    year: "$year",
                    createdAt: "$createdAt",
                    updatedAt: "$updatedAt"
                },
                date: { $push: { date: "$date.date", time: "$date.time", _id: "$date._id" } }
            }
        },
        {
            $project: {
                _id: "$_id._id",
                month: "$_id.month",
                year: "$_id.year",
                date: 1,
                createdAt: "$_id.createdAt",
                updatedAt: "$_id.updatedAt"
            }
        },
        // {
        //     $sort: {
        //         "year": 1,
        //         "month": -1
        //     }
        // },
    ];

    let result = await Slots.aggregate(pipeline);

    const sortedResult = result.sort((a, b) => {
        if (a.year !== b.year) {
            return a.year - b.year;
        }

        if (a.month !== b.month) {
            return b.month - a.month;
        }

        return 0;
    });



    // const result = await Slots.find()

    if (sortedResult) {
        return res.send({
            isSuccess: true,
            msg: "Get All slot.",
            data: sortedResult
        })
    }
}




// delete slot date by admin
export const delSlot = async (req, res) => {
    // await Slots.findOne({ month: req.body.month, year: req.body.year }).then((getSlot) => {
    await Slots.findOneAndUpdate(
        { month: req.body.month, year: req.body.year, cityid: req.body.cityid },
        { $pull: { date: { date: req.body.date } } },
        { new: true }
    ).then((getSlot) => {
        // console.log(getSlot);
        return res.send({
            isSuccess: true,
            msg: `Delete ${req.body.date} Slot by Admin.`,
            // data: result
        })
    })
    // })
}




// delete slot time by admin
export const delSlotTime = async (req, res) => {
    await Slots.findOneAndUpdate(
        {
            month: req.body.month,
            year: req.body.year,
            "date.date": req.body.date // Match the date within the date array
        },
        {
            $pull: {
                "date.$.time": req.body.time // Specify the time slot you want to delete
            }
        },
        { new: true }
    ).then((getTime) => {
        if (getTime) {
            return res.send({
                isSuccess: true,
                msg: `Delete ${req.body.time} Slot by Admin.`,
            })
        } else {
            return res.send({
                isSuccess: false,
                msg: `Something went wrong.`,
            })
        }
    })
}




// get 7 days slots from today date
export const sevDySlot = async (req, res) => {
    const today = new Date();
    const daysToFetch = 7;

    // const pipeline = [
    //     {
    //         $unwind: "$date" // Unwind the date array
    //     },
    //     {
    //         $addFields: {
    //             date: {
    //                 $dateFromString: {
    //                     dateString: "$date.date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             },
    //             // date: {
    //             //     $map: {
    //             //         input: "$date",
    //             //         as: "date",
    //             //         in: {
    //             //             $dateFromString: {
    //             //                 dateString: "$$date.date",
    //             //                 format: "%d-%m-%Y"
    //             //             }
    //             //         }
    //             //     }
    //             // },
    //             times: "$date.time" // Extract times from the unwound date object
    //         }
    //     },
    //     {
    //         $match: {
    //             date: { $gte: today } // Match slots with dates greater than or equal to tomorrow
    //         }
    //     },
    //     {
    //         $sort: {
    //             "date": 1 // Sort by the 'date' field in ascending order
    //         }
    //     },
    //     {
    //         $limit: daysToFetch // Limit to the next 7 slots
    //     },
    //     // {
    //     //     $group: {
    //     //         _id: {
    //     //             _id: "$_id",
    //     //             month: "$month",
    //     //             year: "$year",
    //     //             date: { $dateToString: { format: "%d-%m-%Y", date: "$date" } } // Group by date
    //     //         },
    //     //         times: {
    //     //             $push: "$times" // Push all times for the date
    //     //         }
    //     //     }
    //     // },
    //     // {
    //     //     $project: {
    //     //         _id: "$_id._id",
    //     //         month: "$_id.month",
    //     //         year: "$_id.year",
    //     //         date: {
    //     //             date: "$_id.date",
    //     //             time: "$times" // Assign the times array to the time field
    //     //         }
    //     //     }
    //     // },
    //     // {
    //     //     $sort: {
    //     //         date: 1,
    //     //         "_id.month": 1,
    //     //         "_id.year": 1
    //     //     }
    //     // }

    // ];

    // const pipeline = [
    //     {
    //         $unwind: "$date" // Unwind the date array
    //     },
    //     {
    //         $addFields: {
    //             date: {
    //                 $dateFromString: {
    //                     dateString: "$date.date",
    //                     format: "%d-%m-%Y"
    //                 }
    //             },
    //             times: "$date.time" // Extract times from the unwound date object
    //         }
    //     },
    //     {
    //         $match: {
    //             date: { $gte: today, $lt: new Date(today.getTime() + daysToFetch * 24 * 60 * 60 * 1000) }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "date": 1 // Sort by the 'date' field in ascending order
    //         },
    //     },
    //     {
    //         $limit: daysToFetch // Limit to the next 7 slots
    //     },
    // ];

    const pipeline = [
        {
            $unwind: "$date"
        },
        {
            $addFields: {
                date: {
                    $dateFromString: {
                        dateString: "$date.date",
                        format: "%d-%m-%Y"
                    }
                },
                times: "$date.time"
            }
        },
        {
            $match: {
                date: { $gte: today, $lt: new Date(today.getTime() + daysToFetch * 24 * 60 * 60 * 1000) },
                cityid: new ObjectId('66263982d59cd802bf89f0ac')
            }
        },
        {
            $sort: {
                "date": 1
            }
        },
        {
            $limit: daysToFetch
        },
        {
            $project: {
                _id: 1,
                month: 1,
                year: 1,
                date: {
                    $dateToString: {
                        date: "$date",
                        format: "%Y-%m-%d"
                    }
                },
                createdAt: 1,
                updatedAt: 1,
                times: 1,
                cityid: 1,
                city: 1,
            }
        }
    ];

    const result = await Slots.aggregate(pipeline);
    console.log(result);
    // Execute the aggregation pipeline

    if (!result) {
        return res.send({
            isSuccess: false,
            msg: `Something went wrong.`,
        })
    } else {
        return res.send({
            isSuccess: true,
            msg: result,
        })
    }

}



// Date including today, show to Admin
// export const sevDySlotByAdmin = async (req, res) => {
//     // const today = new Date();
//     // console.log(today);
//     // const today = new Date(req.query.date);
//     let today = req.query.date;
//     let [day, month, year] = today.split('-');
//     let isoDate = new Date(`${year}-${month}-${day}T00:00:00.000Z`);
//     console.log(isoDate);

//     // const time = req.query.time;
//     const daysToFetch = 7;

//     const pipeline = [
//         {
//             $unwind: "$date"
//         },
//         {
//             $addFields: {
//                 date: {
//                     $dateFromString: {
//                         dateString: "$date.date",
//                         format: "%d-%m-%Y"
//                     }
//                 },
//                 times: "$date.time"
//             }
//         },
//         {
//             $match: {
//                 date: { $gte: isoDate, $lt: new Date(isoDate.getTime() + daysToFetch * 24 * 60 * 60 * 1000) }
//             }
//         },
//         {
//             $sort: {
//                 "date": 1
//             }
//         },
//         {
//             $limit: daysToFetch
//         },
//         {
//             $project: {
//                 _id: 1,
//                 month: 1,
//                 year: 1,
//                 date: {
//                     $dateToString: {
//                         date: "$date",
//                         format: "%Y-%m-%d"
//                     }
//                 },
//                 createdAt: 1,
//                 updatedAt: 1,
//                 times: 1
//             }
//         }
//     ];


//     const result = await Slots.aggregate(pipeline);
//     console.log(result);

//     if (!result) {
//         return res.send({
//             isSuccess: false,
//             msg: `Something went wrong.`,
//         })
//     } else {
//         return res.send({
//             isSuccess: true,
//             msg: result,
//         })
//     }
// }

// 7 Days slot for particular cityid (including today), show to Admin
export const sevDySlotByAdmin = async (req, res) => {
    const { date, PIN } = req.query;
    console.log("Requested Date:", date, "PIN:", PIN);

    try {
        // Retrieve cityid based on the provided PIN
        const location = await Location.findOne({ PIN: PIN });
        if (!location) {
            return res.send({
                isSuccess: false,
                msg: `Invalid PIN.`,
            });
        }
        const cityId = location.cityid;

        console.log("Location:", location);
        console.log("City ID:", cityId);

        // Parse the requested date string and adjust the format to match the database
        const [requestedDay, requestedMonth, requestedYear] = date.split('-');
        const monthsMap = {
            "01": "Jan",
            "02": "Feb",
            "03": "Mar",
            "04": "Apr",
            "05": "May",
            "06": "Jun",
            "07": "Jul",
            "08": "Aug",
            "09": "Sep",
            "10": "Oct",
            "11": "Nov",
            "12": "Dec"
        };
        const requestedMonthAdjusted = monthsMap[requestedMonth];

        // Calculate the end date (7 days from the requested date)
        const endDate = new Date(requestedYear, requestedMonth - 1, requestedDay);
        endDate.setDate(endDate.getDate() + 7);

        // If the end date goes beyond the current month, adjust it to the next month
        if (endDate.getMonth() !== parseInt(requestedMonth) - 1) {
            endDate.setMonth(endDate.getMonth() + 1);
        }

        const pipeline = [
            {
                $match: {
                    cityid: cityId,
                    $or: [
                        { $and: [{ month: requestedMonthAdjusted, year: requestedYear }] },
                        { $and: [{ month: { $ne: requestedMonthAdjusted }, year: { $eq: requestedYear } }] }
                    ]
                }
            },
            {
                $unwind: "$date"
            },
            {
                $addFields: {
                    "date.date": {
                        $dateFromString: {
                            dateString: "$date.date",
                            format: "%d-%m-%Y"
                        }
                    },
                    times: "$date.time"
                }
            },
            {
                $match: {
                    "date.date": {
                        $gte: new Date(requestedYear, requestedMonth - 1, requestedDay),
                        $lt: endDate
                    }
                }
            },
            {
                $sort: {
                    "date.date": 1
                }
            },
            {
                $project: {
                    _id: 1,
                    month: 1,
                    year: 1,
                    date: {
                        $dateToString: {
                            date: "$date.date",
                            format: "%Y-%m-%d"
                        }
                    },
                    times: 1,
                    city: 1,
                    cityid: 1,
                    createdAt: 1,
                    updatedAt: 1
                }
            },
            {
                $limit: 7
            }
        ];

        const result = await Slots.aggregate(pipeline);
        console.log(result);

        if (!result || result.length === 0) {
            return res.send({
                isSuccess: false,
                msg: `No slots available for the specified city and date range.`,
            });
        } else {
            return res.send({
                isSuccess: true,
                msg: result,
            });
        }
    } catch (error) {
        console.error("Error:", error);
        return res.send({
            isSuccess: false,
            msg: `Something went wrong.`,
        });
    }
}




// Show Slot by city id
export const eachDateSlotCityid = async (req, res) => {
    console.log(req.params.date);
    const [day, month, year] = (req.params.date).split('-');

    const dateObject = new Date(`${month}-${day}-${year}`);
    const formattedDate = dateObject.toLocaleDateString('en-US', { day: 'numeric', month: 'short', year: 'numeric' });

    console.log(formattedDate);

    // const pipeline = [
    //     {
    //         $match: {
    //             schedule_date: req.params.date
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "customers",
    //             localField: "customer_id",
    //             foreignField: "_id",
    //             as: "customerDetails"
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "addresses",
    //             localField: "address_id",
    //             foreignField: "_id",
    //             as: "addressDetails"
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "itemDetails"
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 schedule_date: "$schedule_date",
    //                 time: "$time"
    //             },
    //             items: {
    //                 $push: {
    //                     _id: "$_id",
    //                     item: "$item"
    //                 }
    //             },
    //             totalWeight: { $sum: "$item.weight" },
    //         }
    //     },
    //     {
    //         $match: {
    //             totalWeight: { $gte: 100 }
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id.schedule_date",
    //             times: {
    //                 $push: {
    //                     // items: "$items",
    //                     time: "$_id.time",
    //                     totalWeight: "$totalWeight"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id", // Keep the same _id for the final grouping
    //             times: {
    //                 $push: {
    //                     time: "$times.time",
    //                     totalWeight: "$times.totalWeight"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "updatedAt": 1
    //         }
    //     },
    //     // {
    //     //     $project: {
    //     //         _id: 0,
    //     //         schedule_date: "$_id",
    //     //         times: 1
    //     //     }
    //     // }
    // ];

    var existCardboard = []
    existCardboard = await Items.findOne({ cityid: new ObjectId(req.query.cityid), item_name: "Cardboard" })

    console.log(existCardboard);
    if (existCardboard != null) {
        const pipeline = [
            {
                $match: {
                    schedule_date: req.params.date
                }
            },
            {
                $unwind: "$item"
            },
            {
                $match: {
                    "item.itemid": new ObjectId(existCardboard._id)
                }
            },
            {
                $group: {
                    _id: {
                        schedule_date: "$schedule_date",
                        time: "$time"
                    },
                    totalWeight: { $sum: "$item.weight" }
                }
            },
            {
                $match: {
                    totalWeight: { $gte: 100000 }
                }
            },
            {
                $group: {
                    _id: "$_id.schedule_date",
                    times: {
                        $push: "$_id.time"
                    }
                }
            },
            {
                $project: {
                    _id: 1,
                    times: 1
                }
            },
            {
                $sort: {
                    "_id": 1
                }
            }
        ];



        const result = await Orders.aggregate(pipeline);
        console.log(result);

        if (!result) {
            return res.send({
                isSuccess: false,
                msg: `Something went wrong.`,
            })
        } else {
            var slot = []
            // result.map(async (x) => {
            // console.log('schedule_date:', x.schedule_date, x.time);

            const targetDate = '05-01-2024';
            const targetTime = '08:00 AM to 10:00 AM';

            const pipeline = [
                {
                    $match: {
                        year: formattedDate.split(' ')[2],
                        month: formattedDate.split(' ')[0],
                        cityid: new ObjectId(req.query.cityid)
                    },
                },
                {
                    $group: {
                        _id: {
                            year: "$year",
                            month: "$month",
                            time: "$time",
                            cityid: "$cityid"
                        },
                        date: { $push: "$date" },
                    },
                },
                {
                    $sort: {
                        "updatedAt": 1,
                    },
                },
                {
                    $addFields: {
                        filteredDates: {
                            $map: {
                                input: "$date",
                                as: "dates",
                                in: {
                                    date: {
                                        $filter: {
                                            input: "$$dates",
                                            as: "d",
                                            cond: { $eq: ["$$d.date", req.params.date] },
                                        },
                                    },
                                    // time: {
                                    //     $filter: {
                                    //         input: "$_id.time",
                                    //         as: "t",
                                    //         cond: { $in: [targetTime, "$$t"] },
                                    //     },
                                    // },
                                },
                            },
                        },
                    },
                },
                {
                    $match: {
                        "filteredDates.date": { $ne: [] }, // Check if the filtered date array is not empty
                        "filteredDates.time": { $ne: [] }, // Check if the filtered time array is not empty
                    },
                },
                {
                    $project: {
                        _id: 0,
                        date: { $arrayElemAt: ["$filteredDates.date", 0] }, // Extract the first element from the date array
                        // time: { $arrayElemAt: ["$filteredDates.time", 0] }, // Extract the first element from the time array
                    },
                },
            ];







            slot = await Slots.aggregate(pipeline);

            console.log(slot);

            // })

            if (slot) {
                return res.send({
                    isSuccess: true,
                    reserve_slots: [],
                    all_slots: slot,
                })
            }


        }
    } else if (existCardboard == null) {
        const pipeline = [
            {
                $match: {
                    schedule_date: req.params.date
                }
            },
            {
                $unwind: "$item"
            },
            // {
            //   $match: {
            //     "item.itemid": new ObjectId("65448a323e5bd9d8ab525153")
            //   }
            // },
            {
                $group: {
                    _id: {
                        schedule_date: "$schedule_date",
                        time: "$time"
                    },
                    totalWeight: { $sum: "$item.weight" }
                }
            },
            {
                $match: {
                    totalWeight: { $gte: 100000 }
                }
            },
            {
                $group: {
                    _id: "$_id.schedule_date",
                    times: {
                        $push: "$_id.time"
                    }
                }
            },
            {
                $project: {
                    _id: 1,
                    times: 1
                }
            },
            {
                $sort: {
                    "_id": 1
                }
            }
        ];



        const result = await Orders.aggregate(pipeline);
        console.log(result);

        if (!result) {
            return res.send({
                isSuccess: false,
                msg: `Something went wrong.`,
            })
        } else {
            var slot = []
            // result.map(async (x) => {
            // console.log('schedule_date:', x.schedule_date, x.time);

            const targetDate = '05-01-2024';
            const targetTime = '08:00 AM to 10:00 AM';

            const pipeline = [
                {
                    $match: {
                        year: formattedDate.split(' ')[2],
                        month: formattedDate.split(' ')[0],
                        cityid: new ObjectId(req.query.cityid)
                    },
                },
                {
                    $group: {
                        _id: {
                            year: "$year",
                            month: "$month",
                            time: "$time",
                            cityid: "$cityid"
                        },
                        date: { $push: "$date" },
                    },
                },
                {
                    $sort: {
                        "updatedAt": 1,
                    },
                },
                {
                    $addFields: {
                        filteredDates: {
                            $map: {
                                input: "$date",
                                as: "dates",
                                in: {
                                    date: {
                                        $filter: {
                                            input: "$$dates",
                                            as: "d",
                                            cond: { $eq: ["$$d.date", req.params.date] },
                                        },
                                    },
                                    // time: {
                                    //     $filter: {
                                    //         input: "$_id.time",
                                    //         as: "t",
                                    //         cond: { $in: [targetTime, "$$t"] },
                                    //     },
                                    // },
                                },
                            },
                        },
                    },
                },
                {
                    $match: {
                        "filteredDates.date": { $ne: [] }, // Check if the filtered date array is not empty
                        "filteredDates.time": { $ne: [] }, // Check if the filtered time array is not empty
                    },
                },
                {
                    $project: {
                        _id: 0,
                        date: { $arrayElemAt: ["$filteredDates.date", 0] }, // Extract the first element from the date array
                        // time: { $arrayElemAt: ["$filteredDates.time", 0] }, // Extract the first element from the time array
                    },
                },
            ];







            slot = await Slots.aggregate(pipeline);

            console.log(slot);

            // })

            if (slot) {
                return res.send({
                    isSuccess: true,
                    reserve_slots: [],
                    all_slots: slot,
                })
            }


        }
    }


}





export const eachDateRouteSlotCityid = async (req, res) => {
    console.log(req.params.date);
    const [day, month, year] = (req.params.date).split('-');

    const dateObject = new Date(`${month}-${day}-${year}`);
    const formattedDate = dateObject.toLocaleDateString('en-US', { day: 'numeric', month: 'short', year: 'numeric' });

    console.log(formattedDate);

    const cityDetails = await Location.findOne({ cityid: new ObjectId(req.query.cityid) })

    // const pipeline = [
    //     {
    //         $match: {
    //             schedule_date: req.params.date
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "customers",
    //             localField: "customer_id",
    //             foreignField: "_id",
    //             as: "customerDetails"
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "addresses",
    //             localField: "address_id",
    //             foreignField: "_id",
    //             as: "addressDetails"
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "itemDetails"
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 schedule_date: "$schedule_date",
    //                 time: "$time"
    //             },
    //             items: {
    //                 $push: {
    //                     _id: "$_id",
    //                     item: "$item"
    //                 }
    //             },
    //             totalWeight: { $sum: "$item.weight" },
    //         }
    //     },
    //     {
    //         $match: {
    //             totalWeight: { $gte: 100 }
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id.schedule_date",
    //             times: {
    //                 $push: {
    //                     // items: "$items",
    //                     time: "$_id.time",
    //                     totalWeight: "$totalWeight"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id", // Keep the same _id for the final grouping
    //             times: {
    //                 $push: {
    //                     time: "$times.time",
    //                     totalWeight: "$times.totalWeight"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "updatedAt": 1
    //         }
    //     },
    //     // {
    //     //     $project: {
    //     //         _id: 0,
    //     //         schedule_date: "$_id",
    //     //         times: 1
    //     //     }
    //     // }
    // ];


    var slot = []
    // result.map(async (x) => {
    // console.log('schedule_date:', x.schedule_date, x.time);
    if (cityDetails) {
        const pipeline = [
            {
                $match: {
                    date: req.params.date,
                    cityid: new ObjectId(req.query.cityid)
                }
            },
            {
                $unwind: "$time" // Unwind the array to destructure nested arrays
            },
            {
                $group: {
                    _id: {
                        _id: "$_id", // Preserve original document _id
                        date: "$date",
                        cityid: "$cityid"
                    },
                    times: {
                        $addToSet: {
                            $map: {
                                input: "$time.time",  // Iterate over the time array
                                as: "t",  // Alias for each time entry
                                in: {
                                    $let: {
                                        vars: {
                                            splitTimes: { $split: ["$$t", " to "] }  // Split 'start' and 'end' times
                                        },
                                        in: {
                                            $concat: [
                                                // Format 'start' time to 24-hour format
                                                {
                                                    $dateToString: {
                                                        date: {
                                                            $dateFromString: {
                                                                dateString: {
                                                                    $concat: ["1970-01-01 ", { $arrayElemAt: ["$$splitTimes", 0] }]
                                                                },
                                                                format: "%Y-%m-%d %H:%M"
                                                            }
                                                        },
                                                        format: "%H:%M"  // Use 24-hour format
                                                    }
                                                },
                                                " ",
                                                {
                                                    $cond: [
                                                        {
                                                            $lt: [
                                                                { $toInt: { $substr: [{ $arrayElemAt: ["$$splitTimes", 0] }, 0, 2] } },
                                                                12
                                                            ]
                                                        },
                                                        "AM",
                                                        "PM"
                                                    ]
                                                },
                                                " - ",
                                                // Format 'end' time to 24-hour format
                                                {
                                                    $dateToString: {
                                                        date: {
                                                            $dateFromString: {
                                                                dateString: {
                                                                    $concat: ["1970-01-01 ", { $arrayElemAt: ["$$splitTimes", 1] }]
                                                                },
                                                                format: "%Y-%m-%d %H:%M"
                                                            }
                                                        },
                                                        format: "%H:%M"  // Use 24-hour format
                                                    }
                                                },
                                                " ",
                                                {
                                                    $cond: [
                                                        {
                                                            $lt: [
                                                                { $toInt: { $substr: [{ $arrayElemAt: ["$$splitTimes", 1] }, 0, 2] } },
                                                                12
                                                            ]
                                                        },
                                                        "AM",
                                                        "PM"
                                                    ]
                                                }
                                            ]
                                        }
                                    }
                                }
                            }
                        } // Add to set to collect unique times
                    }
                }
            },
            {
                $project: {
                    _id: "$_id._id", // Rename _id to the original document's _id
                    date: "$_id.date",
                    time: {
                        $reduce: {
                            input: "$times",
                            initialValue: [],
                            in: { $concatArrays: ["$$value", "$$this"] } // Concatenate arrays
                        }
                    },
                    cityid: "$_id.cityid"
                }
            },
            {
                $project: {
                    _id: 1,
                    date: 1,
                    time: {
                        $setDifference: ["$time", []] // Remove common times (empty array)
                    },
                    cityid: 1,
                }
            }
        ];



        slot = await Routeslot.aggregate(pipeline);

        console.log(slot);

        const transformedSlots = slot.map(slot => ({
            date: [{
                _id: slot._id,
                date: slot.date,
                // cityid: slot.cityid,
                time: slot.time
            }]
        }));


        // })

        if (transformedSlots) {
            return res.send({
                isSuccess: true,
                // reserve_slots: result,
                all_slots: transformedSlots,
            })
        }

    }


}




// Filter each date slot
export const eachDateSlot = async (req, res) => {
    console.log(req.params.date);
    const [day, month, year] = (req.params.date).split('-');

    const dateObject = new Date(`${month}-${day}-${year}`);
    const formattedDate = dateObject.toLocaleDateString('en-US', { day: 'numeric', month: 'short', year: 'numeric' });

    console.log(formattedDate);

    // const pipeline = [
    //     {
    //         $match: {
    //             schedule_date: req.params.date
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "customers",
    //             localField: "customer_id",
    //             foreignField: "_id",
    //             as: "customerDetails"
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "addresses",
    //             localField: "address_id",
    //             foreignField: "_id",
    //             as: "addressDetails"
    //         }
    //     },
    //     {
    //         $unwind: "$item"
    //     },
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "itemDetails"
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: {
    //                 schedule_date: "$schedule_date",
    //                 time: "$time"
    //             },
    //             items: {
    //                 $push: {
    //                     _id: "$_id",
    //                     item: "$item"
    //                 }
    //             },
    //             totalWeight: { $sum: "$item.weight" },
    //         }
    //     },
    //     {
    //         $match: {
    //             totalWeight: { $gte: 100 }
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id.schedule_date",
    //             times: {
    //                 $push: {
    //                     // items: "$items",
    //                     time: "$_id.time",
    //                     totalWeight: "$totalWeight"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id", // Keep the same _id for the final grouping
    //             times: {
    //                 $push: {
    //                     time: "$times.time",
    //                     totalWeight: "$times.totalWeight"
    //                 }
    //             }
    //         }
    //     },
    //     {
    //         $sort: {
    //             "updatedAt": 1
    //         }
    //     },
    //     // {
    //     //     $project: {
    //     //         _id: 0,
    //     //         schedule_date: "$_id",
    //     //         times: 1
    //     //     }
    //     // }
    // ];


    const pipeline = [
        {
            $match: {
                schedule_date: req.params.date
            }
        },
        {
            $unwind: "$item"
        },
        // {
        //     $match: {
        //         "item.itemid": new ObjectId("65448a323e5bd9d8ab525153")
        //     }
        // },
        {
            $group: {
                _id: {
                    schedule_date: "$schedule_date",
                    time: "$time"
                },
                totalWeight: { $sum: "$item.weight" }
            }
        },
        // {
        //     $match: {
        //         totalWeight: { $gte: 100000 }
        //     }
        // },
        {
            $group: {
                _id: "$_id.schedule_date",
                times: {
                    $push: "$_id.time"
                }
            }
        },
        {
            $project: {
                _id: 1,
                times: 1
            }
        },
        {
            $sort: {
                "_id": 1
            }
        }
    ];





    const result = await Orders.aggregate(pipeline);
    console.log(result);

    if (!result) {
        return res.send({
            isSuccess: false,
            msg: `Something went wrong.`,
        })
    } else {
        var slot = []
        // result.map(async (x) => {
        // console.log('schedule_date:', x.schedule_date, x.time);

        const targetDate = '05-01-2024';
        const targetTime = '08:00 AM to 10:00 AM';

        const pipeline = [
            {
                $match: {
                    year: formattedDate.split(' ')[2],
                    month: formattedDate.split(' ')[0],
                    cityid: new ObjectId('65d5772df1cccd1633087da7')
                },
            },
            {
                $group: {
                    _id: {
                        year: "$year",
                        month: "$month",
                        time: "$time",
                    },
                    date: { $push: "$date" },
                },
            },
            {
                $sort: {
                    "updatedAt": 1,
                },
            },
            {
                $addFields: {
                    filteredDates: {
                        $map: {
                            input: "$date",
                            as: "dates",
                            in: {
                                date: {
                                    $filter: {
                                        input: "$$dates",
                                        as: "d",
                                        cond: { $eq: ["$$d.date", req.params.date] },
                                    },
                                },
                                // time: {
                                //     $filter: {
                                //         input: "$_id.time",
                                //         as: "t",
                                //         cond: { $in: [targetTime, "$$t"] },
                                //     },
                                // },
                            },
                        },
                    },
                },
            },
            {
                $match: {
                    "filteredDates.date": { $ne: [] }, // Check if the filtered date array is not empty
                    "filteredDates.time": { $ne: [] }, // Check if the filtered time array is not empty
                },
            },
            {
                $project: {
                    _id: 0,
                    date: { $arrayElemAt: ["$filteredDates.date", 0] }, // Extract the first element from the date array
                    // time: { $arrayElemAt: ["$filteredDates.time", 0] }, // Extract the first element from the time array
                },
            },
        ];







        slot = await Slots.aggregate(pipeline);

        console.log(slot);

        // })

        if (slot) {
            return res.send({
                isSuccess: true,
                reserve_slots: result,
                all_slots: slot,
            })
        }


    }
}






// Get all booked slots.
export const bookedSlot = async (req, res) => {
    const [day, month, year] = (req.params.date).split('-');

    const dateObject = new Date(`${month}-${day}-${year}`);
    const formattedDate = dateObject.toLocaleDateString('en-US', { day: 'numeric', month: 'short', year: 'numeric' });

    console.log(formattedDate);
    const pipeline = [
        {
            $match: {
                year: formattedDate.split(' ')[2],
                month: formattedDate.split(' ')[0],
                // _id: new ObjectId('660aab7be71ba7b6e75803a7'),
                cityid: new ObjectId(req.params.cityid)
            },
        },
        {
            $group: {
                _id: {
                    year: "$year",
                    month: "$month",
                    time: "$time",
                },
                date: { $push: "$date" },
            },
        },
        {
            $sort: {
                "updatedAt": 1,
            },
        },
        {
            $addFields: {
                filteredDates: {
                    $map: {
                        input: "$date",
                        as: "dates",
                        in: {
                            date: {
                                $filter: {
                                    input: "$$dates",
                                    as: "d",
                                    cond: { $eq: ["$$d.date", req.params.date] },
                                },
                            },
                            // time: {
                            //     $filter: {
                            //         input: "$_id.time",
                            //         as: "t",
                            //         cond: { $in: [targetTime, "$$t"] },
                            //     },
                            // },
                        },
                    },
                },
            },
        },
        {
            $match: {
                "filteredDates.date": { $ne: [] }, // Check if the filtered date array is not empty
                "filteredDates.time": { $ne: [] }, // Check if the filtered time array is not empty
            },
        },
        {
            $project: {
                _id: 0,
                date: { $arrayElemAt: ["$filteredDates.date", 0] }, // Extract the first element from the date array
                // time: { $arrayElemAt: ["$filteredDates.time", 0] }, // Extract the first element from the time array
            },
        },
    ];

    const slot = await Slots.aggregate(pipeline);

    console.log(slot[0].date);

    if (slot) {

        const pipeline = [
            {
                $match: {
                    cityid: new ObjectId(req.params.cityid),
                }
            },
            {
                $group: {
                    _id: null,
                    pins: { $addToSet: "$PIN" }
                }
            },
            {
                $unwind: "$pins" // Unwind the pins array to process each pin separately
            },
            {
                $lookup: {
                    from: "addresses",
                    localField: "pins",
                    foreignField: "PIN",
                    as: "matched_addresses"
                }
            },
            {
                $lookup: {
                    from: "orders",
                    localField: "matched_addresses._id",
                    foreignField: "address_id",
                    as: "matched_orders"
                }
            },
            {
                $unwind: "$matched_orders" // Unwind the matched_orders array to process each order separately
            },
            {
                $match: {
                    "matched_orders.schedule_date": req.params.date, // Match orders with the specified date
                    "matched_orders.status": { $nin: ["processed", "processing"] }
                }
            },
            {
                $group: {
                    _id: "$matched_orders.schedule_date", // Group by schedule_date
                    times: { $addToSet: "$matched_orders.time" } // Add unique times to the 'times' array
                }
            },
            {
                $project: {
                    schedule_date: "$_id", // Rename _id to schedule_date
                    times: 1 // Include the times array in the output
                }
            }
        ];

        const locationslot = await Location.aggregate(pipeline);
        console.log("locationslot", locationslot);

        if (locationslot.length != 0) {
            return res.send({
                isSuccess: true,
                bookslot: locationslot,
                allslot: slot[0].date,
            })
        } else {
            return res.send({
                isSuccess: true,
                bookslot: locationslot,
                allslot: slot[0].date,
            })
        }

    } else {
        return res.send({
            isSuccess: false,
            bookslot: [],
            allslot: [],
        })
    }
}





// Update Slot -> Admin
export const updateSlot = async (req, res) => {
    const month = req.body.month;
    const year = req.body.year;
    const date = req.body.date[0].date;
    const timeSlots = req.body.date[0].time;
    const city = req.body.city;
    const cityid = req.body.cityid;


    try {

        console.log("req.body", req.body);

        const updateslot = await Slot.findOneAndUpdate(
            { _id: new ObjectId(req.params.id) },
            {
                $set: {
                    month: month,
                    year: year,
                    date: req.body.date,
                    city: city,
                    cityid: cityid,
                }
            },
            { new: true } // to get the updated document
        );

        console.log("updateslot", updateslot);
        if (updateslot) {
            return res.send({
                isSuccess: true,
                msg: "Update slot",
            })
        }
    } catch (error) {
        res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
            error: error.message,
        });
    }
}


export const slotforeachdatePinCode = async (req, res) => {
    console.log(req.params.date);

    const { cityid, pin } = req.query;
    console.log("cityid", cityid, "pin", pin);

    // Validate required parameters
    if (!req.params.date || !cityid || !pin) {
        return res.status(400).send({
            isSuccess: false,
            msg: "date, cityid, and pin are required",
        });
    }

    // Validate cityid as a valid ObjectId

    const pipeline = [
        {
            $match: {
                date: req.params.date,
                cityid: new mongoose.Types.ObjectId(cityid),
            }
        },
        {
            $unwind: {
                path: "$time"
            }
        },
        {
            $match: {
                "time.zip": pin
            }
        },
        {
            $unwind: {
                path: "$time.time"
            }
        },
        {
            $group: {
                _id: {
                    cityid: "$cityid",
                    date: "$date"
                },
                time: {
                    $addToSet: "$time.time"
                },
            }
        },
        {
            $project: {
                _id: "$_id.cityid",
                date: "$_id.date",
                time: {
                    $map: {
                        input: "$time",
                        as: "timeRange",
                        in: {
                            $let: {
                                vars: {
                                    splitTime: { $split: ["$$timeRange", " to "] }
                                },
                                in: {
                                    $concat: [
                                        // Start time
                                        {
                                            $let: {
                                                vars: { startTime: { $arrayElemAt: ["$$splitTime", 0] } },
                                                in: {
                                                    $concat: [
                                                        {
                                                            $substr: [
                                                                "$$startTime",
                                                                0,
                                                                { $subtract: [{ $indexOfBytes: ["$$startTime", ":"] }, 0] }
                                                            ]
                                                        },
                                                        ":",
                                                        {
                                                            $substr: [
                                                                "$$startTime",
                                                                { $add: [{ $indexOfBytes: ["$$startTime", ":"] }, 1] },
                                                                2
                                                            ]
                                                        },
                                                        " ",
                                                        {
                                                            $cond: {
                                                                if: { $gte: [{ $toInt: { $substr: ["$$startTime", 0, 2] } }, 12] },
                                                                then: "PM",
                                                                else: "AM"
                                                            }
                                                        }
                                                    ]
                                                }
                                            }
                                        },
                                        " to ",
                                        // End time
                                        {
                                            $let: {
                                                vars: { endTime: { $arrayElemAt: ["$$splitTime", 1] } },
                                                in: {
                                                    $concat: [
                                                        {
                                                            $substr: [
                                                                "$$endTime",
                                                                0,
                                                                { $subtract: [{ $indexOfBytes: ["$$endTime", ":"] }, 0] }
                                                            ]
                                                        },
                                                        ":",
                                                        {
                                                            $substr: [
                                                                "$$endTime",
                                                                { $add: [{ $indexOfBytes: ["$$endTime", ":"] }, 1] },
                                                                2
                                                            ]
                                                        },
                                                        " ",
                                                        {
                                                            $cond: {
                                                                if: { $gte: [{ $toInt: { $substr: ["$$endTime", 0, 2] } }, 12] },
                                                                then: "PM",
                                                                else: "AM"
                                                            }
                                                        }
                                                    ]
                                                }
                                            }
                                        }
                                    ]
                                }
                            }
                        }
                    }
                }
            }
        }
    ];
    console.log("pipeline", pipeline);
    try {
        const result = await Routeslot.aggregate(pipeline);
        if (result.length > 0) {
            return res.status(200).send({
                isSuccess: true,
                reserve_slots: [],
                all_slots: [
                    {
                        data: result
                    }
                ],
            });
        } else {
            return res.status(200).send({
                isSuccess: true,
                reserve_slots: [],
                all_slots: [],
            });
        }
    } catch (error) {
        return res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
            error: error.message,
        });
    }
};



