import Orders from "../model/order.model.js";
export const changeOrderStatus = async (req, res) => {
    try {
      const order_id = req.params.orderid; // Extract order ID from route params
      const status = req.body.status; // Extract the status value from the request body
  
      console.log("The status received is:", status);
      console.log("The order ID received is:", order_id);
  
      // Check if the order exists
      const order = await Orders.findById({ _id: order_id });
      console.log("Order fetched:", order);
  
      if (order) {
        // Update the order's status
        const updatedOrder = await Orders.findOneAndUpdate(
          { _id: order_id },
          { $set: { status } },
          { new: true } // Return the updated document
        );
  
        console.log("Updated Order:", updatedOrder);
  
        // Send a success response
        return res.status(200).send({
          isSuccess: true,
          msg: "Order status updated successfully!",
          updatedOrder,
        });
      } else {
        // If no order found, return an error response
        return res.status(404).send({
          isSuccess: false,
          msg: "Order not found!",
        });
      }
    } catch (error) {
      console.error("Error updating order status:", error);
  
      // Send an error response
      return res.status(500).send({
        isSuccess: false,
        msg: "Internal Server Error!",
      });
    }
  };
  
