import Version from "../model/version.model.js";



export const versionChk = async (req, res) => {

    await Version.find().then((x) => {
        return res.send({
            isSuccess: true,
            version: x,
        });
    })
    .catch((error) => {
        return res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
            error: error.message,
        });
    });

}




export const createVersion = async (req, res) => {

    const { version, version_name } = req.body;

    const crtVersion = await Version.create({
        version, version_name
    });

    if (crtVersion) {
        return res.send({
            isSuccess: true,
            version: crtVersion,
        });
    } else {
        return res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
        });
    }

}





export const updateVersion = async (req, res) => {

    const { version, version_name } = req.body;

    const update = await Version.findOneAndUpdate({ _id: req.params.version }, {$set: { version: version, version_name: version_name }})

    if (update) {
        return res.send({
            isSuccess: true,
            version: "Update Successfully.",
        });
    } else {
        return res.status(500).send({
            isSuccess: false,
            msg: "Something went wrong.",
        });
    }

}




