import JWT from 'jsonwebtoken'
import Users from '../model/users.model.js';
import mongoose from 'mongoose';
const adminAuth = async (req, res, next) => {
    if (req.headers.authorization && req.headers.authorization.startsWith('Bearer')) {
        try {
            const token = req.headers.authorization.split(' ')[1];
            const decoded = JWT.verify(token, "AjatusAgent")
            const user = await Users.findOne({ _id: new mongoose.Types.ObjectId(decoded._id), isActive: true }).select('-password');
            if (!user) {
                return res.status(401).json({ error: true, message: 'Unauthorized' });
            }
            req.user = user;
            next();
        }
        catch (err) {
            console.log("Catch block error", err)
            return res.status(401).json({ error: true, message: 'Unauthorized' });
        }
    }
    else {
        return res.status(401).json({ error: true, message: 'Unauthorized' });
    }
}
export default adminAuth