// multerConfig.js

import multer from 'multer';

const storage = multer.diskStorage({
    destination: 'uploads',
    filename: (req, file, cb) => {
      const uniqueSuffix = Date.now() + '-' + Math.round(Math.random() * 1E9);
      const extension = file.originalname.split('.').pop();
      cb(null, uniqueSuffix + '.' + extension);
    },
  });
  
export const upload = multer({ storage }).single("file");

// module.exports = upload;


