import { Timestamp } from "bson";
import mongoose from "mongoose";
const ObjectId = mongoose.Types.ObjectId;

const agentDataSchema=mongoose.Schema({
    agent_Id:{
        type: ObjectId,
        ref:"Users",
        required:true
    },
    name:{
        type:String,

    },
    Date:{
        type:String,
        required:true
    },
    Daily_wages:{
        type:Number
        
    },
    settlement_status:{
        type:Boolean,
        default:false
    },
    modeof_settlement:{
        type:String, 
    },
    settlement_date:{
        type:String,
    },
    advance:{
        type:Number,
    },
    advance_mode:{
        type:String,
    },
    paymentdetails:[
        {
            payment_date:{
                type:String
            },
            p_outId:{
                type:String
            },
            amount:{
                type:Number
            }
        }
    ]

    
    
    
},{Timestamp:true
});
const AgentData=mongoose.model("AgentData",agentDataSchema);
export default AgentData;