import mongoose from "mongoose";

const { Schema } = mongoose;

// Define a schema for the location subdocument
const locationSchema = new Schema({
    latitude: Number,
    longitude: Number,
    time: String,
}, { timestamps: true });

// Define the main schema for agent tracking
const agentTrackingSchema = new Schema({
    agentId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'Users'
    },
    date: {
        type: String,
        required: true
    },
    location: [locationSchema],
}, {
    timestamps: true
});

const agentTracking = mongoose.model("agentTracking", agentTrackingSchema);
export default agentTracking;
