import mongoose from "mongoose";
const { Schema } = mongoose;

const customNotifySchema = mongoose.Schema({
    title: {
        type: String
    },
    content: {
        type: String
    },
    date: {
        type: String,
        required: true
    },
    time: {
        type: String,
        required: true
    },
    conditionId: [{
        _id: { type: Schema.Types.ObjectId },
        condition_name: { type: String }
    }],
    cityid: {
        type: String,        
    },
    itemId: {
        type: String,        
    },
    status: {
        type:String
    },
    image: {
        contentType: String,
        data: Buffer
    },
    imageURL: String,
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    }
}, {
    timestamps: true
});

const CustomNotify = mongoose.model("customNotify", customNotifySchema);
export default CustomNotify;
