import mongoose from "mongoose";

const customerSchema = mongoose.Schema({
    name: {
        type: String,
        default: ""
    },
    mobile: String,
    email: {
        type: String,
        default: ""
    },
    image: {
        contentType: String,
        data: Buffer
    },
    imageURL: String,
    avatar: {
        type: String
    },
    OTP: String,
    token: {
        type: String
    },
    ci: {
        type: String
    },
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    DeleteTime: {
        type: Date,
        default: null
    },
    isComplete: {
        type: Boolean,
        default: false
    },
    refCode: {
        type: String
    },
    useRefCode: {
        type: String
    },
    orderCount: {
        type: Number,
        default: 0
    },
    refCodeUser: {
        type: [String],
        default: []
    },
    PAN: {
        type: String,
    },
    // pan_fileURL: String,
    organisation: {
        type: String,
    },
    gst: {
        type: String,
    },
    business_name: {
        type: String,
    },
    business_reg: {
        type: Boolean,
    },
    username: {
        type: String,
    },
    password: {
        type: String,
    },
    lastLogin: {
        type: Date
    },
    lastLogout:{
        type: Date
    },
    deviceInfo: {
        platform: String,
        Name: String,
        model: String,
        operatingSystem: String,
        osVersion: String,
        IOSAndAndroidSDKVersion: String
    },
    BuyerId: {
        type: mongoose.Schema.Types.ObjectId
    },
    SellerId: {
        type: mongoose.Schema.Types.ObjectId
    }
}, {
    timestamps: true
});
customerSchema.pre('save', function(next) {
    if (this.isDelete) {
        this.DeleteTime = new Date(); // Set current time
    } else {
        this.DeleteTime = null; // Reset DeleteTime if not deleted
    }
    next();
});

const Customers = mongoose.model("customers", customerSchema);
export default Customers;
