import mongoose from "mongoose";
const ObjectId = mongoose.Types.ObjectId;

const donationSchema = mongoose.Schema({
    customerId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'customers',
    },
    NGO_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'ngo',
    },
    orderId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'orders',
    },
    amount: Number,
    donationDate: String,
    donationStatus: String,
    needCertificate: {
        type: Boolean
    },
    certificate_status: {
        type: String,
        default: 'not required'
    },
    certificateUrl: {
        type: String
    },
    // certificate_count: {
    //     type: Number,
    //     default: 0
    // },
    pout: String,
}, {
    timestamps: true
});

const Donation = mongoose.model("donation", donationSchema);
export default Donation;