import mongoose from "mongoose";

const lang = mongoose.Schema({
    item_name: {
        type: String,
    },
    item_desc: {
        type: String,
    },
    price: {
        type: String,
    },
    unit: {
        type: String,
    },
    language: {
        type: String,
    },
    // imageURL: String,
});

const itemsSchema = mongoose.Schema({
    item_name:{
        required: true,
        type: String
    },
    price: {
        required: true,
        type: Number
    },
    dealer_price: {
        required: true,
        type: Number
    },
    unit: {
        required: true,
        type: String
    },
    city: {
        required: true,
        type: String
    },
    cityid: 
        {
          type: mongoose.Schema.Types.ObjectId,
          ref: 'cityPercent', 
        },
      
    image: [{
        contentType: String,
        data: Buffer
    }],
    imageURL: [String],
    description: String,
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    category: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'itemcategory',
    },
    itemLang: [
        lang
    ],
},{
    timestamps:true
});

const Items = mongoose.model("items",itemsSchema);
export default Items;
