import mongoose from "mongoose";
const ObjectId = mongoose.Types.ObjectId;

const locationSchema = mongoose.Schema({
    location:String,
    city: String,
    PIN: {
        type: String,
        required: true
    },
    state: String,
    cityid: {
        type: mongoose.Schema.Types.ObjectId,        
        // ref: 'cityPercent',
    },
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    count: {
        type: Number
    },
},{
    timestamps:true
});

const Location = mongoose.model("location", locationSchema);
export default Location;