import mongoose from "mongoose";
const ObjectId = mongoose.Types.ObjectId;

const ngoSchema = mongoose.Schema({
    name: String,
    email: String,
    PAN: String,
    pan_fileURL: String,
    mobile: String,
    logoURL: String,
    bankName: String,
    bankBranch: String,
    bankAddress: String,
    account_type: {
        type: String
    },
    ngo_bank_account: {
        name: {
            type: String,
        },
        ifsc: {
            type: String,
        },
        account_number: {
            type: String,
        }
    },
    ci: String,
    fa: String,
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    purpose: {
        type: String,
    },
}, {
    timestamps: true
});

const NGO = mongoose.model("ngo", ngoSchema);
export default NGO;