import mongoose from "mongoose";
import CustomNotify from "../model/customNotify.model.js";
import Customers from "../model/customer.model.js";
const ObjectId = mongoose.Types.ObjectId;

const notificationStatusSchema = new mongoose.Schema({
    customerId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'Customer',
        required: true
    },
    customerName: {
        type: String,
        ref: 'Customer',
        required: true
    },
    token: {
        type: String,
        ref: 'Customer',
        required: true
    },
    notificationId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'Notification',
        // required: true
    },
    notificationTitle: {
        type: String,
        ref: 'Notification',
        required: true
    },
    error: {
        type: String,
        required: true
    },
    // createdAt: {
    //     type: Date,
    //     default: Date.now
    // },
    // notification: {
    //   type: mongoose.Schema.Types.ObjectId,
    //   ref: 'Notification',
    //   required: true,
    // },
    // customer: {
    //   type: mongoose.Schema.Types.ObjectId,
    //   ref: 'Customer',
    //   required: true,
    // },
    // status: {
    //     type:String
    // }
}, {
    timestamps: true
});

const NotificationStatus = mongoose.model('NotificationStatus', notificationStatusSchema);
export default NotificationStatus;