import mongoose from "mongoose";

const itemSchema = mongoose.Schema({
    itemid: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'items',
    },
    weight: {
        type: Number,
    },
    item_name: {
        type: String,
    },
    price: {
        type: Number,
    },
    total: {
        type: Number,
    },
    unit: {
        type: String,
    },
    isActive: {
        type: Number,
    }
    // imageURL: String,
});

const orderSchema = mongoose.Schema({
    customer_id: {
        type: mongoose.Schema.Types.ObjectId, // Assuming you're using Mongoose
        ref: 'customers',
    },
    address_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'address',
    },
    agent_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'users',
    },
    item: [
        itemSchema
    ],
    pout: {
        type: String,
    },
    mode: {
        type: String,
    },
    payment_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'paymentdetails',
    },
    // item: [{
    //     itemid: {
    //         type: mongoose.Schema.Types.ObjectId,
    //         ref: 'items',
    //     },
    //     weight: {
    //         type: Number,
    //     }
    // }],
    est_price: {
        type: Number
    },
    order_id: {
        type: String
    },
    schedule_date: {
        type: String
    },
    time: {
        type: String
    },
    isAssign: {
        type: Boolean
    },
    status: {
        type: String,
        default: 'Created'
    },
    reason: String,
    // isActive: {
    //     type:Boolean,
    //     default:true
    // },
    isDelete: {
        type: Number,
        default: 0
    },
    recursive_ord: {
        type: Boolean,
    },
    transctionId: {
        type: String,
    },
    notes: {
        type: String,
    },
    settlement_date: {
        type: String,
    },
    payment_settlement: {
        type: String,
    },
    scheduleDateForLastOrder: {
        type: String,
    },
    pickupday: {
        type: String,
    },
    recursive_orderid: {
        type: mongoose.Schema.Types.ObjectId,
    }
}, {
    timestamps: true
});

async function generateRandomOrderId() {
    let newOrderID;

    let currentDate = new Date();
    let year = currentDate.getFullYear();
    let lastTwoDigitsOfYear = String(year).slice(-2);
    let month = currentDate.getMonth() + 1;

    console.log('Year:', lastTwoDigitsOfYear);
    console.log('Month:', month);

    let lastOrder = await Orders.findOne({}, {}, { sort: { _id: -1 } });
    console.log("lastOrder", lastOrder);
    if (lastOrder) {
        if (lastOrder.order_id.includes('ord_')) {
            var lastOrderNumber = parseInt(lastOrder.order_id.slice(-5)); // Extract last 5 digits as the order number
            newOrderID = `RP${lastTwoDigitsOfYear}${(month).toString().padStart(2, '0')}${(lastOrderNumber + 1).toString().padStart(5, '0')}`;
        } else if (lastOrder) {
            // No order ID found, generate a new one
            let orderNumber = parseInt(lastOrder.order_id.substring(6));
            console.log("Order number is",orderNumber)
            let newOrderNumber = (orderNumber + 1).toString();
            if (newOrderNumber.length < 5) {
                newOrderNumber = newOrderNumber.padStart(5, '0');
            }
            console.log("New Order name is",newOrderNumber)
            newOrderID = `RP${lastTwoDigitsOfYear}${(month).toString().padStart(2, '0')}${newOrderNumber}`;

        }
    }
    else {
        // No orders found, generate the first order ID
        newOrderID = `RP${lastTwoDigitsOfYear}${month.toString().padStart(2, '0')}00001`;
    }

    return newOrderID;

}
orderSchema.pre('save', async function (next) {
    if (!this.order_id) {
        this.order_id = await generateRandomOrderId();
    }
    next();
});

const Orders = mongoose.model("orders", orderSchema);
export default Orders;

