import mongoose from "mongoose";

const paymentSchema = mongoose.Schema({
    customer_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'customers',
    },
    ci: {
        type: String
    },
    fa: {
        type: String
    },
    account_type: {
        type: String
    },
    bank_account: {
        name: {
            type: String,
        },
        ifsc: {
            type: String,
        },
        account_number: {
            type: String,
        }
    },
    vpa: {
        address: {
            type: String,
        },
    },
    mode: {
        type: String,
    },
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    default: {
        type: Number,
        default: 0
    },
    reqdefault: {
        type: Number,
        default: 0
    },
    reqdefaultcount: {
        type: Number,
        default: 0
    }
}, {
    timestamps: true
});

const Paymentdetails = mongoose.model("paymentdetails", paymentSchema);
export default Paymentdetails;
