import mongoose from "mongoose";

const itemSchema = mongoose.Schema({
    itemid: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'items',
    },
    weight: {
        type: Number,
    },
    item_name: {
        type: String,
    },
    price: {
        type: Number,
    },
    total: {
        type: Number,
    },
});

const pickupSchema = mongoose.Schema({
    customer_id: {
        type: mongoose.Schema.Types.ObjectId, // Assuming you're using Mongoose
        ref: 'customers',
    },
    address_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'address',
    },
    agent_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'users',
    },
    order_fk: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'orders',
    },
    item: [
        itemSchema
    ],
    est_price: {
        type: Number
    },
    order_id: {
        type: String
    },
    schedule_date: {
        type: String
    },
    // time: {
    //     type: String
    // },
    status: {
        type: String,
        default: 'pickup'
    },
    isDelete: {
        type: Number,
        default: 0
    }
}, {
    timestamps: true
});

const Pickup = mongoose.model("pickup", pickupSchema);
export default Pickup;
