import mongoose from "mongoose";

const ploggingSchema = mongoose.Schema({

    title: {
        required: true,
        type: String
    },
    eventid: {
        required: true,
        type: String
    },
    date: {
        required: true,
        type: String
    },
    startTime: {
        required: true,
        type: String
    },
    endTime: {
        required: true,
        type: String
    },
    location: {
        // required: true,
        type: String
    },
    cityid: {
        type: mongoose.Schema.Types.ObjectId,
      },
    customers: [{
        type: mongoose.Schema.Types.ObjectId,
        ref: 'customers',
        default: null
      }],
    image: {
        contentType: String,
        data: Buffer
    },
    imageURL: String,
    about: String,
    plg_id: {
        type: String,
        required: true
    },
    plg_name: {
        // required: true,
        type: String
    },
    plg_mail: {
        // required: true,
        type: String
    },
    plg_contact: {
        // required: true,
        type: String
    },
    status: {
        required: true,
        type: String
    },
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    }
}, {
    timestamps: true
});

const Plogging = mongoose.model("plogging", ploggingSchema);
export default Plogging;
