import mongoose from "mongoose";

const scrapcollectionSchema = mongoose.Schema({
    agent_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'users',
    },
    agent_name: {
        type: String,
    },
    schedule_date: {
        type: String
    },
    item: [{
        item_name: {
            type: String
        },
        item_weight: {
            type: Number
        },
        item_unit: {
            type: String
        },
    }],
}, {
    timestamps: true
});

const ScrapCollection = mongoose.model("scrapcollection", scrapcollectionSchema);
export default ScrapCollection;
