import mongoose from "mongoose";
import bcrypt from "bcrypt";
import { type } from "os";
const ObjectId = mongoose.Types.ObjectId;

const usersSchema = mongoose.Schema({
    Daily_wages:{
     type:Number,
    },
    Advance:{
        type:Number,
        default:0
    },
    name: {
        type: String,
        // default: ""
    },
    email: {
        type: String,
        required: true
    },
    password: {
        type: String,
        // required: true
    },

    usertype: String,
    ci: {
        type: String
    },
    
    mobile: {
        type: String,
        required: true
        // default: ""
    },
    cityid: {
        type: mongoose.Schema.Types.ObjectId,        
        // ref: 'cityPercent',
    },
    image: {
        contentType: String,
        data: Buffer
    },
    imageURL: String,    
    token: {
        type: String
    },
    aadhar_no: String,
    vehicle_type: String,
    aadhar_imgURL: String,
    vehicle_registrationURL: String,
    vehicle_insuranceURL: String,
    dl_imgURL: String,
    isApproved: {
        type: Boolean,
        default: false
    },
    isLogin: {
        type: Boolean,
        default: false
    },
    isActive: {
        type: Boolean,
        default: true
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    paymentStatus: {
        type: Boolean,
        default: true
    },
    samedayslotStatus: {
        type: Boolean,
        default: true
    },
}, {
    timestamps: true
});



// Password
// usersSchema.pre('save', function (next) {
//     if (this.isModified('password')) {
//         bcrypt.hash(this.password, 8, (err, hash) => {
//             {
//                 if (err) return next(err);

//                 this.password = hash;
//                 next();
//             }
//         });
//     };
// });

// usersSchema.methods.comparePassword = async function (password) {
//     if (!password) throw new Error('Password is missing, cannot compare!');
//     try {
//         const result = await bcrypt.compare(password, this.password);
//         return result;
//     } catch (error) {
//         console.log('Error while comparing password!', error.message);
//     }
// };

const Users = mongoose.model("users", usersSchema);
export default Users;
