import express from "express";
import { addAddress, getAddressById, getAddressByCusId,updateAddressById, deleteAddress, serviceableAddress, viewAddressByCustomerId, setDefaultAddress } from "../controller/address.controller.js";

const router = express.Router()

router.post("/create", addAddress);
router.post("/serviceAddress", serviceableAddress);
router.get("/cusId/:cusId", getAddressByCusId);
router.put("/update", updateAddressById)
router.delete("/delete/:id", deleteAddress);
router.get("/:id", getAddressById);
router.get("/customerId/:cusId", viewAddressByCustomerId);
router.get("/setDefault/:id", setDefaultAddress);


export default router;