import express from "express";
import { addNotification, getAllNotifications, getNotificationById, editNotification, activateNotification, deactivateNotification, notifyMultipleCustomers, notifySignupButNoOrderCust, notifyOrder20DaysAgoCust, notifyNewItemAdded, notifyCartItems, notifyBasedOnCondition } from "../controller/customNotify.controller.js";

const router = express.Router()

router.post("/create", addNotification);
router.get("/", getAllNotifications);
router.get("/getById/:id", getNotificationById);
router.put("/edit", editNotification);
router.put("/activate/:id", activateNotification);
router.put("/deactivate/:id", deactivateNotification);


router.post("/sendCustomNotify", notifyMultipleCustomers);
router.post("/signupButNoOrderCust", notifySignupButNoOrderCust);
router.post("/order20DaysAgoCust", notifyOrder20DaysAgoCust);
router.post("/notifyNewItemAdded", notifyNewItemAdded);
router.post("/notifyCartItems", notifyCartItems);

router.post("/notifyallConditions", notifyBasedOnCondition);


export default router;