import express from "express";
import { activeCust, activeOrder, activeEst, activePayment, monthAvg, dailyAvg, monthAvg6Month, payAvg, categoryAvg, categoryAvgItem ,agentAnalytics,customerAnalyticsData} from "../controller/dashboard.controller.js";
import adminAuth from "../middleware/AdminAuth.js";
const router = express.Router()

router.get("/cust", activeCust);
router.get("/ord", activeOrder);
router.get("/est", activeEst);
router.get("/payment", activePayment);
router.get("/monthly/:year", monthAvg);
router.get("/daily", dailyAvg);
router.get("/monthly6/:year", monthAvg6Month);
router.get("/payavg/:mode", payAvg);
router.get("/catavg", categoryAvg);
router.get("/catitemavg", categoryAvgItem);
router.get("/agentAnalytics/:id",adminAuth, agentAnalytics);
router.get("/customberData/:customerId", customerAnalyticsData);

export default router;
