import express from "express";
import { addItems, getAllItems, getActiveItems, getItemsById, updateItems, activateItemById, deactivateItemById, deleteItemsById, searchItem, getAllItemsPur, addCityPercent, getAllCityPercent, itemCatInd, updatePrice, getAllItemsPurbyCityid, searchItemByZIP, getAllItemsPurbyCityidByLang, searchItemByZIPByLang, addMultipleImages, deleteItemImage, getCitywiseItems, getItemsByIdByLang, getItemByZip, getAllCollectedItems,NewsearchItemByZIPByLang } from "../controller/items.controller.js";

const router = express.Router()
import adminAuth from "../middleware/AdminAuth.js";

router.post("/create",addItems);
router.get("/", getAllItems);
router.get("/item", getAllItemsPur);
router.get("/itembyCity/:cityid",adminAuth, getAllItemsPurbyCityid);
router.get("/itembyCityByLang/:cityid/:language", getAllItemsPurbyCityidByLang);
router.get("/active", getActiveItems);
router.put("/update",updateItems);

router.post("/addImages/:itemId",addMultipleImages);

router.put("/activate/:id", activateItemById);
router.put("/deactivate/:id", deactivateItemById);
router.delete("/delete/:id",deleteItemsById);
router.get("/search", searchItem);
router.get("/searchbyzip", searchItemByZIP);
router.get("/searchbyzip/:language", NewsearchItemByZIPByLang);

router.post("/addCityPercent", addCityPercent);
router.get("/allCityPercent", getAllCityPercent);


router.get("/getallind/:cityid", itemCatInd);
router.put("/updateprice", updatePrice);
router.get("/citywiseItems/:cityid", getCitywiseItems);


router.get("/anItemByLang/:id/:language", getItemsByIdByLang);
router.delete('/:itemId/image/:index', deleteItemImage);
router.get("/:id", getItemsById);
router.post("/getItemByZip/:PIN", getItemByZip);
router.get("/allCollectedItems/report", getAllCollectedItems);

export default router;
