import express from "express";
import { addLocation, getAllLocation, getLocationById, updateLocation, activateLocationById, deactivateLocationById, deleteLocation, validatePIN, compareLocation, addLocationBulkExcel, findCitybyPIN } from "../controller/location.controller.js";

const router = express.Router()


router.post("/create",addLocation);
router.get("/", getAllLocation);
router.get("/:id", getLocationById);
router.put("/update",updateLocation);
router.put("/activate/:id", activateLocationById);
router.put("/deactivate/:id", deactivateLocationById);
router.delete("/delete/:id",deleteLocation);
router.post("/addBulkLocation",addLocationBulkExcel);
router.get("/validatePIN/:PIN", validatePIN);
router.post("/compare/:PIN", compareLocation)
router.get("/locbypin/:PIN", findCitybyPIN)

export default router;
