import express from "express";

import { createOrder, cancelOrder, confOrder, assOrder, pConAgent, payConfAgent, orderHist, orderHistById, filterOrder, getAllAgent, getAgentDetails, pickupByAgent, pickupSt, QRcode, payStatus, payStatusPout, editOrder, cancelOrderByCust, payment, rescheduleByAdmin, createOrderAgent, withdraw, activeCoins, histCoins, custHist, payStatusPoutEco, orderHistForReport,indOrdHistReport, totalSuccessfulOrders, totalOrders, fetchPrice, refCode, razReceipt, disCoin, refCodeVer, checkOrder,  custHistRef, orderHistAdmin, todayScrapCollectedByAgent, custAllOrdersCount, custWasteAndPrice, custOrderPrices, custTotalOrders, ordHistoryCust, pickupNotification, declineActionNotification, custLastOrders, declineSubsequentNotification, adminSettlment, payProcessedByAdmin, custIndItems, createRecurOrd, recurringOrd, getCountoforder, parentOrdHist, childOrdHist ,changeOrderStatus} from "../controller/order.controller.js";
import { upload } from '../middleware/multerConfig.js';
import adminAuth from "../middleware/AdminAuth.js";
const router = express.Router()

router.post("/fetchOrder", fetchPrice);
router.post("/createOrder", createOrder);
// upload.single('image'),
router.put("/:orderid", cancelOrder);
router.put("/conforder/:orderid", confOrder);
router.put("/assorder/:orderid", assOrder);
router.put("/coforderbyagent/:agentid", pConAgent);
router.put("/payconfbyagent/:agentid", payConfAgent);
router.get("/filtorder/:agentid",adminAuth, filterOrder);
router.get("/historder/:custid", orderHist);
router.get("/limithistordercust/:custid", ordHistoryCust);
router.get("/getCountoforder/:customerId", getCountoforder);
router.get("/adminhistorder/:adminid", orderHistAdmin);
router.get("/indhistorder/:orderid", orderHistById);
router.get("/getagent", getAllAgent);
router.put("/updateorder/:orderid",changeOrderStatus);
// router.get("/getAgentDetails/:orderid", getAgentDetails);
router.post("/createPickup/:orderid",adminAuth, pickupByAgent);
router.post("/payment/:orderid",adminAuth, payment);
router.post("/withdraw/:cust", withdraw);
router.post("/updateSt/:orderid", pickupSt);
router.get("/paystatus", payStatus);
router.get("/paystatus/:pout", payStatusPout);
router.post("/editOrder/:orderid", editOrder);
router.get("/cancelOrder/:orderid", cancelOrderByCust);
router.post("/createOrderAgent", createOrderAgent);
router.post("/reschedule/:orderid", rescheduleByAdmin);
router.get("/activecoins/:cust", activeCoins);
router.post("/updatehist/:cust", histCoins);
router.get("/custhist/:cust", custHist);
router.get("/paystatuseco/:pout", payStatusPoutEco);
router.get("/orderreport/:custid", orderHistForReport);
router.get("/orderind/:id", indOrdHistReport);
router.get("/qrcode", QRcode);

router.get("/successfulOrders", totalSuccessfulOrders);
router.get("/totalOrders", totalOrders);
router.get("/refCode/:refCode", refCode);
router.get("/refCodeVer", refCodeVer);

router.get("/razReceipt/:pout", razReceipt);
router.post("/discount/:cust", disCoin);
router.get("/getAgentDetail/:orderid",adminAuth, getAgentDetails);
router.get("/checkOrder/:custid/:date", checkOrder);
router.get("/custhistref/:cust", custHistRef);

router.get("/todayScrapCollected/:agentId", todayScrapCollectedByAgent);
router.get("/countCustAllOrders/:cusId", custAllOrdersCount);
router.get("/custWasteAndPrice/:cusId", custWasteAndPrice);
router.get("/custOrderPricesByStatus/:cusId", custOrderPrices);
router.get("/custAllOrders/:cusId", custTotalOrders);
router.get("/pickupNotification", pickupNotification);
router.get("/decline/:ordId", declineActionNotification);
router.get("/declineSubsequent/:ordId", declineSubsequentNotification);
router.get("/custLastOrders/:cusId", custLastOrders);
router.post("/adminSettlment", adminSettlment);

router.put("/payProcessedByAdmin/:ordId", payProcessedByAdmin);

router.get("/createRecurOrd", createRecurOrd);
router.get("/bscustomerIndItems/:customerId", custIndItems);

router.get("/recurringOrd/:cust", recurringOrd);

router.get("/parentOrdHist/:custId", parentOrdHist);
router.get("/childOrdHist/:ordId", childOrdHist);

export default router;