import express from "express";
import {updatePasswordByAdmin,sendOtpByMailToAdmin,updatePassword,verifyOtpPassword,usersLogin, getUsersById, createUsers, getAllUsers, activateUserById, deactivateUserById, updateUsers, duplicateEmail, deleteusersById, otpLogin, verifyOTP, selfRegister, approveUserById, approvedUserslist,loginFromDifferentDevice, logoutAgent, getDeviceId,updateUserImages,getUserDetails,deleteAgentOrPartner, paymentAct, getPaymentAct, samedayslotshow, samedayslotstatus,sendOtpByMail ,getAllAgent,getAgent, registerAgentByAdmin,updateAgentByAdmin} from "../controller/users.controller.js";

const router = express.Router()
import adminAuth from '../middleware/AdminAuth.js'

router.post("/login", usersLogin);
router.post("/create", createUsers);
router.post("/createbyadmin",  registerAgentByAdmin);
router.put("/updatebyadmin",updateAgentByAdmin);
router.get("/", getAllUsers);
router.put("/activate/:id", activateUserById);
router.put("/deactivate/:id", deactivateUserById);
router.put("/updateUsers", updateUsers);
router.get("/duplicate/:email", duplicateEmail);
router.delete("/delete/:id", deleteusersById);
router.get("/agents/:zip/:date", getAllAgent);
router.post("/otp",sendOtpByMail);
router.post("/verifyotpBS",verifyOtpPassword);
router.put("/updatepassword",updatePassword);
router.post("/sendOtpByMailToAdmin",sendOtpByMailToAdmin);
router.put("/updatePasswordByAdmin",updatePasswordByAdmin);

router.post("/otpLogin", otpLogin);
router.post("/verifyOTP",verifyOTP);
router.post("/selfRegister",selfRegister);
router.post("/newDeviceLogin", loginFromDifferentDevice);
router.post("/logout/:mobile",logoutAgent);
router.get("/deviceId/:mobile",adminAuth, getDeviceId);
router.put("/approveUser/:userid", approveUserById);
router.get("/allApprovedUsers", approvedUserslist);
router.post("/updateUserImages/:mobile", updateUserImages);
router.get('/getUserdetails/:mobile', adminAuth, getUserDetails)

router.get("/:id", adminAuth, getUsersById);
router.get("/getAgent/:id", getAgent)
router.delete("/deleteAgentOrPartner/:id", deleteAgentOrPartner);

router.put("/paymentAct/:adm", paymentAct);
router.get("/getPaymentAct/:adm", getPaymentAct);
router.put("/samedayslotshow/:adm", samedayslotshow);
router.get("/samedayslotstatus/:adm", samedayslotstatus);
export default router;