import express from 'express';
import connectDb from './db_conn.js';
import customerRoutes from './routes/customerRoutes.js';
import addressRoutes from './routes/addressRoutes.js';
import usersRoutes from './routes/usersRoutes.js';
import ordersRoutes from './routes/orderRoutes.js';
import slotsRoutes from './routes/slotRoutes.js';
import itemsRoutes from './routes/itemsRoutes.js';
import locationRoutes from './routes/locationRoutes.js';
import cors from 'cors';
import bodyParser from 'body-parser';
import pickupRoutes from './routes/pickupRoutes.js';
import cartRoutes from './routes/cartRoutes.js';
import notificationRoutes from './routes/notificationRoutes.js'
import customNotifyRoutes from './routes/customNotifyRoutes.js'
import pmtRoutes from './routes/paymentdetailsRoueter.js';
import feedback from './routes/feedbackRoutes.js';
import version from './routes/versionRoutes.js';
import dashboard from './routes/dashboardRoutes.js';
import footprint from './routes/footprintRoutes.js';
import traslate from './routes/traslateRoutes.js';
import notifyCondition from "./routes/notifyConditionRoutes.js";
import routeslot from "./routes/routeslotRouters.js";
import agentTracking from './routes/agentTrackingRoutes.js';
import ngoRoutes from "./routes/ngoRoutes.js";
import donationRoutes from "./routes/donationRoutes.js";
import dynamicEco from "./routes/dynamicecoRoutes.js";
import dynamicrefamt from "./routes/dynamicrefamtRoues.js";
import status from "./routes/statusRoutes.js";
import agentdata from "./routes/agent.data.routes.js";

import ploggingRoutes from './routes/ploggingRoutes.js';
import itemcategory from './routes/itemcategoryRoutes.js';
import Razorpay from 'razorpay';
import cron from 'node-cron';
import CustomNotify from "../backend/model/customNotify.model.js";
import { google } from "googleapis";
import mongoose from "mongoose";
import fetch from 'node-fetch';
const ObjectId = mongoose.Types.ObjectId;
import SibApiV3Sdk from 'sib-api-v3-sdk';
import archiver from 'archiver';
import fs from 'fs';
import path from 'path';
import { fileURLToPath } from 'url';
import Users from "./model/users.model.js";
import agentData from "./model/Agent.data.js";
import order from "./model/order.model.js";

const __filename = fileURLToPath(import.meta.url);
const __dirname = path.dirname(__filename);


import axios from 'axios';
const mockReq = {};
const mockRes = { send: (data) => console.log(data) };



const apiKey = 'rzp_test_z3cGpxu3MCi7Ma';
// const apiKey = 'rzp_live_c8RouP3eKq6D1C';
const apiSecret = 'FRUC3yrt6FEbBem1HVLgb6Sp';
// const apiSecret = '63WBO3yFwX6gHymOiypMjXm7';

import { payStatus } from './controller/order.controller.js';

import jsonwebtoken from 'jsonwebtoken';
// import agentTracking from './model/agentTracking.model.js';

const app = express();


app.use(cors());
app.options('*', cors());
app.use(express.json());
app.use(express.urlencoded({ extended: true }));


// get Form-data
// app.use(formidable());


const secretKey = "secretKey";

app.use(express.json());

connectDb();

app.use('/api/customers', customerRoutes);
app.use('/api/address', addressRoutes);
app.use('/api/users', usersRoutes);
app.use('/api/orders', ordersRoutes);
app.use('/api/slot', slotsRoutes);
app.use('/api/items', itemsRoutes);
app.use('/api/location', locationRoutes);
app.use('/api/pickup', pickupRoutes);
app.use('/api/cart', cartRoutes);
app.use('/api/notify', notificationRoutes);
app.use('/api/payment', pmtRoutes);
app.use('/api/feedback', feedback);
app.use('/api/version', version);
app.use('/api/itemcategory', itemcategory);

app.use('/api/customNotify', customNotifyRoutes);
app.use('/api/dashboard', dashboard);
app.use('/api/footprint', footprint);
app.use('/api/plogging', ploggingRoutes);
app.use('/api/traslate', traslate);
app.use('/api/notifyCondition', notifyCondition);
app.use('/api/trackAgent', agentTracking);
app.use('/api/ngo', ngoRoutes);
app.use('/api/donation', donationRoutes);
app .use('/api/eco', dynamicEco);
app.use('/api/dynamicrefamt', dynamicrefamt);
app .use('/api/routeslot', routeslot);

app.use('/api/status', status);
app.use('/api/agentdata',agentdata);


// CRON

cron.schedule('*/1 * * * *', async () => {
    // payStatus(mockReq, mockRes);
    console.log('Cron job executed at', new Date());
    // const auth = {
    //     username: apiKey,
    //     password: apiSecret,
    // }
    // try {
    //     const response = await axios.get('http://localhost:6001/api/orders/paystatus/', {
    //         headers: {
    //             'Content-Type': 'application/json',
    //         },
    //         auth: auth,
    //     });
    //     console.log('Cron job executed:', response.data);
    //     return res.send(response.data)
    // }
    // catch (error) {
    //     console.log('Cron job error:', error);
    //     return res.send(error)
    // }
});

async function cronForNoti() {

    cron.schedule('*/1 * * * *', async () => {
        var currentDate = new Date();
        let indianDateStr = new Date().toLocaleString("en-Us", { timeZone: 'Asia/Kolkata' });
        // console.log(indiandate);

        let indianDate = new Date(indianDateStr);

        // Convert to UTC
        let utcDate = new Date(indianDate.getTime() + indianDate.getTimezoneOffset() * 60000);

        // Format the output
        let indianFormattedDate = indianDate.toLocaleDateString("en-IN", { day: '2-digit', month: '2-digit', year: 'numeric' }).split('/').join('-');
        let indianFormattedTime = indianDate.toLocaleTimeString("en-IN", { hour: '2-digit', minute: '2-digit', hour12: false });

        let utcFormattedDate = utcDate.toISOString().split('T')[0].split('-').reverse().join('-');
        let utcFormattedTime = utcDate.toISOString().split('T')[1].split('.')[0].slice(0, 5);

        console.log(indianFormattedDate);
        console.log(indianFormattedTime);
        console.log(utcFormattedDate);
        console.log(utcFormattedTime);



        var formattedDate = utcFormattedDate;
        var formattedTime = utcFormattedTime;
        // console.log('22-12-2023');
        // console.log('13:23');

        try {
            const x = await CustomNotify.find({ date: indianFormattedDate, time: indianFormattedTime, status: 'Not send', isActive: true, isDelete: false });
          
            if (x.length > 0) {
              console.log(x, (new ObjectId(x[0]._id)).toString());
              // const url = 'https://devapisbot.ceibagreen.com/api/customNotify/sendCustomNotify';
              const url = 'https://devapisbot.ceibagreen.com/api/customNotify/notifyallConditions';
              const data = (new ObjectId(x[0]._id)).toString();
          
              try {
                const response = await axios.post(url, { _id: data }, {
                  headers: {
                    'Content-Type': 'application/json',
                  },
                });
          
                if (!response.status === 200) {
                  console.error(`HTTP error! Status: ${response.status}, Text: ${response.statusText}`);
                  console.error('Response body:', response.data);
                } else {
                  console.log('Response:', response.data);
                }
              } catch (error) {
                console.error('Error during axios request:', error.message);
              }
            } else {
              console.warn('No matching CustomNotify found.');
            }
          } catch (findError) {
            console.error('Error during CustomNotify find:', findError.message);
          }
        console.log(formattedTime, currentDate);

    })

}


await cronForNoti()



async function cronForNotificationForOrder() {

  // cron.schedule('0 */5 * * *', async () => {
  cron.schedule('*/1 * * * *', async () => {
    var currentDate = new Date();
    let indianDateStr = new Date().toLocaleString("en-Us", { timeZone: 'Asia/Kolkata' });
    // console.log(indiandate);

    let indianDate = new Date(indianDateStr);

    // Convert to UTC
    let utcDate = new Date(indianDate.getTime() + indianDate.getTimezoneOffset() * 60000);

    // Format the output
    let indianFormattedDate = indianDate.toLocaleDateString("en-IN", { day: '2-digit', month: '2-digit', year: 'numeric' }).split('/').join('-');
    let indianFormattedTime = indianDate.toLocaleTimeString("en-IN", { hour: '2-digit', minute: '2-digit', hour12: false });

    let utcFormattedDate = utcDate.toISOString().split('T')[0].split('-').reverse().join('-');
    let utcFormattedTime = utcDate.toISOString().split('T')[1].split('.')[0].slice(0, 5);

    console.log(indianFormattedDate);
    console.log(indianFormattedTime);
    console.log(utcFormattedDate);
    console.log(utcFormattedTime);



    var formattedDate = utcFormattedDate;
    var formattedTime = utcFormattedTime;
      // console.log('22-12-2023');
      // console.log('13:23');

      try {
          // const x = await CustomNotify.find({ date: formattedDate, time: formattedTime, status: 'Not send', isActive: true, isDelete: false });
        
          // if (x.length > 0) {
            // console.log(x, (new ObjectId(x[0]._id)).toString());
            // const url = 'https://singada1319api.ceibagreen.com/api/orders/pickupNotification';
            const url = 'https://devapisbot.ceibagreen.com/api/orders/pickupNotification';
            console.log("send notification");
            
            // const url = 'http://localhost:9001/api/orders/pickupNotification';
            // const data = (new ObjectId(x[0]._id)).toString();
            console.log('url', url);
        
            try {
              const response = await axios.get(url, {
                headers: {
                  'Content-Type': 'application/json',
                },
              });
        
              if (!response.status === 200) {
                console.error(`HTTP error! Status: ${response.status}, Text: ${response.statusText}`);
                console.error('Response body:', response.data);
              } else {
                console.log('Response:', response.data);
              }
            } catch (error) {
              console.error('Error during axios request:', error.message);
            }
          // } else {
          //   console.warn('No matching CustomNotify found.');
          // }
        } catch (findError) {
          console.error('Error during CustomNotify find:', findError.message);
        }
      console.log(formattedTime, currentDate);

  })

}


await cronForNotificationForOrder()



async function cronForRecursiveOrderCreate() {

  // cron.schedule('0 0 * * *', async () => {
  cron.schedule('*/1 * * * *', async () => {
    var currentDate = new Date();
    let indianDateStr = new Date().toLocaleString("en-Us", { timeZone: 'Asia/Kolkata' });
    // console.log(indiandate);

    let indianDate = new Date(indianDateStr);

    // Convert to UTC
    let utcDate = new Date(indianDate.getTime() + indianDate.getTimezoneOffset() * 60000);

    // Format the output
    let indianFormattedDate = indianDate.toLocaleDateString("en-IN", { day: '2-digit', month: '2-digit', year: 'numeric' }).split('/').join('-');
    let indianFormattedTime = indianDate.toLocaleTimeString("en-IN", { hour: '2-digit', minute: '2-digit', hour12: false });

    let utcFormattedDate = utcDate.toISOString().split('T')[0].split('-').reverse().join('-');
    let utcFormattedTime = utcDate.toISOString().split('T')[1].split('.')[0].slice(0, 5);

    console.log(indianFormattedDate);
    console.log(indianFormattedTime);
    console.log(utcFormattedDate);
    console.log(utcFormattedTime);



    var formattedDate = utcFormattedDate;
    var formattedTime = utcFormattedTime;
      // console.log('22-12-2023');
      // console.log('13:23');

      try {
          // const x = await CustomNotify.find({ date: formattedDate, time: formattedTime, status: 'Not send', isActive: true, isDelete: false });
        
          // if (x.length > 0) {
            // console.log(x, (new ObjectId(x[0]._id)).toString());
            // const url = 'https://singada1319api.ceibagreen.com/api/orders/createRecurOrd';
            const url = 'https://devapisbot.ceibagreen.com/api/orders/createRecurOrd';
            // const url = 'http://localhost:9001/api/orders/createRecurOrd';
            // const data = (new ObjectId(x[0]._id)).toString();
            console.log('url', url);
        
            try {
              const response = await axios.get(url, {
                headers: {
                  'Content-Type': 'application/json',
                },
              });
        
              if (!response.status === 200) {
                console.error(`HTTP error! Status: ${response.status}, Text: ${response.statusText}`);
                console.error('Response body:', response.data);
              } else {
                console.log('Response:', response.data);
              }
            } catch (error) {
              console.error('Error during axios request:', error.message);
            }
          // } else {
          //   console.warn('No matching CustomNotify found.');
          // }
        } catch (findError) {
          console.error('Error during CustomNotify find:', findError.message);
        }
      console.log(formattedTime, currentDate);

  })

}


await cronForRecursiveOrderCreate()



// Redirect undefined routes to a specific URL
app.get('/tabs/store/store-details', (req, res) => {
  res.redirect('https://bit.ly/re-pay');
});
app.get('/api/redirect', (req, res) => {
  res.redirect('https://apisbot.ceibagreen.com/api/redirect');
});

app.get('/refcode', (req, res) => {
  res.redirect(`https://bit.ly/re-pay`);
});
app.get('/refcode/:code', (req, res) => {
  const code = req.params.code || '';
  // console.log("query is " + code);
  res.redirect(`https://devrecyclepay.ceibagreen.com/refcode/${code}`);
});
app.get('/backup', async (req, res) => {
  try {
    if (mongoose.connection.readyState !== 1) {
      console.error('Mongoose is not connected');
      return res.status(500).send('Database not connected');
    }

    // Create backup directory if not exists
    const backupDir = path.join(__dirname, 'backups');
    if (!fs.existsSync(backupDir)) fs.mkdirSync(backupDir);

    const timestamp = new Date().toISOString().split('T')[0];
    const zipFilePath = path.join(backupDir, `backup_${timestamp}.zip`);
    const archive = archiver('zip', { zlib: { level: 9 } });
    const output = fs.createWriteStream(zipFilePath);

    archive.pipe(output);

    const collections = await mongoose.connection.db.listCollections().toArray();
    console.log(`Found ${collections.length} collections`);

    // Iterate collections and add them to the archive
    for (const { name } of collections) {
      try {
        const data = await mongoose.connection.db.collection(name).find({}).toArray();
        archive.append(JSON.stringify(data, null, 2), { name: `${name}.json` });
        console.log(`Added ${name}.json to archive`);
      } catch (error) {
        console.error(`Failed to process collection ${name}:`, error);
      }
    }

    await archive.finalize();

    output.on('close', async () => {
      console.log(`Backup zip created at ${zipFilePath}`);
      await sendBackupEmail(zipFilePath);
      res.send('Database backup created and sent via email');
    });

    archive.on('error', (err) => {
      throw err;
    });
  } catch (error) {
    console.error('Error during backup process:', error);
    res.status(500).send('Backup failed');
  }
});
const sendBackupEmail = async (zipFilePath) => {
  var defaultClient = SibApiV3Sdk.ApiClient.instance;
  var apiKey = defaultClient.authentications['api-key'];
  apiKey.apiKey = process.env.MAILAPIKEY;
  var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();
  var sendSmtpEmail = new SibApiV3Sdk.SendSmtpEmail();
  const backupDir = path.join(__dirname, 'backups');
  // Check if the zip file exists
  if (!fs.existsSync(zipFilePath)) {
    console.error('Zip file does not exist:', zipFilePath);
    return;
  }

  sendSmtpEmail = {
    to: [{ email: 'baniprasad.mangaraj@ajatus.co.in', }],
    sender: { email: 'support@ceibagreen.com', name: 'Ceiba Green Support'}, 
    subject: `Database Backup - ${new Date().toISOString().split('T')[0]}`,
    htmlContent: '<p>The database backup attached below.</p>', 
    attachment: [
      {
        name: path.basename(zipFilePath),
        content: fs.readFileSync(zipFilePath).toString('base64'), 
      },
    ],
  };

  try {
    const data = await apiInstance.sendTransacEmail(sendSmtpEmail);
    console.log('Email sent successfully:');
    fs.rm(backupDir, { recursive: true }, (err) => {
      if (err) {
        console.error('Error deleting backup folder:', err);
      } else {
        console.log('Backup folder deleted successfully.');
      }
    });
  } catch (error) {
    console.error('Error sending email:', error.response ? error.response.body : error);

    const errorEmail = {
      to: [{ email: 'sadangiomprakash@gmail.com' }],
      sender: { email: 'support@ceibagreen.com' },
      subject: "Error during backup",
      htmlContent: '<p>There was an error sending the backup file.</p>',
    };

    try {
      await apiInstance.sendTransacEmail(errorEmail);
      console.log('Error notification email sent successfully.');
    } catch (errorNotificationError) {
      console.error('Error sending error notification email:', errorNotificationError.response ? errorNotificationError.response.body : errorNotificationError);
    }
  }
};

async function cronForDataBackup() {

  cron.schedule('0 1 * * *', async () => {
      try {
          
            // const url = 'https://singada1319api.ceibagreen.com/backup';
            const url = 'https://devapisbot.ceibagreen.com/backup';
            console.log("send notification");
            try {
              const response = await axios.get(url);
              console.log("After data backup",response.data);
            } catch (error) {
              console.error('Error during axios request:', error.message);
            }
        } catch (error) {
          console.error('Error during Database backup:',error.message);
        }
  })

}
cron.schedule('* * * * *', async () => {
   console.log("Cron job started at for agent data", new Date());
  // await runAgentDataJob();
  // console.log("Cron job finished at", new Date());
  try {
    const agent_data = await Users.find({ usertype: "agent" });
    for (const agent of agent_data) {
        // console.log("The agent is", agent);
        const selected_agent = agent._id;
        console.log("The selected agent is", selected_agent);
        var today_Date = new Date().toISOString().slice(0, 10); // "2025-02-10"
        var [year, month, day] = today_Date.split("-");
        var formattedDate = `${day}-${month}-${year}`; // "10-02-25"
        console.log("the formated date is",formattedDate);
         console.log("the date is",today_Date);
        const today = new Date();
        const startOfDay = new Date(today.setUTCHours(0, 0, 0, 0));  // 2025-02-10T00:00:00.000Z
        const endOfDay = new Date(today.setUTCHours(23, 59, 59, 999));


        // Await works here because it's inside an async function
        const todayOrders = await order.find({
            agent_id: selected_agent,
            schedule_date:formattedDate,
            status: { $in: ["processed", "Pickup Completed", "reversed"] }
        });
        
        const createdAt = new Date().toDateString();
        console.log("the order data is", todayOrders);
        if(todayOrders.length>0){
            const agentId=todayOrders[0].agent_id;
            console.log("the agent Id is",agentId);
            
            //fetch the agents data from the user table
            const agent_data = await Users.findOne({ _id: agentId });
            console.log("the agent data is",agent_data);
            var today_Date = new Date().toISOString().slice(0, 10); 
            var [year, month, day] = today_Date.split("-");
            var db_date = `${day}-${month}-${year}`;
            const Daily_wages=agent_data.Daily_wages;
            const agent_name=agent_data.name;
            console.log("the dailywages is",Daily_wages);
            //condition to check if the duplicate data will not entered
            const check_duplicate_entry=await agentData.find({
                agent_Id:agentId,
                Date:db_date,
                Daily_wages: { $gt: 0 }

            })
            console.log()
            if(check_duplicate_entry.length>0){
                
            }
            else{
            
            const agentdata=({
                agent_Id:agentId,
                Date:db_date,
                Daily_wages:Daily_wages,
                name:agent_name
            })
            const response=await agentData.create(agentdata);
            console.log(response);
            
        }
        }
    }
} catch (error) {
    console.log(error);
    
}
});


await cronForDataBackup()

app.use('/uploads', express.static('uploads'));
app.use('/.well-known', express.static('.well-known'));


app.listen(8761, () => {
    console.log("server running successfully");
})
