import mongoose from "mongoose";
import Orders from "../model/order.model.js";
import Items from "../model/items.model.js";
import Orderitems from "../model/orderitem.model.js";
import Address from '../model/address.model.js';
import Customers from "../model/customer.model.js";
import Users from "../model/users.model.js";
const ObjectId = mongoose.Types.ObjectId;
import QRCode from 'qrcode';
import moment from 'moment';
import dotenv from 'dotenv';
import mailgun from 'mailgun-js';
// import brevo, { Order } from '@getbrevo/brevo';
import nodemailer from "nodemailer";
import Transport from "nodemailer-brevo-transport";
import SibApiV3Sdk from 'sib-api-v3-sdk';
import Coin from "../model/coin.model.js";
import Coinhist from "../model/coinhist.model.js";
import { pushNotification } from "./notification.controller.js";
import Location from "../model/location.model.js";
import NGO from "../model/ngo.model.js";
import Donation from "../model/donation.model.js";
import ScrapCollection from "../model/scrapCollection.model.js";
import { pushNotificationForOrders } from "./notification.controller.js";
import Dynamicrefamt from "../model/dynamicrefamt.model.js";

dotenv.config();
// console.log(process.env.APIKEY, process.env.APISECRET, process.env.ACC_NO)
const apiKey = process.env.APIKEY;
// const apiKey = 'rzp_live_c8RouP3eKq6D1C';
const apiSecret = process.env.APISECRET;
// const apiSecret = '63WBO3yFwX6gHymOiypMjXm7';
import axios from 'axios';
import Dynamiceco from "../model/dynamiceco.model.js";

// Order Id randomize
// const generateRandomOrderId = async () => {
//     let orderExists = true;
//     let order_id;

//     while (orderExists) {
//         const randomNumber = Math.floor(Math.random() * 1000000);
//         order_id = `ord_${randomNumber}`;

//         await Orders.findOne({ order_id }).then((x) => {
//             if (!x) {
//                 orderExists = false;
//             }
//         });

//     }

//     return order_id;
// };

//api to change the status for the order which is reversed or Assigned to agent
export const changeOrderStatus = async (req, res) => {
    try {
      const order_id = req.params.orderid; // Extract order ID from route params
      const status = req.body.status; // Extract the status value from the request body
  
      console.log("The status received is:", status);
      console.log("The order ID received is:", order_id);
  
      // Check if the order exists
      const order = await Orders.findOne({ _id: order_id });
      console.log("Order fetched:", order);
  
      if (order) {
        // Update the order's status
        const updatedOrder = await Orders.findOneAndUpdate(
          { _id: order_id },
          { $set: { status } },
          { new: true } // Return the updated document
        );
  
        console.log("Updated Order:", updatedOrder);
  
        // Send a success response
        return res.status(200).send({
          isSuccess: true,
          msg: "Order status updated successfully!",
          updatedOrder,
        });
      } else {
        // If no order found, return an error response
        return res.status(404).send({
          isSuccess: false,
          msg: "Order not found!",
        });
      }
    } catch (error) {
      console.error("Error updating order status:", error);
  
      // Send an error response
      return res.status(500).send({
        isSuccess: false,
        msg: "Internal Server Error!",
      });
    }
  };
  

async function generateRandomOrderId() {
    let newOrderID;

    let currentDate = new Date();
    let year = currentDate.getFullYear();
    let lastTwoDigitsOfYear = String(year).slice(-2);
    let month = currentDate.getMonth() + 1;

    console.log('Year:', lastTwoDigitsOfYear);
    console.log('Month:', month);

    let lastOrder = await Orders.findOne({}, {}, { sort: { _id: -1 } });
    console.log("lastOrder", lastOrder);
    if (lastOrder) {
        if (lastOrder.order_id.includes('ord_')) {
            var lastOrderNumber = parseInt(lastOrder.order_id.slice(-5)); // Extract last 5 digits as the order number
            newOrderID = `RP${lastTwoDigitsOfYear}${(month).toString().padStart(2, '0')}${(lastOrderNumber + 1).toString().padStart(5, '0')}`;
        } else if (lastOrder) {
            // No order ID found, generate a new one
            let orderNumber = parseInt(lastOrder.order_id.substring(6));
            console.log("Order number is", orderNumber)
            let newOrderNumber = (orderNumber + 1).toString();
            if (newOrderNumber.length < 5) {
                newOrderNumber = newOrderNumber.padStart(5, '0');
            }
            console.log("New Order name is", newOrderNumber)
            newOrderID = `RP${lastTwoDigitsOfYear}${(month).toString().padStart(2, '0')}${newOrderNumber}`;

        }
    }
    else {
        // No orders found, generate the first order ID
        newOrderID = `RP${lastTwoDigitsOfYear}${month.toString().padStart(2, '0')}00001`;
    }

    return newOrderID;

}



function trimFormData(formData) {
    const trimmedData = {};
    for (const key in formData) {
        if (formData.hasOwnProperty(key)) {
            const trimmedKey = key.trim();
            const value = formData[key].trim();
            trimmedData[trimmedKey] = value;
        }
    }
    return trimmedData;
}



// Fetch item price from PIN
export const fetchPrice = async (req, res) => {
    const item = req.body.item
    var totalitems = []
    let totalPrice = 0
    let est_price = 0

    await Location.findOne({ PIN: req.body.PIN }).then(async (city) => {

        if (city) {
            if (item.length !== 0) {
                for (const x of item) {

                    const itemDoc = await Items.findOne({ cityid: city.cityid, item_name: x.item });


                    console.log(x, itemDoc);
                    if (itemDoc) {
                        est_price += parseFloat(itemDoc.price) * parseFloat(x.weight);
                    }

                    // if (item.indexOf(x) == item.length - 1 && est_price != 0) {
                    // const order = await Orders.create({
                    //     customer_id: customer_id,
                    //     address_id: address_id,
                    //     schedule_date: schedule_date,
                    //     time: time,
                    //     item: req.body.item,
                    //     est_price: est_price.toFixed(2),
                    //     order_id: order_id,
                    //     mode: mode,
                    //     // payment_id: payment_id,
                    // });

                    // console.log(order);

                    // if (order) {
                    var count = 0
                    console.log(item);
                    for (const x of item) {
                        console.log(x);
                        // const getadd = await Address.findOne({ _id: new mongoose.Types.ObjectId(order.address_id) })
                        // const custdetails = await Customers.findOne({ _id: order.customer_id })
                        // console.log(getadd);
                        const itemDoc = await Items.findOne({ $and: [{ cityid: new mongoose.Types.ObjectId(city.cityid), item_name: x.item, isActive: true }] });
                        console.log("--------------------------------------------------", itemDoc, city.cityid, x.item);
                        if (itemDoc) {

                            let tot = itemDoc.price.toFixed(2) * x.weight;
                            console.log('itemDoc.price', itemDoc.price, tot);

                            const orderitemfinal = {
                                // itemid: new mongoose.Types.ObjectId(order._id),
                                itemid: itemDoc._id,
                                item: itemDoc.item_name,
                                weight: parseFloat(x.weight).toFixed(2),
                                price: itemDoc.price.toFixed(2),
                                total: tot.toFixed(2),
                                itemUnit: itemDoc.unit,
                                isActive: 1
                                // unit: itemDoc.unit
                                // city: getadd.city,
                            };
                            totalPrice = tot + totalPrice
                            count += 1
                            totalitems.push(orderitemfinal)
                            console.log(count == item.length, count, item.length);
                            if (count == item.length) {
                                // if (totalitems) {
                                //     console.log('totalitems', totalitems);

                                //     if (itemItems) {
                                //         return res.send({
                                //             isSuccess: true,
                                //             message: "Create Order Item Individual.",
                                //             order: totalitems
                                //         });
                                //     }
                                // }


                            }
                        } else {

                            // let tot = itemDoc.price.toFixed(2) * x.weight;
                            // console.log('itemDoc.price', itemDoc.price, tot);

                            const orderitemfinal = {
                                // itemid: new mongoose.Types.ObjectId(order._id),
                                // itemid: itemDoc._id,
                                item: x.item,
                                weight: parseFloat(x.weight).toFixed(2),
                                price: 0.00,
                                total: 0.00,
                                isActive: 0
                                // unit: itemDoc.unit
                                // city: getadd.city,
                            };
                            // let totalPrice = 0
                            totalPrice = 0 + totalPrice
                            count += 1
                            totalitems.push(orderitemfinal)
                            console.log(count == item.length, count, item.length);
                            if (count == item.length) {
                                // if (totalitems) {
                                //     console.log('totalitems', totalitems);

                                //     if (itemItems) {
                                //         return res.send({
                                //             isSuccess: true,
                                //             message: "Create Order Item Individual.",
                                //             order: totalitems
                                //         });
                                //     }
                                // }


                            }
                        }

                        if (totalitems.length == item.length) {
                            return res.send({
                                isSuccess: true,
                                message: "Item Availability before Order.",
                                order: totalitems,
                                est_price: totalPrice.toFixed(2)
                            });
                        }

                    }
                    // } 
                    // else {
                    //     return res.send({
                    //         isSuccess: false,
                    //         message: "Failed to create the order.",
                    //     });
                    // }
                    // }
                    // else {
                    //     return res.send({
                    //         isSuccess: false,
                    //         message: "Failed to create the order.",
                    //     });
                    // }
                }
            }
        } else {
            return res.send({
                isSuccess: false,
                message: "Failed to get item.",
            });
        }

    })
}






// Check Order exist or not, for same customer_id, date
export const checkOrder = async (req, res) => {
    await Orders.findOne({ customer_id: req.params.custid, schedule_date: req.params.date, status: { $nin: ["Order Reject by Customer", "Reject by Customer", "Reject Subsequent Orders by Customer", "Rejected by admin", "Pickup Completed", "processed"] } }).then((x) => {
        if (x) {
            return res.send({
                isSuccess: false,
                orderId: x.order_id,
                msg: `Customer already placed order in ${req.params.date} date.`
            })
        } else {
            return res.send({
                isSuccess: true,
            })
        }
    })
}






// Create Order by Customer
export const createOrder = async (req, res) => {
    // console.log(req.fields);
    // const formData = {
    //     customer_id: req.fields.customer_id.trim(),
    //     address_id: req.fields.address_id.trim(),
    //     schedule_date: req.fields.schedule_date.trim(),
    //     item: [
    //       {
    //         itemid: req.fields['item[0][itemid]'].trim(),
    //         weight: req.fields['item[0][weight]'].trim(),
    //       },
    //     ],
    //   };

    //   // Log the parsed form data
    //   console.log(JSON.stringify(formData, null, 2));
    //   console.log(formData);
    let est_price = 0;
    let totalitems = [];
    let totalPrice = 0

    try {
        var { customer_id, address_id, schedule_date, item, time, mode, ngoId, needCertificate, payment_id, pickupday, payment_settlement, recursive_ord } = req.body;
        // var item = JSON.parse(req.body.item)


        // Generate a random order_id
        const order_id = await generateRandomOrderId();
        console.log("order_id", order_id, order_id == 'RP231200NaN');
        if (item.length !== 0) {

            for (const x of item) {
                 // const aggregationPipeline = [
                //     {
                //         $match: {
                //             _id: { $in: itemIds }
                //         }
                //     },
                //     {
                //         $addFields: {
                //             weight: weights,
                //             _idArray: itemIds,
                //         }
                //     },
                //     {
                //         $unwind: "$weight"
                //     },
                //     // {
                //     //     $match: {
                //     //         _idArray: { $in: "$_idArray" }
                //     //     }
                //     // },

                //     // {
                //     //     $project: {
                //     //         _id: { $type: "$_id" },
                //     //         priceType: { $type: "$price" },
                //     //         weightType: { $type: "$weight" },
                //     //     }
                //     // },
                //     {
                //         $project: {
                //             _id: '$_id',
                //             total_price: {
                //                 $multiply: [
                //                     { $toDouble: "$price" }, // Convert price to a double
                //                     { $toDouble: "$weight" } // Use the weight field from the document
                //                 ]
                //             }
                //         }
                //     },
                //     // {
                //     //     $group: {
                //     //         _id: "$_id",
                //     //         total_price: { $sum: "$total_price" }
                //     //     }
                //     // }
                // ]
                const itemDoc = await Items.findOne({ _id: x.itemid });


                console.log(x, itemDoc);
                if (itemDoc) {
                    est_price += parseFloat(itemDoc.price) * parseFloat(x.weight);
                }

                // const image = req.file; // Assuming you have a file input named 'image' in your form
                // if (image) {
                //     x.imageURL = 'uploads/' + image.filename;
                // }

                // const item = req.body.item.map((item) => {
                //     return {
                //         itemid: item.itemid,
                //         weight: item.weight,
                //         imageURL: req.file ? `uploads/${uploadedImage.filename}` : '', // Set imageURL if an image was uploaded
                //     };
                // });



                // console.log(x, est_price, item.indexOf(x) == item.length - 1 && est_price != 0);
                // const totalPriceResult = await Items.aggregate(aggregationPipeline);
                // est_price = totalPriceResult;
                // if (totalPriceResult.length > 0) {
                let order
                if (item.indexOf(x) == item.length - 1 && est_price != 0) {
                    await Customers.findOne({ _id: new ObjectId(customer_id) }).then(async (get_cust) => {
                        console.log("get_cust--------------------------------------------", get_cust);
                        await Orders.findOne({ customer_id: new ObjectId(get_cust._id) }).sort({ createdAt: -1 }).then(async (get_ord) => {
                            console.log("get_ord.recursive_ord", get_ord);
                            const futureDate = moment(schedule_date,'DD-MM-YYYY').add(parseInt(pickupday), 'days').format('DD-MM-YYYY');
                            // if (payment_settlement == 0) {
                            //     payment_settlement = "instant"
                            // }
                            console.log("pickupday && payment_settlement", pickupday && payment_settlement && recursive_ord == false);

                            if (pickupday && payment_settlement && recursive_ord == false) {
                                console.log(req.body);

                                await Orders.findByIdAndUpdate({ _id: new ObjectId(req.body.parentId) }, {
                                    $set: { scheduleDateForLastOrder: futureDate }
                                });

                                order = await Orders.create({
                                    customer_id: customer_id,
                                    address_id: address_id,
                                    schedule_date: schedule_date,
                                    time: time,
                                    item: req.body.item,
                                    est_price: est_price.toFixed(2),
                                    order_id: order_id,
                                    mode: mode,
                                    // recursive_ord: true,
                                    scheduleDateForLastOrder: futureDate,
                                    pickupday: pickupday,
                                    payment_settlement: payment_settlement,
                                    recursive_orderid: req.body.recursive_orderid,
                                });

                            }
                            else if (pickupday && payment_settlement && recursive_ord == true) {
                                console.log("line no 406");

                                order = await Orders.create({
                                    customer_id: customer_id,
                                    address_id: address_id,
                                    schedule_date: schedule_date,
                                    time: time,
                                    item: req.body.item,
                                    est_price: est_price.toFixed(2),
                                    order_id: order_id,
                                    mode: mode,
                                    recursive_ord: true,
                                    scheduleDateForLastOrder: futureDate ,
                                    pickupday: pickupday,
                                    payment_settlement: req.body.payment_settlement,
                                    // recursive_orderid: req.body.recursive_orderid,
                                });
                            }
                            else {
                                order = await Orders.create({
                                    customer_id: customer_id,
                                    address_id: address_id,
                                    schedule_date: schedule_date,
                                    time: time,
                                    item: req.body.item,
                                    est_price: est_price.toFixed(2),
                                    order_id: order_id,
                                    mode: mode,
                                    // payment_id: payment_id,
                                });
                            }
                        })

                    })


                    console.log(order);

                    if (order) {
                        var count = 0
                        console.log(item);
                        for (const x of item) {
                            console.log(x);
                            const getadd = await Address.findOne({ _id: new mongoose.Types.ObjectId(order.address_id) })
                            const custdetails = await Customers.findOne({ _id: order.customer_id })
                            console.log(getadd);
                            const itemDoc = await Items.findOne({ _id: x.itemid });

                            if (itemDoc && custdetails) {
                                const orderitem = await Orderitems.create({
                                    order_id: new mongoose.Types.ObjectId(order._id),
                                    item_id: itemDoc._id,
                                    item_weight: x.weight,
                                    item_price: parseFloat(itemDoc.price),
                                    // total_price: parseFloat(itemDoc.price) * x.weight,
                                    city: getadd.city,
                                });
                                let tot = itemDoc.price.toFixed(2) * x.weight
                                console.log('itemDoc.price', itemDoc.price, tot);

                                const orderitemfinal = {
                                    // itemid: new mongoose.Types.ObjectId(order._id),
                                    itemid: itemDoc._id,
                                    item_name: itemDoc.item_name,
                                    weight: parseFloat(x.weight).toFixed(2),
                                    price: itemDoc.price.toFixed(2),
                                    total: tot.toFixed(2),
                                    // unit: itemDoc.unit
                                    // city: getadd.city,
                                };
                                totalPrice = tot + totalPrice
                                count += 1
                                totalitems.push(orderitemfinal)
                                console.log(orderitem && count == item.length, count, item.length);
                                if (orderitem && count == item.length) {
                                    if (totalitems) {
                                        console.log('totalitems', totalitems);
                                        const itemItems = await Orders.findOneAndUpdate({ _id: order._id }, {
                                            $set: {
                                                // item: totalitems
                                                item: totalitems,
                                                est_price: totalPrice,
                                            }
                                        })
                                        if (itemItems) {
                                            if (itemItems.mode == 'Donation') {
                                                // Save donation details to the database
                                                const donation = new Donation({
                                                    customerId: order.customer_id,
                                                    NGO_id: ngoId,
                                                    orderId: order._id,
                                                    donationDate: order.schedule_date,
                                                    donationStatus: 'pending'
                                                });
                                                await donation.save();
                                                console.log('donation', donation);

                                                let updatedDonation;
                                                if (custdetails && custdetails.PAN) {
                                                    updatedDonation = await Donation.findOneAndUpdate(
                                                        { orderId: order._id },
                                                        {
                                                            $set: {
                                                                needCertificate: true,
                                                                certificate_status: 'pending',
                                                                certificateUrl: null,
                                                            },
                                                        },
                                                        { new: true }
                                                    );
                                                    console.log("updated Donation", updatedDonation);
                                                } else {
                                                    if (needCertificate == "true") {
                                                        updatedDonation = await Donation.findOneAndUpdate(
                                                            { orderId: order._id },
                                                            {
                                                                $set: {
                                                                    needCertificate: true,
                                                                    certificate_status: 'pending',
                                                                    certificateUrl: null,
                                                                },
                                                            },
                                                            { new: true }
                                                        );
                                                        console.log("updated Donation", updatedDonation);
                                                    } else if (req.body.needCertificate == "false") {
                                                        updatedDonation = await Donation.findOneAndUpdate(
                                                            { orderId: order._id },
                                                            {
                                                                $set: {
                                                                    needCertificate: false,
                                                                },
                                                            },
                                                            { new: true }
                                                        );
                                                        console.log("updated Donation", updatedDonation);
                                                    }
                                                }
                                            }

                                        // const mg = mailgun({
                                            //     apiKey: process.env.MAILAPIKEY,
                                            //     domain: process.env.DOMAIN,
                                            // });

                                            let cust = await Customers.find({ _id: order.customer_id })
                                            // const transporter = brevo.createTransport({
                                            //     apiKey: process.env.MAILAPIKEY,
                                            //     domain: process.env.DOMAIN,
                                            //   });

                                            const transporter = nodemailer.createTransport(
                                                new Transport({ apiKey: process.env.MAILAPIKEY })
                                            );

                                            // const transporter = new brevo.Transport(emailConfig);

                                            if (cust) {

                                                var defaultClient = SibApiV3Sdk.ApiClient.instance;

                                                // Configure API key authorization: api-key
                                                var apiKey = defaultClient.authentications['api-key'];
                                                apiKey.apiKey = process.env.MAILAPIKEY;

                                                // Uncomment below two lines to configure authorization using: partner-key
                                                // var partnerKey = defaultClient.authentications['partner-key'];
                                                // partnerKey.apiKey = 'YOUR API KEY';

                                                var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();

                                                var sendSmtpEmail = new SibApiV3Sdk.SendSmtpEmail();
                                                var sendSmtpEmailAdmin = new SibApiV3Sdk.SendSmtpEmail();

                                                // var dynamicContent = {
                                                //     firstname: "John",
                                                //     lastname: "Doe",
                                                // };

                                                const dynamicSubject = `Order Confirmation - Your Order with Recycle Pay [${order.order_id}] has been successfully placed!`;
                                                console.log('totalitems', totalitems);
                                                sendSmtpEmail = {
                                                    to: [{
                                                        email: custdetails.email,
                                                        // email: 'aditi.nandy@ajatus.co.in'
                                                        // name: 'John Doe'
                                                    }],
                                                    from: {
                                                        email: 'support@ceibagreen.com',
                                                        // name: 'Your Name'
                                                    },
                                                    templateId: 10,
                                                    params: {
                                                        "parameter": "recycle-pay",
                                                        "subject": dynamicSubject,
                                                        "order_id": order.order_id, "schedule_date": order.schedule_date, "getadd": getadd, "totalitems": totalitems, "est_price": totalPrice.toFixed(2), "name": custdetails.name, "time": order.time
                                                    },
                                                    subject: dynamicSubject,
                                                    headers: {
                                                        'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                                    }
                                                };
                                                const dynamicAdmSubject = `New order [${order.order_id}] has been placed!`;

                                                sendSmtpEmailAdmin = {
                                                    to: [
                                                        // { email: 'aditi.nandy@ajatus.co.in' }, 
                                                        // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                        //  { email: 'ashok.sarangi@ajatus.co.in' },
                                                        // { email: 'santosh@ceibagreen.com' },
                                                        // { email: 'janmejay@ceibagreen.com' },
                                                        // { email: 'support@ceibagreen.com' },
                                                        // { email: 'neelima@ceibagreen.com' }
                                                        // { email: 'neelima@ajatus.co.in' }
                                                    ],
                                                    from: {
                                                        email: 'support@ceibagreen.com',
                                                        // name: 'Your Name'
                                                    },
                                                    templateId: 14,
                                                    params: { "parameter": "recycle-pay", "subject": "Your Order ID - {{params.order_id}} for Scrap Sale has been placed", "order_id": order.order_id, "schedule_date": order.schedule_date, "getadd": getadd, "totalitems": totalitems, "totalPrice": totalPrice.toFixed(2), "name": custdetails.name, "time": order.time },
                                                    subject: dynamicAdmSubject,
                                                    headers: {
                                                        'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                                    }
                                                };

                                                console.log("order.order_id", order.order_id);

                                                const mailOptions = {
                                                    from: 'orders@recycle-pay.com',
                                                    to: 'aditi.nandy@ajatus.co.in',
                                                    subject: `Your Order ID - ${order.order_id} for Scrap Sale has been placed`,
                                                    text: `<p>Hello ${cust[0].name},</p>
                                                <p>On sucessful order placed a mail to be sent to customer with order details as </p>

                                                <p>Order Id: ${order.order_id}</p>
                                              
                                                <p>Pick Up date: ${order.schedule_date}</p>
                                                <p>Pick Up time: ${order.time}</p>
                                                <p>Total Quantity: ${order.order_id}</p>

                                                <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                                <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                                `,
                                                };


                                                //  Send Notification
                                                const customer = await Customers.findById(customer_id);
                                                const condition_name = "Order";
                                                if (customer && customer.token) {
                                                    pushNotification(
                                                        customer.token,
                                                        "Order created",
                                                        `Your Order ID #${order_id} has been successfully created and will be picked up on ${schedule_date} at ${time}`,
                                                        condition_name
                                                    );
                                                } else {
                                                    console.log("customer or token not exists");
                                                }

                                                try {
                                                    // transporter.sendMail(mailOptions, (error, info) => {
                                                    //     if (error) {
                                                    //         console.error('Error sending email:', error);
                                                    //     } else {
                                                    //         console.log('Email sent:', info.response);
                                                    //     }
                                                    // });
                                                    // apiInstance.sendTransacEmail(sendSmtpEmail).then(function (data) {
                                                    //     console.log('Customer API called successfully. Returned data: ' + data);
                                                    // }, function (error) {
                                                    //     console.error(error);
                                                    // });

                                                    // apiInstance.sendTransacEmail(sendSmtpEmailAdmin).then(function (data) {
                                                    //     console.log('Admin API called successfully. Returned data: ' + data);
                                                    // }, function (error) {
                                                    //     console.error(error);
                                                    // });
                                                } catch (error) {
                                                    console.error("Error:", error);
                                                }
                                            }
                                            // if (cust) {
                                            //     console.log(cust);
                                            //     const mailOptionscust = {
                                            //         from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                            //         // to: cust.email,
                                            //         to: cust[0].email,
                                            //         subject: `Your Order ID - ${order.order_id} for Scrap Sale has been placed`,
                                            //         html: `<p>Hello ${cust[0].name},</p>
                                            //           <p>On sucessful order placed a mail to be sent to customer with order details as </p>

                                            //           <p>Order Id: ${order.order_id}</p>

                                            //           <p>Pick Up date: ${order.schedule_date}</p>
                                            //           <p>Pick Up time: ${order.time}</p>
                                            //           <p>Total Quantity: ${order.order_id}</p>

                                            //           <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                            //           <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                            //           `,
                                            //     };
                                            //     const mailOptionsadmin = {
                                            //         from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                            //         to: cust.email,
                                            //         subject: `Order ID - ${order.order_id} for Scrap Sale has been received`,
                                            //         html: `<p>Hello ${cust.name},</p>
                                            //           <p>On sucessful order placed a mail to be sent to customer with order details as </p>

                                            //           <p>Order Id: ${order.order_id}</p>
                                            //           <p>Order Date: ${order.createdAt.split('T')[0].split('-').reverse().join('-')}</p>
                                            //           <p>Pick Up date: ${order.schedule_date}</p>
                                            //           <p>Pick Up time: ${order.time}</p>
                                            //           <p>Total Quantity: ${order.order_id}</p>

                                            //           <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                            //           <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                            //           `,
                                            //     };
                                            //     try {
                                            //         mg.messages().send(mailOptionscust, (error, body) => {
                                            //             if (error) {
                                            //                 console.error("Mailgun error:", error);
                                            //                 res.status(500).send("Error sending email");
                                            //             } else {
                                            //                 res.status(200);
                                            //             }
                                            //         });
                                            //         mg.messages().send(mailOptionsadmin, (error, body) => {
                                            //             if (error) {
                                            //                 console.error("Mailgun error:", error);
                                            //                 res.status(500).send("Error sending email");
                                            //             } else {
                                            //                 res.status(200);
                                            //             }
                                            //         });

                                            //     } catch (error) {
                                            //         console.error("Error:", error);
                                            //     }
                                            // }
                                           
                                            return res.send({
                                                isSuccess: true,
                                                message: "Create Order Item Individual.",
                                                // order: orderitem
                                            });
                                        }
                                    }


                                }
                            }

                        }
                    } else {
                        return res.send({
                            isSuccess: false,
                            message: "Failed to create the order.",
                        });
                    }
                }
                // else {
                //     return res.send({
                //         isSuccess: false,
                //         message: "Failed to create the order.",
                //     });
                // }
            }
        }


    } catch (error) {
        console.error(error);
        res.status(500).send({
            isSuccess: false,
            message: "An error occurred while creating the order.",
        });
    }


};


// cancel order by customer
export const cancelOrder = async (req, res) => {
    Orders.findOne({ _id: req.params.orderid, status: "Cancel" }).then((cancelord) => {
        if (cancelord) {
            return res.send({
                isSuccess: true,
                message: "Already Cancel.",
            });
        } else {
            Orders.findByIdAndUpdate({ _id: req.params.orderid }, { $set: { status: "Cancel" } }).then((getord) => {
                if (getord) {
                    return res.send({
                        isSuccess: true,
                        message: "cancelled by customer",
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong",
                    });
                }
            })
        }
    })

}



// Order conformed by Admin
export const confOrder = async (req, res) => {
    console.log(req.body.reason);
    Orders.findOne({ _id: req.params.orderid }).then(async (conford) => {
        console.log(req.query.status == "Rejected by admin" && conford.status == "Order Placed");
        if (req.query.status == "Rejected by admin" && (conford.status == "Order Placed" || conford.status == "Created" || conford.status == "Assigned to agent")) {
            await Orders.findByIdAndUpdate(
                { _id: req.params.orderid },
                {
                    $set: {
                        status: "Rejected by admin",
                        reason: req.body.reason || "No reason provided", // Add a default value if reason is not present
                    },
                },
                { new: true }
            ).then(async (getord) => {
                console.log('getord', getord);
                if (getord) {
                    const mg = mailgun({
                        apiKey: process.env.MAILAPIKEY,
                        domain: process.env.DOMAIN,
                    });

                    // send Notification
                    const customer = await Customers.findById(getord.customer_id);
                    const condition_name = "Order";
                    if (customer && customer.token) {
                        pushNotification(
                            customer.token,
                            "Order Rejected",
                            `🛑 We're Sorry! Order #${getord.order_id} couldn't be processed this time. Our team is here to help, please reach out for assistance.`,
                            condition_name
                        );
                    } else {
                        console.log("customer or token not exists");
                    }

                    const cust = await Customers.find({ _id: getord.customer_id })
                    if (cust) {
                        const mailOptionscust = {
                            from: "Ceiba Green Solutions <support@ceibagreen.com>",
                            to: cust.email,
                            subject: `Your Order ID - ${getord.order_id} for Scrap Sale has been rejected`,
                            html: `<p>Hello ${cust.name},</p>
                              <p>🛑 We're Sorry! Order #${getord.order_id} couldn't be processed this time. Our team is here to help, please reach out for assistance</p>

                              <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                              <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                              `,
                        };

                        try {
                            // mg.messages().send(mailOptionscust, (error, body) => {
                            //     if (error) {
                            //         console.error("Mailgun error:", error);
                            //         res.status(500).send("Error sending email");
                            //     } else {
                            //         res.status(200);
                            //     }
                            // });
                        } catch (error) {
                            console.error("Error:", error);
                        }
                    }

                    return res.send({
                        isSuccess: true,
                        message: "Reject by admin",
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong",
                    });
                }
            })
        } else if (req.query.status == "Order Placed") {
            Orders.findByIdAndUpdate({ _id: req.params.orderid }, { $set: { status: "Order Placed" } }).then((getord) => {
                if (getord) {
                    return res.send({
                        isSuccess: true,
                        message: "Confirm by admin",
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong",
                    });
                }
            })
        }
        else {
            return res.send({
                isSuccess: false,
                message: "Something went wrong. First customer needs to placed the order.",
            });
        }
        // else {
        //     Orders.findByIdAndUpdate({ _id: req.params.orderid }, { $set: { status: 1 } }).then((getord) => {
        //         if (getord) {
        //             return res.send({
        //                 isSuccess: true,
        //                 message: "Confirm by admin",
        //             });
        //         } else {
        //             return res.send({
        //                 isSuccess: false,
        //                 message: "Something went wrong",
        //             });
        //         }
        //     })
        // }
    })
}



// Assign order to Agent by Admin
export const assOrder = async (req, res) => {
    Orders.findOne({ _id: req.params.orderid, status: "Assigned to agent" }).then((assord) => {
        console.log("assord", assord);

        if (assord) {
            Orders.findByIdAndUpdate({ _id: req.params.orderid }, { $set: { agent_id: req.body.agentid } }).then(async (getord) => {
                if (getord) {
                    // Send Notification to customer
                    const customer = await Customers.findById(getord.customer_id);
                    const agent = await Users.findById(req.body.agentid);
                    const condition_name = "Order";
                    if (customer && customer.token) {
                        console.log("already assigned agent - to customer");

                        pushNotification(
                            customer.token,
                            "Order Assigned",
                            `Your Order #${getord.order_id}  has been assigned to ${agent.name} for pick up on ${getord.schedule_date} at ${getord.time}.`,
                            condition_name
                        );
                    } else {
                        console.log("customer or token not exists");
                    }


                    // Send Notification to Agent
                    if (agent && agent.token) {
                        console.log("already assigned agent - to agent");

                        pushNotification(
                            agent.token,
                            "Order Assigned",
                            `Order #${getord.order_id} has been assigned to you for pick up on ${getord.schedule_date} at ${getord.time}`,
                            condition_name,
                            req.params.orderid
                        );
                    } else {
                        console.log("agent or token not exists");
                    }

                    return res.send({
                        isSuccess: true,
                        message: "Already Assign to Agent.",
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong",
                    });
                }
            })
        } else {
            Orders.findByIdAndUpdate({ _id: req.params.orderid }, { $set: { agent_id: req.body.agentid, status: "Assigned to agent" } }).then(async (getord) => {
                console.log("getord - 1", getord);

                if (getord) {
                    // Send Notification to customer
                    const customer = await Customers.findById(getord.customer_id);
                    const condition_name = "Order";

                    console.log("getord - 2", getord);
                    const agent = await Users.findById(req.body.agentid);
                                        
                    console.log("agent", agent.name);

                    if (customer && customer.token) {
                        console.log("newly assigned agent - to customer");

                        pushNotification(
                            customer.token,
                            "Order Assigned",
                            `Your Order #${getord.order_id}  has been assigned to ${agent.name} for pick up on ${getord.schedule_date} at ${getord.time}.`,
                            condition_name
                        );
                    } else {
                        console.log("customer or token not exists");
                    }


                    // Send Notification to Agent
                    if (agent && agent.token) {
                        console.log("newly assigned agent - to agent");

                        pushNotification(
                            agent.token,
                            "Order Assigned",
                            `Order #${getord.order_id} has been assigned to you for pick up on ${getord.schedule_date} at ${getord.time}`,
                            condition_name,
                            req.params.orderid
                        );
                    } else {
                        console.log("agent or token not exists");
                    }


                    return res.send({
                        isSuccess: true,
                        message: "Already Assign to Agent.",
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong",
                    });
                }
            })
        }

        // return res.send({
        //     isSuccess: true,
        //     message: "Already Assign to Agent by Admin.",
        // });
    })
}




// Pick up confirm by Agent
export const pConAgent = async (req, res) => {
    if (req.query.status == "Received by agent") {
        const conOrd = await Orders.findOneAndUpdate({ _id: req.query.orderid, agent_id: req.params.agentid }, { $set: { status: "Received by agent" } })
        if (conOrd) {
            res.json({
                isSuccess: true,
                message: "received by agent"
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    } else if (req.query.status == "Payment failed") {
        const conOrd = await Orders.findOneAndUpdate({ _id: req.query.orderid, agent_id: req.params.agentid }, { $set: { status: "Payment failed" } })
        if (conOrd) {
            res.json({
                isSuccess: true,
                message: "payment failed"
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    }

}




// Payment confirm by Agent
export const payConfAgent = async (req, res) => {
    if (req.query.status == "Payment successful") {
        const conOrd = await Orders.findOneAndUpdate({ _id: req.query.orderid, agent_id: req.params.agentid, status: "Received by agent" }, { $set: { status: "Payment successful" } })
        console.log(conOrd);
        if (conOrd) {
            res.json({
                isSuccess: true,
                message: "Payment Confirm."
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    } else if (req.query.status == "Payment failed") {
        const conOrd = await Orders.findOneAndUpdate({ _id: req.query.orderid, agent_id: req.params.agentid, status: 4 }, { $set: { status: "Payment failed" } })
        if (conOrd) {
            res.json({
                isSuccess: true,
                message: "payment failed"
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    }
}




// Get Agent order by filter (All, pending, complete, future)
export const filterOrder = async (req, res) => {
    try {
        const today = new Date().toISOString().split('T')[0];
        const parts = today.split('-');
        const reversedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
        console.log(reversedDate, new Date());

        if (req.query.order == 'upcoming') {
            const pipeline = [
                {
                    $match: {
                        status: { $in: ["Assigned to agent"] },
                        agent_id: new mongoose.Types.ObjectId(req.params.agentid),
                        schedule_date: { $gt: reversedDate }
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address: { $first: "$addressDetails" },
                        customer: { $first: "$customerDetails" },
                        customer_name: {
                            $first: {
                                $let: {
                                    vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                    in: "$$firstCustomer.name"
                                }
                            }
                        },
                        address_id: { $first: "$address_id" },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        // item: { $push: "$item" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
                                price: { $arrayElemAt: ["$itemDetails.price", 0] },
                                // _id: "$item._id",
                                total: 0
                            }
                        },
                        itemDetails: { $push: "$itemDetails" },
                        agent_id: { $first: "$agent_id" },
                        updatedAt: { $first: "$updatedAt" },
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                },
            ];
            const order = await Orders.aggregate(pipeline);
            if (order) {
                console.log(order);
                return res.send({
                    isSuccess: true,
                    msg: "Filter All Orders.",
                    order: order
                })
            } else {
                return res.send({
                    isSuccess: false,
                    msg: "Something went wrong.",
                    order: []
                })
            }





        } else if (req.query.order == 'pending' && req.query.filter == reversedDate) { // pendig Order
            // const order = await Orders.find({
            //     status: { $in: [2, 3] },
            //     schedule_date: req.query.filter
            // })

            const pipeline = [
                {
                    $match: {
                        $and: [
                            {
                                $or: [
                                    { status: "Assigned to agent" },
                                    { status: "Out for pickup" },
                                    { status: "Received by agent" },
                                    { status: "Pickup Completed" }
                                ]
                            },
                            { agent_id: new mongoose.Types.ObjectId(req.params.agentid) },
                            { schedule_date: reversedDate }
                        ]
                    }
                },
                {
                    $match: {
                        $or: [
                            { status: { $in: ["Assigned to agent", "Out for pickup", "Received by agent"] } },
                            {
                                $and: [
                                    { status: "Pickup Completed" },
                                    {
                                        $or: [
                                            { recursive_ord: { $exists: false } },
                                            // { recursive_ord: true },
                                            // { recursive_ord: false }
                                        ]
                                    }
                                ]
                            }
                        ]
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $unwind: "$item"
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address: { $first: "$addressDetails" },
                        customer: { $first: "$customerDetails" },
                        customer_name: {
                            $first: {
                                $let: {
                                    vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                    in: "$$firstCustomer.name"
                                }
                            }
                        },
                        address_id: { $first: "$address_id" },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
                                price: { $arrayElemAt: ["$itemDetails.price", 0] },
                                total: 0
                            }
                        },
                        agent_id: { $first: "$agent_id" },
                        updatedAt: { $first: "$updatedAt" },
                        recursive_ord: { $first: "$recursive_ord" },
                    }
                },
                {
                    $sort: {
                        updatedAt: 1
                    }
                }
            ];


            const order = await Orders.aggregate(pipeline);
            const agent = await Users.findById(order.agent_id);
            const condition_name = "Order";
            if (order) {
                // send Notification to Agent
                if (agent && agent.token) {
                    pushNotification(
                        agent.token,
                        "Today's Orders",
                        `Following orders are to be picked up Today`,
                        condition_name
                    );
                } else {
                    console.log("agent or token not exists");
                }

                return res.send({
                    isSuccess: true,
                    msg: "Filter Pending Orders.",
                    order: order
                })
            } else {
                return res.send({
                    isSuccess: false,
                    msg: "Something went wrong.",
                    order: []
                })
            }
        } else if (req.query.order == 'complete' && req.query.filter == reversedDate) { // complete Order
            // const order = await Orders.find({
            //     status: { $in: [2, 3] },
            //     schedule_date: req.query.filter
            // })

            const pipeline = [
                {
                    $match: {
                        $and: [
                            {
                                $or: [
                                    { status: { $in: ["processed", "Cash", "Pickup Completed"] } },
                                ]
                            },
                            { agent_id: new mongoose.Types.ObjectId(req.params.agentid) },
                            { schedule_date: reversedDate },
                            // { recursive_ord: { $exists: true } }
                        ]
                    }
                },
                {
                    $match: {
                        $or: [
                            { status: { $in: ["processed", "Cash", "Pickup Completed"] } },
                            {
                                $and: [
                                    { status: "Pickup Completed" },
                                    {
                                        $or: [
                                            { recursive_ord: { $exists: false } },
                                            { recursive_ord: true },
                                            // { recursive_ord: false }
                                        ]
                                    }
                                ]
                            }
                        ]
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address: { $first: "$addressDetails" },
                        customer: { $first: "$customerDetails" },
                        customer_name: {
                            $first: {
                                $let: {
                                    vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                    in: "$$firstCustomer.name"
                                }
                            }
                        },
                        address_id: { $first: "$address_id" },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        // item: { $push: "$item" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
                                price: { $arrayElemAt: ["$itemDetails.price", 0] },
                                // _id: "$item._id",
                                total: 0
                            }
                        },
                        itemDetails: { $push: "$itemDetails" },
                        agent_id: { $first: "$agent_id" },
                        updatedAt: { $first: "$updatedAt" },
                        recursive_ord: { $first: "$recursive_ord" },
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                },
            ];



            const order = await Orders.aggregate(pipeline);
            console.log(order);
            if (order) {
                return res.send({
                    isSuccess: true,
                    msg: "Filter Complete Orders.",
                    order: order
                })
            } else {
                return res.send({
                    isSuccess: false,
                    msg: "Something went wrong.",
                    order: []
                })
            }
        } else if (req.query.order == 'future' && req.query.filter == reversedDate) { // future Order
            // const order = await Orders.find({
            //     status: { $in: [2, 3] },
            //     schedule_date: req.query.filter
            // })

            console.log(moment.utc(req.query.filter, 'DD-MM-YYYY').toDate());

            const pipeline = [
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $addFields: {
                        schedule_date: {
                            $dateFromString: {
                                dateString: "$schedule_date",
                                format: "%d-%m-%Y"
                            }
                        }
                    }
                },
                {
                    $match: {
                        status: { $in: ["Assigned to agent"] },
                        agent_id: new mongoose.Types.ObjectId(req.params.agentid),
                        schedule_date: { $gt: moment.utc(req.query.filter, 'DD-MM-YYYY').toDate() }
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address: { $first: "$addressDetails" },
                        customer: { $first: "$customerDetails" },
                        customer_name: {
                            $first: {
                                $let: {
                                    vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                    in: "$$firstCustomer.name"
                                }
                            }
                        },
                        address_id: { $first: "$address_id" },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        // item: { $push: "$item" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
                                price: { $arrayElemAt: ["$itemDetails.price", 0] },
                                // _id: "$item._id",
                                total: 0
                            }
                        },
                        itemDetails: { $push: "$itemDetails" },
                        agent_id: { $first: "$agent_id" },
                        updatedAt: { $first: "$updatedAt" },
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                },
            ];



            const order = await Orders.aggregate(pipeline);
            console.log(order);
            if (order) {
                return res.send({
                    isSuccess: true,
                    msg: "Filter Future Orders.",
                    order: order
                })
            } else {
                return res.send({
                    isSuccess: false,
                    msg: "Something went wrong.",
                    order: []
                })
            }
        } else if (req.query.order == 'all') { // complete Order
            // const order = await Orders.find({
            //     status: { $in: [2, 3] },
            //     schedule_date: req.query.filter
            // })

            const pipeline = [
                {
                    $match: {
                        status: { $in: ["Assigned to agent", "Out for pickup", "Received by agent", "processed", "Cash", "Pickup Completed"] },
                        agent_id: new mongoose.Types.ObjectId(req.params.agentid),
                        // schedule_date: reversedDate
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        // customer_id: { $first: "$customer_id" },
                        // address: { $first: "$addressDetails" },
                        // customer: { $first: "$customerDetails" },
                        // customer_name: {
                        //     $first: {
                        //         $let: {
                        //             vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                        //             in: "$$firstCustomer.name"
                        //         }
                        //     }
                        // },
                        // address_id: { $first: "$address_id" },
                        // est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        status: { $first: "$status" },
                        // isDelete: { $first: "$isDelete" },
                        // item: { $push: "$item" },
                        // item: {
                        //     $push: {
                        //         itemid: "$item.itemid",
                        //         weight: "$item.weight",
                        //         item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
                        //         price: { $arrayElemAt: ["$itemDetails.price", 0] },
                        //         // _id: "$item._id",
                        //         total: 0
                        //     }
                        // },
                        // itemDetails: { $push: "$itemDetails" },
                        // agent_id: { $first: "$agent_id" },
                        updatedAt: { $first: "$updatedAt" },
                        createdAt: { $first: "$createdAt" },
                    }
                },
                {
                    $sort: {
                        "createdAt": -1
                    }
                },
            ];



            const order = await Orders.aggregate(pipeline);
            console.log(order);
            if (order) {
                return res.send({
                    isSuccess: true,
                    msg: "Get All Orders.",
                    order: order
                })
            } else {
                return res.send({
                    isSuccess: false,
                    msg: "Something went wrong.",
                    order: []
                })
            }
        }
        else {
            return res.send({
                isSuccess: false,
                msg: "Something went wrong.",
                order: []
            })
        }
    } catch {
        return res.send({
            isSuccess: false,
            msg: "Something went wrong.",
        })
    }
}




// OrderHistory by customer_id from order table
export const orderHist = async (req, res) => {
    // Orders.find({ customer_id: req.params.custid }).then((getord) => {
    //     // console.log(getord);
    //     for (const x of getord.item) {
    //         Items.findOne({ _id: x.itemid }).then((getitem) => {
    //             getitem.item_name
    //         })
    //     }
    //     return res.send({
    //         isSuccess: true,
    //         message: "Order History",
    //         data: getord
    //     });
    // })
    const usertype = await Users.findOne({ _id: req.params.custid, usertype: "admin" })
    console.log(usertype);
    if (usertype) {
        const pipeline = [
            {
                $match: {
                    status: { $ne: 'Order Cancel by Customer.' } // Exclude documents with status 'Order Cancel by Customer'
                }
            },
            {
                $lookup: {
                    from: "customers",
                    localField: "customer_id",
                    foreignField: "_id",
                    as: "customerDetails"
                }
            },
            {
                $lookup: {
                    from: "items",
                    localField: "item.itemid",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $group: {
                    _id: "$_id",
                    customer_id: { $first: "$customer_id" },
                    customer_name: {
                        $first: {
                            $let: {
                                vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                in: "$$firstCustomer.name"
                            }
                        }
                    },
                    address_id: { $first: "$address_id" },
                    est_price: { $first: "$est_price" },
                    order_id: { $first: "$order_id" },
                    schedule_date: { $first: "$schedule_date" },
                    status: { $first: "$status" },
                    isDelete: { $first: "$isDelete" },
                    item: { $push: "$item" },
                    itemDetails: { $push: "$itemDetails" },
                    createdAt: { $first: "$createdAt" },
                    parent_recursive_ord: { $first: "$recursive_ord" },
                    pickupday: { $first: "$pickupday" },
                    payment_settlement: { $first: "$payment_settlement" },
                }
            },
            {
                $sort: {
                    createdAt: -1 // 1 for ascending order, -1 for descending order
                }
            }
        ];

        const result = await Orders.aggregate(pipeline);

        if (result) {
            res.json({
                isSuccess: true,
                message: "Order History",
                data: result
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    } else {
        const pipeline = [
            {
                $match: {
                    customer_id: new mongoose.Types.ObjectId(req.params.custid)
                }
            },
            {
                $lookup: {
                    from: "customers",
                    localField: "customer_id",
                    foreignField: "_id",
                    as: "customerDetails"
                }
            },
            {
                $lookup: {
                    from: "items",
                    localField: "item.itemid",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $group: {
                    _id: "$_id",
                    customer_id: { $first: "$customer_id" },
                    customer_name: {
                        $first: {
                            $let: {
                                vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                in: "$$firstCustomer.name"
                            }
                        }
                    },
                    address_id: { $first: "$address_id" },
                    est_price: { $first: "$est_price" },
                    order_id: { $first: "$order_id" },
                    schedule_date: { $first: "$schedule_date" },
                    status: { $first: "$status" },
                    isDelete: { $first: "$isDelete" },
                    item: { $push: "$item" },
                    itemDetails: { $push: "$itemDetails" },
                    createdAt: { $first: "$createdAt" },
                    parent_recursive_ord: { $first: "$recursive_ord" },
                    pickupday: { $first: "$pickupday" },
                    payment_settlement: { $first: "$payment_settlement" },
                }
            },
            {
                $sort: {
                    createdAt: -1 // 1 for ascending order, -1 for descending order
                }
            }
        ];

        const result = await Orders.aggregate(pipeline);

        if (result) {
            res.json({
                isSuccess: true,
                message: "Order History",
                data: result
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    }
}



// Get Parent recursive order
export const parentOrdHist = async (req, res) => {
    await Orders.find({
        $or: [
            { recursive_ord: true },
            { recursive_ord: false }
        ],
        customer_id: new ObjectId(req.params.custId)
    }).then((parent) => {
        if (parent) {
            return res.send({
                isSuccess: true,
                data: parent,
            })
        } else {
            return res.send({
                isSuccess: false,
                data: [],
            })
        }
    })
}



// Get child recursive order from parent recursive order
export const childOrdHist = async (req, res) => {
    await Orders.find({ recursive_orderid: new ObjectId(req.params.ordId) }).then((child) => {
        if (child) {
            return res.send({
                isSuccess: true,
                data: child,
            })
        } else {
            return res.send({
                isSuccess: false,
                data: [],
            })
        }
    })
}




//admin order history code
export const orderHistAdmin = async (req, res) => {
    try {
        let limit = 10;
        let page = req.query.offset ? parseInt(req.query.offset) : null;
        let offset = page ? Math.max(0, (page - 1) * limit) : 0;
        let StartDate = req.query.startDate;
        let EndDate = req.query.endDate;
        let cityName = req.query.cityName;
        let customerName = req.query.customerName;
        let mobileNumber = req.query.mobileNumber;
        let status = req.query.status;
        let orderId = req.query.orderId;
        let organisation = req.query.organisation;
        let scheduledate = req.query.scheduledate;
        let agent = req.query.agent;

        const parseDate = (dateString) => {
            const [day, month, year] = dateString.split('-');
            return new Date(Date.UTC(year, month - 1, day));
        };

        let startDateObj = StartDate ? parseDate(StartDate) : null;
        let endDateObj = EndDate ? parseDate(EndDate) : null;

        console.log("Start Date:", startDateObj);
        console.log("End Date:", endDateObj);

        const pipeline = [
            {
                $addFields: {
                    scheduleDateObj: {
                        $dateFromString: {
                            dateString: "$schedule_date",
                            format: "%d-%m-%Y"
                        }
                    }
                },
            },
            {
                $lookup: {
                    from: "customers",
                    localField: "customer_id",
                    foreignField: "_id",
                    as: "customerDetails"
                }
            },
            {
                $lookup: {
                    from: "addresses",
                    localField: "address_id",
                    foreignField: "_id",
                    as: "address"
                }
            },
            {
                $lookup: {
                    from: "items",
                    localField: "item.itemid",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $lookup: {
                    from: "users",
                    localField: "agent_id",
                    foreignField: "_id",
                    as: "agentDetails"
                }
            },
            {
                $unwind: {
                    path: "$agentDetails",
                    preserveNullAndEmptyArrays: true
                }
            },
            {
                $addFields: {
                    trimmedAgentName: {
                        $trim: { input: "$agentDetails.name" }
                    }
                }
            }
        ];

        if (startDateObj && endDateObj) {
            pipeline.push({
                $match: {
                    scheduleDateObj: {
                        $gte: startDateObj,
                        $lte: endDateObj
                    }
                }
            });
        } else if (startDateObj) {
            pipeline.push({
                $match: {
                    scheduleDateObj: {
                        $gte: startDateObj
                    }
                }
            });
        } else if (endDateObj) {
            pipeline.push({
                $match: {
                    scheduleDateObj: {
                        $lte: endDateObj
                    }
                }
            });
        }

        if (cityName) {
            pipeline.push({
                $match: {
                    "itemDetails.city": cityName
                }
            });
        }

        if (customerName) {
            pipeline.push({
                $match: {
                    "customerDetails.name": {
                        $regex: customerName,
                        $options: 'i'
                    }
                }
            });
        }

        if (mobileNumber) {
            pipeline.push({
                $match: {
                    "customerDetails.mobile": {
                        $regex: mobileNumber,
                        $options: 'i'
                    }
                }
            });
        }

        if (status) {
            pipeline.push({
                $match: {
                    status: status
                }
            });
        }

        if (orderId && orderId.trim() !== '') {
            pipeline.push({
                $match: {
                    order_id: {
                        $regex: orderId,
                        $options: 'i'
                    }
                }
            });
        }

        if (organisation) {
            pipeline.push({
                $match: {
                    "customerDetails.organisation": {
                        $regex: organisation,
                        $options: 'i'
                    }
                }
            });
        }

        if (scheduledate) {
            pipeline.push({
                $match: {
                    "schedule_date": scheduledate
                }
            });
        }

        if (agent) {
            pipeline.push({
                $match: {
                    trimmedAgentName: agent.trim()
                }
            });
        }

        const countPipeline = [...pipeline];

        // Add sorting to both pipelines
        pipeline.push(
            {
                $sort: { scheduleDateObj: 1, _id: 1 }
            }
        );

        // Apply pagination only if the offset is provided
        if (page) {
            pipeline.push(
                {
                    $skip: offset
                },
                {
                    $limit: limit
                }
            );
        } else {
            // Remove limit if no offset is provided
            limit = 0;
        }

        pipeline.push(
            {
                $project: {
                    "customer_name": { $ifNull: [{ $arrayElemAt: ["$customerDetails.name", 0] }, "N/A"] },
                    "customer_mobile": { $ifNull: [{ $arrayElemAt: ["$customerDetails.mobile", 0] }, "N/A"] },
                    "organisation": { $ifNull: [{ $arrayElemAt: ["$customerDetails.organisation", 0] }, "N/A"] },
                    "agent_name": { $ifNull: ["$agentDetails.name", "Not Assigned"] },
                    "location": { $ifNull: [{ $arrayElemAt: ["$address.location", 0] }, "N/A"] },
                    "landmark": { $ifNull: [{ $arrayElemAt: ["$address.landmark", 0] }, "N/A"] },
                    order_id: 1,
                    "city": { $ifNull: [{ $arrayElemAt: ["$itemDetails.city", 0] }, "N/A"] },
                    schedule_date: 1,
                    status: 1
                }
            },
        );

        const [dataResult, countResult] = await Promise.all([
            Orders.aggregate(pipeline),
            Orders.aggregate(countPipeline).count("count"),
        ]);

        const totalCount = countResult.length > 0 ? countResult[0].count : 0;

        res.json({
            isSuccess: true,
            message: "Order History",
            data: dataResult,
            count: totalCount,
        });
    } catch (error) {
        console.log(error);
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
};





export const ordHistoryCust = async (req, res) => {
    let limit = 6; // Default limit
    let offset = req.query.offset; // Default offset

        // if (offset > 0) {
        //     limit = limit * (offset + 1); // Update limit based on offset
        // }

        const pipeline = [
            {
                $match: {
                    customer_id: new mongoose.Types.ObjectId(req.params.custid)
                }
            },
            {
                $lookup: {
                    from: "customers",
                    localField: "customer_id",
                    foreignField: "_id",
                    as: "customerDetails"
                }
            },
            {
                $lookup: {
                    from: "items",
                    localField: "item.itemid",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $group: {
                    _id: "$_id",
                    customer_id: { $first: "$customer_id" },
                    customer_name: {
                        $first: {
                            $let: {
                                vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                in: "$$firstCustomer.name"
                            }
                        }
                    },
                    address_id: { $first: "$address_id" },
                    est_price: { $first: "$est_price" },
                    order_id: { $first: "$order_id" },
                    schedule_date: { $first: "$schedule_date" },
                    status: { $first: "$status" },
                    isDelete: { $first: "$isDelete" },
                    item: { $push: "$item" },
                    itemDetails: { $push: "$itemDetails" },
                    createdAt: { $first: "$createdAt" },
                }
            },
            {
                $sort: {
                    createdAt: -1 // 1 for ascending order, -1 for descending order
                }
            },
            {
                $skip: offset * limit // Skip documents based on offset
            },
            {
                $limit: limit // Limit documents
            }
        ];

        const result = await Orders.aggregate(pipeline);

        if (result) {
            res.json({
                isSuccess: true,
                message: "Order History",
                data: result
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
}




// GetOrderById => order detail by _id from order table
export const orderHistById = async (req, res) => {

    // console.log(getord);
    // const pipeline = [
    //     // First, match the order by _id
    //     {
    //         $match: {
    //             _id: new mongoose.Types.ObjectId(req.params.orderid)
    //         }
    //     },
    //     // Then, unwind the 'item' array to prepare for the join
    //     // {
    //     //     $unwind: "$item"
    //     // },
    //     // Next, perform a $lookup to join with the 'items' collection
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "itemDetails"
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "users",
    //             localField: "agent_id",
    //             foreignField: "_id",
    //             as: "agent"
    //         }
    //     },
    //     // Unwind the result of the $lookup to get individual item details
    //     // {
    //     //     $unwind: "$itemDetails"
    //     // },
    //     // Finally, group the data as needed
    //     // {
    //     //     $group: {
    //     //         _id: "$_id", // Group by the order's _id
    //     //         order: { $first: "$$ROOT" }, // Keep the entire order document
    //     //         items: { $push: "$itemDetails" } // Push the item details into an 'items' array
    //     //     }
    //     // }
    //     {
    //         $group: {
    //             _id: "$_id",
    //             customer_id: { $first: "$customer_id" },
    //             address_id: { $first: "$address_id" },
    //             est_price: { $first: "$est_price" },
    //             order_id: { $first: "$order_id" },
    //             schedule_date: { $first: "$schedule_date" },
    //             status: { $first: "$status" },
    //             isDelete: { $first: "$isDelete" },
    //             createdAt: { $first: "$createdAt" },
    //             // item: { $push: "$item" },
    //             item: {
    //                 $push: {
    //                     itemid: "$item.itemid",
    //                     weight: "$item.weight",
    //                     item_name: { $arrayElemAt: ["$itemDetails.item_name", 0] },
    //                     price: { $arrayElemAt: ["$itemDetails.price", 0] },
    //                     // _id: "$item._id",
    //                     total: 0
    //                 }
    //             },
    //             // itemDetails: { $push: "$itemDetails" },
    //             agent: { $first: "$agent" }
    //             // order: { $first: "$$ROOT" },
    //             // items: { $push: "$itemDetails" }
    //         }
    //     }
    // ];



    const pipeline = [
        {
            $match: {
                _id: new mongoose.Types.ObjectId(req.params.orderid)
            }
        },
        {
            $unwind: "$item" // Unwind the "item" array
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "itemDetails"
            }
        },
        {
            $lookup: {
                from: "customers",
                localField: "customer_id",
                foreignField: "_id",
                as: "customerDetails"
            }
        },
        {
            $lookup: {
                from: "addresses",
                localField: "address_id",
                foreignField: "_id",
                as: "addressDetails"
            }
        },
        {
            $lookup: {
                from: "paymentdetails",
                localField: "customer_id",
                foreignField: "customer_id",
                as: "paymentDetails"
            }
        },
        {
            $addFields: {
                filteredPaymentDetails: {
                    $arrayElemAt: [
                        {
                            $filter: {
                                input: "$paymentDetails",
                                as: "paymentDetail",
                                cond: {
                                    $and: [
                                        { $eq: ["$$paymentDetail.mode", "$mode"] }, 
                                        { $eq: ["$$paymentDetail.default", 1] } 
                                    ]
                                }
                            }
                        },
                        0
                    ]
                }
            }
        },
        {
            $addFields: {
                filtereditemDetails: {
                    $arrayElemAt: [
                        {
                            $filter: {
                                input: "$itemDetails",
                                as: "itemDetails",
                                cond: { $eq: ["$$itemDetails._id", "$item.itemid"] }
                            }
                        },
                        0
                    ]
                }
            }
        },
        {
            $lookup: {
                from: "donations",
                let: { orderId: "$_id", mode: "$mode" },
                pipeline: [
                    {
                        $match: {
                            $expr: {
                                $and: [
                                    { $eq: ["$orderId", "$$orderId"] },
                                    { $eq: ["$$mode", "Donation"] }
                                ]
                            }
                        }
                    }
                ],
                as: "donationDetails"
            }
        },
        {
            $addFields: {
                donationDetails: {
                    $cond: {
                        if: { $eq: ["$mode", "Donation"] },
                        then: { $arrayElemAt: ["$donationDetails", 0] },
                        else: null
                    }
                }
            }
        },
        {
            $lookup: {
                from: "ngos",
                let: { ngoId: "$donationDetails.NGO_id" },
                pipeline: [
                    {
                        $match: {
                            $expr: {
                                $eq: ["$_id", "$$ngoId"]
                            }
                        }
                    }
                ],
                as: "NGODetails"
            }
        },
        {
            $addFields: {
                NGODetails: {
                    $cond: {
                        if: { $eq: ["$mode", "Donation"] },
                        then: { $arrayElemAt: ["$NGODetails", 0] },
                        else: null
                    }
                }
            }
        },
        {
            $group: {
                _id: "$_id",
                customer_id: { $first: "$customer_id" },
                address_id: { $first: "$address_id" },
                customer_name: { $first: { $arrayElemAt: ["$customerDetails.name", 0] } },
                customer_mobile: { $first: { $arrayElemAt: ["$customerDetails.mobile", 0] } },
                est_price: { $first: "$est_price" },
                order_id: { $first: "$order_id" },
                schedule_date: { $first: "$schedule_date" },
                status: { $first: "$status" },
                isDelete: { $first: "$isDelete" },
                createdAt: { $first: "$createdAt" },
                agent_id: { $first: "$agent_id" },
                item: {
                    $push: {
                        itemid: "$item.itemid",
                        weight: "$item.weight",
                        item_name: "$item.item_name",
                        price: "$item.price",
                        total: "$item.total",
                        itemLang: "$itemDetails.itemLang",
                        unit: { $arrayElemAt: ["$itemDetails.unit", 0] }
                    }
                },
                time: { $first: "$time" },
                mode: { $first: "$mode" },
                pout: { $first: "$pout" },
                notes: { $first: "$notes" },
                settlement_date: { $first: "$settlement_date" },
                transactionId: { $first: "$transctionId" },
                payment: { $first: "$filteredPaymentDetails" },
                reason: { $first: "$reason" },
                donation: { $first: "$donationDetails" },
                NGO: { $first: "$NGODetails" },
                recursive_ord: { $first: "$recursive_ord" },
                payment_settlement: { $first: "$payment_settlement" },
                scheduleDateForLastOrder: { $first: "$scheduleDateForLastOrder" },
                pickupday: { $first: "$pickupday" },
            }
        },
        {
            $sort: {
                "updatedAt": 1
            }
        },
    ];






    const result = await Orders.aggregate(pipeline);
    // console.log(result);
    Orders.findOne({ _id: req.params.orderid, }).then(async (getord) => {
        if (getord && result) {
            const add = await Address.findOne({ _id: getord.address_id })
            const cust = await Customers.findOne({ _id: getord.customer_id })
            const Agent = await Users.findOne({ _id: getord.agent_id })
            // console.log(add, cust);
            if (add && cust && !Agent) {
                var getIndOrd = {
                    "result": result,
                    // "item": getord.item,
                    "city": add.city,
                    "state": add.state,
                    "pin": add.PIN,
                    "name": cust.name,
                    "mobile": cust.mobile,
                    "email": cust.email,
                    "location": add.location,
                    "landmark": add.landmark,
                    // "Agent_mobile": Agent.mobile,
                    // "Agent_email": Agent.email,
                    // "Agent_name": Agent.name,
                }
                if (getIndOrd) {
                    return res.send({
                        isSuccess: true,
                        message: "Individual Order History",
                        data: getIndOrd
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong.",
                    });
                }

            } else if (add && cust && Agent) {
                var getIndOrd = {
                    "result": result,
                    // "item": getord.item,
                    "city": add.city,
                    "state": add.state,
                    "pin": add.PIN,
                    "name": cust.name,
                    "mobile": cust.mobile,
                    "email": cust.email,
                    "location": add.location,
                    "landmark": add.landmark,
                    "Agent_mobile": Agent.mobile,
                    "Agent_email": Agent.email,
                    "Agent_name": Agent.name,
                }
                if (getIndOrd) {
                    return res.send({
                        isSuccess: true,
                        message: "Individual Order History",
                        data: getIndOrd
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: "Something went wrong.",
                    });
                }
            }
            else {
                return res.send({
                    isSuccess: false,
                    message: "Either Customer or address id or Agent id will not exist.",
                });
            }
        }
    })
}




// Get All agent by admin
export const getAllAgent = async (req, res) => {
    const getAgent = await Users.find({ usertype: "agent", isActive: true, isDelete: false }, '-image')
    console.log(getAgent);
    if (getAgent) {
        return res.send({
            isSuccess: true,
            message: "Get All Agents",
            data: getAgent
        });

    } else {
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
}





// get agent order details
// export const getAgentDetails = async (req, res) => {
//     // const pipeline = [
//     //     {
//     //         $match: {
//     //             _id: new mongoose.Types.ObjectId(req.params.orderid)
//     //         }
//     //     },
//     //     {
//     //         $lookup: {
//     //             from: "items",
//     //             localField: "item.itemid",
//     //             foreignField: "_id",
//     //             as: "itemDetails"
//     //         }
//     //     },
//     //     {
//     //         $lookup: {
//     //             from: "users",
//     //             localField: "agent_id",
//     //             foreignField: "_id",
//     //             as: "agent"
//     //         }
//     //     },
//     //     {
//     //         $group: {
//     //             _id: "$_id",
//     //             customer_id: { $first: "$customer_id" },
//     //             address_id: { $first: "$address_id" },
//     //             est_price: { $first: "$est_price" },
//     //             order_id: { $first: "$order_id" },
//     //             schedule_date: { $first: "$schedule_date" },
//     //             status: { $first: "$status" },
//     //             isDelete: { $first: "$isDelete" },
//     //             createdAt: { $first: "$createdAt" },
//     //             item: { $push: "$item" },
//     //             itemDetails: { $push: "$itemDetails" },
//     //             agent: { $first: "$agent" }
//     //             // order: { $first: "$$ROOT" },
//     //             // items: { $push: "$itemDetails" }
//     //         }
//     //     }
//     // ];


//     const auth = {
//         username: apiKey,
//         password: apiSecret,
//     }
//     const response = await axios.get(`https://api.razorpay.com/v1/transactions?account_number=${process.env.ACC_NO}&count=1`, {
//             headers: {
//                 'Content-Type': 'application/json',
//             },
//             auth: auth,
//         })

//     var main_bal = response.data.items[0].balance
//     console.log(response.data.items[0].balance);


//     try {
//         const pipeline = [
//             {
//                 $match: {
//                     _id: new mongoose.Types.ObjectId(req.params.orderid)
//                 }
//             },
//             {
//                 $unwind: "$item" // Unwind the "item" array
//             },
//             {
//                 $lookup: {
//                     from: "items",
//                     localField: "item.itemid",
//                     foreignField: "_id",
//                     as: "itemDetails"
//                 }
//             },
//             {
//                 $lookup: {
//                     from: "customers",
//                     localField: "customer_id",
//                     foreignField: "_id",
//                     as: "customerDetails"
//                 }
//             },
//             {
//                 $lookup: {
//                     from: "paymentdetails",
//                     localField: "customer_id",
//                     foreignField: "customer_id",
//                     as: "paymentDetails"
//                 }
//             },
//             {
//                 $lookup: {
//                     from: "addresses",
//                     localField: "address_id",
//                     foreignField: "_id",
//                     as: "addressDetails"
//                 }
//             },

//             // filter by payment _id
//             // {
//             //     $addFields: {
//             //         filteredPaymentDetails: {
//             //             $arrayElemAt: [
//             //                 {
//             //                     $filter: {
//             //                         input: "$paymentDetails",
//             //                         as: "paymentDetail",
//             //                         cond: { $eq: ["$$paymentDetail._id", "$payment_id"] }
//             //                     }
//             //                 },
//             //                 0
//             //             ]
//             //         }
//             //     }
//             // },

//             // filter by mode
//             {
//                 $addFields: {
//                     filteredPaymentDetails: {
//                         $arrayElemAt: [
//                             {
//                                 $filter: {
//                                     input: "$paymentDetails",
//                                     as: "paymentDetail",
//                                     cond: { $eq: ["$$paymentDetail.mode", "$mode"] }
//                                 }
//                             },
//                             0
//                         ]
//                     }
//                 }
//             },
//             {
//                 $addFields: {
//                     filtereditemDetails: {
//                         $arrayElemAt: [
//                             {
//                                 $filter: {
//                                     input: "$itemDetails",
//                                     as: "itemDetails",
//                                     cond: { $eq: ["$$itemDetails._id", "$item.itemid"] }
//                                 }
//                             },
//                             0
//                         ]
//                     }
//                 }
//             },
//             {
//                 $group: {
//                     _id: "$_id",
//                     customer_id: { $first: "$customer_id" },
//                     address_id: { $first: "$address_id" },
//                     address: { $first: "$addressDetails" },
//                     customer_name: { $first: { $arrayElemAt: ["$customerDetails.name", 0] } },
//                     customer_mobile: { $first: { $arrayElemAt: ["$customerDetails.mobile", 0] } },
//                     est_price: { $first: "$est_price" },
//                     order_id: { $first: "$order_id" },
//                     schedule_date: { $first: "$schedule_date" },
//                     time: { $first: "$time" },
//                     status: { $first: "$status" },
//                     isDelete: { $first: "$isDelete" },
//                     createdAt: { $first: "$createdAt" },
//                     agent: { $first: "$agent_id" },
//                     item: {
//                         $push: {
//                             itemid: "$item.itemid",
//                             weight: "$item.weight",
//                             item_name: "$item.item_name",
//                             price: "$item.price",
//                             // _id: "$item._id",
//                             total: "$item.total",
//                             unit: { $arrayElemAt: ["$itemDetails.unit", 0] }

//                         }
//                     },
//                     paymentOptions: { $first: "$paymentDetails" },
//                     mode: { $first: "$mode" },
//                     // payment_id: { $first: "$payment_id" },
//                     paymentDetails: { $first: "$filteredPaymentDetails" },
//                     main_balance: { $first: main_bal / 100 },
//                     // final_est_price: 0
//                 }
//             },
//             {
//                 $sort: {
//                     "updatedAt": 1
//                 }
//             },
//         ];



//         const result = await Orders.aggregate(pipeline);
//         console.log(result);
//         if (result) {
//             return res.send({
//                 isSuccess: true,
//                 message: "Get Agent Order Details",
//                 data: result
//                 // data: [
//                 //     {
//                 //       _id: result[0]._id,
//                 //       customer_id: result[0].customer_id,
//                 //       address_id: result[0].address_id,
//                 //       address: result[0].addressDetails,
//                 //       customer_name: result[0].customer_name,
//                 //       customer_mobile: result[0].customer_mobile,
//                 //       est_price: result[0].est_price,
//                 //       order_id: result[0].order_id,
//                 //       schedule_date: result[0].schedule_date,
//                 //       status: result[0].status,
//                 //       isDelete: result[0].isDelete,
//                 //       createdAt: result[0].createdAt,
//                 //       agent: result[0].agent,
//                 //       item: result[0].item.map((item) => {
//                 //         return {
//                 //           itemid: item.itemid,
//                 //           weight: item.weight,
//                 //           item_name: item.itemDetails[0] ? item.itemDetails[0].item_name : null,
//                 //           price: item.itemDetails[0] ? item.itemDetails[0].price : null,
//                 //           total: item.weight * (item.itemDetails[0] ? item.itemDetails[0].price : 0),
//                 //           _id: item._id
//                 //         };
//                 //       }),
//                 //       mode: result[0].mode,
//                 //       paymentDetails: result[0].paymentDetails
//                 //     }
//                 //   ]
//             });

//         } else {
//             return res.send({
//                 isSuccess: false,
//                 message: "Something went wrong.",
//             });
//         }
//     } catch {
//         return res.send({
//             isSuccess: false,
//             message: "Something went wrong.",
//         });
//     }

// }



export const getAgentDetails = async (req, res) => {
    // const pipeline = [
    //     {
    //         $match: {
    //             _id: new mongoose.Types.ObjectId(req.params.orderid)
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "items",
    //             localField: "item.itemid",
    //             foreignField: "_id",
    //             as: "itemDetails"
    //         }
    //     },
    //     {
    //         $lookup: {
    //             from: "users",
    //             localField: "agent_id",
    //             foreignField: "_id",
    //             as: "agent"
    //         }
    //     },
    //     {
    //         $group: {
    //             _id: "$_id",
    //             customer_id: { $first: "$customer_id" },
    //             address_id: { $first: "$address_id" },
    //             est_price: { $first: "$est_price" },
    //             order_id: { $first: "$order_id" },
    //             schedule_date: { $first: "$schedule_date" },
    //             status: { $first: "$status" },
    //             isDelete: { $first: "$isDelete" },
    //             createdAt: { $first: "$createdAt" },
    //             item: { $push: "$item" },
    //             itemDetails: { $push: "$itemDetails" },
    //             agent: { $first: "$agent" }
    //             // order: { $first: "$$ROOT" },
    //             // items: { $push: "$itemDetails" }
    //         }
    //     }
    // ];


    const auth = {
        username: apiKey,
        password: apiSecret,
    }
    const response = await axios.get(`https://api.razorpay.com/v1/transactions?account_number=${process.env.ACC_NO}&count=1`, {
        headers: {
            'Content-Type': 'application/json',
        },
        auth: auth,
    })

    var main_bal = response.data.items[0].balance
    console.log(response.data.items[0].balance);



    const mode = await Orders.find({ _id: new ObjectId(req.params.orderid) })
    // console.log(mode[0].mode != "Donation");
    console.log(mode);
    
    const orderCount = await Orders.find({ customer_id: new ObjectId(mode[0].customer_id),status: { $in: ["processed", "Pickup Completed"] }}).count();
    console.log('orderCount', orderCount);
    const custCheck = await Customers.find({ _id: new ObjectId(mode[0].customer_id) })
    console.log("custCheck", custCheck);
    let getPaymentAct = await Users.find({ usertype: "admin", isActive: true, isDelete: false })
    console.log("getPaymentAct", getPaymentAct);
    
    try {
        console.log("mode[0]", mode[0]);
        
        if (mode[0].mode != "Donation" && mode[0].mode != "Cash" && mode[0].mode != "Eco") {
            const pipeline = [
                {
                    $match: {
                        _id: new mongoose.Types.ObjectId(req.params.orderid)
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "paymentdetails",
                        localField: "customer_id",
                        foreignField: "customer_id",
                        as: "paymentDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $addFields: {
                        filteredPaymentDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$paymentDetails",
                                        as: "paymentDetail",
                                        cond: {
                                            $and: [
                                                { $eq: ["$$paymentDetail.mode", "$mode"] },
                                                { $eq: ["$$paymentDetail.default", 1] }
                                            ]
                                        }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $addFields: {
                        filtereditemDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$itemDetails",
                                        as: "itemDetails",
                                        cond: { $eq: ["$$itemDetails._id", "$item.itemid"] }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address_id: { $first: "$address_id" },
                        address: { $first: "$addressDetails" },
                        customer_name: { $first: { $arrayElemAt: ["$customerDetails.name", 0] } },
                        business_reg: { $first: { $arrayElemAt: ["$customerDetails.business_reg", 0] } },
                        // customer: { $first: { $arrayElemAt: ["$customerDetails", 0] } },
                        customer_mobile: { $first: { $arrayElemAt: ["$customerDetails.mobile", 0] } },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        time: { $first: "$time" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        createdAt: { $first: "$createdAt" },
                        agent: { $first: "$agent_id" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: "$item.item_name",
                                price: "$item.price",
                                total: "$item.total",
                                unit: { $arrayElemAt: ["$itemDetails.unit", 0] }
                            }
                        },
                        paymentOptions: { $first: "$paymentDetails" },
                        // paymentOptions: { $first: "$filteredPaymentDetails" },
                        mode: { $first: "$mode" },
                        payment_settlement: { $first: "$payment_settlement" },
                        pickupday: { $first: "$pickupday" },
                        paymentDetails: { $first: "$filteredPaymentDetails" },
                        main_balance: { $first: main_bal / 100 },
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                },
            ];
            
            
            const result = await Orders.aggregate(pipeline);
        console.log(result);
        if (result) {
            if (orderCount > 2 && mode[0].mode != "Eco" ){
                console.log("mode[0].payment_settlement", mode[0].payment_settlement);

                if (result[0].payment_settlement || result[0].payment_settlement == 0 ) {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive : false, payProcessedByAdmin : true,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
                
                // if (mode[0].payment_settlement == 0) {
                //     return res.send({
                //         isSuccess: true,
                //         message: "Get Agent Order Details",
                //         data: result,
                //         payThroughAdmin: true,
                //         payProcessedByAdmin: true,
                //     })
                // } else {
                //     return res.send({
                //         isSuccess: true,
                //         message: "Get Agent Order Details",
                //         data: result,
                //         payThroughAdmin: true,
                //         payProcessedByAdmin: false,
                //         recursive: false,
                //     })
                // }
                
            }
            else if (orderCount <= 2 && mode[0].mode != "Eco"){
                console.log("mode[0].payment_settlement", mode[0].payment_settlement);
                
                if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: false,
                        recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: false,
                        recursive : false, payProcessedByAdmin : false,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
                
            }
            else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        recursive : result[0].payment_settlement? true : false, 
                        payProcessedByAdmin :false
                    })
                }
            // else if (result[0].payment_settlement || result[0].payment_settlement == 0) {
            //     return res.send({
            //         isSuccess: true,
            //         message: "Get Agent Order Details",
            //         data: result,
            //         payThroughAdmin: true,
            //         recursive : true, 
            //         payProcessedByAdmin :false , 
            //         payment_settlement : "0"
            //     })
            // }
            // else {
            //     return res.send({
            //         isSuccess: true,
            //         message: "Get Agent Order Details",
            //         data: result,
            //         recursive : false, 
            //         payProcessedByAdmin :false
            //     })
            // }
            // return res.send({
            //     isSuccess: true,
            //     message: "Get Agent Order Details",
            //     data: result,
            //     // data: [
            //     //     {
            //     //       _id: result[0]._id,
            //     //       customer_id: result[0].customer_id,
            //     //       address_id: result[0].address_id,
            //     //       address: result[0].addressDetails,
            //     //       customer_name: result[0].customer_name,
            //     //       customer_mobile: result[0].customer_mobile,
            //     //       est_price: result[0].est_price,
            //     //       order_id: result[0].order_id,
            //     //       schedule_date: result[0].schedule_date,
            //     //       status: result[0].status,
            //     //       isDelete: result[0].isDelete,
            //     //       createdAt: result[0].createdAt,
            //     //       agent: result[0].agent,
            //     //       item: result[0].item.map((item) => {
            //     //         return {
            //     //           itemid: item.itemid,
            //     //           weight: item.weight,
            //     //           item_name: item.itemDetails[0] ? item.itemDetails[0].item_name : null,
            //     //           price: item.itemDetails[0] ? item.itemDetails[0].price : null,
            //     //           total: item.weight * (item.itemDetails[0] ? item.itemDetails[0].price : 0),
            //     //           _id: item._id
            //     //         };
            //     //       }),
            //     //       mode: result[0].mode,
            //     //       paymentDetails: result[0].paymentDetails
            //     //     }
            //     //   ]
            // });

        } else {
            return res.send({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
        }
        else if (mode[0].mode == "Eco") {
            const pipeline = [
                {
                    $match: {
                        _id: new mongoose.Types.ObjectId(req.params.orderid)
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "paymentdetails",
                        localField: "customer_id",
                        foreignField: "customer_id",
                        as: "paymentDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $addFields: {
                        filteredPaymentDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$paymentDetails",
                                        as: "paymentDetail",
                                        cond: {
                                            $and: [
                                                { $eq: ["$$paymentDetail.mode", "$mode"] },
                                                { $eq: ["$$paymentDetail.default", 1] }
                                            ]
                                        }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $addFields: {
                        filtereditemDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$itemDetails",
                                        as: "itemDetails",
                                        cond: { $eq: ["$$itemDetails._id", "$item.itemid"] }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address_id: { $first: "$address_id" },
                        address: { $first: "$addressDetails" },
                        customer_name: { $first: { $arrayElemAt: ["$customerDetails.name", 0] } },
                        business_reg: { $first: { $arrayElemAt: ["$customerDetails.business_reg", 0] } },
                        // customer: { $first: { $arrayElemAt: ["$customerDetails", 0] } },
                        customer_mobile: { $first: { $arrayElemAt: ["$customerDetails.mobile", 0] } },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        time: { $first: "$time" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        createdAt: { $first: "$createdAt" },
                        agent: { $first: "$agent_id" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: "$item.item_name",
                                price: "$item.price",
                                total: "$item.total",
                                unit: { $arrayElemAt: ["$itemDetails.unit", 0] }
                            }
                        },
                        paymentOptions: { $first: "$paymentDetails" },
                        // paymentOptions: { $first: "$filteredPaymentDetails" },
                        mode: { $first: "$mode" },
                        payment_settlement: { $first: "$payment_settlement" },
                        pickupday: { $first: "$pickupday" },
                        paymentDetails: { $first: "$filteredPaymentDetails" },
                        main_balance: { $first: main_bal / 100 },
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                },
            ];
            
            
            const result = await Orders.aggregate(pipeline);
        console.log(result);
        if (result) {
            if (orderCount > 1 && mode[0].mode == "Eco" && custCheck[0].business_reg == true) {
                if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive : false, payProcessedByAdmin : true,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }

            } 
            else if (orderCount <= 1 && mode[0].mode != "Eco" && custCheck[0].business_reg == true){
                console.log("mode[0].payment_settlement", mode[0].payment_settlement);
                
                if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: false,
                        recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: false,
                        recursive : false, payProcessedByAdmin : true,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
                
            }
            else if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                return res.send({
                    isSuccess: true,
                    message: "Get Agent Order Details",
                    data: result,
                    payThroughAdmin: true,
                    recursive : true, 
                    payProcessedByAdmin :false , 
                    payment_settlement : "0",
                    getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                })
            }
            else {
                return res.send({
                    isSuccess: true,
                    message: "Get Agent Order Details",
                    data: result,
                    recursive : false, 
                    payProcessedByAdmin :false,
                    getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                })
            }

            
            // return res.send({
            //     isSuccess: true,
            //     message: "Get Agent Order Details",
            //     data: result,
            //     // data: [
            //     //     {
            //     //       _id: result[0]._id,
            //     //       customer_id: result[0].customer_id,
            //     //       address_id: result[0].address_id,
            //     //       address: result[0].addressDetails,
            //     //       customer_name: result[0].customer_name,
            //     //       customer_mobile: result[0].customer_mobile,
            //     //       est_price: result[0].est_price,
            //     //       order_id: result[0].order_id,
            //     //       schedule_date: result[0].schedule_date,
            //     //       status: result[0].status,
            //     //       isDelete: result[0].isDelete,
            //     //       createdAt: result[0].createdAt,
            //     //       agent: result[0].agent,
            //     //       item: result[0].item.map((item) => {
            //     //         return {
            //     //           itemid: item.itemid,
            //     //           weight: item.weight,
            //     //           item_name: item.itemDetails[0] ? item.itemDetails[0].item_name : null,
            //     //           price: item.itemDetails[0] ? item.itemDetails[0].price : null,
            //     //           total: item.weight * (item.itemDetails[0] ? item.itemDetails[0].price : 0),
            //     //           _id: item._id
            //     //         };
            //     //       }),
            //     //       mode: result[0].mode,
            //     //       paymentDetails: result[0].paymentDetails
            //     //     }
            //     //   ]
            // });

        } else {
            return res.send({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
        }   
        else if (mode[0].mode == "Donation") {
            const pipeline = [
                {
                    $match: {
                        _id: new mongoose.Types.ObjectId(req.params.orderid)
                    }
                },
                {
                    $unwind: "$item" // Unwind the "item" array
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $lookup: {
                        from: "donations",
                        localField: "_id",
                        foreignField: "orderId",
                        as: "donationDetails"
                    }
                },
                {
                    $unwind: "$donationDetails"
                },
                {
                    $lookup: {
                        from: "paymentdetails",
                        localField: "donationDetails.NGO_id",
                        foreignField: "customer_id",
                        as: "paymentDetails"
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $addFields: {
                        filteredPaymentDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$paymentDetails",
                                        as: "paymentDetail",
                                        cond: {
                                            $and: [
                                                { $eq: ["$$paymentDetail.mode", "$mode"] },
                                                { $eq: ["$$paymentDetail.default", 1] }
                                            ]
                                        }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $addFields: {
                        filtereditemDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$itemDetails",
                                        as: "itemDetails",
                                        cond: { $eq: ["$$itemDetails._id", "$item.itemid"] }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address_id: { $first: "$address_id" },
                        address: { $first: "$addressDetails" },
                        customer_name: { $first: { $arrayElemAt: ["$customerDetails.name", 0] } },
                        customer_mobile: { $first: { $arrayElemAt: ["$customerDetails.mobile", 0] } },
                        business_reg: { $first: { $arrayElemAt: ["$customerDetails.business_reg", 0] } },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        time: { $first: "$time" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        createdAt: { $first: "$createdAt" },
                        agent: { $first: "$agent_id" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: "$item.item_name",
                                price: "$item.price",
                                total: "$item.total",
                                unit: { $arrayElemAt: ["$itemDetails.unit", 0] }
                            }
                        },
                        paymentOptions: { $first: null },
                        paymentDetails: { $first: { $arrayElemAt: ["$paymentDetails", 0] } }, // Convert to an object
                        mode: { $first: "$mode" },
                        payment_settlement: { $first: "$payment_settlement" },
                        pickupday: { $first: "$pickupday" },
                        main_balance: { $first: main_bal / 100 }
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                }
            ];
            
            
            
            
            const result = await Orders.aggregate(pipeline);
        console.log(result);
        if (result) {
            if (orderCount > 1 && mode[0].mode == "Donation" && custCheck[0].business_reg == true){
                if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive : false, payProcessedByAdmin : true,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
            } 
            else if (orderCount <= 1 && mode[0].mode == "Donation" && custCheck[0].business_reg == true){
                console.log("mode[0].payment_settlement", mode[0].payment_settlement);
                
                if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: false,
                        recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                } else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: false,
                        recursive : false, payProcessedByAdmin : true,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
                
            }
            else if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                return res.send({
                    isSuccess: true,
                    message: "Get Agent Order Details",
                    data: result,
                    payThroughAdmin: true,
                    recursive : true, 
                    payProcessedByAdmin :false , 
                    payment_settlement : "0",
                    getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                })
            }
            else {
                return res.send({
                    isSuccess: true,
                    message: "Get Agent Order Details",
                    data: result,
                    recursive : false, 
                    payProcessedByAdmin :false,
                    getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                })
            }
            // return res.send({
            //     isSuccess: true,
            //     message: "Get Agent Order Details",
            //     data: result
            //     // data: [
            //     //     {
            //     //       _id: result[0]._id,
            //     //       customer_id: result[0].customer_id,
            //     //       address_id: result[0].address_id,
            //     //       address: result[0].addressDetails,
            //     //       customer_name: result[0].customer_name,
            //     //       customer_mobile: result[0].customer_mobile,
            //     //       est_price: result[0].est_price,
            //     //       order_id: result[0].order_id,
            //     //       schedule_date: result[0].schedule_date,
            //     //       status: result[0].status,
            //     //       isDelete: result[0].isDelete,
            //     //       createdAt: result[0].createdAt,
            //     //       agent: result[0].agent,
            //     //       item: result[0].item.map((item) => {
            //     //         return {
            //     //           itemid: item.itemid,
            //     //           weight: item.weight,
            //     //           item_name: item.itemDetails[0] ? item.itemDetails[0].item_name : null,
            //     //           price: item.itemDetails[0] ? item.itemDetails[0].price : null,
            //     //           total: item.weight * (item.itemDetails[0] ? item.itemDetails[0].price : 0),
            //     //           _id: item._id
            //     //         };
            //     //       }),
            //     //       mode: result[0].mode,
            //     //       paymentDetails: result[0].paymentDetails
            //     //     }
            //     //   ]
            // });

        } else {
            return res.send({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
        } else if (mode[0].mode == "Cash") {
            const pipeline = [
                {
                    $match: {
                        _id: new mongoose.Types.ObjectId(req.params.orderid)
                    }
                },
                {
                    $unwind: "$item"
                },
                {
                    $lookup: {
                        from: "items",
                        localField: "item.itemid",
                        foreignField: "_id",
                        as: "itemDetails"
                    }
                },
                {
                    $lookup: {
                        from: "customers",
                        localField: "customer_id",
                        foreignField: "_id",
                        as: "customerDetails"
                    }
                },
                {
                    $lookup: {
                        from: "paymentdetails",
                        localField: "customer_id",
                        foreignField: "customer_id",
                        as: "paymentDetails"
                    }
                },
                {
                    $lookup: {
                        from: "addresses",
                        localField: "address_id",
                        foreignField: "_id",
                        as: "addressDetails"
                    }
                },
                {
                    $addFields: {
                        filteredPaymentDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$paymentDetails",
                                        as: "paymentDetail",
                                        cond: {
                                            $and: [
                                                { $eq: ["$$paymentDetail.mode", "$mode"] },
                                                { $eq: ["$$paymentDetail.default", 1] }
                                            ]
                                        }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $addFields: {
                        filtereditemDetails: {
                            $arrayElemAt: [
                                {
                                    $filter: {
                                        input: "$itemDetails",
                                        as: "itemDetails",
                                        cond: { $eq: ["$$itemDetails._id", "$item.itemid"] }
                                    }
                                },
                                0
                            ]
                        }
                    }
                },
                {
                    $group: {
                        _id: "$_id",
                        customer_id: { $first: "$customer_id" },
                        address_id: { $first: "$address_id" },
                        address: { $first: "$addressDetails" },
                        customer_name: { $first: { $arrayElemAt: ["$customerDetails.name", 0] } },
                        customer_mobile: { $first: { $arrayElemAt: ["$customerDetails.mobile", 0] } },
                        business_reg: { $first: { $arrayElemAt: ["$customerDetails.business_reg", 0] } },
                        // customer: { $first: { $arrayElemAt: ["$customerDetails", 0] } },
                        est_price: { $first: "$est_price" },
                        order_id: { $first: "$order_id" },
                        schedule_date: { $first: "$schedule_date" },
                        time: { $first: "$time" },
                        status: { $first: "$status" },
                        isDelete: { $first: "$isDelete" },
                        createdAt: { $first: "$createdAt" },
                        agent: { $first: "$agent_id" },
                        item: {
                            $push: {
                                itemid: "$item.itemid",
                                weight: "$item.weight",
                                item_name: "$item.item_name",
                                price: "$item.price",
                                total: "$item.total",
                                unit: { $arrayElemAt: ["$itemDetails.unit", 0] }
                            }
                        },
                        paymentOptions: { $first: "$paymentDetails" },
                        // paymentOptions: { $first: "$filteredPaymentDetails" },
                        mode: { $first: "$mode" },
                        payment_settlement: { $first: "$payment_settlement" },
                        pickupday: { $first: "$pickupday" },
                        paymentDetails: { $first: "$filteredPaymentDetails" },
                        main_balance: { $first: main_bal / 100 }
                    }
                },
                {
                    $sort: {
                        "updatedAt": 1
                    }
                }
            ];
            
            const result = await Orders.aggregate(pipeline);
            
            console.log(result);
            console.log("(mode[0].payment_settlement).parseInt > 0 || mode[0].payment_settlement == 0", result[0].payment_settlement);

            if (result) {
                // console.log("orderCount > 1 && mode[0].mode == 'Cash' && custCheck[0].business_reg == true", orderCount > 1 && mode[0].mode == "Cash" && custCheck[0].business_reg == true);
                if (orderCount > 1 && mode[0].mode == "Cash" && custCheck[0].business_reg == true){
                    if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                        return res.send({
                            isSuccess: true,
                            message: "Get Agent Order Details",
                            data: result,
                            payThroughAdmin: true,
                            recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                            getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                        })
                    } else {
                        return res.send({
                            isSuccess: true,
                            message: "Get Agent Order Details",
                            data: result,
                            payThroughAdmin: true,
                            recursive : false, payProcessedByAdmin : true,
                            getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                        })
                    }
                    
                } 
                else if (orderCount <= 1 && mode[0].mode != "Cash" && custCheck[0].business_reg == true){
                    console.log("mode[0].payment_settlement", mode[0].payment_settlement);
                    
                    if (result[0].payment_settlement || result[0].payment_settlement == 0) {
                        return res.send({
                            isSuccess: true,
                            message: "Get Agent Order Details",
                            data: result,
                            payThroughAdmin: false,
                            recursive: true, payProcessedByAdmin : true, payment_settlement : "0",
                            getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                        })
                    } else {
                        return res.send({
                            isSuccess: true,
                            message: "Get Agent Order Details",
                            data: result,
                            payThroughAdmin: false,
                            recursive : false, payProcessedByAdmin : true,
                            getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                        })
                    }
                    
                }
                else if (result[0].payment_settlement || result[0].payment_settlement == 0) {                    
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        payThroughAdmin: true,
                        recursive : true, 
                        payProcessedByAdmin :false , 
                        payment_settlement : "0",
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
                else {
                    return res.send({
                        isSuccess: true,
                        message: "Get Agent Order Details",
                        data: result,
                        recursive : false, 
                        payProcessedByAdmin :false,
                        getPaymentActbyAdm: getPaymentAct[0].paymentStatus
                    })
                }
                // return res.send({
                //     isSuccess: true,
                //     message: "Get Agent Order Details",
                //     data: result
                //     // data: [
                //     //     {
                //     //       _id: result[0]._id,
                //     //       customer_id: result[0].customer_id,
                //     //       address_id: result[0].address_id,
                //     //       address: result[0].addressDetails,
                //     //       customer_name: result[0].customer_name,
                //     //       customer_mobile: result[0].customer_mobile,
                //     //       est_price: result[0].est_price,
                //     //       order_id: result[0].order_id,
                //     //       schedule_date: result[0].schedule_date,
                //     //       status: result[0].status,
                //     //       isDelete: result[0].isDelete,
                //     //       createdAt: result[0].createdAt,
                //     //       agent: result[0].agent,
                //     //       item: result[0].item.map((item) => {
                //     //         return {
                //     //           itemid: item.itemid,
                //     //           weight: item.weight,
                //     //           item_name: item.itemDetails[0] ? item.itemDetails[0].item_name : null,
                //     //           price: item.itemDetails[0] ? item.itemDetails[0].price : null,
                //     //           total: item.weight * (item.itemDetails[0] ? item.itemDetails[0].price : 0),
                //     //           _id: item._id
                //     //         };
                //     //       }),
                //     //       mode: result[0].mode,
                //     //       paymentDetails: result[0].paymentDetails
                //     //     }
                //     //   ]
                // });

            } else {
                return res.send({
                    isSuccess: false,
                    message: "Something went wrong.",
                });
            }
        }
        
    } catch {
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }

}






// "Pickup Completed" status added by Agent
export const pickupSt = async (req, res) => {
    try {
        const getstatus = await Orders.findOne({ _id: req.params.orderid })
        if (getstatus) {
            await Orders.findOneAndUpdate({ _id: req.params.orderid }, {
                $set: {
                    status: 'Pickup Completed',
                    mode: req.body.mode,
                }
            }).then((x) => {
                return res.send({
                    isSuccess: true,
                    message: "Pickup Completed By Agent.",
                });
            })
        }
    } catch {
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
}










// Create Pickup by Agent
export const pickupByAgent = async (req, res) => {
    const today = moment().format('DD-MM-YYYY');
    var futureDate
    const getstatus = await Orders.findOne({ _id: req.params.orderid })
    const Customer = await Customers.findOne({ _id: new ObjectId(getstatus.customer_id) })
    // console.log("customer", Customer.business_reg);


    let count = 0
    const { customer_id, address_id, schedule_date, item, est_price, order_id, status, mode, long, lat } = req.body;
    console.log("eq.body.mode == 'Cash' && Customer.business_reg", Customer, getstatus);

    if (Customer) {
        futureDate = moment().add(parseInt(Customer.pickupday), 'days').format('DD-MM-YYYY');
        console.log('Today:', today);
        console.log('7 days from now:', futureDate);
        if (Customer.business_reg) {
            if (req.body.mode != 'Cash' && Customer.business_reg) {
                try {
                    const OrderID = await Orders.findOne({ _id: req.params.orderid })
                    // if (OrderID) {

                    console.log("response OrderID: ", OrderID);

                    if (OrderID) {
                        console.log("response OrderID: ", OrderID);
                        await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                            $set: {
                                customer_id: customer_id,
                                address_id: address_id,
                                schedule_date: schedule_date,
                                // time: time,
                                item: item,
                                est_price: parseFloat(est_price).toFixed(2),
                                order_id: order_id,
                                agent_id: req.body.agent,
                                // status: status,
                                mode: mode,
                                status: "Pickup Completed",
                                // recursive_ord: false,
                                // pout: response.data.id,
                            }
                        }, { new: true }).then(async (confirmation) => {

                            console.log("confirmation-----------------------------------", confirmation);
                            const indicesToRemove = [];
                            await Promise.all(
                                confirmation.item.map(async (conf_ord, index) => {
                                    if (conf_ord.weight == 0) {
                                        console.log("conf_ord.weight == 0", index);
                                        indicesToRemove.push(index);
                                    }
                                })
                            )

                            indicesToRemove.sort((a, b) => b - a);
                            indicesToRemove.forEach(index => {
                                confirmation.item.splice(index, 1);
                            });
                            if (confirmation) {
                                // console.log("enter x condition block", x);
                                let requestData = {
                                    customer_id: confirmation.customer_id,
                                    address_id: confirmation.address_id,
                                    schedule_date: futureDate,
                                    time: confirmation.time,
                                    item: confirmation.item,
                                    est_price: confirmation.est_price.toFixed(2),
                                    // order_id: x.order_id,
                                    mode: confirmation.mode,
                                    recursive_ord: true,
                                }
                                console.log("requestData", requestData);
                                if (requestData) {
                                    console.log("requestData", requestData);
                                    // await axios.post("https://singada1319api.ceibagreen.com/api/orders/createOrder", requestData, {
                                    // // await axios.post(`https://devapisbot.ceibagreen.com/api/orders/createOrder`, requestData, {
                                    // // await axios.post(`http://localhost:9001/api/orders/createOrder`, requestData, {
                                    //     headers: {
                                    //         'Content-Type': 'application/json',
                                    //     },
                                    // })
                                }
                            }


                            // return res.send({
                            //     isSuccess: true,
                            //     message: "Pickup Completed By Agent.",
                            // });

                            console.log('confirmation', confirmation);
                            for (const x of item) {
                                console.log(x);
                                // const itemDoc = await Items.findOne({ _id: x.itemid });

                                if (x) {
                                    const orderitems = await Orderitems.findOne({ item_id: new mongoose.Types.ObjectId(x.itemid), order_id: new mongoose.Types.ObjectId(req.params.orderid) })
                                    console.log("orderitems : ", orderitems);
                                    if (orderitems) {
                                        await Orderitems.findOneAndUpdate({ order_id: req.params.orderid, item_id: new mongoose.Types.ObjectId(x.itemid) }, {
                                            $set: {
                                                item_weight: x.weight,
                                            }
                                        }).then(async (updtInd) => {
                                            console.log('updtInd', updtInd);
                                            count += 1
                                            console.log(count == item.length);
                                            if (count == item.length) {

                                                // send Notification
                                                const customer = await Customers.findById(confirmation.customer_id);
                                                const condition_name = "Order";
                                                console.log("confirmation.customer_id     ", confirmation.customer_id);
                                                console.log("customer", customer);
                                                const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })

                                                if (customer && customer.token) {
                                                    console.log("Level-1,   customer.token   ", customer.token);

                                                    pushNotification(
                                                        customer.token,
                                                        "Order Picked Up",
                                                        `Your order Id #${confirmation.order_id} has been picked up.`,
                                                        condition_name
                                                    );
                                                } else {
                                                    console.log("customer or token not exists");
                                                }

                                                console.log("message pushed successfully.");

                                                return res.send({
                                                    isSuccess: true,
                                                    message: "Pickup Completed By Agent."
                                                    // order: updtInd
                                                });
                                            }
                                        })
                                    } else {
                                        const itemDoc = await Items.findOne({ _id: x.itemid });
                                        var getadd = await Address.findOne({ _id: address_id })

                                        if (itemDoc) {
                                            const orderitem = await Orderitems.create({
                                                order_id: new mongoose.Types.ObjectId(req.params.orderid),
                                                item_id: itemDoc._id,
                                                item_weight: x.weight,
                                                item_price: parseFloat(itemDoc.price),
                                                city: getadd.city,
                                            });
                                            count += 1
                                            console.log(count == item.length);
                                            if (count == item.length) {

                                                // send Notification
                                                const customer = await Customers.findById(confirmation.customer_id);
                                                const condition_name = "Order";
                                                console.log("confirmation.customer_id     ", confirmation.customer_id);
                                                console.log("customer", customer);
                                                const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })

                                                if (customer && customer.token) {
                                                    console.log("Level-4,   customer.token   ", customer.token);

                                                    pushNotification(
                                                        customer.token,
                                                        "Order Picked Up",
                                                        `Your order Id #${confirmation.order_id} has been picked up.`,
                                                        condition_name
                                                    );
                                                } else {
                                                    console.log("customer or token not exists");
                                                }

                                                console.log("message pushed successfully.");
                                                return res.send({
                                                    isSuccess: true,
                                                    message: "Pickup Completed By Agent."
                                                    // order: updtInd
                                                });
                                            }
                                        }
                                    }


                                }

                            }
                        })
                    } else {
                        res.send({
                            isSuccess: false,
                            message: "Pickup Failed."
                        })
                    }

                    // }
                } catch (error) {

                    // res.send({
                    //     isSuccess: false,
                    //     message: 'An error occurred during the API request.',
                    //     error: error.response.data.error.description
                    // });
                }

            } else if (req.body.mode == 'Cash' && Customer.business_reg) {
                await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        customer_id: customer_id,
                        address_id: address_id,
                        schedule_date: schedule_date,
                        // time: time,
                        item: item,
                        est_price: est_price,
                        order_id: order_id,
                        agent_id: req.body.agent,
                        status: "Pickup Completed",
                        mode: req.body.mode,
                        // recursive_ord: false,
                    }
                }, { new: true }).then(async (confirmation) => {
                    console.log(confirmation, "confirmation.address_id", confirmation.address_id);
                    const indicesToRemove = [];
                    await Promise.all(
                        confirmation.item.map(async (conf_ord, index) => {
                            if (conf_ord.weight == 0) {
                                console.log("conf_ord.weight == 0", index);
                                indicesToRemove.push(index);
                            }
                        })
                    )

                    indicesToRemove.sort((a, b) => b - a);
                    indicesToRemove.forEach(index => {
                        confirmation.item.splice(index, 1);
                    });
                    if (confirmation) {
                        // console.log("enter x condition block", x);
                        let requestData = {
                            customer_id: confirmation.customer_id,
                            address_id: confirmation.address_id,
                            schedule_date: futureDate,
                            time: confirmation.time,
                            item: confirmation.item,
                            est_price: confirmation.est_price.toFixed(2),
                            // order_id: x.order_id,
                            mode: confirmation.mode,
                            recursive_ord: true,
                        }
                        console.log("requestData", requestData);
                        if (requestData) {
                            console.log("requestData", requestData);
                            // await axios.post("https://singada1319api.ceibagreen.com/api/orders/createOrder", requestData, {
                            // // await axios.post(`https://devapisbot.ceibagreen.com/api/orders/createOrder`, requestData, {
                            //     // await axios.post(`http://localhost:9001/api/orders/createOrder`, requestData, {
                            //     headers: {
                            //         'Content-Type': 'application/json',
                            //     },
                            // })
                        }
                    }
                    for (const x of item) {
                        console.log("x", x);
                        // const itemDoc = await Items.findOne({ _id: x.itemid });

                        if (x) {
                            const orderitems = await Orderitems.findOne({ item_id: new mongoose.Types.ObjectId(x.itemid), order_id: new mongoose.Types.ObjectId(req.params.orderid) })
                            console.log("orderitems : ", orderitems);
                            if (orderitems) {
                                await Orderitems.findOneAndUpdate({ order_id: req.params.orderid, item_id: new mongoose.Types.ObjectId(x.itemid) }, {
                                    $set: {
                                        item_weight: x.weight,
                                    }
                                }).then(async (updtInd) => {
                                    console.log('updtInd', updtInd);
                                    count += 1
                                    console.log(count == item.length);
                                    if (count == item.length) {

                                        // send Notification
                                        const customer = await Customers.findById(confirmation.customer_id);
                                        const condition_name = "Order";
                                        console.log("confirmation.customer_id     ", confirmation.customer_id);
                                        console.log("customer1", customer);
                                        const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })
                                        console.log("update address", x);
                                        if (customer && customer.token) {
                                            console.log("Level-2,   customer.token   ", customer.token);

                                            pushNotification(
                                                customer.token,
                                                "Order Picked Up",
                                                `Your order Id #${confirmation.order_id} has been picked up.`,
                                                condition_name
                                            );
                                        } else {
                                            console.log("customer or token not exists");
                                        }

                                        console.log("message pushed successfully.");
                                        return res.send({
                                            isSuccess: true,
                                            message: "Pickup Completed By Agent."
                                            // mode: "Cash",
                                            // message: { "status": "Cash" },
                                            // order: updtInd
                                        });
                                    }
                                })
                            } else {
                                const itemDoc = await Items.findOne({ _id: x.itemid });
                                var getadd = await Address.findOne({ _id: address_id })

                                if (itemDoc) {
                                    const orderitem = await Orderitems.create({
                                        order_id: new mongoose.Types.ObjectId(req.params.orderid),
                                        item_id: itemDoc._id,
                                        item_weight: x.weight,
                                        item_price: parseFloat(itemDoc.price),
                                        city: getadd.city,
                                    });
                                    count += 1
                                    console.log(count == item.length);
                                    if (count == item.length) {

                                        // send Notification
                                        const customer = await Customers.findById(confirmation.customer_id);
                                        const condition_name = "Order";
                                        console.log("confirmation.customer_id     ", confirmation.customer_id);
                                        console.log("customer", customer);
                                        const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })

                                        if (customer && customer.token) {
                                            console.log("Level-4,   customer.token   ", customer.token);

                                            pushNotification(
                                                customer.token,
                                                "Order Picked Up",
                                                `Your order Id #${confirmation.order_id} has been picked up.`,
                                                condition_name
                                            );
                                        } else {
                                            console.log("customer or token not exists");
                                        }
                                        console.log("message pushed successfully.");
                                        return res.send({
                                            isSuccess: true,
                                            message: "Pickup Completed By Agent."
                                            // mode: "Cash",
                                            // message: { "status": "Cash" },
                                            // order: updtInd
                                        });
                                    }
                                }
                            }


                        }

                    }
                    // if (confirmation) {
                    //     return res.send({
                    //         isSuccess: true,
                    //         message: "Create Pick Item.",
                    //     });
                    // } else {
                    //     return res.send({
                    //         isSuccess: false,
                    //         message: "Something went wrong."
                    //     })
                    // }
                })
            }
        }


        else {
            if (req.body.mode != 'Cash') {
                try {
                    const OrderID = await Orders.findOne({ _id: req.params.orderid })
                    // if (OrderID) {

                    console.log("response OrderID: ", OrderID);

                    if (OrderID) {
                        console.log("response OrderID: ", OrderID);
                        await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                            $set: {
                                customer_id: customer_id,
                                address_id: address_id,
                                schedule_date: schedule_date,
                                // time: time,
                                item: item,
                                est_price: parseFloat(est_price).toFixed(2),
                                order_id: order_id,
                                agent_id: req.body.agent,
                                // status: status,
                                mode: mode,
                                status: "Pickup Completed",
                                // pout: response.data.id,
                            }
                        }).then(async (confirmation) => {

                            console.log('confirmation', confirmation);
                            for (const x of item) {
                                console.log(x);
                                // const itemDoc = await Items.findOne({ _id: x.itemid });

                                if (x) {
                                    const orderitems = await Orderitems.findOne({ item_id: new mongoose.Types.ObjectId(x.itemid), order_id: new mongoose.Types.ObjectId(req.params.orderid) })
                                    console.log("orderitems : ", orderitems);
                                    if (orderitems) {
                                        await Orderitems.findOneAndUpdate({ order_id: req.params.orderid, item_id: new mongoose.Types.ObjectId(x.itemid) }, {
                                            $set: {
                                                item_weight: x.weight,
                                            }
                                        }).then(async (updtInd) => {
                                            console.log('updtInd', updtInd);
                                            count += 1
                                            console.log(count == item.length);
                                            if (count == item.length) {

                                                // send Notification
                                                const customer = await Customers.findById(confirmation.customer_id);
                                                const condition_name = "Order";
                                                console.log("confirmation.customer_id     ", confirmation.customer_id);
                                                console.log("customer", customer);
                                                const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })

                                                if (customer && customer.token) {
                                                    console.log("Level-1,   customer.token   ", customer.token);

                                                    pushNotification(
                                                        customer.token,
                                                        "Order Picked Up",
                                                        `Your order Id #${confirmation.order_id} has been picked up.`,
                                                        condition_name
                                                    );
                                                } else {
                                                    console.log("customer or token not exists");
                                                }

                                                console.log("message pushed successfully.");

                                                return res.send({
                                                    isSuccess: true,
                                                    message: "Pickup Completed By Agent."
                                                    // order: updtInd
                                                });
                                            }
                                        })
                                    } else {
                                        const itemDoc = await Items.findOne({ _id: x.itemid });
                                        var getadd = await Address.findOne({ _id: address_id })

                                        if (itemDoc) {
                                            const orderitem = await Orderitems.create({
                                                order_id: new mongoose.Types.ObjectId(req.params.orderid),
                                                item_id: itemDoc._id,
                                                item_weight: x.weight,
                                                item_price: parseFloat(itemDoc.price),
                                                city: getadd.city,
                                            });
                                            count += 1
                                            console.log(count == item.length);
                                            if (count == item.length) {

                                                // send Notification
                                                const customer = await Customers.findById(confirmation.customer_id);
                                                const condition_name = "Order";
                                                console.log("confirmation.customer_id     ", confirmation.customer_id);
                                                console.log("customer", customer);
                                                const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })

                                                if (customer && customer.token) {
                                                    console.log("Level-4,   customer.token   ", customer.token);

                                                    pushNotification(
                                                        customer.token,
                                                        "Order Picked Up",
                                                        `Your order Id #${confirmation.order_id} has been picked up.`,
                                                        condition_name
                                                    );
                                                } else {
                                                    console.log("customer or token not exists");
                                                }

                                                console.log("message pushed successfully.");
                                                return res.send({
                                                    isSuccess: true,
                                                    message: "Pickup Completed By Agent."
                                                    // order: updtInd
                                                });
                                            }
                                        }
                                    }


                                }

                            }
                        })
                    } else {
                        res.send({
                            isSuccess: false,
                            message: "Pickup Failed."
                        })
                    }

                    // }
                } catch (error) {

                    // res.send({
                    //     isSuccess: false,
                    //     message: 'An error occurred during the API request.',
                    //     error: error.response.data.error.description
                    // });
                }

            } else if (req.body.mode == 'Cash') {
                await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        customer_id: customer_id,
                        address_id: address_id,
                        schedule_date: schedule_date,
                        // time: time,
                        item: item,
                        est_price: est_price,
                        order_id: order_id,
                        agent_id: req.body.agent,
                        status: "Pickup Completed",
                        mode: req.body.mode,
                    }
                }).then(async (confirmation) => {
                    console.log(confirmation, "confirmation.address_id", confirmation.address_id);
                    for (const x of item) {
                        console.log(x);
                        // const itemDoc = await Items.findOne({ _id: x.itemid });

                        if (x) {
                            const orderitems = await Orderitems.findOne({ item_id: new mongoose.Types.ObjectId(x.itemid), order_id: new mongoose.Types.ObjectId(req.params.orderid) })
                            console.log("orderitems : ", orderitems);
                            if (orderitems) {
                                await Orderitems.findOneAndUpdate({ order_id: req.params.orderid, item_id: new mongoose.Types.ObjectId(x.itemid) }, {
                                    $set: {
                                        item_weight: x.weight,
                                    }
                                }).then(async (updtInd) => {
                                    console.log('updtInd', updtInd);
                                    count += 1
                                    console.log(count == item.length);
                                    if (count == item.length) {

                                        // send Notification
                                        const customer = await Customers.findById(confirmation.customer_id);
                                        const condition_name = "Order";
                                        console.log("confirmation.customer_id     ", confirmation.customer_id);
                                        console.log("customer1", customer);
                                        const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })
                                        console.log("update address", x);
                                        if (customer && customer.token) {
                                            console.log("Level-2,   customer.token   ", customer.token);

                                            pushNotification(
                                                customer.token,
                                                "Order Picked Up",
                                                `Your order Id #${confirmation.order_id} has been picked up.`,
                                                condition_name
                                            );
                                        } else {
                                            console.log("customer or token not exists");
                                        }

                                        console.log("message pushed successfully.");
                                        return res.send({
                                            isSuccess: true,
                                            message: "Pickup Completed By Agent."
                                            // mode: "Cash",
                                            // message: { "status": "Cash" },
                                            // order: updtInd
                                        });
                                    }
                                })
                            } else {
                                const itemDoc = await Items.findOne({ _id: x.itemid });
                                var getadd = await Address.findOne({ _id: address_id })

                                if (itemDoc) {
                                    const orderitem = await Orderitems.create({
                                        order_id: new mongoose.Types.ObjectId(req.params.orderid),
                                        item_id: itemDoc._id,
                                        item_weight: x.weight,
                                        item_price: parseFloat(itemDoc.price),
                                        city: getadd.city,
                                    });
                                    count += 1
                                    console.log(count == item.length);
                                    if (count == item.length) {

                                        // send Notification
                                        const customer = await Customers.findById(confirmation.customer_id);
                                        const condition_name = "Order";
                                        console.log("confirmation.customer_id     ", confirmation.customer_id);
                                        console.log("customer", customer);
                                        const x = await Address.findOneAndUpdate({ _id: confirmation.address_id }, { $set: { longitude: long, latitude: lat } })

                                        if (customer && customer.token) {
                                            console.log("Level-4,   customer.token   ", customer.token);

                                            pushNotification(
                                                customer.token,
                                                "Order Picked Up",
                                                `Your order Id #${confirmation.order_id} has been picked up.`,
                                                condition_name
                                            );
                                        } else {
                                            console.log("customer or token not exists");
                                        }
                                        console.log("message pushed successfully.");
                                        return res.send({
                                            isSuccess: true,
                                            message: "Pickup Completed By Agent."
                                            // mode: "Cash",
                                            // message: { "status": "Cash" },
                                            // order: updtInd
                                        });
                                    }
                                }
                            }


                        }

                    }
                    // if (confirmation) {
                    //     return res.send({
                    //         isSuccess: true,
                    //         message: "Create Pick Item.",
                    //     });
                    // } else {
                    //     return res.send({
                    //         isSuccess: false,
                    //         message: "Something went wrong."
                    //     })
                    // }
                })
            }
        }
    }








    // const confirmation = await Orders.create({
    //     order_fk: req.body._id,
    //     customer_id: customer_id,
    //     address_id: address_id,
    //     schedule_date: schedule_date,
    //     // time: time,
    //     item: item,
    //     est_price: est_price,
    //     order_id: order_id,
    //     agent_id: req.body.agent,
    // });


}





// Verify Reference code
export const refCode = async (req, res) => {
    await Customers.findOne({ refCode: req.params.refCode, isDelete: false }).then((x) => {
        if (x) {
            return res.json({
                isSuccess: true,
                msg: "Entered refCode was correct."
            })
        } else {
            return res.json({
                isSuccess: false,
                msg: "Please Enter correct reference code."
            })
        }
    })
}






export const refCodeVer = async (req, res) => {
    console.log(req.query.refCode == "");
    await Customers.findOne({ refCode: req.query.refCode }).then((x) => {
        if (x) {
            return res.json({
                isSuccess: true,
                msg: "Entered refCode was correct."
            })
        } else {
            return res.json({
                isSuccess: false,
                msg: "Please Enter correct reference code."
            })
        }
    })
}






// Add referal eco coins
async function referalEcoCoins(mainCustomer, customerId, amount) {
    console.log("enter", mainCustomer, customerId, amount);
    await Customers.findById({ _id: mainCustomer }).then(async (x) => {
        if (x) {
            console.log(x, (x._id).toString());
            const coins = await Coin.findOne({ customer_id: new ObjectId(x._id) });
            console.log('coin', coins);
            if (coins) {
                const updatedCoins = coins.coins + amount;
                const leftCoins = amount + coins.left;
                const earnCoins = amount + coins.earn;

                const updatedCoin = await Coin.findOneAndUpdate(
                    { customer_id: mainCustomer },
                    {
                        $set: {
                            coins: updatedCoins,
                            left: leftCoins,
                            earn: earnCoins,
                            spend: coins.spend,
                            // pout: response.data.id,
                        }
                    },
                    { new: true } // to get the updated document
                );

                // if (updatedCoin) {
                const coinhist = await Coinhist.create({
                    customer_id: mainCustomer,
                    coins: updatedCoins,
                    left: leftCoins,
                    earn: earnCoins,
                    spend: updatedCoin.spend,
                    purpose: `Referal credit from Recycle-Pay.`,
                    credit: amount,
                    debit: 0,
                    order_id: x.order_id,
                    refCust: customerId,
                });

                console.log("coinhist1", updatedCoin);

                // send Notification to Customer
                // const customer = await Customers.findById(x._id);
                // if (customer && customer.token) {
                //     pushNotification(
                //         customer.token,
                //         "Thank You!",
                //         `${customer.name} for your referral to a new member and you have earned 5 Ecopot points which has been credited in your Ecopot wallet.`
                //     );
                // } else {
                //     console.log("customer or token not exists");
                // }

                // send Notification to Agent
                // const agent = await Users.findById(x.agent_id);
                // if (agent && agent.token) {
                //     pushNotification(
                //         agent.token,
                //         "Order Completed",
                //         `Order #${x.order_id} Has Been Completed Successfully!`
                //     );
                // } else {
                //     console.log("agent or token not exists");
                // }

                return ({
                    isSuccess: true,
                    mode: "Eco",
                    message: { status: "processed" },
                    // order: updtInd
                });
                // } else {
                //     const coin = await Coin.create({
                //         customer_id: x.customer_id,
                //         coins: x.est_price,
                //         left: x.est_price,
                //         spend: 0,
                //         // purpose: `${x.est_price} Credit from Recycle-Pay.`,
                //         // credit: x.est_price,
                //         // debit: 0,
                //         // order_id: x.order_id,
                //     });

                //     if (coin) {
                //         return res.send({
                //             isSuccess: true,
                //             mode: "Eco",
                //             message: { status: "processed" },
                //             // order: updtInd
                //         });
                //     }

                // }
            } else {
                const coin = await Coin.create({
                    customer_id: mainCustomer,
                    coins: amount,
                    left: amount,
                    earn: amount,
                    spend: 0,
                    // purpose: `${x.est_price} Credit from Recycle-Pay.`,
                    // credit: x.est_price,
                    // debit: 0,
                    // order_id: x.order_id,
                });

                const coinhist = await Coinhist.create({
                    customer_id: mainCustomer,
                    coins: amount,
                    left: amount,
                    spend: 0,
                    earn: amount,
                    purpose: `Credit from Recycle-Pay.`,
                    credit: amount,
                    debit: 0,
                    order_id: x.order_id,
                    refCust: customerId,
                });

                console.log("coinhist", coinhist);

                if (coin) {
                    // send Notification to Customer
                    // const customer = await Customers.findById(mainCustomer);
                    // if (customer && customer.token) {
                    //     pushNotification(
                    //         customer.token,
                    //         "Thank You!",
                    //         `${customer.name} for your referral to a new member and you have earned 5 Ecopot points which has been credited in your Ecopot wallet.`
                    //     );
                    // } else {
                    //     console.log("customer or token not exists");
                    // }

                    // send Notification to Agent
                    // const agent = await Users.findById(x.agent_id);
                    // if (agent && agent.token) {
                    //     pushNotification(
                    //         agent.token,
                    //         "Order Completed",
                    //         `Order #${x.order_id} Has Been Completed Successfully!`
                    //     );
                    // } else {
                    //     console.log("agent or token not exists");
                    // }

                    return ({
                        isSuccess: true,
                        mode: "Eco",
                        message: { status: "processed" },
                        // order: updtInd
                    });
                }
            }

        }
    })
}






async function fiveLevelOrderCondition(orderCount, useRefCode, x) {
    const minorder = await Dynamicrefamt.find();
    console.log("line no 3434", orderCount, minorder);
    if (orderCount == 1) {
        const mainCustomer = await Customers.findOne({ refCode: useRefCode, isDelete: false });
        if (mainCustomer) {
            console.log("mainCustomer enter");
            referalEcoCoins(mainCustomer._id, x, minorder[0].oneorder)
        } else {
            // return res.json({
            //     isSuccess: false,
            //     msg: "Could not credit referal amount."
            // })
        }
    } else if (orderCount == 2) {
        const mainCustomer = await Customers.findOne({ refCode: useRefCode, isDelete: false });
        if (mainCustomer) {
            console.log("mainCustomer enter");
            referalEcoCoins(mainCustomer._id, x, minorder[0].twoorder)
        } else {
            // return res.json({
            //     isSuccess: false,
            //     msg: "Could not credit referal amount."
            // })
        }
    } else if (orderCount == 3) {
        const mainCustomer = await Customers.findOne({ refCode: useRefCode, isDelete: false });
        if (mainCustomer) {
            console.log("mainCustomer enter");
            referalEcoCoins(mainCustomer._id, x, minorder[0].threeorder)
        } else {
            // return res.json({
            //     isSuccess: false,
            //     msg: "Could not credit referal amount."
            // })
        }
    } else if (orderCount == 4) {
        const mainCustomer = await Customers.findOne({ refCode: useRefCode, isDelete: false });
        if (mainCustomer) {
            console.log("mainCustomer enter");
            referalEcoCoins(mainCustomer._id, x, minorder[0].fourorder)
        } else {
            // return res.json({
            //     isSuccess: false,
            //     msg: "Could not credit referal amount."
            // })
        }
    } else if (orderCount == 5) {
        const mainCustomer = await Customers.findOne({ refCode: useRefCode, isDelete: false });
        if (mainCustomer) {
            console.log("mainCustomer enter");
            referalEcoCoins(mainCustomer._id, x, minorder[0].fiveorder)
        } else {
            // return res.json({
            //     isSuccess: false,
            //     msg: "Could not credit referal amount."
            // }
        }
    }
}






// Payment API
export const payment = async (req, res) => {
    const auth = {
        username: apiKey,
        password: apiSecret,
    }
    try {
        const OrderID = await Orders.findOne({ _id: req.params.orderid })
        // console.log(OrderID, req.body.mode);
        if (OrderID) {
            if (req.body.mode != 'Cash' && req.body.mode != 'Eco' && req.body.mode != 'Donation') {
                const idempotencyKey = OrderID._id.toString();
                const requestData = {
                    account_number: process.env.ACC_NO,
                    // account_number: "4564566996247139",
                    fund_account_id: req.body.fa,
                    // amount: req.body.est_price * 100,
                    // amount: Math.round(req.body.est_price) * 100,
                    // amount: parseInt((OrderID.est_price).toFixed(2) * 100),
                    amount: parseInt(parseFloat(OrderID.est_price).toFixed(2) * 100),
                    currency: "INR",
                    mode: OrderID.mode,
                    purpose: "payout",
                    notes: { notes: `${OrderID.order_id} Payback via RecyclePay` },
                    // purpose: ``,
                }
                const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
                    headers: {
                        'Content-Type': 'application/json',
                        'X-Payout-Idempotency': idempotencyKey,
                    },
                    auth: auth,
                })
                if (response) {
                    await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                        $set: {
                            status: response.data.status,
                            est_price: response.data.amount / 100,
                            pout: response.data.id,
                        }
                    }).then(async (x) => {
                        if (x) {
                            const mg = mailgun({
                                apiKey: process.env.MAILAPIKEY,
                                domain: process.env.DOMAIN,
                            });

                            // send Notification to Customer
                            const customer = await Customers.findById(x.customer_id);
                            const minorder = await Dynamicrefamt.find();
                            const condition_name = "Order";
                            if (customer) {
                                await Customers.findOne({ _id: x.customer_id }).then(async (x) => {
                                    if (x.orderCount < 5) {
                                        await Customers.findByIdAndUpdate({ _id: x._id }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                            console.log('x', x, minorder[0].minorder);
                                            if (x.orderCount < 5 && OrderID.est_price > minorder[0].minorder) {
                                                await Customers.findByIdAndUpdate({ _id: new ObjectId(x._id) }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                                    console.log("customer", x, x.orderCount);
                                                    const mainCustomer = await Customers.findOne({ refCode: x.useRefCode, isDelete: false });
                                                    if (x.orderCount <= 5) {
                                                        fiveLevelOrderCondition(x.orderCount, x.useRefCode, x._id)
                                                    } else {

                                                    }
                                                })
                                            }
                                        })
                                    }
                                })
                            }
                            if (customer && customer.token) {
                                pushNotification(
                                    customer.token,
                                    "Order Completed",
                                    `🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!`,
                                    condition_name
                                );
                            } else {
                                console.log("customer or token not exists");
                            }

                            // send Notification to Agent
                            const agent = await Users.findById(x.agent_id);
                            if (agent && agent.token) {
                                pushNotification(
                                    agent.token,
                                    "Order Completed",
                                    `Order #${x.order_id} Has Been Completed Successfully!`,
                                    condition_name
                                );
                            } else {
                                console.log("agent or token not exists");
                            }

                            const cust = await Customers.find({ _id: x.customer_id })
                            if (cust) {
                                const mailOptionscust = {
                                    from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                    to: cust.email,
                                    subject: `Your Order ID - ${x.order_id} for Scrap Sale has been completed`,
                                    html: `<p>Hello ${cust.name},</p>
                                      <p>🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!</p>
        
                                      <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                      <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                      `,
                                };


                                const mailOptionsadmin = {
                                    from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                    to: cust.email,
                                    subject: `Order ID - ${x.order_id} for Scrap Sale has been completed`,
                                    html: `<p>Hello ${cust.name},</p>
                                      <p>🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!</p>
        
                                      <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                      <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                      `,
                                };

                                try {
                                    // mg.messages().send(mailOptionscust, (error, body) => {
                                    //     if (error) {
                                    //         console.error("Mailgun error:", error);
                                    //         res.status(500).send("Error sending email");
                                    //     } else {
                                    //         res.status(200);
                                    //     }
                                    // });

                                    // mg.messages().send(mailOptionsadmin, (error, body) => {
                                    //     if (error) {
                                    //         console.error("Mailgun error:", error);
                                    //         res.status(500).send("Error sending email");
                                    //     } else {
                                    //         res.status(200);
                                    //     }
                                    // });
                                } catch (error) {
                                    console.error("Error:", error);
                                }
                            }
                            return res.send({
                                isSuccess: true,
                                message: response.data,
                                // order: updtInd
                            });
                        }
                    })

                }
            } else if (req.body.mode == 'Cash') {
                // if (response) {
                await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        status: "processed",
                        // pout: response.data.id,
                    }
                }).then(async (x) => {
                    console.log("order", x);
                    if (x) {
                        const mg = mailgun({
                            apiKey: process.env.MAILAPIKEY,
                            domain: process.env.DOMAIN,
                        });

                        // send Notification to Customer
                        const customer = await Customers.findById(x.customer_id);
                        const minorder = await Dynamicrefamt.find();
                        const condition_name = "Order";
                        if (customer) {
                            await Customers.findOne({ _id: x.customer_id }).then(async (x) => {
                                if (x.orderCount < 5) {
                                    await Customers.findByIdAndUpdate({ _id: x._id }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                        console.log('x', x, minorder[0].minorder);
                                        if (x.orderCount < 5 && OrderID.est_price > minorder[0].minorder) {
                                            await Customers.findByIdAndUpdate({ _id: new ObjectId(x._id) }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                                console.log("customer", x, x.orderCount);
                                                const mainCustomer = await Customers.findOne({ refCode: x.useRefCode, isDelete: false });
                                                if (x.orderCount <= 5) {
                                                    fiveLevelOrderCondition(x.orderCount, x.useRefCode, x._id)
                                                } else {

                                                }
                                            })
                                        }
                                    })
                                }
                            })
                        }
                        if (customer && customer.token) {
                            pushNotification(
                                customer.token,
                                "Order Completed",
                                `🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!`,
                                condition_name
                            );
                        } else {
                            console.log("customer or token not exists");
                        }

                        // send Notification to Agent
                        const agent = await Users.findById(x.agent_id);
                        if (agent && agent.token) {
                            pushNotification(
                                agent.token,
                                "Order Completed",
                                `Order #${x.order_id} Has Been Completed Successfully!`,
                                condition_name
                            );
                        } else {
                            console.log("agent or token not exists");
                        }

                        const cust = await Customers.find({ _id: x.customer_id })
                        if (cust) {
                            const mailOptionscust = {
                                from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                to: cust.email,
                                subject: `Your Order ID - ${x.order_id} for Scrap Sale has been completed`,
                                html: `<p>Hello ${cust.name},</p>
                                      <p>🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!</p>
        
                                      <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                      <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                      `,
                            };


                            const mailOptionsadmin = {
                                from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                to: cust.email,
                                subject: `Order ID - ${x.order_id} for Scrap Sale has been completed`,
                                html: `<p>Hello ${cust.name},</p>
                                      <p>🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!</p>
        
                                      <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                      <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                      `,
                            };

                            try {
                                // mg.messages().send(mailOptionscust, (error, body) => {
                                //     if (error) {
                                //         console.error("Mailgun error:", error);
                                //         res.status(500).send("Error sending email");
                                //     } else {
                                //         res.status(200);
                                //     }
                                // });

                                // mg.messages().send(mailOptionsadmin, (error, body) => {
                                //     if (error) {
                                //         console.error("Mailgun error:", error);
                                //         res.status(500).send("Error sending email");
                                //     } else {
                                //         res.status(200);
                                //     }
                                // });
                            } catch (error) {
                                console.error("Error:", error);
                            }
                        }
                        return res.send({
                            isSuccess: true,
                            mode: "Cash",
                            message: { status: "processed" },
                            // order: updtInd
                        });
                    }
                })

                // }
            } else if (req.body.mode == 'Eco') {
                await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        status: "processed",
                        // pout: response.data.id,
                    }
                }).then(async (x) => {
                    if (x) {
                        console.log(x, (x.customer_id).toString());
                        const coins = await Coin.findOne({ customer_id: x.customer_id });
                        console.log('coin', coins);
                        if (coins) {
                            const updatedCoins = coins.coins + (x.est_price * 10);
                            const leftCoins = (x.est_price * 10) + coins.left;

                            const updatedCoin = await Coin.findOneAndUpdate(
                                { customer_id: coins.customer_id },
                                {
                                    $set: {
                                        coins: updatedCoins,
                                        left: leftCoins,
                                        spend: coins.spend,

                                        // pout: response.data.id,
                                    }
                                },
                                { new: true } // to get the updated document
                            );

                            // if (updatedCoin) {
                            const coinhist = await Coinhist.create({
                                customer_id: updatedCoin.customer_id,
                                coins: updatedCoins,
                                left: (x.est_price * 10) + updatedCoin.left,
                                spend: updatedCoin.spend,
                                purpose: `Credit from Recycle-Pay.`,
                                credit: (x.est_price * 10),
                                debit: 0,
                                order_id: x.order_id,
                            });

                            // send Notification to Customer
                            const customer = await Customers.findById(x.customer_id);
                            const minorder = await Dynamicrefamt.find();
                            const condition_name = "Order";
                            if (customer) {
                                await Customers.findOne({ _id: x.customer_id }).then(async (x) => {
                                    console.log('x', x, minorder[0].minorder);
                                    if (x.orderCount < 5) {
                                        await Customers.findByIdAndUpdate({ _id: x._id }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                            console.log('x', x, minorder[0].minorder);
                                            if (x.orderCount < 5 && OrderID.est_price > minorder[0].minorder) {
                                                await Customers.findByIdAndUpdate({ _id: new ObjectId(x._id) }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                                    console.log("customer", x, x.orderCount);
                                                    const mainCustomer = await Customers.findOne({ refCode: x.useRefCode, isDelete: false });
                                                    if (x.orderCount <= 5) {
                                                        fiveLevelOrderCondition(x.orderCount, x.useRefCode, x._id)
                                                    } else {

                                                    }
                                                })
                                            }
                                        })
                                    }
                                })
                            }
                            if (customer && customer.token) {
                                pushNotification(
                                    customer.token,
                                    "Order Completed",
                                    `🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!`,
                                    condition_name
                                );
                            } else {
                                console.log("customer or token not exists");
                            }

                            // send Notification to Agent
                            const agent = await Users.findById(x.agent_id);
                            if (agent && agent.token) {
                                pushNotification(
                                    agent.token,
                                    "Order Completed",
                                    `Order #${x.order_id} Has Been Completed Successfully!`,
                                    condition_name
                                );
                            } else {
                                console.log("agent or token not exists");
                            }

                            return res.json({
                                isSuccess: true,
                                mode: "Eco",
                                message: { status: "processed" },
                                // order: updtInd
                            });
                            // } else {
                            //     const coin = await Coin.create({
                            //         customer_id: x.customer_id,
                            //         coins: x.est_price,
                            //         left: x.est_price,
                            //         spend: 0,
                            //         // purpose: `${x.est_price} Credit from Recycle-Pay.`,
                            //         // credit: x.est_price,
                            //         // debit: 0,
                            //         // order_id: x.order_id,
                            //     });

                            //     if (coin) {
                            //         return res.send({
                            //             isSuccess: true,
                            //             mode: "Eco",
                            //             message: { status: "processed" },
                            //             // order: updtInd
                            //         });
                            //     }

                            // }
                        } else {
                            const coin = await Coin.create({
                                customer_id: x.customer_id,
                                coins: (x.est_price * 10),
                                left: (x.est_price * 10),
                                spend: 0,
                                // purpose: `${(x.est_price * 10)} Credit from Recycle-Pay.`,
                                // credit: (x.est_price * 10),
                                // debit: 0,
                                // order_id: x.order_id,
                            });

                            const coinhist = await Coinhist.create({
                                customer_id: x.customer_id,
                                coins: (x.est_price * 10),
                                left: (x.est_price * 10),
                                spend: 0,
                                purpose: `Credit from Recycle-Pay.`,
                                credit: (x.est_price * 10),
                                debit: 0,
                                order_id: x.order_id,
                            });

                            if (coin) {
                                // send Notification to Customer
                                const customer = await Customers.findById(x.customer_id);
                                const condition_name = "Order";
                                if (customer && customer.token) {
                                    pushNotification(
                                        customer.token,
                                        "Order Completed",
                                        `🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!`,
                                        condition_name
                                    );
                                } else {
                                    console.log("customer or token not exists");
                                }

                                // send Notification to Agent
                                const agent = await Users.findById(x.agent_id);
                                if (agent && agent.token) {
                                    pushNotification(
                                        agent.token,
                                        "Order Completed",
                                        `Order #${x.order_id} Has Been Completed Successfully!`,
                                        condition_name
                                    );
                                } else {
                                    console.log("agent or token not exists");
                                }

                                return res.send({
                                    isSuccess: true,
                                    mode: "Eco",
                                    message: { status: "processed" },
                                    // order: updtInd
                                });
                            }
                        }

                    }
                })
            } else if (req.body.mode == 'Donation') {
                console.log("Donation mode chosen");
                const idempotencyKey = OrderID._id.toString();
                const requestData = {
                    // customer_id: req.body.ngoId,
                    account_number: process.env.ACC_NO,
                    fund_account_id: req.body.fa,
                    amount: parseInt(parseFloat(OrderID.est_price).toFixed(2) * 100),
                    currency: "INR",
                    mode: "IMPS",
                    purpose: "payout",
                    notes: { notes: `${OrderID.order_id} Payback via RecyclePay` },
                }
                console.log("requestData", requestData);
                try {
                    const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
                        headers: {
                            'Content-Type': 'application/json',
                            'X-Payout-Idempotency': idempotencyKey,
                        },
                        auth: auth,
                    });

                    if (response) {
                        console.log("Going to set pout...");
                        await Donation.findOneAndUpdate(
                            { orderId: new mongoose.Types.ObjectId(req.params.orderid) },
                            {
                                $set: {
                                    amount: response.data.amount / 100,
                                    donationStatus: response.data.status,
                                }
                            },
                            { new: true }
                        );

                        await Orders.findByIdAndUpdate(
                            { _id: req.params.orderid },
                            {
                                $set: {
                                    status: response.data.status,
                                    est_price: response.data.amount / 100,
                                    pout: response.data.id,
                                }
                            },
                            { new: true } // This option returns the updated document
                        ).then(async (x) => {
                            console.log("x value is : ", x);
                            const cust = await Customers.find({ _id: new mongoose.Types.ObjectId(x.customer_id) })
                            const getadd = await Address.findOne({ _id: new mongoose.Types.ObjectId(x.address_id) })

                            const transporter = nodemailer.createTransport(
                                new Transport({ apiKey: process.env.MAILAPIKEY })
                            );

                            const customer = await Customers.findById(x.customer_id);
                            const minorder = await Dynamicrefamt.find();
                            const condition_name = "Order";
                            if (customer) {
                                await Customers.findOne({ _id: x.customer_id }).then(async (x) => {
                                    if (x.orderCount < 5) {
                                        await Customers.findByIdAndUpdate({ _id: x._id }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                            console.log('x', x, minorder[0].minorder);
                                            if (x.orderCount < 5 && OrderID.est_price > minorder[0].minorder) {
                                                await Customers.findByIdAndUpdate({ _id: new ObjectId(x._id) }, { $set: { orderCount: x.orderCount + 1 } }).then(async (x) => {
                                                    console.log("customer", x, x.orderCount);
                                                    const mainCustomer = await Customers.findOne({ refCode: x.useRefCode, isDelete: false });
                                                    if (x.orderCount <= 5) {
                                                        fiveLevelOrderCondition(x.orderCount, x.useRefCode, x._id)
                                                    } else {

                                                    }
                                                })
                                            }
                                        })
                                    }
                                })
                            }

                            if (x) {
                                const ngoData = await NGO.findOne({ fa: req.body.fa });
                                const donationData = await Donation.findOne({ orderId: OrderID._id });
                                console.log("ngo data", ngoData);
                                console.log("ngo name", ngoData.PAN);
                                console.log("x", x, cust);

                                // Mail to Customer after successful donation
                                // if (cust) {

                                //     var defaultClient = SibApiV3Sdk.ApiClient.instance;

                                //     // Configure API key authorization: api-key
                                //     var apiKey = defaultClient.authentications['api-key'];
                                //     apiKey.apiKey = process.env.MAILAPIKEY;

                                //     // Uncomment below two lines to configure authorization using: partner-key
                                //     // var partnerKey = defaultClient.authentications['partner-key'];
                                //     // partnerKey.apiKey = 'YOUR API KEY';

                                //     var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();

                                //     var sendSmtpEmail = new SibApiV3Sdk.SendSmtpEmail();
                                //     var sendSmtpEmailAdmin = new SibApiV3Sdk.SendSmtpEmail();

                                //     // var dynamicContent = {
                                //     //     firstname: "John",
                                //     //     lastname: "Doe",
                                //     // };

                                //     const dynamicSubject = `Order Amount Donation - Your Order with Recycle Pay [${x.order_id}] amount has been successfully donated!`;
                                //     sendSmtpEmail = {
                                //         to: [{
                                //             email: cust.email,
                                //             // email: 'aditi.nandy@ajatus.co.in'
                                //             // name: 'John Doe'
                                //         }],
                                //         from: {
                                //             email: 'support@ceibagreen.com',
                                //             // name: 'Your Name'
                                //         },
                                //         templateId: 10,
                                //         params: {
                                //             "parameter": "recycle-pay",
                                //             "subject": dynamicSubject,
                                //             "order_id": x.order_id, "schedule_date": x.schedule_date, "getadd": getadd, "totalitems": x.item, "est_price": x.est_price.toFixed(2), "name": cust.name, "time": x.time
                                //         },
                                //         subject: dynamicSubject,
                                //         headers: {
                                //             'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                //         }
                                //     };
                                //     // const dynamicAdmSubject = `Customer Mail to Admin - Amount of order [${x.order_id}] has been donated!`;
                                //     sendSmtpEmailAdmin = {
                                //         to: [
                                //             // { email: 'aditi.nandy@ajatus.co.in' }, 
                                //             // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                //             //  { email: 'ashok.sarangi@ajatus.co.in' },
                                //             // { email: 'santosh@ceibagreen.com' },
                                //             // { email: 'janmejay@ceibagreen.com' },
                                //             // { email: 'support@ceibagreen.com' },
                                //             // { email: 'neelima@ceibagreen.com' }
                                //             // { email: 'neelima@ajatus.co.in' }
                                //             { email: 'ashka.kumari@ajatus.co.in' }
                                //         ],
                                //         from: {
                                //             email: 'support@ceibagreen.com',
                                //             // name: 'Your Name'
                                //         },
                                //         templateId: 17,
                                //         // params: { "parameter": "recycle-pay", "DonorFN": x.order_id, "DonorPAN": x.schedule_date, "DonationAMT": x.est_price.toFixed(2), "UTR": x.item, "NGO": cust.name },
                                //         subject: 'Request for 80G Tax Exemption Certificate',
                                //         headers: {
                                //             'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                //         }
                                //     };

                                //     console.log("x.order_id", x.order_id);

                                //     const mailOptions = {
                                //         from: 'orders@recycle-pay.com',
                                //         to: 'ashka.kumari@ajatus.co.in',
                                //         subject: `Your Order ID - ${x.order_id} for Scrap Sale has been donated`,
                                //         text: `<p>Hello ${cust[0].name},</p>
                                //     <p>On successful donation a mail to be sent to customer with order details as </p>

                                //     <p>Order Id: ${x.order_id}</p>

                                //     <p>Pick Up date: ${x.schedule_date}</p>
                                //     <p>Pick Up time: ${x.time}</p>
                                //     <p>Total Quantity: ${x.item.weight}</p>

                                //     <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                //     <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                //     `,
                                //     };


                                // // send Notification to Customer
                                // const customer = await Customers.findById(x.customer_id);
                                // const condition_name = "Order";

                                // if (customer && customer.token) {
                                //     pushNotification(
                                //         customer.token,
                                //         "Order Completed",
                                //         `🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Donated To ${ngoData.name}!`,
                                //         condition_name
                                //     );
                                //     console.log(`notification sent to ${customer.name}`);
                                // } else {
                                //     console.log("customer or token not exists");
                                // }

                                // // send Notification to Agent
                                // const agent = await Users.findById(x.agent_id);
                                // console.log("agent", agent);
                                // if (agent && agent.token) {
                                //     pushNotification(
                                //         agent.token,
                                //         "Order Completed",
                                //         `Order #${x.order_id} Has Been Completed Successfully!`,
                                //         condition_name
                                //     );
                                //     console.log(`notification sent to ${agent.name}`);
                                // } else {
                                //     console.log("agent or token not exists");
                                // }

                                //     try {
                                //         // transporter.sendMail(mailOptions, (error, info) => {
                                //         //     if (error) {
                                //         //         console.error('Error sending email:', error);
                                //         //     } else {
                                //         //         console.log('Email sent:', info.response);
                                //         //     }
                                //         // });
                                //         apiInstance.sendTransacEmail(sendSmtpEmail).then(function (data) {
                                //             console.log('Customer API for donation called successfully. Returned data: ' + data);
                                //         }, function (error) {
                                //             console.error(error);
                                //         });

                                //         apiInstance.sendTransacEmail(sendSmtpEmailAdmin).then(function (data) {
                                //             console.log('Admin API for donation called successfully. Returned data: ' + data);
                                //         }, function (error) {
                                //             console.error(error);
                                //         });
                                //     } catch (error) {
                                //         console.error("Error:", error);
                                //     }
                                // }

                                // Mail to NGO after receiving donation
                                if (ngoData) {


                                    const dynamicCertAdminSubject = `Donation Payment of Order Id - ${x.order_id}`;
                                    sendSmtpEmailCertAdmin = {
                                        to: [
                                            // { email: cust[0].email },
                                            // { email: 'aditi.nandy@ajatus.co.in' },
                                            // { email: 'omprakash.sadangi@ajatus.co.in' },
                                            { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                            //  { email: 'ashok.sarangi@ajatus.co.in' },
                                            // { email: 'santosh@ceibagreen.com' },
                                            // { email: 'janmejay@ceibagreen.com' },
                                            // { email: 'support@ceibagreen.com' },
                                            // { email: 'neelima@ceibagreen.com' }
                                            // { email: 'neelima@ajatus.co.in' }
                                        ],
                                        from: {
                                            email: 'support@ceibagreen.com',
                                            // name: 'Your Name'
                                        },
                                        templateId: 24,
                                        params: { "parameter": "recycle-pay", "Name": cust[0].name, "PAN": cust[0].PAN, "Amt": x.est_price.toFixed(2), "name": ngoData.name, "purpose": ngoData.purpose, "UTR": x.pout.split("_")[1], "orderId": x.order_id },
                                        subject: dynamicCertAdminSubject,
                                        headers: {
                                            'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                        }
                                    };
                                }

                                    var defaultClient = SibApiV3Sdk.ApiClient.instance;

                                    // Configure API key authorization: api-key
                                    var apiKey = defaultClient.authentications['api-key'];
                                    apiKey.apiKey = process.env.MAILAPIKEY;

                                    // Uncomment below two lines to configure authorization using: partner-key
                                    // var partnerKey = defaultClient.authentications['partner-key'];
                                    // partnerKey.apiKey = 'YOUR API KEY';

                                    var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();

                                    var sendSmtpEmail = new SibApiV3Sdk.SendSmtpEmail();
                                    var sendSmtpEmailAdmin = new SibApiV3Sdk.SendSmtpEmail();
                                    var sendSmtpEmailCertCust = new SibApiV3Sdk.SendSmtpEmail();
                                    var sendSmtpEmailCertAdmin = new SibApiV3Sdk.SendSmtpEmail();

                                    // var dynamicContent = {
                                    //     firstname: "John",
                                    //     lastname: "Doe",
                                    // };

                                    // const dynamicSubject = `Donation Received - A Customer with Recycle Pay order [${x.order_id}] amount has been successfully donated to your organization!`;
                                    // sendSmtpEmail = {
                                    //     to: [{
                                    //         email: ngoData.email,
                                    //         // email: 'santoshini@ajatus.co.in'
                                    //         // name: 'John Doe'
                                    //     }],
                                    //     from: {
                                    //         email: 'support@ceibagreen.com',
                                    //         // name: 'Your Name'
                                    //     },
                                    //     templateId: 10,
                                    //     params: {
                                    //         "parameter": "recycle-pay",
                                    //         "subject": dynamicSubject,
                                    //         "order_id": x.order_id, "schedule_date": x.schedule_date, "getadd": getadd, "totalitems": x.item, "est_price": x.est_price.toFixed(2), "name": cust.name, "time": x.time
                                    //     },
                                    //     subject: dynamicSubject,
                                    //     headers: {
                                    //         'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                    //     }
                                    // };


                                    if (donationData.needCertificate == true) {
                                        const dynamicAdmSubject = `Request for 80G Tax Exemption Certificate - Recycle Pay Order No. ${x.order_id}`;
                                        sendSmtpEmailAdmin = {
                                            to: [
                                                { email: ngoData.email },
                                                // { email: 'aditi.nandy@ajatus.co.in' },
                                                // { email: 'omprakash.sadangi@ajatus.co.in' },
                                                // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                //  { email: 'ashok.sarangi@ajatus.co.in' },
                                                // { email: 'santosh@ceibagreen.com' },
                                                // { email: 'janmejay@ceibagreen.com' },
                                                // { email: 'support@ceibagreen.com' },
                                                // { email: 'neelima@ceibagreen.com' }
                                                // { email: 'neelima@ajatus.co.in' }
                                                // { email: 'ashka.kumari@ajatus.co.in' }
                                            ],
                                            from: {
                                                email: 'support@ceibagreen.com',
                                                // name: 'Your Name'
                                            },
                                            templateId: 17,
                                            params: { "parameter": "recycle-pay", "Name": cust[0].name, "PAN": cust[0].PAN, "Amt": x.est_price.toFixed(2), "name": ngoData.name, "purpose": ngoData.purpose, "UTR": x.pout.split("_")[1], "orderId": x.order_id },
                                            subject: dynamicAdmSubject,
                                            headers: {
                                                'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                            }
                                        };

                                        const dynamicCertCustSubject = `Confirmation of Your Donation to The ${ngoData.name}`;
                                        sendSmtpEmailCertCust = {
                                            to: [
                                                { email: cust[0].email },
                                                // { email: 'aditi.nandy@ajatus.co.in' },
                                                // { email: 'omprakash.sadangi@ajatus.co.in' },
                                                // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                //  { email: 'ashok.sarangi@ajatus.co.in' },
                                                // { email: 'santosh@ceibagreen.com' },
                                                // { email: 'janmejay@ceibagreen.com' },
                                                // { email: 'support@ceibagreen.com' },
                                                // { email: 'neelima@ceibagreen.com' }
                                                // { email: 'neelima@ajatus.co.in' }
                                                // { email: 'ashka.kumari@ajatus.co.in' }
                                            ],
                                            from: {
                                                email: 'support@ceibagreen.com',
                                                // name: 'Your Name'
                                            },
                                            templateId: 20,
                                            params: { "parameter": "recycle-pay", "Name": cust[0].name, "PAN": cust[0].PAN, "Amt": x.est_price.toFixed(2), "name": ngoData.name, "purpose": ngoData.purpose, "UTR": x.pout.split("_")[1], "orderId": x.order_id },
                                            subject: dynamicCertCustSubject,
                                            headers: {
                                                'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                            }
                                        };
                                    } else if (donationData.needCertificate == false) {
                                        const dynamicAdmSubject = `Confirmation of Donation - Recycle Pay Order No. ${x.order_id}`;
                                        sendSmtpEmailAdmin = {
                                            to: [
                                                { email: ngoData.email },
                                                // { email: 'aditi.nandy@ajatus.co.in' },
                                                // { email: 'omprakash.sadangi@ajatus.co.in' },
                                                // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                //  { email: 'ashok.sarangi@ajatus.co.in' },
                                                // { email: 'santosh@ceibagreen.com' },
                                                // { email: 'janmejay@ceibagreen.com' },
                                                // { email: 'support@ceibagreen.com' },
                                                // { email: 'neelima@ceibagreen.com' }
                                                // { email: 'neelima@ajatus.co.in' }
                                                // { email: 'ashka.kumari@ajatus.co.in' }
                                            ],
                                            from: {
                                                email: 'support@ceibagreen.com',
                                                // name: 'Your Name'
                                            },
                                            templateId: 22,
                                            params: { "parameter": "recycle-pay", "Name": cust[0].name, "PAN": cust[0].PAN, "Amt": x.est_price.toFixed(2), "name": ngoData.name, "purpose": ngoData.purpose, "UTR": x.pout.split("_")[1], "orderId": x.order_id },
                                            subject: dynamicAdmSubject,
                                            headers: {
                                                'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                            }
                                        };

                                        const dynamicCertCustSubject = `Confirmation of Your Donation to The ${ngoData.name}`;
                                        sendSmtpEmailCertCust = {
                                            to: [
                                                { email: cust[0].email },
                                                // { email: 'aditi.nandy@ajatus.co.in' },
                                                // { email: 'omprakash.sadangi@ajatus.co.in' },
                                                // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                //  { email: 'ashok.sarangi@ajatus.co.in' },
                                                // { email: 'santosh@ceibagreen.com' },
                                                // { email: 'janmejay@ceibagreen.com' },
                                                // { email: 'support@ceibagreen.com' },
                                                // { email: 'neelima@ceibagreen.com' }
                                                // { email: 'neelima@ajatus.co.in' }
                                                // { email: 'ashka.kumari@ajatus.co.in' }
                                            ],
                                            from: {
                                                email: 'support@ceibagreen.com',
                                                // name: 'Your Name'
                                            },
                                            templateId: 21,
                                            params: { "parameter": "recycle-pay", "Name": cust[0].name, "PAN": cust[0].PAN, "Amt": x.est_price.toFixed(2), "name": ngoData.name, "purpose": ngoData.purpose, "UTR": x.pout.split("_")[1], "orderId": x.order_id },
                                            subject: dynamicCertCustSubject,
                                            headers: {
                                                'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                            }
                                        };


                                        const dynamicCertAdminSubject = `Donation Payment of Order Id - ${x.order_id}`;
                                        sendSmtpEmailCertAdmin = {
                                            to: [
                                                // { email: cust[0].email },
                                                // { email: 'aditi.nandy@ajatus.co.in' },
                                                // { email: 'omprakash.sadangi@ajatus.co.in' },
                                                { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                //  { email: 'ashok.sarangi@ajatus.co.in' },
                                                // { email: 'santosh@ceibagreen.com' },
                                                // { email: 'janmejay@ceibagreen.com' },
                                                // { email: 'support@ceibagreen.com' },
                                                // { email: 'neelima@ceibagreen.com' }
                                                { email: 'neelima@ajatus.co.in' }
                                            ],
                                            from: {
                                                email: 'support@ceibagreen.com',
                                                // name: 'Your Name'
                                            },
                                            templateId: 24,
                                            params: { "parameter": "recycle-pay", "Name": cust[0].name, "PAN": cust[0].PAN, "Amt": x.est_price.toFixed(2), "name": ngoData.name, "purpose": ngoData.purpose, "UTR": x.pout.split("_")[1], "orderId": x.order_id },
                                            subject: dynamicCertAdminSubject,
                                            headers: {
                                                'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                            }
                                        };
                                    }


                                    console.log("x.order_id", x.order_id);

                                    try {
                                        // transporter.sendMail(mailOptions, (error, info) => {
                                        //     if (error) {
                                        //         console.error('Error sending email:', error);
                                        //     } else {
                                        //         console.log('Email sent:', info.response);
                                        //     }
                                        // });
                                        // apiInstance.sendTransacEmail(sendSmtpEmail).then(function (data) {
                                        //     console.log('NGO API to receive donation called successfully. Returned data: ' + data);
                                        // }, function (error) {
                                        //     console.error(error);
                                        // });

                                        apiInstance.sendTransacEmail(sendSmtpEmailAdmin).then(function (data) {
                                            console.log('Admin API to receive donation by NGO called successfully. Returned data: ' + data);
                                        }, function (error) {
                                            console.error(error);
                                        });


                                        apiInstance.sendTransacEmail(sendSmtpEmailCertCust).then(function (data) {
                                            console.log('Admin API to receive donation by NGO called successfully. Returned data: ' + data);
                                        }, function (error) {
                                            console.error(error);
                                        });


                                        apiInstance.sendTransacEmail(sendSmtpEmailCertAdmin).then(function (data) {
                                            console.log('Admin API to receive donation by NGO called successfully. Returned data: ' + data);
                                        }, function (error) {
                                            console.error(error);
                                        });
                                    } catch (error) {
                                        console.error("Error:", error);
                                    }
                                }

                                return res.send({
                                    isSuccess: true,
                                    message: {
                                        status: response.data.status,
                                    },
                                    mode: "Donation"
                                });
                            });
                        
                    }
                }
                 catch (error) {
                    console.error(error);
                    return res.status(500).send({
                        error: true,
                        message: 'Failed to process the donation',
                        details: error.response.data, // Include details from Razorpay response for debugging
                    });
                }
            }
        }
    }
     catch (error) {
        res.send({
            isSuccess: false,
            message: 'An error occurred during the API request.',
            error: error.response
        });
    }
}





// Withdraw API
export const withdraw = async (req, res) => {
    const auth = {
        username: apiKey,
        password: apiSecret,
    }
    console.log(req.params.cust, req.body);
    try {
        const Coins = await Coin.findOne({ customer_id: req.params.cust })
        console.log(req.body, Coins);

        if (Coins) {
            console.log(req.body.mode, parseInt(parseFloat(Coins.coins).toFixed(2) * 100));
            let LeftCoin = Coins.left / 10;
            if (req.body.mode != 'Eco' && req.body.mode != 'Cash') {
                console.log(Coins.coins, req.body.mode);
                const requestData = {
                    account_number: process.env.ACC_NO,
                    // account_number: "4564566996247139",
                    fund_account_id: req.body.fa,
                    // amount: req.body.est_price * 100,
                    // amount: Math.round(req.body.est_price) * 100,
                    amount: parseInt(parseFloat(req.body.amount).toFixed(2) * 100),
                    currency: "INR",
                    mode: req.body.mode,
                    purpose: "payout",
                    notes: { notes: `Payback via RecyclePay` },
                    // purpose: ``,
                }
                const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    auth: auth,
                })
                console.log(response, Coins.withdraw, Coins.left);
                if (response) {
                    await Coin.findOneAndUpdate({ customer_id: req.params.cust }, {
                        $set: {
                            mode: req.body.mode,
                            // coins: 0,
                            left: Coins.left - parseInt(parseFloat((req.body.amount) * 10)),
                            spend: Coins.spend + parseInt(parseFloat((req.body.amount) * 10)),
                            withdraw: Coins.withdraw + parseInt(parseFloat((req.body.amount) * 10)),
                        }
                    },
                        { new: true }
                    ).then(async (x) => {
                        console.log(x);
                        console.log(response);

                        if (x) {
                            const mg = mailgun({
                                apiKey: process.env.MAILAPIKEY,
                                domain: process.env.DOMAIN,
                            });
                            const coinhist = await Coinhist.create({
                                customer_id: req.params.cust,
                                coins: x.coins,
                                left: x.left,
                                spend: x.spend,
                                purpose: `Withdraw from Recycle-Pay.`,
                                withdraw: x.withdraw,
                                pout: response.data.id,
                                status: response.data.status,
                                debit: parseInt(parseFloat((req.body.amount) * 10)),
                                credit: 0,
                            });
                            console.log(coinhist);
                            const cust = await Customers.find({ _id: x.customer_id })
                            if (cust) {
                                const mailOptionscust = {
                                    from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                    to: cust.email,
                                    subject: `Your Order ID - ${x.order_id} for Scrap Sale has been completed`,
                                    html: `<p>Hello ${cust.name},</p>
                                      <p>🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!</p>
        
                                      <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                      <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                      `,
                                };


                                const mailOptionsadmin = {
                                    from: "Ceiba Green Solutions <support@ceibagreen.com>",
                                    to: cust.email,
                                    subject: `Order ID - ${x.order_id} for Scrap Sale has been completed`,
                                    html: `<p>Hello ${cust.name},</p>
                                      <p>🎁 Hooray! Order #${x.order_id} Has Been Completed! Rs.${x.est_price} Has Been Paid!</p>
        
                                      <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                      <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                      `,
                                };

                                try {
                                    // mg.messages().send(mailOptionscust, (error, body) => {
                                    //     if (error) {
                                    //         console.error("Mailgun error:", error);
                                    //         res.status(500).send("Error sending email");
                                    //     } else {
                                    //         res.status(200);
                                    //     }
                                    // });

                                    // mg.messages().send(mailOptionsadmin, (error, body) => {
                                    //     if (error) {
                                    //         console.error("Mailgun error:", error);
                                    //         res.status(500).send("Error sending email");
                                    //     } else {
                                    //         res.status(200);
                                    //     }
                                    // });
                                } catch (error) {
                                    console.error("Error:", error);
                                }
                            }
                            return res.send({
                                isSuccess: true,
                                message: response.data,
                                // order: updtInd
                            });
                        }
                    })

                }
            }
        }
    } catch (error) {
        res.send({
            isSuccess: false,
            message: 'An error occurred during the API request.',
            error: error.response.data.error.description
        });
    }


}





// Trasaction history of customer
export const custHist = async (req, res) => {
    const { page = 1, limit = 10 } = req.query; // Default to page 1 and limit 10 if not provided
    const offset = (page - 1) * limit;

    try {
        const history = await Coinhist.find({ customer_id: req.params.cust })
            .sort({ createdAt: -1 }) // Sort by createdAt in descending order
            .skip(parseInt(offset))
            .limit(parseInt(limit));

        if (history.length > 0) {
            // Convert createdAt to date and time in India timezone
            const formattedHistory = history.map(entry => {
                const createdAt = new Date(entry.createdAt);
                const options = {
                    timeZone: 'Asia/Kolkata',
                    hour12: false,
                    hour: 'numeric',
                    minute: 'numeric',
                    second: 'numeric',
                };
                return {
                    ...entry.toObject(),
                    date: createdAt.toISOString().split('T')[0], // Extract date
                    time: createdAt.toLocaleString('en-IN', options), // Convert to India timezone
                };
            });

            return res.send({
                isSuccess: true,
                history: formattedHistory
            });
        } else {
            return res.send({
                isSuccess: false,
                history: []
            });
        }
    } catch (error) {
        console.error(error);
        return res.status(500).send({
            isSuccess: false,
            message: 'Internal Server Error'
        });
    }
};







export const custHistRef = async (req, res) => {
    const { page = 1, limit = 40 } = req.query; // Default to page 1 and limit 10 if not provided
    const offset = (page - 1) * limit;

    try {
        const history = await Coinhist.aggregate([
            {
                $match: { customer_id: new mongoose.Types.ObjectId(req.params.cust) }
            },
            {
                $sort: { createdAt: -1 }
            },
            {
                $skip: parseInt(offset)
            },
            {
                $limit: parseInt(limit)
            },
            {
                $lookup: {
                    from: 'customers',
                    localField: 'refCust',
                    foreignField: '_id',
                    as: 'customer_details'
                }
            },
            {
                $unwind: {
                    path: '$customer_details',
                    preserveNullAndEmptyArrays: true
                }
            },
            {
                $project: {
                    _id: 1,
                    customer_id: 1,
                    coins: 1,
                    createdAt: 1,
                    'customer_details.name': 1,
                    'customer_details.email': 1,
                    credit: 1,
                    debit: 1,
                    withdraw: 1,
                    refCust: 1,
                }
            }
        ]);

        if (history.length > 0) {
            // Convert createdAt to date and time in India timezone
            const formattedHistory = history.map(entry => {
                const createdAt = new Date(entry.createdAt);
                const options = {
                    timeZone: 'Asia/Kolkata',
                    hour12: false,
                    hour: 'numeric',
                    minute: 'numeric',
                    second: 'numeric',
                };
                return {
                    ...entry,
                    date: createdAt.toISOString().split('T')[0], // Extract date
                    time: createdAt.toLocaleString('en-IN', options), // Convert to India timezone
                };
            });

            return res.send({
                isSuccess: true,
                history: formattedHistory
            });
        } else {
            return res.send({
                isSuccess: false,
                history: []
            });
        }
    } catch (error) {
        console.error(error);
        return res.status(500).send({
            isSuccess: false,
            message: 'Internal Server Error'
        });
    }
};










// 3 status trasaction (eg. coins, left, spend)






// Payment Status
export const payStatusPout = async (req, res) => {
    try {
        // const filterProc = await Orders.find({ status: "processing" })
        console.log(req.params.pout);
        const auth = {
            username: apiKey,
            password: apiSecret,
        }
        // let pout = req.params.pout;https://desktop.postman.com/?desktopVersion=10.19.0&userId=16507359&teamId=0
        // if (filterProc) {
        // filterProc.map(async (x) => {
        const response = await axios.get(`https://api.razorpay.com/v1/payouts/${req.params.pout}`, {
            headers: {
                'Content-Type': 'application/json',
            },
            auth: auth,
        })

        console.log(response.data.status);

        if (response.data.status != 'processing') {
            console.log(req.params.pout);
            // Orders.findOneAndUpdate({ pout: req.params.pout }, { $set: { status: response.data.status } }).then((x) => {
            //     console.log("resp",x);

            // }).catch(err=>{
            //     console.log("errpr",err);
            // })
            const orders = await Orders.findOneAndUpdate({ pout: req.params.pout }, { $set: { status: response.data.status } })
            if (orders) {
                console.log(orders);
                return res.send({
                    isSuccess: true,
                    message: { "order_id": orders.order_id, "status": response.data.status },
                    msg: response.data,
                });
            } else {
                return res.send({
                    isSuccess: false,
                    message: "Something went wrong.",
                });
            }
        }
        else {
            return res.send({
                isSuccess: false,
                message: `Payment process status ${response.data.status}`,
            });
        }


        // console.log(response.data.status);
        // })
        // } 
        // else {
        //     console.log('No id available.');
        // }


    } catch (error) {
        console.log(error);
        return res.send({
            isSuccess: false,
            message: 'An error occurred during the API request.',
            error: error
        });
    }

}





// Payment Status After withdraw Eco Coins
export const payStatusPoutEco = async (req, res) => {
    try {
        // const filterProc = await Orders.find({ status: "processing" })
        console.log(req.params.pout);
        const auth = {
            username: apiKey,
            password: apiSecret,
        }
        // let pout = req.params.pout;https://desktop.postman.com/?desktopVersion=10.19.0&userId=16507359&teamId=0
        // if (filterProc) {
        // filterProc.map(async (x) => {
        const response = await axios.get(`https://api.razorpay.com/v1/payouts/${req.params.pout}`, {
            headers: {
                'Content-Type': 'application/json',
            },
            auth: auth,
        })

        console.log(response.data.status);

        if (response.data.status != 'processing') {
            console.log(req.params.pout);
            // Orders.findOneAndUpdate({ pout: req.params.pout }, { $set: { status: response.data.status } }).then((x) => {
            //     console.log("resp",x);

            // }).catch(err=>{
            //     console.log("errpr",err);
            // })
            const hist = await Coinhist.findOneAndUpdate({ pout: req.params.pout }, { $set: { status: response.data.status } })
            if (hist) {
                console.log(hist);
                return res.send({
                    isSuccess: true,
                    message: { "status": response.data.status },
                    msg: response.data,
                });
            } else {
                return res.send({
                    isSuccess: false,
                    message: "Something went wrong.",
                });
            }
        }
        else {
            return res.send({
                isSuccess: false,
                message: `Payment process status ${response.data.status}`,
            });
        }


        // console.log(response.data.status);
        // })
        // } 
        // else {
        //     console.log('No id available.');
        // }


    } catch (error) {
        console.log(error);
        return res.send({
            isSuccess: false,
            message: 'An error occurred during the API request.',
            error: error
        });
    }

}







// Payment Status
export const payStatus = async (req, res) => {
    try {
        const filterProc = await Orders.find({ status: "processing" })
        console.log('filterProc', filterProc);
        const auth = {
            username: apiKey,
            password: apiSecret,
        }
        // let pout = req.params.pout;https://desktop.postman.com/?desktopVersion=10.19.0&userId=16507359&teamId=0
        if (filterProc.length != 0) {
            filterProc.map(async (x) => {
                const response = await axios.get(`https://api.razorpay.com/v1/payouts/${x.pout}`, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    auth: auth,
                })

                console.log('payment status procced', response.data);

                if (response.data.status != 'processing') {
                    const orders = await Orders.findOneAndUpdate({ pout: x.pout }, { $set: { status: response.data.status } })
                    if (orders) {
                        console.log(orders);
                        return res.send({
                            isSuccess: true,
                            message: response.data,
                            // msg: response.data,
                        });
                    } else {
                        return res.send({
                            isSuccess: false,
                            message: "Something went wrong.",
                        });
                    }
                }
                else {
                    return res.send({
                        isSuccess: false,
                        message: `Payment process status ${response.data.status}`,
                    });
                }


                // console.log(response.data.status);
            })
        }
        else if (filterProc.length == 0) {
            console.log('No id available.');
            return res.send({
                isSuccess: false,
                message: `No id available.`,
            });
        }


    } catch (error) {
        console.log(error);
        return res.send({
            isSuccess: false,
            message: 'An error occurred during the API request.',
            // error: error
            error: error.response.data.error.description
        });
    }

}








// Edit Order by Customer
export const editOrder = async (req, res) => {
    let est_price = 0;
    let count = 0;
    try {
        // const { customer_id, address_id, schedule_date, item, time, mode, payment_id, est_price, order_id } = req.body;
        const { schedule_date, time } = req.body;
        // var item = JSON.parse(req.body.item)

        // console.log("response payouts: ", response.data);


        const today = new Date().toISOString().split('T')[0];
        const parts = today.split('-');
        const reversedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
        console.log(reversedDate);
        await Orders.findOne({ _id: req.params.orderid, schedule_date: reversedDate }).then(async (schedule) => {
            if (schedule) {
                return res.send({
                    isSuccess: true,
                    message: `Order can't reschedule in same date.`,
                })
            } else {
                await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        // customer_id: customer_id,
                        // address_id: address_id,
                        schedule_date: schedule_date,
                        time: time,
                        // item: req.body.item,
                        // est_price: est_price,
                        // order_id: order_id,
                        // mode: mode,
                    }
                }).then(async (confirmation) => {

                    console.log(confirmation);
                    // for (const x of item) {
                    //     console.log(x);
                    //     // const itemDoc = await Items.findOne({ _id: x.itemid });

                    //     if (x) {
                    //         const orderitems = await Orderitems.findOne({ item_id: new mongoose.Types.ObjectId(x.itemid), order_id: new mongoose.Types.ObjectId(req.params.orderid) })
                    //         console.log("orderitems : ", orderitems);
                    //         if (orderitems) {
                    //             await Orderitems.findOneAndUpdate({ order_id: req.params.orderid, item_id: new mongoose.Types.ObjectId(x.itemid) }, {
                    //                 $set: {
                    //                     item_weight: x.weight,
                    //                 }
                    //             }).then(async (updtInd) => {
                    //                 console.log('updtInd', updtInd);
                    //                 count += 1
                    //                 console.log(count == item.length);
                    //                 if (count == item.length) {
                    //                     return res.send({
                    //                         isSuccess: true,
                    //                         message: `Update ${order_id} Order.`,
                    //                         data: confirmation,
                    //                         // message: response.data,
                    //                         // order: updtInd
                    //                     });
                    //                 }
                    //             })
                    //         } else {
                    //             const itemDoc = await Items.findOne({ _id: x.itemid });
                    //             var getadd = await Address.findOne({ _id: address_id })

                    //             if (itemDoc) {
                    //                 const orderitem = await Orderitems.create({
                    //                     order_id: new mongoose.Types.ObjectId(req.params.orderid),
                    //                     item_id: itemDoc._id,
                    //                     item_weight: x.weight,
                    //                     item_price: parseFloat(itemDoc.price),
                    //                     city: getadd.city,
                    //                 });
                    //                 count += 1
                    //                 console.log(count == item.length);
                    //                 if (count == item.length) {
                    //                     return res.send({
                    //                         isSuccess: true,
                    //                         message: `Update ${order_id} Order.`,
                    //                         data: confirmation,
                    //                         // message: response.data,
                    //                         // order: updtInd
                    //                     });
                    //                 }
                    //             }
                    //         }


                    //     }

                    // }


                    if (confirmation) {
                        return res.send({
                            isSuccess: true,
                            message: `Update Order. Schedule on ${schedule_date} at ${time}`,
                            data: confirmation,
                            // message: response.data,
                            // order: updtInd
                        });
                    }
                })
            }

        })





    } catch (error) {
        console.error(error);
        res.status(500).send({
            isSuccess: false,
            message: "An error occurred while creating the order.",
        });
    }
};








// Cancel Order by Customer
export const cancelOrderByCust = async (req, res) => {
    try {
        const today = new Date().toISOString().split('T')[0];
        const parts = today.split('-');
        const reversedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
        console.log(reversedDate);


        await Orders.findOne({
            _id: req.params.orderid,
            $or: [
                { schedule_date: reversedDate },
                { status: "Assigned to agent" }
            ]
        }).then(async (schedule) => {
            console.log('schedule', schedule);
            if (schedule) {
                return res.send({
                    isSuccess: true,
                    message: `Order can't Cancel in same date Or Can't delete after Assign the agent.`,
                })
            } else {
                await Orders.findOneAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        status: `Order Cancel by Customer.`
                    }
                }).then(async (confirmation) => {
                    if (confirmation) {
                        return res.send({
                            isSuccess: true,
                            message: `Order Cancel by customer.`,
                            // data: confirmation,
                            // message: response.data,
                            // order: updtInd
                        })
                    }

                })
            }
        })


    } catch {
        res.status(500).send({
            isSuccess: false,
            message: "An error occurred while creating the order.",
        });
    }
}







// Reschedule Order by Admin
export const rescheduleByAdmin = async (req, res) => {
    try {
        let { schedule_date, time } = req.body;
        await Orders.findOne({ _id: req.params.orderid }).then(async (x) => {
            if (x) {
                await Orders.findByIdAndUpdate({ _id: req.params.orderid }, {
                    $set: {
                        schedule_date: schedule_date,
                        time: time,
                    }
                }).then((y) => {
                    if (y) {
                        return res.send({
                            isSuccess: true,
                            message: `Update Order. Schedule on ${schedule_date} at ${time}`,
                            // data: confirmation,
                        });
                    }
                })
            }
        })
    } catch {
        return res.send({
            isSuccess: false,
            message: `Something went wrong.`,
            // data: confirmation,
        });
    }
}















// Create Order by Agent
export const createOrderAgent = async (req, res) => {
    // console.log(req.fields);
    // const formData = {
    //     customer_id: req.fields.customer_id.trim(),
    //     address_id: req.fields.address_id.trim(),
    //     schedule_date: req.fields.schedule_date.trim(),
    //     item: [
    //       {
    //         itemid: req.fields['item[0][itemid]'].trim(),
    //         weight: req.fields['item[0][weight]'].trim(),
    //       },
    //     ],
    //   };

    //   // Log the parsed form data
    //   console.log(JSON.stringify(formData, null, 2));
    //   console.log(formData);
    let est_price = 0;
    let totalitems = [];
    try {
        const { customer_id, address_id, schedule_date, item, time, mode, payment_id, agent_id } = req.body;
        // var item = JSON.parse(req.body.item)


        // Generate a random order_id
        const order_id = await generateRandomOrderId();
        if (item.length !== 0) {
            for (const x of item) {
                // const aggregationPipeline = [
                //     {
                //         $match: {
                //             _id: { $in: itemIds }
                //         }
                //     },
                //     {
                //         $addFields: {
                //             weight: weights,
                //             _idArray: itemIds,
                //         }
                //     },
                //     {
                //         $unwind: "$weight"
                //     },
                //     // {
                //     //     $match: {
                //     //         _idArray: { $in: "$_idArray" }
                //     //     }
                //     // },

                //     // {
                //     //     $project: {
                //     //         _id: { $type: "$_id" },
                //     //         priceType: { $type: "$price" },
                //     //         weightType: { $type: "$weight" },
                //     //     }
                //     // },
                //     {
                //         $project: {
                //             _id: '$_id',
                //             total_price: {
                //                 $multiply: [
                //                     { $toDouble: "$price" }, // Convert price to a double
                //                     { $toDouble: "$weight" } // Use the weight field from the document
                //                 ]
                //             }
                //         }
                //     },
                //     // {
                //     //     $group: {
                //     //         _id: "$_id",
                //     //         total_price: { $sum: "$total_price" }
                //     //     }
                //     // }
                // ]
                const itemDoc = await Items.findOne({ _id: x.itemid });


                console.log(x, itemDoc);
                if (itemDoc) {
                    est_price += parseFloat(itemDoc.price) * parseFloat(x.weight);
                }

                // const image = req.file; // Assuming you have a file input named 'image' in your form
                // if (image) {
                //     x.imageURL = 'uploads/' + image.filename;
                // }

                // const item = req.body.item.map((item) => {
                //     return {
                //         itemid: item.itemid,
                //         weight: item.weight,
                //         imageURL: req.file ? `uploads/${uploadedImage.filename}` : '', // Set imageURL if an image was uploaded
                //     };
                // });



                // console.log(x, est_price, item.indexOf(x) == item.length - 1 && est_price != 0);
                // const totalPriceResult = await Items.aggregate(aggregationPipeline);
                // est_price = totalPriceResult;
                // if (totalPriceResult.length > 0) {
                if (item.indexOf(x) == item.length - 1 && est_price != 0) {
                    const order = await Orders.create({
                        customer_id: customer_id,
                        address_id: address_id,
                        schedule_date: schedule_date,
                        time: time,
                        item: req.body.item,
                        est_price: est_price,
                        order_id: order_id,
                        mode: mode,
                        agent_id: agent_id,
                        status: "processed"
                        // payment_id: payment_id,
                    });

                    console.log(order);

                    if (order) {

                        console.log(order, (order.customer_id).toString());
                        const coins = await Coin.findOne({ customer_id: order.customer_id });
                        console.log('coin', coins);
                        if (coins) {
                            const updatedCoins = coins.coins + order.est_price;
                            const leftCoins = order.est_price + coins.left;

                            const updatedCoin = await Coin.findOneAndUpdate(
                                { customer_id: coins.customer_id },
                                {
                                    $set: {
                                        coins: updatedCoins,
                                        left: leftCoins,
                                        spend: coins.spend,

                                        // pout: response.data.id,
                                    }
                                },
                                { new: true } // to get the updated document
                            );

                            // if (updatedCoin) {
                            console.log('order.est_price + updatedCoin.left', order.est_price + updatedCoin.left);
                            const coinhist = await Coinhist.create({
                                customer_id: updatedCoin.customer_id,
                                coins: updatedCoins,
                                left: updatedCoin.left,
                                spend: updatedCoin.spend,
                                purpose: `Credit from Recycle-Pay.`,
                                credit: order.est_price,
                                debit: 0,
                                order_id: order.order_id,
                            });
                            // return res.json({
                            //     isSuccess: true,
                            //     mode: "Eco",
                            //     message: { status: "processed" },
                            //     // order: updtInd
                            // });
                            // } else {
                            //     const coin = await Coin.create({
                            //         customer_id: x.customer_id,
                            //         coins: x.est_price,
                            //         left: x.est_price,
                            //         spend: 0,
                            //         // purpose: `${x.est_price} Credit from Recycle-Pay.`,
                            //         // credit: x.est_price,
                            //         // debit: 0,
                            //         // order_id: x.order_id,
                            //     });

                            //     if (coin) {
                            //         return res.send({
                            //             isSuccess: true,
                            //             mode: "Eco",
                            //             message: { status: "processed" },
                            //             // order: updtInd
                            //         });
                            //     }

                            // }
                        } else {
                            const coin = await Coin.create({
                                customer_id: order.customer_id,
                                coins: order.est_price,
                                left: order.est_price,
                                spend: 0,
                                // purpose: `${x.est_price} Credit from Recycle-Pay.`,
                                // credit: x.est_price,
                                // debit: 0,
                                // order_id: x.order_id,
                            });

                            const coinhist = await Coinhist.create({
                                customer_id: order.customer_id,
                                coins: order.est_price,
                                left: order.est_price,
                                spend: 0,
                                purpose: `Credit from Recycle-Pay.`,
                                credit: order.est_price,
                                debit: 0,
                                order_id: order.order_id,
                            });

                            // if (coin) {
                            //     return res.send({
                            //         isSuccess: true,
                            //         mode: "Eco",
                            //         message: { status: "processed" },
                            //         // order: updtInd
                            //     });
                            // }
                        }
                        var count = 0
                        console.log(item);
                        for (const x of item) {
                            console.log(x);
                            var getadd = await Address.findOne({ _id: order.address_id })
                            console.log(getadd.city);
                            const itemDoc = await Items.findOne({ _id: x.itemid });
                            const custdetails = await Customers.findOne({ _id: order.customer_id })

                            if (itemDoc) {
                                const orderitem = await Orderitems.create({
                                    order_id: new mongoose.Types.ObjectId(order._id),
                                    item_id: itemDoc._id,
                                    item_weight: x.weight,
                                    item_price: parseFloat(itemDoc.price),
                                    // total_price: parseFloat(itemDoc.price) * x.weight,
                                    city: getadd.city,
                                });
                                const orderitemfinal = {
                                    // itemid: new mongoose.Types.ObjectId(order._id),
                                    itemid: itemDoc._id,
                                    item_name: itemDoc.item_name,
                                    weight: x.weight,
                                    price: parseFloat(itemDoc.price).toFixed(2),
                                    total: (parseFloat(itemDoc.price) * x.weight).toFixed(2),
                                    // city: getadd.city,
                                };
                                count += 1
                                totalitems.push(orderitemfinal)
                                console.log(orderitem && count == item.length, count, item.length);
                                if (orderitem && count == item.length) {
                                    if (totalitems) {
                                        console.log('totalitems', totalitems);
                                        const itemItems = await Orders.findOneAndUpdate({ _id: order._id }, {
                                            $set: {
                                                // item: totalitems
                                                item: totalitems,
                                            }
                                        })
                                        if (itemItems) {
                                            let cust = await Customers.find({ _id: order.customer_id })
                                            // const transporter = brevo.createTransport({
                                            //     apiKey: process.env.MAILAPIKEY,
                                            //     domain: process.env.DOMAIN,
                                            //   });

                                            const transporter = nodemailer.createTransport(
                                                new Transport({ apiKey: process.env.MAILAPIKEY })
                                            );

                                            // const transporter = new brevo.Transport(emailConfig);

                                            if (cust) {

                                                var defaultClient = SibApiV3Sdk.ApiClient.instance;

                                                // Configure API key authorization: api-key
                                                var apiKey = defaultClient.authentications['api-key'];
                                                apiKey.apiKey = process.env.MAILAPIKEY;

                                                // Uncomment below two lines to configure authorization using: partner-key
                                                // var partnerKey = defaultClient.authentications['partner-key'];
                                                // partnerKey.apiKey = 'YOUR API KEY';

                                                var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();

                                                var sendSmtpEmail = new SibApiV3Sdk.SendSmtpEmail();
                                                var sendSmtpEmailAdmin = new SibApiV3Sdk.SendSmtpEmail();

                                                // var dynamicContent = {
                                                //     firstname: "John",
                                                //     lastname: "Doe",
                                                // };

                                                const dynamicSubject = `Order Confirmation - Your Order with Recycle Pay [${order.order_id}] has been successfully placed!`;
                                                console.log('totalitems', totalitems);
                                                sendSmtpEmail = {
                                                    to: [{
                                                        email: custdetails.email,
                                                        // email: 'aditi.nandy@ajatus.co.in'
                                                        // name: 'John Doe'
                                                    }],
                                                    from: {
                                                        email: 'support@ceibagreen.com',
                                                        // name: 'Your Name'
                                                    },
                                                    templateId: 10,
                                                    params: {
                                                        "parameter": "recycle-pay",
                                                        "subject": dynamicSubject,
                                                        "order_id": order.order_id, "schedule_date": order.schedule_date, "getadd": getadd, "totalitems": totalitems, "est_price": est_price.toFixed(2), "name": custdetails.name, "time": order.time
                                                    },
                                                    subject: dynamicSubject,
                                                    headers: {
                                                        'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                                    }
                                                };
                                                const dynamicAdmSubject = `New order [${order.order_id}] has been placed!`;
                                                sendSmtpEmailAdmin = {
                                                    to: [
                                                        // { email: 'aditi.nandy@ajatus.co.in' },
                                                        // { email: 'baniprasad.mangaraj@ajatus.co.in' },
                                                        // { email: 'ashok.sarangi@ajatus.co.in' },
                                                        // {email: 'santosh@ceibagreen.com'},
                                                        // { email: 'janmejay@ceibagreen.com' }, 
                                                        //  { email: 'support@ceibagreen.com' },
                                                        //  { email: 'neelima@ceibagreen.com' }
                                                        //  { email: 'neelima@ajatus.co.in' }
                                                    ],
                                                    from: {
                                                        email: 'support@ceibagreen.com',
                                                        // name: 'Your Name'
                                                    },
                                                    templateId: 14,
                                                    params: { "parameter": "recycle-pay", "subject": "Your Order ID - {{params.order_id}} for Scrap Sale has been placed", "order_id": order.order_id, "schedule_date": order.schedule_date, "getadd": getadd, "totalitems": totalitems, "totalPrice": est_price.toFixed(2), "name": custdetails.name, "time": order.time },
                                                    subject: dynamicAdmSubject,
                                                    headers: {
                                                        'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
                                                    }
                                                };


                                                console.log("order.order_id", order.order_id);

                                                const mailOptions = {
                                                    from: 'orders@recycle-pay.com',
                                                    to: 'aditi.nandy@ajatus.co.in',
                                                    subject: `Your Order ID - ${order.order_id} for Scrap Sale has been placed`,
                                                    text: `<p>Hello ${cust[0].name},</p>
                                                <p>On sucessful order placed a mail to be sent to customer with order details as </p>

                                                <p>Order Id: ${order.order_id}</p>
                                              
                                                <p>Pick Up date: ${order.schedule_date}</p>
                                                <p>Pick Up time: ${order.time}</p>
                                                <p>Total Quantity: ${order.order_id}</p>

                                                <p>If you have any questions or need any assistance, feel free to reach out to our support team. We are here to ensure a smooth and rewarding experience for you.</p>
                                                <p>To access your organization's account and take advantage of all the features our platform offers, kindly visit our website: <a href="https://www.ceibagreen.com">https://www.ceibagreen.com</a></p>
                                                `,
                                                };

                                                try {
                                                    // transporter.sendMail(mailOptions, (error, info) => {
                                                    //     if (error) {
                                                    //         console.error('Error sending email:', error);
                                                    //     } else {
                                                    //         console.log('Email sent:', info.response);
                                                    //     }
                                                    // });
                                                    apiInstance.sendTransacEmail(sendSmtpEmail).then(function (data) {
                                                        console.log('Customer API called successfully. Returned data: ' + data);
                                                    }, function (error) {
                                                        console.error(error);
                                                    });

                                                    apiInstance.sendTransacEmail(sendSmtpEmailAdmin).then(function (data) {
                                                        console.log('Admin API called successfully. Returned data: ' + data);
                                                    }, function (error) {
                                                        console.error(error);
                                                    });
                                                } catch (error) {
                                                    console.error("Error:", error);
                                                }
                                            }
                                            return res.send({
                                                isSuccess: true,
                                                message: "Create Order Item Individual.",
                                                // order: orderitem
                                            });
                                        }
                                    }


                                }
                            }

                        }
                    } else {
                        res.send({
                            isSuccess: false,
                            message: "Failed to create the order.",
                        });
                    }
                }
            }
        }


    } catch (error) {
        console.error(error);
        res.status(500).send({
            isSuccess: false,
            message: "An error occurred while creating the order.",
        });
    }


};







// Get all coins For each users
export const activeCoins = async (req, res) => {
    await Coin.find({ customer_id: req.params.cust }).then((x) => {
        if (x) {
            return res.send({
                isSuccess: true,
                message: 'Get available coins',
                data: x
            });
        } else {
            return res.send({
                isSuccess: false,
                message: 'Something went wrong.',
            });
        }
    })
}






// Update history of Coin
export const histCoins = async (req, res) => {
    console.log(req.params.cust, req.body);
    await Coin.findOne({ customer_id: req.params.cust }).then(async (x) => {
        if (x) {
            console.log(x, req.body);
            const y = await Coin.findOneAndUpdate(
                { customer_id: x.customer_id },
                {
                    $set: {
                        customer_id: req.params.cust,
                        coins: x.coins,
                        left: x.left - req.body.spend,
                        spend: x.spend + req.body.spend,
                    }
                },
                { new: true }
            );
            console.log(y);
            if (y) {
                const coinhist = await Coinhist.create({
                    customer_id: y.customer_id,
                    coins: x.coins,
                    left: x.left - req.body.spend,
                    spend: x.spend + req.body.spend,
                    purpose: req.body.purpose,
                    credit: 0,
                    debit: req.body.spend,
                    order_id: req.body.order_id,
                    // order_id: x.order_id,
                });
                if (coinhist) {
                    return res.send({
                        isSuccess: true,
                        message: 'Update used coins transaction.',
                        data: coinhist
                    });
                } else {
                    return res.send({
                        isSuccess: false,
                        message: 'Something went wrong.',
                    });
                }

            }
        }

    })
}











// Report of total Orders
export const orderHistForReport = async (req, res) => {
    const usertype = await Users.findOne({ _id: req.params.custid, usertype: "admin" })
    console.log(usertype);

    if (usertype) {
        const pipeline = [
            // {
            //   $match: {
            //     $expr: {
            //         $and: [
            //             {
            //                 $gte: [
            //                     {
            //                         $dateFromString: {
            //                             dateString: "$schedule_date",
            //                             format: "%d-%m-%Y"
            //                         }
            //                     },
            //                     {
            //                         $dateFromString: {
            //                             dateString: req.query.to,
            //                             format: "%d-%m-%Y"
            //                         }
            //                     }
            //                 ]
            //             },
            //             {
            //                 $lte: [
            //                     {
            //                         $dateFromString: {
            //                             dateString: "$schedule_date",
            //                             format: "%d-%m-%Y"
            //                         }
            //                     },
            //                     {
            //                         $dateFromString: {
            //                             dateString: req.query.from,
            //                             format: "%d-%m-%Y"
            //                         }
            //                     }
            //                 ]
            //             }
            //         ]
            //     },

            //     // status: 'processed'
            //     // Add other match conditions if needed
            //   }
            // },
            {
                $lookup: {
                    from: "customers",
                    localField: "customer_id",
                    foreignField: "_id",
                    as: "customerDetails"
                }
            },
            {
                $lookup: {
                    from: "addresses",
                    localField: "address_id",
                    foreignField: "_id",
                    as: "addressesDetails"
                }
            },
            {
                $group: {
                    _id: "$_id",
                    customer_id: { $first: "$customer_id" },
                    customer_name: {
                        $first: {
                            $let: {
                                vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                in: "$$firstCustomer.name"
                            }
                        }
                    },
                    customer_mobile: {
                        $first: {
                            $let: {
                                vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                in: "$$firstCustomer.mobile"
                            }
                        }
                    },
                    address_id: { $first: "$address_id" },
                    est_price: { $first: "$est_price" },
                    order_id: { $first: "$order_id" },
                    schedule_date: { $first: "$schedule_date" },
                    time: { $first: "$time" },
                    status: { $first: "$status" },
                    isDelete: { $first: "$isDelete" },
                    mode: { $first: "$mode" },
                    createdAt: { $first: "$createdAt" },
                    // addressDetails: { $first: "$addressesDetails" },
                    // address: {
                    //     $first: {
                    //       $concat: [
                    //         { $ifNull: ["$addressesDetails.location", ""] },
                    //         ", ",
                    //         { $ifNull: ["$addressesDetails.city", ""] },
                    //         ", ",
                    //         { $ifNull: ["$addressesDetails.state", ""] }
                    //       ]
                    //     }
                    //   },
                    location: { $first: { $arrayElemAt: ["$addressesDetails.location", 0] } },
                    city: { $first: { $arrayElemAt: ["$addressesDetails.city", 0] } },
                    state: { $first: { $arrayElemAt: ["$addressesDetails.state", 0] } },
                    PIN: { $first: { $arrayElemAt: ["$addressesDetails.PIN", 0] } },
                    latitude: { $first: { $arrayElemAt: ["$addressesDetails.latitude", 0] } },
                    longitude: { $first: { $arrayElemAt: ["$addressesDetails.longitude", 0] } }
                }
            },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $group: {
                    _id: null,
                    grandTotalEstPrice: { $sum: "$est_price" },
                    orders: { $push: "$$ROOT" }
                }
            },
            {
                $project: {
                    _id: 0,
                    grandTotalEstPrice: 1,
                    orders: 1
                }
            }
        ];


        const result = await Orders.aggregate(pipeline);


        if (result) {
            res.json({
                isSuccess: true,
                message: "Order History",
                data: result
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    } else {
        const pipeline = [
            // {
            //   $match: {
            //     $expr: {
            //         $and: [
            //             {
            //                 $gte: [
            //                     {
            //                         $dateFromString: {
            //                             dateString: "$schedule_date",
            //                             format: "%d-%m-%Y"
            //                         }
            //                     },
            //                     {
            //                         $dateFromString: {
            //                             dateString: req.query.to,
            //                             format: "%d-%m-%Y"
            //                         }
            //                     }
            //                 ]
            //             },
            //             {
            //                 $lte: [
            //                     {
            //                         $dateFromString: {
            //                             dateString: "$schedule_date",
            //                             format: "%d-%m-%Y"
            //                         }
            //                     },
            //                     {
            //                         $dateFromString: {
            //                             dateString: req.query.from,
            //                             format: "%d-%m-%Y"
            //                         }
            //                     }
            //                 ]
            //             }
            //         ]
            //     },

            //     // status: 'processed'
            //     // Add other match conditions if needed
            //   }
            // },
            {
                $lookup: {
                    from: "customers",
                    localField: "customer_id",
                    foreignField: "_id",
                    as: "customerDetails"
                }
            },
            {
                $lookup: {
                    from: "addresses",
                    localField: "address_id",
                    foreignField: "_id",
                    as: "addressesDetails"
                }
            },
            {
                $group: {
                    _id: "$_id",
                    customer_id: { $first: "$customer_id" },
                    customer_name: {
                        $first: {
                            $let: {
                                vars: { firstCustomer: { $arrayElemAt: ["$customerDetails", 0] } },
                                in: "$$firstCustomer.name"
                            }
                        }
                    },
                    address_id: { $first: "$address_id" },
                    est_price: { $first: "$est_price" },
                    order_id: { $first: "$order_id" },
                    schedule_date: { $first: "$schedule_date" },
                    time: { $first: "$time" },
                    status: { $first: "$status" },
                    isDelete: { $first: "$isDelete" },
                    mode: { $first: "$mode" },
                    createdAt: { $first: "$createdAt" },
                    // addressDetails: { $first: "$addressesDetails" },
                    location: { $first: { $arrayElemAt: ["$addressesDetails.location", 0] } },
                    city: { $first: { $arrayElemAt: ["$addressesDetails.city", 0] } },
                    state: { $first: { $arrayElemAt: ["$addressesDetails.state", 0] } },
                    latitude: { $first: { $arrayElemAt: ["$addressesDetails.latitude", 0] } },
                    longitude: { $first: { $arrayElemAt: ["$addressesDetails.longitude", 0] } }
                }
            },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $group: {
                    _id: null,
                    grandTotalEstPrice: { $sum: "$est_price" },
                    orders: { $push: "$$ROOT" }
                }
            },
            {
                $project: {
                    _id: 0,
                    grandTotalEstPrice: 1,
                    orders: 1
                }
            }
        ];

        const result = await Orders.aggregate(pipeline);

        if (result) {
            res.json({
                isSuccess: true,
                message: "Order History",
                data: result
            });
        } else {
            res.json({
                isSuccess: false,
                message: "Something went wrong.",
            });
        }
    }
}









// Report individual Order history in Report
export const indOrdHistReport = async (req, res) => {
    const pipeline = [
        {
            $match: {
                _id: new mongoose.Types.ObjectId(req.params.id)
            }
        },
        {
            $lookup: {
                from: "items",
                localField: "item.itemid",
                foreignField: "_id",
                as: "itemDetails"
            }
        },
        {
            $group: {
                _id: "$_id",
                item: { $push: "$item" },
                itemDetails: { $push: "$itemDetails" },
            }
        },
        {
            $sort: {
                createdAt: -1 // 1 for ascending order, -1 for descending order
            }
        }
    ];

    const result = await Orders.aggregate(pipeline);

    if (result) {
        res.json({
            isSuccess: true,
            message: "Order History",
            data: result
        });
    } else {
        res.json({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
}



export const totalSuccessfulOrders = async (req, res) => {
    try {
        // Count the total number of successful orders
        const totalSuccessfulOrders = await Orders.countDocuments({ status: 'processed' });
        return res.send({
            isSuccess: true,
            message: 'Total successful orders retrieved successfully',
            data: totalSuccessfulOrders
        });
    } catch (error) {
        console.error(error);
        return res.status(500).send({
            isSuccess: false,
            message: "Error retrieving total successful orders",
        });
    }
};


export const totalOrders = async (req, res) => {
    try {
        // Count the total number of successful orders
        const totalOrders = await Orders.countDocuments();
        return res.send({
            isSuccess: true,
            message: 'Total orders retrieved successfully',
            data: totalOrders
        });
    } catch (error) {
        console.error(error);
        return res.status(500).send({
            isSuccess: false,
            message: "Error retrieving total orders",
        });
    }
};




















// QR code generater
export const QRcode = async (req, res) => {
    const { id, width, height } = req.query;

    // Generate the QR code
    QRCode.toDataURL(id, { width, height }, (err, url) => {
        if (err) {
            res.status(500).json({ error: 'Failed to generate QR code' });
        } else {
            // res.send(url);
            res.send(`
                    <html>
                        <body>
                        <img src="${url}" alt="QR Code">
                        </body>
                    </html>
                    `);
        }
    });
}










// Razorpay Successful Receipt -> Admin

export const razReceipt = async (req, res) => {
    try {
        const auth = {
            username: apiKey,
            password: apiSecret,
        };
        const response = await axios.get(`https://api.razorpay.com/v1/payouts/${req.params.pout}`, {
            headers: {
                'Content-Type': 'application/json',
            },
            auth: auth,
        });
        console.log(response.data);

        if (response.data.status == "processed") {
            const response1 = await axios.get(`https://api.razorpay.com/v1/fund_accounts/${response.data.fund_account_id}`, {
                headers: {
                    'Content-Type': 'application/json',
                },
                auth: auth,
            });
            console.log('response1', response1.data);
            if (response1.data) {
                return res.send({
                    isSuccess: true,
                    message: 'Razorpay Successful Receipt',
                    data: response.data,
                    data1: response1.data,
                });
            }
        }
    } catch (error) {
        console.log(error);
        if (error.response && error.response.data && error.response.data.error && error.response.data.error.description) {
            return res.send({
                isSuccess: false,
                message: 'An error occurred during the API request.',
                error: error.response.data.error.description
            });
        } else {
            return res.send({
                isSuccess: false,
                message: 'An error occurred during the API request.',
                error: error.message
            });
        }
    }
}










// Discount eco coins price
export const disCoin = async (req, res) => {
    const Coins = await Coin.findOne({ customer_id: req.params.cust })
    console.log(req.body, Coins);
    await Coin.findOneAndUpdate({ customer_id: req.params.cust }, {
        $set: {
            // mode: req.body.mode,
            // coins: 0,
            left: Coins.left - req.body.discount,
            spend: Coins.spend + req.body.discount,
            // withdraw: Coins.withdraw + Coins.left,
        }
    },
        { new: true }
    ).then(async (x) => {
        console.log(x);
        // console.log(response);

        if (x) {
            const coinhist = await Coinhist.create({
                customer_id: req.params.cust,
                // coins: 0,
                left: 0,
                spend: x.spend + req.body.discount,
                purpose: `Withdraw from Recycle-Pay.`,
                // withdraw: x.withdraw + x.left,
                // pout: response.data.id,
                // status: response.data.status,
                debit: req.body.discount,
                credit: 0,
            });
            console.log(coinhist);
            const cust = await Customers.find({ _id: x.customer_id })
            if (cust) {

                try {

                } catch (error) {
                    console.error("Error:", error);
                }
            }
            return res.send({
                isSuccess: true,
                message: coinhist,
                // order: updtInd
            });
        }
    })
}


// get total number of orders of that respective customer
export const custAllOrdersCount = async (req, res) => {
    try {
        const customerId = new mongoose.Types.ObjectId(req.params.cusId);
        const customer = await Customers.findOne({ _id: customerId });

        if (customer) {
            const totalOrders = await Orders.countDocuments({ customer_id: customer._id });
            const processedOrders = await Orders.countDocuments({ customer_id: customer._id, status: 'processed' });
            const completedOrders = await Orders.countDocuments({ customer_id: customer._id, status: 'Pickup Completed' });

            if (totalOrders > 0) {
                return res.send({
                    isSuccess: true,
                    message: 'Data retrieved successfully',
                    TotalOrders: totalOrders,
                    ProcessedOrders: processedOrders,
                    CompletedOrders: completedOrders
                });
            } else {
                return res.send({
                    isSuccess: true,
                    message: 'No order placed by the customer'
                });
            }
        } else {
            return res.send({
                isSuccess: false,
                message: 'Customer not found!'
            });
        }
    } catch (error) {
        console.error(error);
        return res.status(500).send({
            isSuccess: false,
            message: "Error retrieving data",
        });
    }
};


// Get total quantity of waste collected and total price for 'Pickup Completed' and 'processed' statuses separately
export const custWasteAndPrice = async (req, res) => {
    try {
        const customerId = new mongoose.Types.ObjectId(req.params.cusId);
        const customer = await Customers.findOne({ _id: customerId });

        if (!customer) {
            return res.send({ isSuccess: false, message: 'Customer not found!' });
        }
        console.log(`Customer Name: ${customer.name}`);

        // Aggregate total quantity of waste collected
        const totalQuantityData = await Orders.aggregate([
            { $match: { customer_id: customer._id, status: { $in: ['Pickup Completed', 'processed'] } } },
            { $unwind: "$item" },
            { $group: { _id: null, totalQuantity: { $sum: "$item.weight" } } }
        ]);

        // Aggregate total price of 'Pickup Completed' orders
        const completedOrdersData = await Orders.aggregate([
            { $match: { customer_id: customer._id, status: 'Pickup Completed' } },
            { $addFields: { roundedEstPrice: { $round: ["$est_price", 2] } } },
            { $group: { _id: null, totalPrice: { $sum: "$roundedEstPrice" } } }
        ]);

        // Aggregate total price of 'processed' orders
        const processedOrdersData = await Orders.aggregate([
            { $match: { customer_id: customer._id, status: 'processed' } },
            { $addFields: { roundedEstPrice: { $round: ["$est_price", 2] } } },
            { $group: { _id: null, totalPrice: { $sum: "$roundedEstPrice" } } }
        ]);

        const totalQuantity = totalQuantityData[0]?.totalQuantity || 0;
        const completedPrice = completedOrdersData[0]?.totalPrice || 0;
        const processedPrice = processedOrdersData[0]?.totalPrice || 0;

        console.log(`Total Quantity: ${totalQuantity}`);
        console.log(`Pickup Completed Price: ${completedPrice}`);
        console.log(`Processed Price: ${processedPrice}`);

        // Format the response
        const response = {
            isSuccess: true,
            message: 'Data retrieved successfully',
            TotalQuantity: totalQuantity,
            TotalAmountPaid: { TotalPrice: processedPrice },
            TotalPendingAmount: { TotalPrice: completedPrice }
        };

        return res.send(response);
    } catch (error) {
        console.error(error);
        return res.status(500).send({ isSuccess: false, message: "Error retrieving data" });
    }
};


// Get total completed order price and payment success order price for a customer
export const custOrderPrices = async (req, res) => {
    try {
        const customerId = new mongoose.Types.ObjectId(req.params.cusId);
        const customer = await Customers.findOne({ _id: customerId });

        if (customer) {
            // Aggregate total price of completed orders
            const completedOrdersPrice = await Orders.aggregate([
                { $match: { customer_id: customer._id, status: 'Pickup Completed' } },
                { $group: { _id: null, total: { $sum: "$est_price" } } }
            ]);

            // Aggregate total price of payment success orders
            const paymentSuccessOrdersPrice = await Orders.aggregate([
                { $match: { customer_id: customer._id, status: 'processed' } },
                { $group: { _id: null, total: { $sum: "$est_price" } } }
            ]);

            return res.send({
                isSuccess: true,
                message: 'Data retrieved successfully',
                CompletedOrdersPrice: completedOrdersPrice[0] ? completedOrdersPrice[0].total : 0,
                PaymentSuccessOrdersPrice: paymentSuccessOrdersPrice[0] ? paymentSuccessOrdersPrice[0].total : 0
            });
        } else {
            return res.send({
                isSuccess: false,
                message: 'Customer not found!'
            });
        }
    } catch (error) {
        console.error(error);
        return res.status(500).send({
            isSuccess: false,
            message: "Error retrieving data",
        });
    }
};


// showing month wise all orders of the respective businesscustomer
export const custTotalOrders = async (req, res) => {
    try {
        const customerId = new mongoose.Types.ObjectId(req.params.cusId);
        const customer = await Customers.findOne({ _id: customerId });

        if (customer) {
            const month = req.query.month;
            const year = req.query.year;
            let totalOrders = await Orders.find({ customer_id: customer._id });
            if (month && year) {
                totalOrders = totalOrders.filter(order => {
                    const [day, orderMonth, orderYear] = order.schedule_date.split('-');
                    return orderMonth === month && orderYear === year;
                });
            } else if (!month && !year) {
                totalOrders = [];
            }
            totalOrders = totalOrders.sort((a, b) => {
                const dateA = new Date(a.schedule_date.split('-').reverse().join('-'));
                const dateB = new Date(b.schedule_date.split('-').reverse().join('-'));
                return dateB - dateA;
            });

            const transformedOrders = [];
            let totalSum = 0;

            for (let order of totalOrders) {
                for (let item of order.item) {
                    const itemData = await Items.findById(item.itemid);
                    if (itemData) {
                        const transformedOrder = {
                            _id: order._id,
                            customer_id: order.customer_id,
                            address_id: order.address_id,
                            item_name: item.item_name,
                            weight: item.weight,
                            price: item.price,
                            total: item.total,
                            unit: itemData.unit,
                            mode: order.mode,
                            est_price: order.est_price,
                            order_id: order.order_id,
                            schedule_date: order.schedule_date,
                            time: order.time,
                            status: order.status,
                            isDelete: order.isDelete,
                            createdAt: order.createdAt,
                            updatedAt: order.updatedAt,
                            __v: order.__v,
                            agent_id: order.agent_id
                        };
                        transformedOrders.push(transformedOrder);
                        totalSum += parseFloat(item.total);
                    }
                }
            }

            return res.send({
                isSuccess: true,
                message: 'All orders are below:',
                data: transformedOrders,
                totalSum: totalSum.toFixed(2)
            });
        } else {
            return res.send({
                isSuccess: false,
                message: 'Customer not found!'
            });
        }
    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Error retrieving total orders",
        });
    }
};





// Send action-based-notification Order pickup for bussines-customer
export const pickupNotification = async (req, res) => {
    try {
        let currentDate = new Date();

        currentDate.setDate(currentDate.getDate() + 1);

        let day = String(currentDate.getDate()).padStart(2, '0');
        let month = String(currentDate.getMonth() + 1).padStart(2, '0');
        let year = currentDate.getFullYear();
        const date = `${day}-${month}-${year}`;
        const param_ord = []

        await Orders.find({ schedule_date: date, pickupday: { $exists: true, $ne: null }, status: { $nin: ["Reject by Customer", "Reject Subsequent Orders by Customer"] } }).then(async (buss_cust) => {
            console.log('buss_cust', buss_cust);
            buss_cust.map(async (cust) => {
                console.log('cust', cust);
                await Customers.find({ _id: new ObjectId(cust.customer_id), business_reg: true, isDelete: false, isActive: true }).then(async (order) => {
                    console.log("business_reg", order[0]);
                    if (order) {
                        param_ord.push(cust)
                    }
                })
                console.log("param_ord", param_ord);
            })
            console.log('param_ord.length', param_ord.length);
            pushNotificationForOrders(param_ord)
        })
    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Error retrieving total orders",
        });
    }
};





// get last order details of customer
export const custLastOrders = async (req, res) => {
    try {
        let order = []
        const customer = await Customers.findOne({ _id: req.params.cusId });
        console.log(customer);
        if (customer.business_reg == true) {
            const customerId = new mongoose.Types.ObjectId(req.params.cusId);
            order = await Orders.findOne({
                customer_id: customerId,
                $or: [
                    { recursive_ord: true },
                    { recursive_ord: false }
                ],
                // status: { $ne: "Reject Subsequent Orders by Customer" }
            }).sort({ createdAt: -1 });

            console.log("order", order);
            if (order == null || order.status == "Reject Subsequent Orders by Customer") {
                return res.send({
                    isSuccess: false,
                    business_cust: 1,
                    recursive_ord: 0,
                    message: 'Register as business customer, but Last Order not found!'
                });
            }
            else if (order.length != 0 && order.status != "Reject Subsequent Orders by Customer") {
                return res.send({
                    isSuccess: true,
                    business_cust: 1,
                    recursive_ord: 1,
                    message: 'Register as business customer, Last order:',
                    data: order
                });
            }

        } else {
            return res.send({
                isSuccess: false,
                business_cust: 0,
                recursive_ord: 0,
                message: 'Customer not register as business customer.'
            });
        }
    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Error retrieving total orders",
        });
    }
};





// decline Notification
export const declineActionNotification = async (req, res) => {
    let data
    // const order_id = await generateRandomOrderId();

    try {
        await Orders.findByIdAndUpdate({ _id: new ObjectId(req.params.ordId) }, { $set: { status: "Reject by Customer" } }, { new: true }).then(async (x) => {
            await Customers.findOne({ _id: new ObjectId(x.customer_id) }).then(async (cust) => {
                const today = moment().format('DD-MM-YYYY');
                const futureDate = moment().add(parseInt(cust.pickupday), 'days').format('DD-MM-YYYY');

                console.log('Today:', today);
                console.log('7 days from now:', futureDate);

                const indicesToRemove = [];
                await Promise.all(
                    x.item.map(async (conf_ord, index) => {
                        if (conf_ord.weight == 0) {
                            console.log("conf_ord.weight == 0", index);
                            indicesToRemove.push(index);
                        }
                    })
                )

                indicesToRemove.sort((a, b) => b - a);
                indicesToRemove.forEach(index => {
                    x.item.splice(index, 1);
                });

                // data = {
                //     customer_id: x.customer_id,
                //     address_id: x.address_id,
                //     schedule_date: futureDate,
                //     time: x.time,
                //     item: x.item,
                //     est_price: x.est_price.toFixed(2),
                //     // order_id: x.order_id,
                //     mode: x.mode,
                //     // recursive_ord: x.true,
                // }

                const order = {
                    parentId: x._id,
                    customer_id: x.customer_id,
                    address_id: x.address_id,
                    schedule_date: futureDate,
                    time: x.time,
                    item: x.item,
                    est_price: x.est_price.toFixed(2),
                    // order_id: order_id,
                    mode: x.mode,
                    scheduleDateForLastOrder: futureDate,
                    pickupday: x.pickupday,
                    payment_settlement: x.payment_settlement,
                    recursive_ord: false,
                    recursive_orderid: x._id,
                };

                if (order) {
                    console.log("order", order);
    
            // await axios.post("https://singada1319api.ceibagreen.com/api/orders/createOrder", order, {
                await axios.post(`https://devapisbot.ceibagreen.com/api/orders/createOrder`, order, {
                    // await axios.post(`http://localhost:9001/api/orders/createOrder`, order, {
                        headers: {
                            'Content-Type': 'application/json',
                        },
                    })
                }
            })
            // await axios.post("https://singada1319api.ceibagreen.com/api/orders/createOrder", data, {
            //     // const response = await axios.post("https://devapisbot.ceibagreen.com/api/orders/createOrder", data, {
            // // const response = await axios.post("http://localhost:9001/api/orders/createOrder", data, {
            //     headers: {
            //       'Content-Type': 'application/json',
            //     },
            //   });
            return res.send({
                isSuccess: true,
                message: "Order Reject by Customer.",
            });
        })
        // console.log("decline", decline);
    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
};






// decline Subsequent Orders
export const declineSubsequentNotification = async (req, res) => {
    try {
        await Orders.findByIdAndUpdate({ _id: new ObjectId(req.params.ordId) }, { $set: { status: "Reject Subsequent Orders by Customer" } }).then(async (x) => {
            await Orders.findByIdAndUpdate({ _id: new ObjectId(x.recursive_orderid) }, { $set: { notes: "Reject Subsequent Orders by Customer", recursive_ord: false } }).then(async (y) => {
                return res.send({
                    isSuccess: true,
                    message: "Reject Subsequent Orders by Customer.",
                });
            })
        })
        // console.log("decline", decline);
    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
};



function numberToWords(num) {
    const ones = ["", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"];
    const teens = ["", "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen"];
    const tens = ["", "ten", "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety"];

    if (num < 10) {
        return ones[num];
    } else if (num < 20) {
        return teens[num - 10];
    } else if (num < 100) {
        return tens[Math.floor(num / 10)] + (num % 10 !== 0 ? "-" + ones[num % 10] : "");
    } else {
        return num.toString(); // for numbers above 99, just return the number as string
    }
}




// Admin - Recursive Order Settlement
export const adminSettlment = async (req, res) => {
    const { orderID, mode, transctionId, notes, settlement_date } = req.body;
    let dynamicRefAmt = 0;

    try {
        // Fetch the orders based on orderID
        const orders = await Orders.find({
            order_id: { $in: orderID },
            status: "Pickup Completed"
        });

        if (orders.length === 0) {
            return res.send({
                isSuccess: false,
                message: "No orders found with the specified criteria.",
            });
        }

        // Loop through each order and update accordingly
        for (let order of orders) {
            console.log("order", order);

            const customer = await Customers.findOne({ _id: new ObjectId(order.customer_id) });
            console.log("customer", customer);

            const parentcustomer = await Customers.findOne({ refCode: customer.useRefCode });
            console.log("parentcustomer", parentcustomer);

            console.log("customer.useRefCode && customer.useRefCode == parentcustomer.refCode", customer.useRefCode && customer.useRefCode == parentcustomer.refCode);

            if (!customer) {
                continue;
            }

            if (customer.useRefCode && customer.useRefCode == parentcustomer.refCode) {
                // Check order count
                const orderCount = await Orders.countDocuments({ customer_id: new ObjectId(order.customer_id) });
                console.log("orderCount", orderCount);

                if (orderCount <= 5 || orderCount > 5) {
                    // Get the last 5 orders for the customer
                    const recentOrders = await Orders.find({ customer_id: new ObjectId(order.customer_id) })
                        .sort({ createdAt: 1 })
                        .limit(5);
                    console.log("recentOrders", recentOrders);

                    let matchingOrderIndex = recentOrders.findIndex(recentOrder => {
                        console.log("recentOrder", recentOrder.order_id, order.order_id === recentOrder.order_id);
                        return order.order_id === recentOrder.order_id;
                    });

                    if (matchingOrderIndex !== -1) {
                        console.log("Index of matchingOrder:", matchingOrderIndex);
                        let matchingOrder = numberToWords(matchingOrderIndex + 1);
                        console.log("matchingOrder as words:", matchingOrder);

                        const dynamicRefAmtDoc = await Dynamicrefamt.findOne();
                        dynamicRefAmt = dynamicRefAmtDoc?.[`${matchingOrder}order`] || 0;

                        const parentupdatedCoins = await Coin.findOne({ customer_id: new ObjectId(parentcustomer._id) });
                        console.log("dynamicRefAmt: ", dynamicRefAmt);

                        // Update the coins collection with the dynamicRefAmt
                        let updateCoin = await Coin.findOneAndUpdate(
                            { customer_id: new ObjectId(parentcustomer._id) },
                            {
                                $set: {
                                    coins: parentupdatedCoins.coins + dynamicRefAmt,
                                    left: parentupdatedCoins.left + dynamicRefAmt,
                                    earn: parentupdatedCoins.earn + dynamicRefAmt,
                                }
                            }, { new: true }
                        );

                        if (updateCoin) {
                            console.log("updatedCoins", updateCoin);
                            // Create a history entry for the coin update
                            await Coinhist.create({
                                customer_id: new ObjectId(parentcustomer._id),
                                coins: parentupdatedCoins.coins + dynamicRefAmt,
                                left: parentupdatedCoins.left + dynamicRefAmt,
                                spend: 0,
                                earn: parentupdatedCoins.earn + dynamicRefAmt,
                                purpose: `Credit from Recycle-Pay.`,
                                credit: dynamicRefAmt,
                                debit: 0,
                                order_id: order.order_id,
                                refCust: order.customer_id,
                            });
                        }
                    }
                }
            }

            if (mode == "Eco") {
                let updateCoin = await Coin.updateMany(
                    { customer_id: new ObjectId(order.customer_id) },
                    [{
                        $set: {
                            coins: { $add: ["$coins", { $multiply: [order.est_price, 10] }] },
                            left: { $add: ["$left", { $multiply: [order.est_price, 10] }] },
                            earn: { $add: ["$earn", { $multiply: [order.est_price, 10] }] },
                        }
                    }], { new: true }
                );

                const updatedCoins = await Coin.findOne({ customer_id: new ObjectId(order.customer_id) });

                if (updatedCoins) {
                    console.log("updatedCoins", updatedCoins);

                    // Create a history entry for the coin update
                    await Coinhist.create({
                        customer_id: new ObjectId(order.customer_id),
                        coins: updatedCoins.coins,
                        left: updatedCoins.left,
                        spend: 0,
                        earn: updatedCoins.earn,
                        purpose: `Credit from Recycle-Pay.`,
                        credit: order.est_price * 10,
                        debit: 0,
                        order_id: order.order_id,
                    });

                    await Orders.updateOne(
                        { _id: new ObjectId(order._id) },
                        {
                            $set: {
                                notes: notes,
                                settlement_date: settlement_date,
                                status: "processed",
                                mode: mode,
                            }
                        }
                    );
                }
            } else {
                await Orders.updateOne(
                    { _id: new ObjectId(order._id) },
                    {
                        $set: {
                            mode: mode,
                            transctionId: transctionId,
                            notes: notes,
                            settlement_date: settlement_date,
                            status: "processed"
                        }
                    }
                );
            }
        }

        return res.send({
            isSuccess: true,
            message: "Orders processed successfully.",
        });

    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Something went wrong.",
        });
    }
};













// get data of agent total scrap collection quantity with respective item name(chandan)
export const todayScrapCollectedByAgent = async (req, res) => {
    try {
        const agentId = new mongoose.Types.ObjectId(req.params.agentId);
        const today = new Date();
        const day = String(today.getDate()).padStart(2, '0');
        const month = String(today.getMonth() + 1).padStart(2, '0');
        const year = today.getFullYear();

        const todayDate = `${day}-${month}-${year}`;
        console.log("Today's Date:", todayDate);
        console.log(`Agent ID: ${agentId}`);

        // Find the agent's name
        const agent = await Users.findById(agentId);
        if (!agent) {
            return res.send({
                isSuccess: false,
                message: 'Agent not found',
            });
        }
        const orders = await Orders.aggregate([
            {
                $match: {
                    agent_id: agentId,
                    schedule_date: todayDate,
                    status: {
                        $in: ["reversed", "Pickup Completed", "processed", "processing"]
                    }
                }
            },
            {
                $unwind: {
                    path: "$item"
                }
            },
            {
                $lookup: {
                    from: "items",
                    localField: "item.itemid",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $match: {
                    "item.weight": { $gt: 0 } // Filter items with weight greater than 0
                }
            },
            {
                $group: {
                    _id: "$item.item_name",
                    item_weight: { $sum: "$item.weight" },
                    item_unit: { $first: { $arrayElemAt: ["$itemDetails.unit", 0] } }
                }
            },
            {
                $project: {
                    _id: 0,
                    item_name: "$_id",
                    item_weight: 1,
                    item_unit: 1
                }
            }
        ])

        if (!orders.length) {
            return res.send({
                isSuccess: false,
                message: 'No processed orders found for today',
            });
        }

        return res.send({
            isSuccess: true,
            message: 'Scrap collection updated successfully',
            data: orders
        });
    } catch (error) {
        console.error(error);
        return res.send({
            isSuccess: false,
            message: "Error updating scrap collection"
        });
    }
};




// Order Status update as processed -> Payment done by Admin
export const payProcessedByAdmin = async (req, res) => {
    await Orders.findByIdAndUpdate({ _id: new ObjectId(req.params.ordId) }, { $set: { status: req.body.status, notes: `Payment ${req.body.status} by Recycle-Pay Admin.` } }).then((processed) => {
        if (processed) {
            return res.json({
                isSuccess: true,
                msg: `Payment ${req.body.status}.`
            })
        } else {
            return res.json({
                isSuccess: true,
                msg: "Something went wrong."
            })
        }
    })
}

// Child Recursive order create from parent recursive order
export const createRecurOrd = async (req, res) => {
    try {
        const order_id = await generateRandomOrderId();
        const { scheduleDateForLastOrder } = req.query;
        
        // Use moment to get today's date in 'DD-MM-YYYY' format or use scheduleDate if provided
        const baseDate = scheduleDateForLastOrder || moment().format('DD-MM-YYYY');

        
        let today = new Date();
        let day = String(today.getDate()).padStart(2, '0');
        let month = String(today.getMonth() + 1).padStart(2, '0');
        let year = today.getFullYear();
        let formattedToday = `${day}-${month}-${year}`;

        const recursiveOrders = await Orders.find({
            recursive_ord: true,
            scheduleDateForLastOrder:baseDate
        });
        console.log("recursiveOrders", recursiveOrders);
        const orderPromises = recursiveOrders.map(async (x) => {
            const futureDate = moment(baseDate, 'DD-MM-YYYY').add(parseInt(x.pickupday), 'days').format('DD-MM-YYYY');

            const order = {
                parentId: x._id,
                customer_id: x.customer_id,
                address_id: x.address_id,
                schedule_date: baseDate,
                time: x.time,
                item: x.item,
                est_price: x.est_price.toFixed(2),
                mode: x.mode,
                scheduleDateForLastOrder: futureDate,
                pickupday: x.pickupday,
                payment_settlement: x.payment_settlement,
                recursive_ord: false,
                recursive_orderid: x._id,
            };

            if (order) {
                console.log("order------------------------------------------------------------!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", order);

            // await axios.post("https://singada1319api.ceibagreen.com/api/orders/createOrder", order, {
                await axios.post(`https://devapisbot.ceibagreen.com/api/orders/createOrder`, order, {
                // await axios.post(`http://localhost:9001/api/orders/createOrder`, order, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                })
            }

            // if (order) {
            //     await Orders.findByIdAndUpdate(x._id, {
            //         $set: { scheduleDateForLastOrder: futureDate }
            //     });
            //     return { parent: x, child: order };
            // }
        });

        // Wait for all orders to be created and updates to be made
        const results = await Promise.all(orderPromises);

        // Filter out any undefined results (in case order creation failed)
        const successfulResults = results.filter(result => result);

        return res.json({
            isSuccess: true,
            orders: successfulResults
        });
    } catch (error) {
        console.error(error);
        return res.status(500).json({ error: 'Internal Server Error' });
    }
};







//Individual items of an business customer whose orders are in pickup completed and processed status
export const custIndItems = async (req, res) => {
    try {
        const { customerId } = req.params;
        const statuses = ["processed", "Pickup Completed", "processing"];
        const customerObjectId = new mongoose.Types.ObjectId(customerId);

        // Aggregate the orders
        const result = await Orders.aggregate([
            {
                $match: {
                    customer_id: customerObjectId,
                    status: { $in: statuses }
                }
            },
            {
                $unwind: "$item"
            },
            {
                $group: {
                    _id: "$item.itemid",
                    totalWeight: {
                        $sum: {
                            $round: [{ $ifNull: ["$item.weight", 0] }, 3]
                        }
                    },
                    totalPrice: {
                        $sum: {
                            $round: [{ $ifNull: ["$item.total", 0] }, 2]
                        }
                    }
                }
            },
            {
                $match: {
                    totalWeight: { $gt: 0 }
                }
            },
            {
                $lookup: {
                    from: "items",
                    localField: "_id",
                    foreignField: "_id",
                    as: "itemDetails"
                }
            },
            {
                $unwind: "$itemDetails"
            },
            {
                $project: {
                    _id: 0,
                    itemId: "$_id",
                    itemName: {
                        $cond: {
                            if: { $ne: ["$itemDetails.item_name", null] },
                            then: "$itemDetails.item_name",
                            else: { $arrayElemAt: ["$itemDetails.itemLang.item_name", 0] }
                        }
                    },
                    totalWeight: {
                        $cond: {
                            if: { $eq: [{ $mod: [{ $round: ["$totalWeight", 3] }, 1] }, 0] },
                            then: { $toInt: { $round: ["$totalWeight", 3] } },
                            else: { $round: ["$totalWeight", 3] }
                        }
                    },
                    totalPrice: 1,
                    unit: {
                        $cond: {
                            if: { $ne: ["$itemDetails.unit", null] },
                            then: "$itemDetails.unit",
                            else: { $arrayElemAt: ["$itemDetails.itemLang.unit", 0] }
                        }
                    },
                    imageURL: {
                        $cond: {
                            if: { $isArray: "$itemDetails.imageURL" },
                            then: { $arrayElemAt: ["$itemDetails.imageURL", 0] },
                            else: "$itemDetails.imageURL"
                        }
                    }
                }
            },
            {
                $sort: {
                    itemName: 1
                }
            }
        ]);

        res.status(200).json(result);
    } catch (error) {
        res.status(500).json({ error: error.message });
    }
};







// Get recurring order details for every customer
export const recurringOrd = async (req, res) => {
    await Orders.find({ customer_id: new ObjectId(req.params.cust), recursive_ord: true }).then((ord) => {
        return res.json({
            isSuccess: true,
            orders: ord
        })
    })
}













// getting count of all order and total amount of all successful order by om
export const getCountoforder = async (req, res) => {
    try {
        const { customerId } = req.params;
        const customerObjectId = new mongoose.Types.ObjectId(customerId);

        // Aggregate the orders
        const result = await Orders.aggregate([
            {
                $match: {
                    customer_id: customerObjectId
                }
            },
            {
                $group: {
                    _id: null,
                    totalOrders: { $sum: 1 },
                    successfulOrders: {
                        $sum: {
                            $cond: [{ $eq: ["$status", "processed"] }, 1, 0]
                        }
                    },
                    pendingOrders: {
                        $sum: {
                            $cond: [{ $eq: ["$status", "Pickup Completed"] }, 1, 0]
                        }
                    },
                    processingOrders: {
                        $sum: {
                            $cond: [{ $eq: ["$status", "processing"] }, 1, 0]
                        }
                    },
                    rejectedOrders: {
                        $sum: {
                            $cond: [{ $eq: ["$status", "Rejected by admin"] }, 1, 0]
                        }
                    },
                    paymentReceived: {
                        $sum: {
                            $cond: [
                                { $eq: ["$status", "processed"] },
                                { $round: ["$est_price", 2] },
                                0
                            ]
                        }
                    }
                }
            }
        ]);

        const summary = result.length
            ? {
                totalOrders: result[0].totalOrders,
                successfulOrders: result[0].successfulOrders,
                pendingOrders: result[0].pendingOrders,
                processingOrders: result[0].processingOrders,
                rejectedOrders: result[0].rejectedOrders,
                paymentReceived: result[0].paymentReceived.toFixed(2)
            }
            : {
                totalOrders: 0,
                successfulOrders: 0,
                pendingOrders: 0,
                processingOrders: 0,
                rejectedOrders: 0,
                paymentReceived: "0.00"
            };

        res.status(200).json(summary);
    } catch (error) {
        res.status(500).json({ error: error.message });
    }
};
